VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cJohna_Xfile"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'==================================================
'New version 1.03
'3/02/2002
'  -multiple bounding box colision detection
'
''
'==================================================





Option Explicit

Private Type Tsphere
   Vcenter As D3DVECTOR
   Radius As Single
End Type


Private Type XGroup
    IndexList() As Integer
    VertexList() As D3DVERTEX
    mtVertexList() As D3DVERTEX
    Mat As D3DMATERIAL7
    Texture As DirectDrawSurface7
    TextureFileName As String
    bBOX As D3DRMBOX
    vBoxSize As D3DVECTOR
    BoxVERTICES() As D3DVERTEX
    Sphere As Tsphere
    B_BOX As New cJohna_BoundingBox
End Type
Private GLOB_BOXvert() As D3DVERTEX

Private Type Johna_COLI_Plane_DATA
         Plane_VectorNORMAL As D3DVECTOR
         FQ_distance As Single
End Type


Enum Johna_BOX_levelColision
     GLOBAL_BOX = &HFF20
     MULTIPLE_BOX = &HFF21

End Enum

Private Type VerTEX_PARAM
  vPosition As D3DVECTOR
  Vscal As D3DVECTOR
  Vrotate As D3DVECTOR
  

End Type

Private Xobject As VerTEX_PARAM

'======paramtre pour le BOX de colision
Public Bounding_BOX_Width As Single
Public Bounding_BOX_Height As Single
Public Bounding_BOX_DEPH As Single



Private vert() As D3DLVERTEX



Private DX As DirectX7
Private RM As Direct3DRM3

Private TempMatrix As D3DMATRIX
Private TranMatrix As D3DMATRIX
Private RotMatrix As D3DMATRIX
Private ScaleMatrix As D3DMATRIX
Private GroupCount As Long
Private Groups() As XGroup
Private GLOB_BOX As D3DRMBOX 'for global object box bounding
Public GLOB_BBOX As New cJohna_BoundingBox
Private PATH_file As String


Private Active As Boolean

Public YawSpin As Single
Public PitchSpin As Single
Public FillMode As FillModeEnum
Public ShadeMode As ShadeModeEnum

Public Enum FillModeEnum
    Points = 1
    Solid = 3
    Wireframe = 2
End Enum

Public Enum ShadeModeEnum
    Gouraud = 2
    Flat = 1
End Enum


Private Const X_PI = 3.13987644547878
Private Const X_RAD = X_PI / 180

Private Const EPSILON = 0.0001
Private Type IntersectTest
  T As Double
  U As Double
  v As Double
End Type




' Renders the group object to the backsurface
Private Sub RenderGroup(groupid As Long, d3ddev As Direct3DDevice7, Optional Use_texture As Boolean = True)
    On Local Error Resume Next
    Dim Mat As D3DMATERIAL7
    Dim C As Long
    With Groups(groupid)
    
        If (Not .Texture Is Nothing) And Use_texture Then
            d3ddev.SetTexture 0, .Texture
        ElseIf Not Use_texture Then
            'd3ddev.SetTexture 0, Nothing
        End If
        
        .Mat.Ambient.A = 1
        .Mat.Ambient.R = 1
        .Mat.Ambient.G = 1
        .Mat.Ambient.B = 1
        
        d3ddev.SetMaterial .Mat
        
        
        d3ddev.DrawIndexedPrimitive D3DPT_TRIANGLELIST, D3DFVF_VERTEX, _
            .VertexList(0), UBound(.VertexList) + 1, .IndexList, _
                UBound(.IndexList), D3DDP_DEFAULT
    End With
                
End Sub


Private Sub AddVertex(groupid As Long, Vertex As D3DVERTEX)
    With Groups(groupid)
        LSet .VertexList(UBound(.VertexList)) = Vertex
        ReDim Preserve .VertexList(UBound(.VertexList) + 1)
        ReDim .mtVertexList(UBound(.VertexList))
    End With
End Sub

Private Function VertexIndex(groupid As Long, Index As Long) As Long
    With Groups(groupid)
        VertexIndex = .IndexList(Index)
    End With
End Function

Private Sub AddVertexIndex(groupid As Long, VertexIndex As Long)
    With Groups(groupid)
        .IndexList(UBound(.IndexList)) = VertexIndex
        ReDim Preserve .IndexList(UBound(.IndexList) + 1)
    End With
End Sub

Private Function IndexCount(groupid As Long) As Long
    With Groups(groupid)
        IndexCount = UBound(.IndexList) + 1
    End With
End Function


'Public Sub rotate(rotPitch As Single, rotYaw As Single)
    'DX.RotateXMatrix TempMatrix, rotPitch
    'DX.MatrixMultiply RotMatrix, TempMatrix, RotMatrix
    'DX.RotateYMatrix TempMatrix, rotYaw
    'DX.MatrixMultiply RotMatrix, TempMatrix, RotMatrix
'End Sub

'Public Sub SetPOSITION(tranX As Single, tranY As Single, tranZ As Single)
    'TranslateMatrix TranMatrix, MakeVector(tranX, tranY, tranZ)
'End Sub
'Public Sub AdjustScale(sx As Single, sy As Single, sz As Single)
    'With ScaleMatrix
       ' .rc11 = sx
        '.rc22 = sy
       ' .rc33 = sz
    'End With
'End Sub

Private Sub Class_Initialize()
    ' setup the object's world matrix
    Set DX = New DirectX7
    ReDim Groups(0)
    DX.IdentityMatrix RotMatrix
    DX.IdentityMatrix ScaleMatrix
    DX.IdentityMatrix TempMatrix
    DX.IdentityMatrix TranMatrix
    FillMode = Solid
    ShadeMode = Gouraud
End Sub

' Loads an .X file into the scene.
Public Sub Load(JOX As johna_DX7, filename As String, Optional Try_LoadingTEXTURE As Boolean = True)
    
  
    Dim GIndex As Long
    Dim IIndex As Long
    Dim Index As Long
    Dim ArraySize As Long
    Dim IArray() As Long
    Dim VertCount As Long
    Dim FaceCount As Long
    Dim FaceVertCount As Long
    Dim TempVertex As D3DVERTEX
    Dim TempRMVertex As D3DRMVERTEX
    Dim TextureDesc As DDSURFACEDESC2
    Dim frame As Direct3DRMFrame3
    Dim strPath As String
    Dim MeshB As Direct3DRMMeshBuilder3
    Dim Mesh As Direct3DRMMesh

    strPath = StripFilenameFromPath(filename)
    PATH_file = strPath
    
    On Error GoTo XFileErr
    
    ' create the required retained mode objects... we're going to use
    ' retained mode to do our dirty work instead of trying to parse
    ' the .X file ourselves.
    
    Set RM = DX.Direct3DRMCreate
    
    Active = False
    
    ' try to load the .X file into a mesh
    On Local Error Resume Next
    Set MeshB = RM.CreateMeshBuilder
    MeshB.LoadFromFile filename, "", D3DRMLOAD_FIRST, Nothing, Nothing

    ' if that didnt work try loading it into a frame
    If Err.Number <> 0 Then
        Err.Clear
        On Error GoTo XFileErr
        Set MeshB = RM.CreateMeshBuilder
        Set frame = RM.CreateFrame(Nothing)
        frame.LoadFromFile filename, "", D3DRMLOAD_FIRST, Nothing, Nothing
        MeshB.AddFrame frame
        
    End If
    
    MeshB.GetBOX GLOB_BOX
    
    Dim I
    
   
    
    ' generate appropriate normals if they aren't already correct.
    MeshB.GenerateNormals 3.14 / 4, D3DRMGENERATENORMALS_USECREASEANGLE
    
    ' use the meshbuilder information to create a mesh object.
    ' it will be easier to parse from the mesh object than from the
    ' meshbuilder.
    Set Mesh = MeshB.CreateMesh
    
    ' resize our group object array
    GroupCount = Mesh.GetGroupCount
    ReDim Groups(GroupCount - 1)
    
    ' loop through the number of groups in the mesh
    ' each group can contain a seperate texture
    For GIndex = 0 To Mesh.GetGroupCount - 1
        
        ' get the required information for our parsing
        With Groups(GIndex)
            ReDim .IndexList(0)
            ReDim .VertexList(0)
            ReDim .mtVertexList(0)
        End With

        
        Mesh.GetSizes GIndex, VertCount, FaceCount, FaceVertCount, ArraySize
        ReDim IArray(ArraySize)
        
        Mesh.GetGroupData GIndex, IArray()
                       
        
        'setup our texture for this particular group object
        If JOX.D3D_DEV.GetDeviceGuid() = "IID_IDirect3DHALDevice" Then
            TextureDesc.lFlags = DDSD_CAPS
            TextureDesc.ddsCaps.lCaps = DDSCAPS_TEXTURE
            TextureDesc.ddsCaps.lCaps2 = DDSCAPS2_TEXTUREMANAGE
        Else
            TextureDesc.lFlags = DDSD_CAPS
            TextureDesc.ddsCaps.lCaps = DDSCAPS_TEXTURE Or DDSCAPS_SYSTEMMEMORY
            TextureDesc.ddsCaps.lCaps2 = 0
        End If
        
      If Try_LoadingTEXTURE Then
        If Load_GOODTEXTURE(filename) Then
            On Local Error Resume Next
            With Groups(GIndex)
                
                Set .Texture = JOX.CreateTextureEX(.TextureFileName, 128, 128)
            End With
            On Error GoTo XFileErr
        End If
    End If
    
        
        Dim C As Long
        Dim rmmat As Direct3DRMMaterial2
        C = Mesh.GetGroupColor(GIndex)
        Set rmmat = Mesh.GetGroupMaterial(GIndex)
        
        With Groups(GIndex).Mat.diffuse
            .A = DX.ColorGetAlpha(C)
            .R = DX.ColorGetRed(C)
            .G = DX.ColorGetGreen(C)
            .B = DX.ColorGetBlue(C)
        End With
        With Groups(GIndex).Mat.Ambient
            rmmat.GetAmbient .R, .G, .B
            .A = 1
        End With
        With Groups(GIndex).Mat.specular
            rmmat.GetSpecular .R, .G, .B
            .A = 1
        End With
        With Groups(GIndex).Mat.emissive
            rmmat.GetEmissive .R, .G, .B
            .A = 1
        End With
        Groups(GIndex).Mat.power = rmmat.GetPower()

        
        ' loop through the faces in the group
        ' we'll need to deal with 4 verterice faces differently than
        ' 3 sided.  we're adding indices to the group object here.
        Dim fanIndex As Long
        Dim J As Long
        Dim bGetFaceCount As Boolean
        
        IIndex = 0
        bGetFaceCount = False
        If FaceVertCount = 0 Then bGetFaceCount = True
        
        Do While IIndex < ArraySize
             If bGetFaceCount Then
                FaceVertCount = IArray(IIndex)
                IIndex = IIndex + 1
             End If
             

            fanIndex = IIndex
                
                
            For J = 0 To FaceVertCount - 3
                'add the fan point
                AddVertexIndex GIndex, IArray(fanIndex)
                
                'add 2 other points
                AddVertexIndex GIndex, IArray(IIndex + J + 1)
                AddVertexIndex GIndex, IArray(IIndex + J + 2)
            Next
            IIndex = IIndex + FaceVertCount
        Loop
             
        
        ' loop through the vertices and add them to the group object.
        For Index = 0 To VertCount - 1
                Mesh.GetVertex GIndex, Index, TempRMVertex
                With TempRMVertex
                    TempVertex.X = .Position.X
                    TempVertex.Y = .Position.Y
                    TempVertex.Z = .Position.Z
                    TempVertex.nx = .Normal.X
                    TempVertex.ny = .Normal.Y
                    TempVertex.nz = .Normal.Z
                    TempVertex.tu = .tu
                    TempVertex.tv = .tv
                End With
                AddVertex GIndex, TempVertex
        Next
    Next
    
   
Dim xBOX() As D3DRMBOX
ReDim Preserve xBOX(0 To GroupCount - 1) As D3DRMBOX
For I = 0 To GroupCount - 1
    
    JOX.OBJECT_getBoundingBOX Groups(I).VertexList, Groups(I).bBOX
    Groups(I).B_BOX.CreateBoxEX Groups(I).bBOX, "Xfile Model" + Str(I)
    GLOB_BBOX.CreateBoxEX GLOB_BOX, "Xmodel Global Box"
 
Next I

'Add global BOX
 Xobject.Vscal = Vector(1, 1, 1)
    
    Active = True
Exit Sub

XFileErr:
 
    MsgBox "error loading xfile"
    Active = False
End Sub


Function CheckIfVisible(JohnaEngine As johna_DX7) As Boolean
   'the great visibility check with the sphere!
   'mesh sphere must be computed before calling this function
   Dim ClipStatus
   
   CheckIfVisible = False
  ClipStatus = JohnaEngine.D3D_DEV.ComputeSphereVisibility(GLOB_BBOX.Get_BoxCenter, GLOB_BBOX.Get_BoxRadius)
 If ClipStatus And &HFFF000 Then
   'not visible
   'Visible = 0
 Else
  If ClipStatus And &HFFF Then
   'partially visible :
   CheckIfVisible = True
   'Visible = 1
  Else
   CheckIfVisible = True
   'entirely visible
   'Visible = 2
 End If
 
 End If
End Function


Public Sub Render(JOX As johna_DX7, Optional Use_builtIN_transformation As Boolean = True, Optional Use_BuiltINtexture As Boolean = True)
    
    On Local Error Resume Next

    Dim Index As Long

    If Not Active Then Exit Sub
            
    
    'check visibility
    If Not CheckIfVisible(JOX) Then Exit Sub
    
    
    If Use_builtIN_transformation Then
      Dim Zmat As D3DMATRIX
      Dim I
      'Dim rVERT() As D3DVERTEX
      
      JOX.CLearMATRIX
      'Zmat = CreateMatrix(Xobject.Vrotate, Xobject.Vscal, Xobject.Vrotate)
      '
      JOX.OBJECT_Scale_Rotate_MovEX Xobject.Vscal, Xobject.Vrotate, Xobject.vPosition
      
      
    End If
    
    
    
    ' render each group
    'JOX.USE_default_RENDERSTATE
    JOX.USE_defaultMaterial
      JOX.D3D_DEV.SetRenderState D3DRENDERSTATE_ALPHABLENDENABLE, False

    JOX.Set_Light 1
    
    For Index = 0 To UBound(Groups)
        RenderGroup Index, JOX.D3D_DEV, Use_BuiltINtexture
         'Me.VerTEX_MatMULTILPY Groups(Index).BoxVERTICES, Zmat, rVERT
         
         'JOX.CLearMATRIX
         
        
    Next
    
    
    
End Sub


Private Sub CreateCubeEX(DX_7 As DirectX7, Vertices() As D3DVERTEX, Vsize As D3DVECTOR, Optional TileX = 1, Optional TileY = 1)
     ReDim Preserve Vertices(23)
      Dim V1 As D3DVECTOR
     Dim V2 As D3DVECTOR
     Dim Sx, Sy, Sz
     
     Sx = Vsize.X
     Sy = Vsize.Y
     Sz = Vsize.Z
     
     V1 = Vector(-Sx / 2, 0, -Sz / 2)
     V2 = Vector(Sx / 2, Sy, Sz / 2)
           
    ' Create vertices describing the front face of the cube.
    DX_7.CreateD3DVertex V1.X, V2.Y, V1.Z, 0, 0, -1, 0, 0, Vertices(0)
    DX_7.CreateD3DVertex V2.X, V2.Y, V1.Z, 0, 0, -1, TileX, 0, Vertices(1)
    DX_7.CreateD3DVertex V1.X, V1.Y, V1.Z, 0, 0, -1, 0, TileY, Vertices(2)
    DX_7.CreateD3DVertex V2.X, V1.Y, V1.Z, 0, 0, -1, TileX, TileY, Vertices(3)
        
    ' Create vertices describing the back face of the cube.
    DX_7.CreateD3DVertex V1.X, V2.Y, V2.Z, 0, 0, 1, TileX, 0, Vertices(4)
    DX_7.CreateD3DVertex V1.X, V1.Y, V2.Z, 0, 0, 1, TileX, TileY, Vertices(5)
    DX_7.CreateD3DVertex V2.X, V2.Y, V2.Z, 0, 0, 1, 0, 0, Vertices(6)
    DX_7.CreateD3DVertex V2.X, V1.Y, V2.Z, 0, 0, 1, 0, TileY, Vertices(7)
        
    ' Create vertices describing the top face of the cube.
    DX_7.CreateD3DVertex V1.X, V2.Y, V2.Z, 0, 1, 0, 0, 0, Vertices(8)
    DX_7.CreateD3DVertex V2.X, V2.Y, V2.Z, 0, 1, 0, TileX, 0, Vertices(9)
    DX_7.CreateD3DVertex V1.X, V2.Y, V1.Z, 0, 1, 0, 0, TileY, Vertices(10)
    DX_7.CreateD3DVertex V2.X, V2.Y, V1.Z, 0, 1, 0, TileX, TileY, Vertices(11)
        
    ' Create vertices describing the bottom face of the cube.
    DX_7.CreateD3DVertex V1.X, V1.Y, V2.Z, 0, -1, 0, 0, 0, Vertices(12)
    DX_7.CreateD3DVertex V1.X, V1.Y, V1.Z, 0, -1, 0, 0, TileY, Vertices(13)
    DX_7.CreateD3DVertex V2.X, V1.Y, V2.Z, 0, -1, 0, TileX, 0, Vertices(14)
    DX_7.CreateD3DVertex V2.X, V1.Y, V1.Z, 0, -1, 0, TileX, TileY, Vertices(15)
        
    ' Create vertices describing the right face of the cube.
    DX_7.CreateD3DVertex V2.X, V2.Y, V1.Z, 1, 0, 0, 0, 0, Vertices(16)
    DX_7.CreateD3DVertex V2.X, V2.Y, V2.Z, 1, 0, 0, TileX, 0, Vertices(17)
    DX_7.CreateD3DVertex V2.X, V1.Y, V1.Z, 1, 0, 0, 0, TileY, Vertices(18)
    DX_7.CreateD3DVertex V2.X, V1.Y, V2.Z, 1, 0, 0, TileX, TileY, Vertices(19)
        
    ' Create vertices describing the left face of the cube.
    DX_7.CreateD3DVertex V1.X, V2.Y, V1.Z, -1, 0, 0, TileX, 0, Vertices(20)
    DX_7.CreateD3DVertex V1.X, V1.Y, V1.Z, -1, 0, 0, TileX, TileY, Vertices(21)
    DX_7.CreateD3DVertex V1.X, V2.Y, V2.Z, -1, 0, 0, 0, 0, Vertices(22)
    DX_7.CreateD3DVertex V1.X, V1.Y, V2.Z, -1, 0, 0, 0, TileY, Vertices(23)
    
End Sub

Private Function StripFilenameFromPath(sPath As String) As String
    Dim Q As Integer
    Dim R As Integer
    
    'do we have a path string
    R = InStr(sPath, "\")
    If R = 0 Then Exit Function

    Do While R <> 0
        Q = R
        R = InStr(R + 1, sPath, "\")
    Loop
    
    StripFilenameFromPath = Mid$(sPath, 1, Q)
End Function




Function BOX_size() As D3DVECTOR
   
   BOX_size = VICTOR(Me.Bounding_BOX_Width, Me.Bounding_BOX_Height, Me.Bounding_BOX_DEPH)
End Function




Function IScollision(ObjectPOS As D3DVECTOR, Optional Method As Johna_BOX_levelColision = GLOBAL_BOX) As Boolean
 Dim I
 
 
 'If COLdet.Get_ColisionEX(GLOB_BOX, Groups(0).VertexList, ObjectPOS, Me.Vscal, Me.Vrotation, Me.vPosition) Then
  'IScollision = 1
 
 'End If
 'Exit Function
 
 If Method = GLOBAL_BOX Then
   If GLOB_BBOX.IS_Inside(ObjectPOS) Then
       IScollision = True
       Exit Function
    End If
 
 End If
 
 
 
 'multiple bounding box
 For I = 0 To GroupCount - 1
    
    If Groups(I).B_BOX.IS_Inside(ObjectPOS) Then
       IScollision = True
       Exit Function
    End If
    
    
Next I
  
    
End Function






Function VerTEX_MatMULTILPY(vert() As D3DVERTEX, MATA As D3DMATRIX, retVert() As D3DVERTEX)

Dim I, J, Z
I = LBound(vert)
J = UBound(vert)
'Dim retVert() As D3DVERTEX
ReDim Preserve retVert(I To J) As D3DVERTEX
retVert = vert
Dim VC As D3DVECTOR
For Z = I To J
    VC = VICTOR(retVert(Z).X, retVert(Z).Y, retVert(Z).Z)
    VectorMatrixMultiply VC, VC, MATA
    
    retVert(Z).X = VC.X ' (retVert(Z).x * MATA.rc11) + (retVert(Z).Y * MATA.rc21) + (retVert(Z).Z * MATA.rc31) + MATA.rc41
    retVert(Z).Y = VC.Y ' (retVert(Z).x * MATA.rc12) + (retVert(Z).Y * MATA.rc22) + (retVert(Z).Z * MATA.rc32) + MATA.rc42
    retVert(Z).Z = VC.Z ' (retVert(Z).x * MATA.rc13) + (retVert(Z).Y * MATA.rc23) + (retVert(Z).Z * MATA.rc33) + MATA.rc43
Next Z


End Function


Private Function VectorMatrixMultiply(vDest As D3DVECTOR, _
                                vSrc As D3DVECTOR, _
                                 Mat As D3DMATRIX)
Dim X, Y, Z, W

 X = vSrc.X * Mat.rc11 + vSrc.Y * Mat.rc21 + vSrc.Z * Mat.rc31 + Mat.rc41
 Y = vSrc.X * Mat.rc12 + vSrc.Y * Mat.rc22 + vSrc.Z * Mat.rc32 + Mat.rc42
Z = vSrc.X * Mat.rc13 + vSrc.Y * Mat.rc23 + vSrc.Z * Mat.rc33 + Mat.rc43
 W = vSrc.X * Mat.rc14 + vSrc.Y * Mat.rc24 + vSrc.Z * Mat.rc34 + Mat.rc44
    
    If Abs(W) < 0.00001 Then
        VectorMatrixMultiply = 0
        Exit Function
    End If

    vDest.X = X / W
    vDest.Y = Y / W
    vDest.Z = Z / W

    VectorMatrixMultiply = 1




End Function


Private Function getdist3d(vec1 As D3DVECTOR, vec2 As D3DVECTOR) As Single
On Error GoTo BugOut:
    
    getdist3d = Sqr(((vec1.X - vec2.X) * (vec1.X - vec2.X)) + ((vec1.Y - vec2.Y) * (vec1.Y - vec2.Y)) + ((vec1.Z - vec2.Z) * (vec1.Z * vec2.Z)))
Exit Function
BugOut:
    'Stops Sqr(-n) screwing things up
    getdist3d = 0
End Function


Private Function BOX_to_Sphere(zBOX As D3DRMBOX) As Tsphere
  Dim Ts As Tsphere
    Ts.Radius = MAX_3(zBOX.max.X - zBOX.min.X, zBOX.max.Y - zBOX.min.Y, zBOX.max.Z - zBOX.min.Z)
    Ts.Vcenter = Vmiddle(zBOX.max, zBOX.min)
    BOX_to_Sphere = Ts
End Function



Private Function MAX_3(V1, V2, V3) As Single
      If V1 > V2 And V1 > V3 Then MAX_3 = V1
      If V2 > V1 And V2 > V3 Then MAX_3 = V2
      If V3 > V2 And V3 > V1 Then MAX_3 = V3
      
     If MAX_3 = 0 Then
      If V1 > V2 And V1 = V3 Then MAX_3 = V1
      If V2 > V3 And V2 = V1 Then MAX_3 = V2
      If V3 > V2 And V3 = V1 Then MAX_3 = V3
    End If
    
    If MAX_3 = 0 Then
     If V1 = V2 And V1 = V3 Then MAX_3 = V1
     
    End If
    
      
End Function




Private Function Vrotate(Vorigin As D3DVECTOR, Vrot As D3DVECTOR, Xray As Single) As D3DVECTOR
Dim DVEC As D3DVECTOR

DVEC.X = Vorigin.X + Cos(Vrot.X) * Xray
DVEC.Y = Vorigin.Y + Sin(Vrot.Y) * Xray
DVEC.Z = Vorigin.Z + Sin(Vrot.Z) * Xray

Vrotate = DVEC

End Function


Private Function GetPlane_VECTOR(V1 As D3DVECTOR, V2 As D3DVECTOR, V3 As D3DVECTOR) As Johna_COLI_Plane_DATA
  Dim vPlane As Johna_COLI_Plane_DATA
  Dim GX As New DirectX7
  Dim Vret As D3DVECTOR
  Dim p1 As D3DVECTOR, p2 As D3DVECTOR
  
  'deux droite vecteur directeur du plan
  GX.VectorSubtract p1, V3, V2
  GX.VectorSubtract p2, V1, V2
  
  'calcul le vecteur normal
  GX.VectorCrossProduct Vret, p1, p2
 
  GX.VectorNormalize Vret
  vPlane.Plane_VectorNORMAL = Vret
  vPlane.FQ_distance = -GX.VectorDotProduct(Vret, V2)
  
  'norm = CrossProduct( SubVect(p2 ,p1), SubVect( p0,p1) );
  'norm = Normalize(norm);
  'distance = -DotProduct( norm, p1 );

  
  
Set GX = Nothing
End Function


Private Function RayCollision(orig As D3DVECTOR, Dir As D3DVECTOR, vert0 As D3DVECTOR, Vert1 As D3DVECTOR, Vert2 As D3DVECTOR, T As Double, U As Double, v As Double) As Byte
  Dim edge1 As D3DVECTOR
  Dim edge2 As D3DVECTOR
  Dim tvec As D3DVECTOR
  Dim pvec As D3DVECTOR
  Dim qvec As D3DVECTOR
  Dim inv_det As Double
  Dim det As Double

'/* trouve les vecteurs des deux cots en utilisant un des sommets *'/
   DX.VectorSubtract edge1, Vert1, vert0
   DX.VectorSubtract edge2, Vert2, vert0

'/* commence  calculer *'/
   DX.VectorCrossProduct pvec, Dir, edge2
   
'/* si det est prs de zero, alors le vecteur de la ligne et du plan du triangle
  'sont colinaires *'/
   det = DX.VectorDotProduct(edge1, pvec)

   If det > -EPSILON And det < EPSILON Then
    RayCollision = 0
    Exit Function
   End If
   inv_det = 1 / det

   'calcule la distance entre l'origine et le premier vertex du triangle
   DX.VectorSubtract tvec, orig, vert0
   
   'calcule l'lement u
   U = DX.VectorDotProduct(edge1, pvec) * inv_det
    
    If U < 0 Or U > 1 Then
      RayCollision = 0
      Exit Function
   End If

    'Prepare to test v parameter
     DX.VectorCrossProduct qvec, tvec, edge1
     
    'Calcule le paramtre v
     v = DX.VectorDotProduct(Dir, qvec) * inv_det
     
     If v < 0 Or U + v > 1 Then
       RayCollision = 0
       Exit Function
    End If
    
    'calcule la distance entre l'origine et le point de collision.
     T = DX.VectorDotProduct(edge1, qvec) * inv_det
     
     RayCollision = 1
    
    'ColScore.t = t
    'ColScore.u = u
    'ColScore.v = v
  End Function




Private Function vNormal(VA As D3DVECTOR, VB As D3DVECTOR) As Single
  vNormal = Sqr((VB.X - VA.X) ^ 2 + (VB.Y - VA.Y) ^ 2 + (VB.Z - VA.Z) ^ 2)

End Function

Private Function Vsub(A As D3DVECTOR, B As D3DVECTOR) As D3DVECTOR
  Dim Dest As D3DVECTOR
  Dest.X = A.X - B.X
  Dest.Y = A.Y - B.Y
  Dest.Z = A.Z - B.Z
  Vsub = Dest
End Function


Private Function Vmiddle(VA As D3DVECTOR, VB As D3DVECTOR) As D3DVECTOR
Vmiddle.X = (VA.X + VB.X) / 2
Vmiddle.Y = (VA.Y + VB.Y) / 2
Vmiddle.Z = (VA.Z + VB.Z) / 2

End Function



Private Function VAdd(A As D3DVECTOR, B As D3DVECTOR) As D3DVECTOR
  Dim Dest As D3DVECTOR
  Dest.X = A.X + B.X
  Dest.Y = A.Y + B.Y
  Dest.Z = A.Z + B.Z
  VAdd = Dest
End Function

Private Function VScale(src As D3DVECTOR, S As Single) As D3DVECTOR
  Dim Dest As D3DVECTOR
  Dest.X = src.X * S
  Dest.Y = src.Y * S
  Dest.Z = src.Z * S
  VScale = Dest
End Function

Private Function Vector(X, Y, Z) As D3DVECTOR

    Vector.X = X
    Vector.Y = Y
    Vector.Z = Z

End Function


Public Function ReloadTextures(ddraw As DirectDraw7, dev As Direct3DDevice7)
    On Local Error Resume Next
    Dim I As Long
    Dim TextureDesc As DDSURFACEDESC2
            
    
    'setup our texture for this particular group object
    If dev.GetDeviceGuid() = "IID_IDirect3DHALDevice" Then
        TextureDesc.lFlags = DDSD_CAPS
        TextureDesc.ddsCaps.lCaps = DDSCAPS_TEXTURE
        TextureDesc.ddsCaps.lCaps2 = DDSCAPS2_TEXTUREMANAGE
    Else
        TextureDesc.lFlags = DDSD_CAPS
        TextureDesc.ddsCaps.lCaps = DDSCAPS_TEXTURE Or DDSCAPS_SYSTEMMEMORY
        TextureDesc.ddsCaps.lCaps2 = 0
    End If
                
    For I = 0 To GroupCount - 1
        With Groups(I)
            'Set .TEXTURE = JOX.ddraw.CreateSurfaceFromFile(.TextureFileName, TextureDesc)
        End With
    Next
End Function


Sub Load_TEXURE(JOX As johna_DX7, Pindex, TEXTURE_file As String)

        With Groups(Pindex)
            Set .Texture = JOX.CreateTextureEX(TEXTURE_file, 256, 128)
        End With

End Sub

Private Function Load_GOODTEXTURE(STxFILE As String) As Boolean

Dim LON, I, J, Z
Dim ST() As String * 20
Dim SS As String * 32000
Dim S As String
Open STxFILE For Binary As 1
   LON = LOF(1)
   'ReDim ST((Int(LON - 1) / 20))
   Get 1, , SS
   
   

Close 1


If InStr(SS, "xof") < 1 And InStr(SS, "bin") < 1 Then
  Load_GOODTEXTURE = 0
  Exit Function
End If

Dim FIL() As String
Z = 1
Dim zz
zz = -1
Do While Z < Len(SS) - 1
  If InStr(Z, UCase(SS), UCase("texturefilename")) > 0 Then
     J = InStr(Z, UCase(SS), UCase("texturefilename"))
     S = Mid(SS, J + 23, 23)
     S = Check_Space(S)
     zz = zz + 1
     ReDim Preserve FIL(zz)
     FIL(zz) = S
     
     
     Z = J + 1
  Else
    Exit Do
  End If

Loop

endz:
zz = -1

For I = UBound(FIL) To 0 Step -1
   zz = zz + 1
   Groups(zz).TextureFileName = PATH_file + FIL(I)

Next I

Load_GOODTEXTURE = True

End Function


Private Function Check_Space(ST As String) As String
Dim I, J, Z
Dim S As String
Dim AL As String
AL = "abcdefghijklmnopqrstuvwxyz0123456789_."
Z = Len(ST)

For I = 1 To Z

 If (InStr(UCase(AL), UCase(Mid(ST, I, 1)))) > 0 Then
  S = S + Mid(ST, I, 1)
 Else
  Check_Space = S
  Exit Function
 End If


Next I






End Function




Private Function MakeVector(X As Single, Y As Single, Z As Single) As D3DVECTOR
    Dim v As D3DVECTOR
    v.X = X
    v.Y = Y
    v.Z = Z
    MakeVector = v
End Function




Private Sub Class_Terminate()
If UBound(Groups) > 0 Then Erase Groups

End Sub




Public Sub GETvertext(ByRef Tver() As D3DVERTEX)
Dim I
With Groups(0)

I = UBound(.VertexList)
ReDim Preserve Tver(I)
Tver = .VertexList

End With

End Sub


Public Sub GET_ObjectVERTICES(ByRef lpVert() As D3DVERTEX, lpINDICES() As Integer)

Dim I
With Groups(0)

I = UBound(.VertexList)

lpVert = .VertexList
lpINDICES = .IndexList
End With



End Sub


Public Property Get Vertext_count() As Long
Dim I As Long
I = UBound(Groups(0).VertexList())
Vertext_count = I
End Property



Public Sub GETindex(ByRef Tindex() As Integer)
Dim I
With Groups(0)

I = UBound(.IndexList)
ReDim Preserve Tindex(I)
Tindex = .IndexList

End With

End Sub

Public Property Get INDEX_count() As Long
Dim I As Long
I = UBound(Groups(0).IndexList())
INDEX_count = I
End Property




'============================================
'
'
'===================================
'*********************Transformation PARAM*****************'



Public Property Get Vscal() As D3DVECTOR
      Vscal = Xobject.Vscal
      'ComputeBOX
End Property

Public Property Let Vscal(vNew As D3DVECTOR)
      Xobject.Vscal = vNew
      ComputeBOX

End Property

Public Property Get vPosition() As D3DVECTOR
      vPosition = Xobject.vPosition
      'ComputeBOX
End Property

Public Property Let vPosition(vNew As D3DVECTOR)
      Xobject.vPosition = vNew
      ComputeBOX
End Property


Public Property Get Vrotation() As D3DVECTOR
      Vrotation = Xobject.Vrotate
      'ComputeBOX
End Property

Public Property Let Vrotation(vNew As D3DVECTOR)
      Xobject.Vrotate = vNew
      ComputeBOX
End Property

Sub Set_Position(X, Y, Z)
  Xobject.vPosition.X = X
  Xobject.vPosition.Y = Y
  Xobject.vPosition.Z = Z
  ComputeBOX
End Sub

Sub Set_Rotation(X, Y, Z)
  Xobject.Vrotate.X = X
  Xobject.Vrotate.Y = Y
  Xobject.Vrotate.Z = Z
  ComputeBOX
End Sub

Sub Set_Scale(X, Y, Z)
  Xobject.Vscal.X = X
  Xobject.Vscal.Y = Y
  Xobject.Vscal.Z = Z
  ComputeBOX
End Sub

Private Sub ComputeBOX()
  Dim I
  For I = 0 To GroupCount - 1
    With Groups(I)
       .B_BOX.Set_Rotation Xobject.Vrotate.X, Xobject.Vrotate.Y, Xobject.Vrotate.Z
       .B_BOX.Set_Scale Xobject.Vscal.X, Xobject.Vscal.Y, Xobject.Vscal.Z
       .B_BOX.Set_Position Xobject.vPosition.X, Xobject.vPosition.Y, Xobject.vPosition.Z
    End With
  Next I
  
       GLOB_BBOX.Set_Rotation Xobject.Vrotate.X, Xobject.Vrotate.Y, Xobject.Vrotate.Z
       GLOB_BBOX.Set_Scale Xobject.Vscal.X, Xobject.Vscal.Y, Xobject.Vscal.Z
       GLOB_BBOX.Set_Position Xobject.vPosition.X, Xobject.vPosition.Y, Xobject.vPosition.Z
End Sub



Public Function GETBounding_BOX(ByRef RetBox As D3DRMBOX)
    GLOB_BBOX.Get_BoundingBOX RetBox
    
End Function

Private Sub OBJECT_getBoundingBOX(lpVert() As D3DVERTEX, ByRef RetBox As D3DRMBOX)
Dim I, J, zz
Dim Vec As D3DVECTOR

' bounding box
   Dim min As D3DVECTOR
   Dim max As D3DVECTOR
   min = Vector(99999999, 999999999, 999999999)
   max = Vector(-999999999, -999999999, -999999999)
   
 I = LBound(lpVert)
 J = UBound(lpVert)
 
   
For zz = I To J
   With lpVert(zz)
       If .X > max.X Then max.X = .X
       If .Y > max.Y Then max.Y = .Y
       If .Z > max.Z Then max.Z = .Z
       If .X < min.X Then min.X = .X
       If .Y < min.Y Then min.Y = .Y
       If .Z < min.Z Then min.Z = .Z
       
      End With
Next zz
RetBox.max = max
RetBox.min = min
End Sub

Private Sub OBJECT_getGlobal_BOX(lpBOX() As D3DRMBOX, ByRef RetBox As D3DRMBOX)
Dim I, J
Dim RET As D3DRMBOX
Dim Vec As D3DRMBOX

I = LBound(lpBOX)
RET = lpBOX(I)

For J = I To UBound(lpBOX)
    Vec = lpBOX(J)
    If Vec.min.X < RET.min.X Then RET.min.X = Vec.min.X
    If Vec.min.Y < RET.min.Y Then RET.min.Y = Vec.min.Y
    If Vec.min.Z < RET.min.Z Then RET.min.Z = Vec.min.Z

    If Vec.max.X > RET.max.X Then RET.max.X = Vec.max.X
    If Vec.max.Y > RET.max.Y Then RET.max.Y = Vec.max.Y
    If Vec.max.Z > RET.max.Z Then RET.max.Z = Vec.max.Z


Next J

RetBox = RET
End Sub




Private Function CreateMatrix(RotVec As D3DVECTOR, ScalVec As D3DVECTOR, TransVec As D3DVECTOR) As D3DMATRIX

Dim CosRx As Single, CosRy As Single, CosRz As Single
Dim SinRx As Single, SinRy As Single, SinRz As Single

Dim Rx As Single, Ry As Single, Rz As Single, Sx As Single, _
Sy As Single, Sz As Single, Tx As Single, Ty As Single, tz As Single


Rx = RotVec.X
Ry = RotVec.Y
Rz = RotVec.Z

Sx = ScalVec.X
Sy = ScalVec.Y
Sz = ScalVec.Z

Tx = TransVec.X
Ty = TransVec.Y
tz = TransVec.Z

Dim Zpi
Zpi = 3.14564875441112
Dim Zrad
Zrad = Zpi / 180
Dim DXc As New DirectX7


DXc.IdentityMatrix CreateMatrix

CosRx = Cos(Rx * Zrad) 'Used 6x
CosRy = Cos(Ry * Zrad) 'Used 4x
CosRz = Cos(Rz * Zrad) 'Used 4x
SinRx = Sin(Rx * Zrad) 'Used 5x
SinRy = Sin(Ry * Zrad) 'Used 5x
SinRz = Sin(Rz * Zrad) 'Used 5x
'total of 29 trig functions
'23 trig functions cancelled out by
'this optimisation; hence the 2.6x speed increase.

With CreateMatrix
        .rc11 = (Sx * CosRy * CosRz)
        .rc12 = (Sx * CosRy * SinRz)
        .rc13 = -(Sx * SinRy)
        
        .rc21 = -(Sy * CosRx * SinRz) + (Sy * SinRx * SinRy * CosRz)
        .rc22 = (Sy * CosRx * CosRz) + (Sy * SinRx * SinRy * SinRz)
        .rc23 = (Sy * SinRx * CosRy)
        
        .rc31 = (Sz * SinRx * SinRz) + (Sz * CosRx * SinRy * CosRz)
        .rc32 = -(Sz * SinRx * CosRx) + (Sz * CosRx * SinRy * SinRz)
        .rc33 = (Sz * CosRx * CosRy)
        
        .rc41 = Tx
        .rc42 = Ty
        .rc43 = tz
        .rc44 = 1#
End With

Set DXc = Nothing
End Function


