VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cJohna_BoundingBox"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

'==================================================
'  1/02/2002
'
'  Cjohna_Bounding box class
'    for handle with AABB colision
'
'
'-3/02/2002
'  give up builtin transformation tools
'   rotate euler ect...
'
'=========================================

Option Explicit

'for translating and scaling
Private Type VerTEX_PARAM
  vPosition As D3DVECTOR
  Vscal As D3DVECTOR
  Vrotate As D3DVECTOR
  Vsize As D3DVECTOR
  Vcenter As D3DVECTOR
  vOrg As D3DVECTOR
  Radius As Single
  OrgBOX As D3DRMBOX
  OrgSize As D3DVECTOR
  TransVert() As D3DVERTEX
  StaticVert() As D3DVERTEX
  Name As String
End Type

Private OBJET As VerTEX_PARAM

'for colision Detection
Private Const X_PI = 3.13987644547878
Private Const X_RAD = X_PI / 180

Private Const EPSILON = 0.0001
Private Type IntersectTest
  T As Double
  U As Double
  v As Double
End Type

Private bBOX As D3DRMBOX
'Private Bvert() As D3DVERTEX 'for the CubeBOX

Private BoxMatrix As D3DMATRIX



Property Get Name() As String
  Name = OBJET.Name
End Property

Sub CreateBox(vBoxMin As D3DVECTOR, vBoxMax As D3DVECTOR, Optional Name As String)
  bBOX.min = vBoxMin
  bBOX.max = vBoxMax
  OBJET.Vscal = Vector(1, 1, 1)
  OBJET.OrgBOX = bBOX
  OBJET.OrgSize = VICTOR(bBOX.max.X - bBOX.min.X, bBOX.max.Y - bBOX.min.Y, bBOX.max.Z - bBOX.min.Z)
  CreateCubeEX OBJET.StaticVert, OBJET.OrgSize
  OBJET.Name = Name
  Compute
End Sub

Sub CreateBoxEX(vBOX As D3DRMBOX, Optional Name As String)
  bBOX = vBOX
  OBJET.Vscal = Vector(1, 1, 1)
  OBJET.OrgBOX = bBOX
  OBJET.OrgSize = VICTOR(bBOX.max.X - bBOX.min.X, bBOX.max.Y - bBOX.min.Y, bBOX.max.Z - bBOX.min.Z)
  CreateCubeEX OBJET.StaticVert, OBJET.OrgSize
  OBJET.Name = Name
  Compute
End Sub

Sub CreateBoxFromVertices(lpVert() As D3DVERTEX, Optional Name As String)
Dim RET As D3DRMBOX
    OBJECT_getBoundingBOX lpVert(), RET
    CreateBoxEX RET
End Sub


Sub CombineWithEX(BoxtoCombine As D3DRMBOX)

If (BoxtoCombine.max.X > bBOX.max.X) Then bBOX.max.X = BoxtoCombine.max.X
        If (BoxtoCombine.max.Y > bBOX.max.Y) Then bBOX.max.Y = BoxtoCombine.max.Y
        If (BoxtoCombine.max.Z > bBOX.max.Z) Then bBOX.max.Z = BoxtoCombine.max.Z
        If (bBOX.min.X < BoxtoCombine.min.X) Then bBOX.min.X = bBOX.min.X
        If (bBOX.min.Y < BoxtoCombine.min.Y) Then bBOX.min.Y = bBOX.min.Y
        If (bBOX.min.Z < BoxtoCombine.min.Z) Then bBOX.min.Z = bBOX.min.Z
End Sub



Sub CombineWith(Vmin As D3DVECTOR, Vmax As D3DVECTOR)
Dim BoxtoCombine As D3DRMBOX

BoxtoCombine.min = Vmin
BoxtoCombine.max = Vmax


If (BoxtoCombine.max.X > bBOX.max.X) Then bBOX.max.X = BoxtoCombine.max.X
        If (BoxtoCombine.max.Y > bBOX.max.Y) Then bBOX.max.Y = BoxtoCombine.max.Y
        If (BoxtoCombine.max.Z > bBOX.max.Z) Then bBOX.max.Z = BoxtoCombine.max.Z
        If (BoxtoCombine.max.X > bBOX.max.X) Then bBOX.max.X = BoxtoCombine.max.X
        
        If (bBOX.min.X < BoxtoCombine.min.X) Then bBOX.min.X = bBOX.min.X
        If (bBOX.min.Y < BoxtoCombine.min.Y) Then bBOX.min.Y = bBOX.min.Y
        If (bBOX.min.Z < BoxtoCombine.min.Z) Then bBOX.min.Z = bBOX.min.Z
End Sub




'Compute all parameters
Private Sub Compute3()
  
  
  BoxMatrix = GLOB.MATRIX_Scale_Rotate_MOV(OBJET.Vscal, OBJET.Vrotate, OBJET.vPosition)
  

  
  
  'BoxMatrix = CreateMatrix(OBJET.Vrotate, OBJET.Vscal, OBJET.vPosition)
  GLOB.VerTEX_MatMULTILPY OBJET.StaticVert, BoxMatrix, OBJET.TransVert
  
  'get the transfomed box
  OBJECT_getBoundingBOX OBJET.TransVert, bBOX
  
  OBJET.Radius = MAX_3(bBOX.max.X - bBOX.min.X, bBOX.max.Y - bBOX.min.Y, bBOX.max.Z - bBOX.min.Z)
  OBJET.Vcenter = Vmiddle(bBOX.max, bBOX.min)
  OBJET.Vsize = Vector(bBOX.max.X - bBOX.min.X, bBOX.max.Y - bBOX.min.Y, bBOX.max.Z - bBOX.min.Z)
  

End Sub


Sub RenDer_TransparentBOX(Engine As johna_DX7)

Engine.FX_alphaBlend_FrameTransparency 1
 Engine.OBJECT_Scale_Rotate_MovEX OBJET.Vscal, OBJET.Vrotate, OBJET.vPosition
 Engine.RenderCUBE OBJET.StaticVert
 Engine.CLearMATRIX
Engine.FX_alphaBlend_FrameTransparency 0
End Sub


'This one is Faster than the previous one
Private Sub Compute()



Dim VC(7) As D3DVECTOR
    VC(0) = VICTOR(OBJET.OrgBOX.max.X, OBJET.OrgBOX.min.Y, OBJET.OrgBOX.min.Z)
    VC(1) = VICTOR(OBJET.OrgBOX.max.X, OBJET.OrgBOX.min.Y, OBJET.OrgBOX.max.Z)
    VC(2) = VICTOR(OBJET.OrgBOX.min.X, OBJET.OrgBOX.min.Y, OBJET.OrgBOX.max.Z)
    VC(3) = VICTOR(OBJET.OrgBOX.min.X, OBJET.OrgBOX.min.Y, OBJET.OrgBOX.min.Z)
    VC(4) = VICTOR(OBJET.OrgBOX.max.X, OBJET.OrgBOX.max.Y, OBJET.OrgBOX.min.Z)
    VC(5) = VICTOR(OBJET.OrgBOX.max.X, OBJET.OrgBOX.max.Y, OBJET.OrgBOX.max.Z)
    VC(6) = VICTOR(OBJET.OrgBOX.min.X, OBJET.OrgBOX.max.Y, OBJET.OrgBOX.max.Z)
    VC(7) = VICTOR(OBJET.OrgBOX.min.X, OBJET.OrgBOX.max.Y, OBJET.OrgBOX.min.Z)


  BoxMatrix = GLOB.MATRIX_Scale_Rotate_MOV(OBJET.Vscal, OBJET.Vrotate, OBJET.vPosition)

  
 
    GLOB.VectorMatrixMultiply VC(0), VC(0), BoxMatrix
    GLOB.VectorMatrixMultiply VC(1), VC(1), BoxMatrix
    GLOB.VectorMatrixMultiply VC(2), VC(2), BoxMatrix
    GLOB.VectorMatrixMultiply VC(3), VC(3), BoxMatrix
    GLOB.VectorMatrixMultiply VC(4), VC(4), BoxMatrix
    GLOB.VectorMatrixMultiply VC(5), VC(5), BoxMatrix
    GLOB.VectorMatrixMultiply VC(6), VC(6), BoxMatrix
    GLOB.VectorMatrixMultiply VC(7), VC(7), BoxMatrix


  'K = VC(0).X
  
  'update the box
    bBOX.max.X = maxiHeight(VC(0).X, VC(1).X, VC(2).X, VC(3).X, VC(4).X, VC(5).X, VC(6).X, VC(7).X)
    bBOX.max.Y = maxiHeight(VC(0).Y, VC(1).Y, VC(2).Y, VC(3).Y, VC(4).Y, VC(5).Y, VC(6).Y, VC(7).Y)
    bBOX.max.Z = maxiHeight(VC(0).Z, VC(1).Z, VC(2).Z, VC(3).Z, VC(4).Z, VC(5).Z, VC(6).Z, VC(7).Z)

     bBOX.min.X = MiniHeight(VC(0).X, VC(1).X, VC(2).X, VC(3).X, VC(4).X, VC(5).X, VC(6).X, VC(7).X)
     bBOX.min.Y = MiniHeight(VC(0).Y, VC(1).Y, VC(2).Y, VC(3).Y, VC(4).Y, VC(5).Y, VC(6).Y, VC(7).Y)
     bBOX.min.Z = MiniHeight(VC(0).Z, VC(1).Z, VC(2).Z, VC(3).Z, VC(4).Z, VC(5).Z, VC(6).Z, VC(7).Z)

  
  OBJET.Radius = MAX_3(bBOX.max.X - bBOX.min.X, bBOX.max.Y - bBOX.min.Y, bBOX.max.Z - bBOX.min.Z) / 2
  OBJET.Vcenter = Vmiddle(bBOX.max, bBOX.min)
  OBJET.Vsize = Vector(bBOX.max.X - bBOX.min.X, bBOX.max.Y - bBOX.min.Y, bBOX.max.Z - bBOX.min.Z)
  
 
End Sub


Sub ApplyMatrix(oBjectMat As D3DMATRIX)
  'BoxMatrix = CreateMatrix(OBJET.Vrotate, OBJET.Vscal, OBJET.vPosition)
  GLOB.VerTEX_MatMULTILPY OBJET.StaticVert, oBjectMat, OBJET.TransVert
  '
  BoxMatrix = oBjectMat
  'get the transfomed box
  OBJECT_getBoundingBOX OBJET.TransVert, bBOX
  
End Sub

'Out parameters
Function Get_BoxRadius() As Single
   Get_BoxRadius = OBJET.Radius
End Function

Function Get_BoxSize() As D3DVECTOR
  Get_BoxSize = OBJET.Vsize
End Function


Function Get_BoxCenter() As D3DVECTOR
       Get_BoxCenter = OBJET.Vcenter
End Function

Function Get_Position() As D3DVECTOR
  Get_Position = OBJET.vPosition
End Function


Function Get_Rotation() As D3DVECTOR
  Get_Rotation = OBJET.Vrotate
End Function


Function Get_Scale() As D3DVECTOR
  Get_Scale = OBJET.Vscal
End Function


Function Get_BoxMatrix() As D3DMATRIX
  Get_BoxMatrix = BoxMatrix
End Function


Sub Get_BoundingSphere(ByRef RetSphereCenter As D3DVECTOR, ByRef RetRadius)
  RetSphereCenter = OBJET.Vcenter
  RetRadius = OBJET.Radius
End Sub

Sub Get_BoundingBOX(RetBox As D3DRMBOX)
   RetBox = bBOX
End Sub

Sub Get_BoundingBoxEX(ByRef BoxMIN As D3DVECTOR, BoxMAX As D3DVECTOR)
  BoxMIN = bBOX.min
   BoxMAX = bBOX.max

End Sub

'Transformations
Sub Set_Position(X, Y, Z)
  OBJET.vPosition.X = X
  OBJET.vPosition.Y = Y
  OBJET.vPosition.Z = Z
  
  
  'bBOX.min.X = 'bBOX.min.X + X
  'bBOX.min.Y = 'bBOX.min.Y + Y
  'bBOX.min.Z = 'bBOX.min.Z + Z
  
  'bBOX.max.X = 'bBOX.max.X + X
  'bBOX.max.Y = 'bBOX.max.Y + Y
  'bBOX.max.Z = 'bBOX.max.Z + Z
  
  'fill the box and sphere parameters
    Compute
End Sub

Sub Set_Rotation(X As Single, Y As Single, Z As Single)
  
  'Dim 'VC(7) As D3DVECTOR
    'VC(0) = VICTOR(bBOX.max.X, bBOX.min.Y, bBOX.min.Z)
    'VC(1) = VICTOR(bBOX.max.X, bBOX.min.Y, bBOX.max.Z)
    'VC(2) = VICTOR(bBOX.min.X, bBOX.min.Y, bBOX.max.Z)
    'VC(3) = VICTOR(bBOX.min.X, bBOX.min.Y, bBOX.min.Z)
    'VC(4) = VICTOR(bBOX.max.X, bBOX.max.Y, bBOX.min.Z)
    'VC(5) = VICTOR(bBOX.max.X, bBOX.max.Y, bBOX.max.Z)
    'VC(6) = VICTOR(bBOX.min.X, bBOX.max.Y, bBOX.max.Z)
    'VC(7) = VICTOR(bBOX.min.X, bBOX.max.Y, bBOX.min.Z)
  
  
  'Dim I
  'I = OBJET.Radius
  'For I = 0 To 7
     'VC(I) = Vector_RotateAroundVector('VC(I), X, Y, Z, OBJET.Vcenter)
  
  'Next I
  
  
  'update the box
    'bBOX.max.X = maxiHeight('VC(0).X, 'VC(1).X, 'VC(2).X, 'VC(3).X, 'VC(4).X, 'VC(5).X, 'VC(6).X, 'VC(7).X)
    'bBOX.max.Y = maxiHeight('VC(0).Y, 'VC(1).Y, 'VC(2).Y, 'VC(3).Y, 'VC(4).Y, 'VC(5).Y, 'VC(6).Y, 'VC(7).Y)
    'bBOX.max.Z = maxiHeight('VC(0).Z, 'VC(1).Z, 'VC(2).Z, 'VC(3).Z, 'VC(4).Z, 'VC(5).Z, 'VC(6).Z, 'VC(7).Z)

     'bBOX.min.X = MiniHeight('VC(0).X, 'VC(1).X, 'VC(2).X, 'VC(3).X, 'VC(4).X, 'VC(5).X, 'VC(6).X, 'VC(7).X)
     'bBOX.min.Y = MiniHeight('VC(0).Y, 'VC(1).Y, 'VC(2).Y, 'VC(3).Y, 'VC(4).Y, 'VC(5).Y, 'VC(6).Y, 'VC(7).Y)
     'bBOX.min.Z = MiniHeight('VC(0).Z, 'VC(1).Z, 'VC(2).Z, 'VC(3).Z, 'VC(4).Z, 'VC(5).Z, 'VC(6).Z, 'VC(7).Z)

  
 
  
  
  OBJET.Vrotate.X = X
  OBJET.Vrotate.Y = Y
  OBJET.Vrotate.Z = Z
  
  'fill the box and sphere parameters
    Compute
  
End Sub


 Sub Set_Scale(X, Y, Z)
  Dim Tmp As Single
  
  OBJET.Vscal.X = X
  OBJET.Vscal.Y = Y
  OBJET.Vscal.Z = Z
  
 
    'fill the box and sphere parameters
    Compute
End Sub



'===================================
'*********************Transformation PARAM*****************'



Public Property Get Vscal() As D3DVECTOR
      Vscal = OBJET.Vscal
      Compute
End Property

Public Property Let Vscal(vNew As D3DVECTOR)
      OBJET.Vscal = vNew
      Compute

End Property

Public Property Get vPosition() As D3DVECTOR
      vPosition = OBJET.vPosition
      
End Property

Public Property Let vPosition(vNew As D3DVECTOR)
      OBJET.vPosition = vNew
      Compute
End Property


Public Property Get Vrotation() As D3DVECTOR
      Vrotation = OBJET.Vrotate
      
End Property

Public Property Let Vrotation(vNew As D3DVECTOR)
      OBJET.Vrotate = vNew
      
End Property




Private Sub Set_Scale2(X, Y, Z)
  Dim Tmp As Single
  
  OBJET.Vscal.X = X
  OBJET.Vscal.Y = Y
  OBJET.Vscal.Z = Z
  
  bBOX.min.X = bBOX.min.X * X
  bBOX.min.Y = bBOX.min.Y * Y
  bBOX.min.Z = bBOX.min.Z * Z
  
  bBOX.max.X = bBOX.max.X * X
  bBOX.max.Y = bBOX.max.Y * Y
  bBOX.max.Z = bBOX.max.Z * Z
  
  
  'check for inverted values
    If (bBOX.max.X < bBOX.min.X) Then
        Tmp = bBOX.max.X
        bBOX.max.X = bBOX.min.X
        bBOX.min.X = Tmp
    End If
    
    If (bBOX.max.Y < bBOX.min.Y) Then
        Tmp = bBOX.max.Y
        bBOX.max.Y = bBOX.min.Y
        bBOX.min.Y = Tmp
    End If
    
    If (bBOX.max.Z < bBOX.min.Z) Then
        Tmp = bBOX.max.Z
        bBOX.max.Z = bBOX.min.Z
        bBOX.min.Z = Tmp
    End If
    
    'fill the box and sphere parameters
    Compute
End Sub


'Sub Apply_Matrix(TransformationMatrix As D3DMATRIX)


'first get Rotate angles






'End Sub


'Sub Apply_Quaternion(Quat As D3DRMQUATERNION)



'End Sub


'tools functions
Private Function maxiHeight(n1, n2, N3, N4, N5, N6, N7, N8)
    Dim maxi: maxi = n1
    
    If (n2 > maxi) Then maxi = n2
    If (N3 > maxi) Then maxi = N3
    If (N4 > maxi) Then maxi = N4
    If (N5 > maxi) Then maxi = N5
    If (N6 > maxi) Then maxi = N6
    If (N7 > maxi) Then maxi = N7
    If (N8 > maxi) Then maxi = N8
    maxiHeight = maxi
End Function

Private Function MiniHeight(n1, n2, N3, N4, N5, N6, N7, N8)

Dim Mini: Mini = n1

    If (n2 < Mini) Then Mini = n2
    If (N3 < Mini) Then Mini = N3
    If (N4 < Mini) Then Mini = N4
    If (N5 < Mini) Then Mini = N5
    If (N6 < Mini) Then Mini = N6
    If (N7 < Mini) Then Mini = N7
    If (N8 < Mini) Then Mini = N8
    MiniHeight = Mini

End Function


'colision Method
'tools
Private Sub SetBoundingVertex()

'Create the Bounding Cube Vextex
 'CreateCubeEX Bvert(), VICTOR(OBJET.Vsize.X, OBJET.Vsize.Y, OBJET.Vsize.Z)



End Sub



'return an array with Transformed Vertext
Public Sub Get_BoundingVertext(ByRef RetVertArray() As D3DVERTEX)
'Dim Ret() As D3DVERTEX
  'VerTEX_MatMULTILPY Bvert(), BoxMatrix, Ret()
  
  ReDim RetVertArray(LBound(OBJET.TransVert) To UBound(OBJET.TransVert))
  RetVertArray = OBJET.TransVert
End Sub


'Point intersection
Function IS_Inside(Tpoint As D3DVECTOR) As Boolean
Dim ST
ST = Name
  If (Tpoint.X >= bBOX.min.X And _
      Tpoint.X <= bBOX.max.X And _
      Tpoint.Y >= bBOX.min.Y And _
      Tpoint.Y <= bBOX.max.Y And _
      Tpoint.Z >= bBOX.min.Z And _
      Tpoint.Z <= bBOX.max.Z) Then IS_Inside = True
End Function

Function IS_InsideEX(X, Y, Z) As Boolean
  If (X >= bBOX.min.X And X <= bBOX.max.X And Y >= bBOX.min.Y And Y <= bBOX.max.Y And Z >= bBOX.min.Z And Z <= bBOX.max.Z) Then IS_InsideEX = True
End Function




'rayIntersection
Function IS_RayIntersect(RayStart As D3DVECTOR, RayEnd As D3DVECTOR) As Boolean


  '// an infinite ray would intersect the box but if it is not
  '// we must check if the ray is out side the box
  If (RayStart.X > bBOX.max.X And RayEnd.X > bBOX.max.X) Then
     IS_RayIntersect = False
     Exit Function
  End If
  If (RayStart.Y > bBOX.max.Y And RayEnd.Y > bBOX.max.Y) Then
     IS_RayIntersect = False
     Exit Function
  End If
  If (RayStart.Z > bBOX.max.Z And RayEnd.Z > bBOX.max.Z) Then
     IS_RayIntersect = False
     Exit Function
  End If
  If (RayStart.X < bBOX.min.X And RayEnd.X < bBOX.min.X) Then
     IS_RayIntersect = False
     Exit Function
  End If
  If (RayStart.Y < bBOX.min.Y And RayEnd.Y < bBOX.min.Y) Then
     IS_RayIntersect = False
     Exit Function
  End If
  If (RayStart.Z < bBOX.min.Z And RayEnd.Z < bBOX.min.Z) Then
     IS_RayIntersect = False
     Exit Function
  End If
  
    If (IS_InsideEX(RayStart.X, RayStart.Y, RayStart.Z)) Then
     IS_RayIntersect = True
     Exit Function
  End If
    If (IS_InsideEX(RayEnd.X, RayEnd.Y, RayEnd.Z)) Then
     IS_RayIntersect = True
     Exit Function
  End If
    
    
    Dim Tx, Ty, tz, Lent, Sx, Sy, Sz, Plen
    
     Tx = RayEnd.X - RayStart.X
     Ty = RayEnd.Y - RayStart.Y
     tz = RayEnd.Z - RayStart.Z

     Lent = Sqr(Tx * Tx + Ty * Ty + tz * tz)

    If (Lent = 0#) Then
      IS_RayIntersect = False
      Exit Function
    End If


     Sx = (bBOX.max.X + bBOX.min.X) / 2 - RayStart.X
     Sy = (bBOX.max.Y + bBOX.min.Y) / 2 - RayStart.Y
     Sz = (bBOX.max.Z + bBOX.min.Z) / 2 - RayStart.Z

    '// normalize t
    Tx = Tx / Lent
    Ty = Ty / Lent
    tz = tz / Lent

     Plen = Tx * Sx + Ty * Sy + tz * Sz

    '// t is the bbox center projection point on the ray
    Tx = Tx * Plen
    Ty = Ty * Plen
    tz = tz * Plen

    If (IS_InsideEX(Tx + RayStart.X, Ty + RayStart.Y, tz + RayStart.Z)) Then
       IS_RayIntersect = True
     Exit Function
  End If
    


End Function




'line intersection
Private Function IS_LineIntersect(x1min, x1max, x2min, x2max) As Boolean

If (x1min <= x2min And x2min <= x1max) Then
       IS_LineIntersect = True
     Exit Function
  End If
    If (x1min <= x2max And x2max <= x1max) Then
       IS_LineIntersect = True
     Exit Function
  End If
    If (x2min <= x1min And x1min <= x2max) Then
       IS_LineIntersect = True
     Exit Function
  End If
    If (x2min <= x1max And x1max <= x2max) Then
       IS_LineIntersect = True
     Exit Function
  End If

End Function




'Sphere bounding colision
Function IS_SphereIntersect(VphereCenter As D3DVECTOR, SphereRadius) As Boolean
    Dim smaxX, smaxY, smaxZ, sminX, sminY, sminZ
     smaxX = VphereCenter.X + SphereRadius
     smaxY = VphereCenter.Y + SphereRadius
     smaxZ = VphereCenter.Z + SphereRadius
     sminX = VphereCenter.X - SphereRadius
     sminY = VphereCenter.Y - SphereRadius
     sminZ = VphereCenter.Z - SphereRadius
    If (IS_LineIntersect(bBOX.min.X, bBOX.max.X, sminX, smaxX) And _
        IS_LineIntersect(bBOX.min.Y, bBOX.max.Y, sminY, smaxY) And _
        IS_LineIntersect(bBOX.min.Z, bBOX.max.Z, sminZ, smaxZ)) Then IS_SphereIntersect = True


End Function


'BOX BOX colision
Function IS_BoxIntersect(cBOX As D3DRMBOX) As Boolean

    If (IS_LineIntersect(bBOX.min.X, bBOX.max.X, cBOX.min.X, cBOX.max.X) And _
        IS_LineIntersect(bBOX.min.Y, bBOX.max.Y, cBOX.min.Y, cBOX.max.Y) And _
        IS_LineIntersect(bBOX.min.Z, bBOX.max.Z, cBOX.min.Z, cBOX.max.Z)) Then IS_BoxIntersect = True
    
End Function



'Box Tri Tri
Function IS_TriIntersect(p1 As D3DVECTOR, p2 As D3DVECTOR, P3 As D3DVECTOR) As Boolean
  
  If IS_Inside(p1) Then
     IS_TriIntersect = True
     Exit Function
  End If
  
   If IS_Inside(p2) Then
     IS_TriIntersect = True
     Exit Function
  End If
  
   If IS_Inside(P3) Then
     IS_TriIntersect = True
     Exit Function
  End If
  
  
End Function


Function IS_TriIntersectEX(p1 As D3DVERTEX, p2 As D3DVERTEX, P3 As D3DVERTEX) As Boolean
  
  If IS_InsideEX(p1.X, p1.Y, p1.Z) Then
     IS_TriIntersectEX = True
     Exit Function
  End If
  
If IS_InsideEX(p2.X, p2.Y, p2.Z) Then
     IS_TriIntersectEX = True
     Exit Function
  End If
  
  If IS_InsideEX(P3.X, P3.Y, P3.Z) Then
     IS_TriIntersectEX = True
     Exit Function
  End If
  
  
End Function

















Private Sub CreateCubeEX(Vertices() As D3DVERTEX, Vsize As D3DVECTOR, Optional TileX = 1, Optional TileY = 1)
     ReDim Preserve Vertices(23)
      Dim V1 As D3DVECTOR
     Dim V2 As D3DVECTOR
     Dim Sx, Sy, Sz
     Dim DX As New DirectX7
     Sx = Vsize.X
     Sy = Vsize.Y
     Sz = Vsize.Z
     
     V1 = Vector(-Sx / 2, 0, -Sz / 2)
     V2 = Vector(Sx / 2, Sy, Sz / 2)
           
    ' Create vertices describing the front face of the cube.
    DX.CreateD3DVertex V1.X, V2.Y, V1.Z, 0, 0, -1, 0, 0, Vertices(0)
    DX.CreateD3DVertex V2.X, V2.Y, V1.Z, 0, 0, -1, TileX, 0, Vertices(1)
    DX.CreateD3DVertex V1.X, V1.Y, V1.Z, 0, 0, -1, 0, TileY, Vertices(2)
    DX.CreateD3DVertex V2.X, V1.Y, V1.Z, 0, 0, -1, TileX, TileY, Vertices(3)
        
    ' Create vertices describing the back face of the cube.
    DX.CreateD3DVertex V1.X, V2.Y, V2.Z, 0, 0, 1, TileX, 0, Vertices(4)
    DX.CreateD3DVertex V1.X, V1.Y, V2.Z, 0, 0, 1, TileX, TileY, Vertices(5)
    DX.CreateD3DVertex V2.X, V2.Y, V2.Z, 0, 0, 1, 0, 0, Vertices(6)
    DX.CreateD3DVertex V2.X, V1.Y, V2.Z, 0, 0, 1, 0, TileY, Vertices(7)
        
    ' Create vertices describing the top face of the cube.
    DX.CreateD3DVertex V1.X, V2.Y, V2.Z, 0, 1, 0, 0, 0, Vertices(8)
    DX.CreateD3DVertex V2.X, V2.Y, V2.Z, 0, 1, 0, TileX, 0, Vertices(9)
    DX.CreateD3DVertex V1.X, V2.Y, V1.Z, 0, 1, 0, 0, TileY, Vertices(10)
    DX.CreateD3DVertex V2.X, V2.Y, V1.Z, 0, 1, 0, TileX, TileY, Vertices(11)
        
    ' Create vertices describing the bottom face of the cube.
    DX.CreateD3DVertex V1.X, V1.Y, V2.Z, 0, -1, 0, 0, 0, Vertices(12)
    DX.CreateD3DVertex V1.X, V1.Y, V1.Z, 0, -1, 0, 0, TileY, Vertices(13)
    DX.CreateD3DVertex V2.X, V1.Y, V2.Z, 0, -1, 0, TileX, 0, Vertices(14)
    DX.CreateD3DVertex V2.X, V1.Y, V1.Z, 0, -1, 0, TileX, TileY, Vertices(15)
        
    ' Create vertices describing the right face of the cube.
    DX.CreateD3DVertex V2.X, V2.Y, V1.Z, 1, 0, 0, 0, 0, Vertices(16)
    DX.CreateD3DVertex V2.X, V2.Y, V2.Z, 1, 0, 0, TileX, 0, Vertices(17)
    DX.CreateD3DVertex V2.X, V1.Y, V1.Z, 1, 0, 0, 0, TileY, Vertices(18)
    DX.CreateD3DVertex V2.X, V1.Y, V2.Z, 1, 0, 0, TileX, TileY, Vertices(19)
        
    ' Create vertices describing the left face of the cube.
    DX.CreateD3DVertex V1.X, V2.Y, V1.Z, -1, 0, 0, TileX, 0, Vertices(20)
    DX.CreateD3DVertex V1.X, V1.Y, V1.Z, -1, 0, 0, TileX, TileY, Vertices(21)
    DX.CreateD3DVertex V1.X, V2.Y, V2.Z, -1, 0, 0, 0, 0, Vertices(22)
    DX.CreateD3DVertex V1.X, V1.Y, V2.Z, -1, 0, 0, 0, TileY, Vertices(23)
    
    Set DX = Nothing
End Sub


Private Sub OBJECT_getBoundingBOX(lpVert() As D3DVERTEX, ByRef RetBox As D3DRMBOX)
Dim I, J, zz
Dim Vec As D3DVECTOR

' bounding box
   Dim min As D3DVECTOR
   Dim max As D3DVECTOR
   min = Vector(99999999, 999999999, 999999999)
   max = Vector(-999999999, -999999999, -999999999)
   
 I = LBound(lpVert)
 J = UBound(lpVert)
 
   
For zz = I To J
   With lpVert(zz)
       If .X > max.X Then max.X = .X
       If .Y > max.Y Then max.Y = .Y
       If .Z > max.Z Then max.Z = .Z
       If .X < min.X Then min.X = .X
       If .Y < min.Y Then min.Y = .Y
       If .Z < min.Z Then min.Z = .Z
       
      End With
Next zz
RetBox.max = max
RetBox.min = min
End Sub

