VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cMATH"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

Option Explicit
Private P_dCalculatorMatrix As D3DMATRIX
Private PIFactor As Single

Function min(V1, V2)
  If V1 < V2 Then min = V1
  If V2 < V1 Then min = V2
  If V2 = V1 Then min = V1
End Function

Function max(V1, V2)
  If V1 > V2 Then max = V1
  If V2 > V1 Then max = V2
  If V2 = V1 Then max = V1
End Function


Function MAX_3(V1, V2, V3) As Single
      MAX_3 = max(max(V1, V2), V3)
      
End Function


Public Function Vector(X, Y, Z) As D3DVECTOR

    Vector.X = X
    Vector.Y = Y
    Vector.Z = Z

End Function

Function Matrix_Create(RotVec As D3DVECTOR, ScalVec As D3DVECTOR, TransVec As D3DVECTOR) As D3DMATRIX

  Dim CosRx As Single, CosRy As Single, CosRz As Single
  Dim SinRx As Single, SinRy As Single, SinRz As Single

  Dim Rx As Single, Ry As Single, Rz As Single, Sx As Single, _
          sy As Single, Sz As Single, Tx As Single, Ty As Single, tz As Single

    Rx = RotVec.X
    Ry = RotVec.Y
    Rz = RotVec.Z

    Sx = ScalVec.X
    sy = ScalVec.Y
    Sz = ScalVec.Z

    Tx = TransVec.X
    Ty = TransVec.Y
    tz = TransVec.Z

  Dim Zpi ':( As Variant ?':( Move line to top of current Function
    Zpi = 3.14564875441112
  Dim Zrad ':( As Variant ?':( Move line to top of current Function
    Zrad = Zpi / 180
  Dim DXc As New DirectX7 ':( Move line to top of current Function

    DXc.IdentityMatrix Matrix_Create

    CosRx = Cos(Rx * Zrad) 'Used 6x
    CosRy = Cos(Ry * Zrad) 'Used 4x
    CosRz = Cos(Rz * Zrad) 'Used 4x
    SinRx = Sin(Rx * Zrad) 'Used 5x
    SinRy = Sin(Ry * Zrad) 'Used 5x
    SinRz = Sin(Rz * Zrad) 'Used 5x
    'total of 29 trig functions
    '23 trig functions cancelled out by
    'this optimisation; hence the 2.6x speed increase.

    With Matrix_Create
        .rc11 = (Sx * CosRy * CosRz)
        .rc12 = (Sx * CosRy * SinRz)
        .rc13 = -(Sx * SinRy)
        
        .rc21 = -(sy * CosRx * SinRz) + (sy * SinRx * SinRy * CosRz)
        .rc22 = (sy * CosRx * CosRz) + (sy * SinRx * SinRy * SinRz)
        .rc23 = (sy * SinRx * CosRy)
        
        .rc31 = (Sz * SinRx * SinRz) + (Sz * CosRx * SinRy * CosRz)
        .rc32 = -(Sz * SinRx * CosRx) + (Sz * CosRx * SinRy * SinRz)
        .rc33 = (Sz * CosRx * CosRy)
        
        .rc41 = Tx
        .rc42 = Ty
        .rc43 = tz
        .rc44 = 1#
    End With 'CREATEMATRIX

    Set DXc = Nothing

End Function '

Public Function VectorMatrixMultiply(vDest As D3DVECTOR, _
                                     vSrc As D3DVECTOR, _
                                     Mat As D3DMATRIX)

  Dim X, Y, Z, W ':( As Variant ?

    X = vSrc.X * Mat.rc11 + vSrc.Y * Mat.rc21 + vSrc.Z * Mat.rc31 + Mat.rc41
    Y = vSrc.X * Mat.rc12 + vSrc.Y * Mat.rc22 + vSrc.Z * Mat.rc32 + Mat.rc42
    Z = vSrc.X * Mat.rc13 + vSrc.Y * Mat.rc23 + vSrc.Z * Mat.rc33 + Mat.rc43
    W = vSrc.X * Mat.rc14 + vSrc.Y * Mat.rc24 + vSrc.Z * Mat.rc34 + Mat.rc44
    
    If Abs(W) < 0.0000000001 Then
        VectorMatrixMultiply = 0
        Exit Function '>---> Bottom
    End If

    vDest.X = X / W
    vDest.Y = Y / W
    vDest.Z = Z / W

    VectorMatrixMultiply = 1

End Function


Function VerTEX_MatMULTILPY(vert() As D3DVERTEX, MATA As D3DMATRIX, retVert() As D3DVERTEX)

Dim I, J, Z
I = LBound(vert)
J = UBound(vert)
'Dim retVert() As D3DVERTEX
ReDim Preserve retVert(I To J) As D3DVERTEX
retVert = vert
Dim VC As D3DVECTOR
For Z = I To J
    VC = VICTOR(retVert(Z).X, retVert(Z).Y, retVert(Z).Z)
    VectorMatrixMultiply VC, VC, MATA
    
    retVert(Z).X = VC.X '(retVert(Z).x * MATA.rc11) + (retVert(Z).Y * MATA.rc21) + (retVert(Z).Z * MATA.rc31) + MATA.rc41
    retVert(Z).Y = VC.Y '(retVert(Z).x * MATA.rc12) + (retVert(Z).Y * MATA.rc22) + (retVert(Z).Z * MATA.rc32) + MATA.rc42
    retVert(Z).Z = VC.Z '(retVert(Z).x * MATA.rc13) + (retVert(Z).Y * MATA.rc23) + (retVert(Z).Z * MATA.rc33) + MATA.rc43
Next Z


End Function



Public Function VDist(VA As D3DVECTOR, VB As D3DVECTOR) As Single

    VDist = Sqr((VB.X - VA.X) ^ 2 + (VB.Y - VA.Y) ^ 2 + (VB.Z - VA.Z) ^ 2)

End Function

Public Function Vsub(A As D3DVECTOR, B As D3DVECTOR) As D3DVECTOR

  Dim Dest As D3DVECTOR

    Dest.X = A.X - B.X
    Dest.Y = A.Y - B.Y
    Dest.Z = A.Z - B.Z
    Vsub = Dest

End Function

Public Function Vmiddle(VA As D3DVECTOR, VB As D3DVECTOR) As D3DVECTOR

    Vmiddle.X = (VA.X + VB.X) / 2
    Vmiddle.Y = (VA.Y + VB.Y) / 2
    Vmiddle.Z = (VA.Z + VB.Z) / 2

End Function

Public Function VAdd(A As D3DVECTOR, B As D3DVECTOR) As D3DVECTOR

  Dim Dest As D3DVECTOR

    Dest.X = A.X + B.X
    Dest.Y = A.Y + B.Y
    Dest.Z = A.Z + B.Z
    VAdd = Dest

End Function

Public Function VScale(src As D3DVECTOR, S As Single) As D3DVECTOR

  Dim Dest As D3DVECTOR

    Dest.X = src.X * S
    Dest.Y = src.Y * S
    Dest.Z = src.Z * S
    VScale = Dest

End Function

Function RetIdentityMatrix() As D3DMATRIX

  Dim RET As D3DMATRIX

    IdentityMatrix RET

End Function

'=================================
' IdentityMatrix
'=================================
Sub IdentityMatrix(Dest As D3DMATRIX)
  
    Dest.rc11 = 1
    Dest.rc12 = 0
    Dest.rc13 = 0
    Dest.rc14 = 0
    Dest.rc21 = 0
    Dest.rc22 = 1
    Dest.rc23 = 0
    Dest.rc24 = 0
    Dest.rc31 = 0
    Dest.rc32 = 0
    Dest.rc33 = 1
    Dest.rc34 = 0
    Dest.rc41 = 0
    Dest.rc42 = 0
    Dest.rc43 = 0
    Dest.rc44 = 1
  
End Sub

Public Sub Matrix_dentity(dMatrix As D3DMATRIX)

    dMatrix.rc11 = 1
    dMatrix.rc12 = 0
    dMatrix.rc13 = 0
    dMatrix.rc14 = 0
    dMatrix.rc21 = 0
    dMatrix.rc22 = 1
    dMatrix.rc23 = 0
    dMatrix.rc24 = 0
    dMatrix.rc31 = 0
    dMatrix.rc32 = 0
    dMatrix.rc33 = 1
    dMatrix.rc34 = 0
    dMatrix.rc41 = 0
    dMatrix.rc42 = 0
    dMatrix.rc43 = 0
    dMatrix.rc44 = 1

End Sub

 Function Matrix_Rotate(dSource As D3DMATRIX, ByVal nValueX As Single, ByVal nValueY As Single, ByVal nValueZ As Single) As D3DMATRIX

    ' Setup local variables ...
       Matrix_Rotate = dSource
       ' DirectX.IdentityMatrix MRotate
        Dim L_nCos As Single        ' Holds cosine value of angle
        Dim L_nSin As Single        ' Holds sine value of angle
        
    ' Do rotation around X-Axis ...
        If nValueX <> 0 Then
        
            ' Reset caluculator to identity matrix
            MIdentity P_dCalculatorMatrix
                
            ' Get angle values
            L_nCos = Cos(nValueX * PIFactor)
            L_nSin = Sin(nValueX * PIFactor)
            
            ' Add transformations
            With P_dCalculatorMatrix
                .rc22 = L_nCos
                .rc33 = L_nCos
                .rc23 = -L_nSin
                .rc32 = L_nSin
            End With
            
            ' Apply transformations
            Matrix_Rotate = MMultiply(P_dCalculatorMatrix, Matrix_Rotate)
            
        End If
    
    ' Do rotation around Y-Axis ...
        If nValueY <> 0 Then
        
            ' Reset caluculator to identity matrix
            MIdentity P_dCalculatorMatrix
            
            ' Get angle values
            L_nCos = Cos(nValueY * PIFactor)
            L_nSin = Sin(nValueY * PIFactor)
            
            ' Add transformations
            With P_dCalculatorMatrix
                .rc11 = L_nCos
                .rc33 = L_nCos
                .rc13 = L_nSin
                .rc31 = -L_nSin
            End With
            
            ' Apply transformations
            Matrix_Rotate = MMultiply(P_dCalculatorMatrix, Matrix_Rotate)
            
        End If
        
    ' Do rotation around Z-Axis ...
        If nValueZ <> 0 Then
        
            ' Reset caluculator to identity matrix
            MIdentity P_dCalculatorMatrix
            
            ' Get angle values
            L_nCos = Cos(nValueZ * PIFactor)
            L_nSin = Sin(nValueZ * PIFactor)
            
            ' Add transformations
            With P_dCalculatorMatrix
                .rc11 = L_nCos
                .rc22 = L_nCos
                .rc12 = -L_nSin
                .rc21 = L_nSin
            End With
            
            ' Apply transformations
            Matrix_Rotate = MMultiply(P_dCalculatorMatrix, Matrix_Rotate)
            
        End If
        
    ' Return result ...
     
    
End Function





' MTRANSLATE: Translates a matrix along the axis
Public Function Matrix_Translate(dSource As D3DMATRIX, ByVal nValueX As Single, ByVal nValueY As Single, ByVal nValueZ As Single) As D3DMATRIX

  ' Reset to identity matrix

    MIdentity P_dCalculatorMatrix
    
    ' Add calculations
    With P_dCalculatorMatrix
        .rc41 = nValueX
        .rc42 = nValueY
        .rc43 = nValueZ
    End With 'P_DCALCULATORMATRIX

    ' Apply transformations

    ' Return result
    Matrix_Translate = MMultiply(P_dCalculatorMatrix, dSource)
    
End Function

Public Function MTrans_EX(dSource As D3DMATRIX, Vec As D3DVECTOR) As D3DMATRIX

  ' Reset to identity matrix

    MIdentity P_dCalculatorMatrix
    
    ' Add calculations
    With P_dCalculatorMatrix
        .rc41 = Vec.X
        .rc42 = Vec.Y
        .rc43 = Vec.Z
    End With 'P_DCALCULATORMATRIX

    ' Apply transformations

    ' Return result
    MTrans_EX = MMultiply(P_dCalculatorMatrix, dSource)
    
End Function

Function MATRIX_Scale_Rotate_MOV(Vscal As D3DVECTOR, Vrot As D3DVECTOR, Vmov As D3DVECTOR) As D3DMATRIX

  Dim Matz As D3DMATRIX
  Dim ROTz As D3DMATRIX
  Dim MOVz As D3DMATRIX
  Dim TEMPz As D3DMATRIX
  Dim DX7 As New DirectX7
    DX7.IdentityMatrix Matz
    DX7.IdentityMatrix MOVz
    DX7.IdentityMatrix ROTz

    Matz = MScale(Matz, Vscal.X, Vscal.Y, Vscal.Z)
    ROTz = MRotate(ROTz, Vrot.X, Vrot.Y, Vrot.Z)
    MOVz = MTranslate(MOVz, Vmov.X, Vmov.Y, Vmov.Z)

    DX7.MatrixMultiply TEMPz, Matz, ROTz
    DX7.MatrixMultiply Matz, TEMPz, MOVz

    MATRIX_Scale_Rotate_MOV = Matz
 Set DX7 = Nothing
End Function

Public Function Matrix_Multiply(dM1 As D3DMATRIX, dM2 As D3DMATRIX) As D3DMATRIX

  Dim DX7 As New DirectX7

    ' Calculate multiply ...
    DX7.MatrixMultiply Matrix_Multiply, dM2, dM1
    Set DX7 = Nothing

End Function

' MSCALE: Scales a matrix along the axis
Public Function Matrix_Scale(dSource As D3DMATRIX, ByVal nValueX As Single, ByVal nValueY As Single, ByVal nValueZ As Single) As D3DMATRIX

  ' Reset to identity matrix

    MIdentity P_dCalculatorMatrix
    
    ' Add calculations
    With P_dCalculatorMatrix
        .rc11 = nValueX
        .rc22 = nValueY
        .rc33 = nValueZ
    End With 'P_DCALCULATORMATRIX
    
    ' Apply transformations
    
    ' Return result
    ' dSource =
    
    Matrix_Scale = MMultiply(P_dCalculatorMatrix, dSource)
    
End Function



Sub Matrix_ToQuaternion(MatFrom As D3DMATRIX, QuatTo As D3DRMQUATERNION)



 Dim tr, S
 Dim TempMat(0 To 3, 0 To 3) As Single
 Dim I, J, K
 Dim nxt(2): nxt(0) = 2: nxt(1) = 3: nxt(2) = 1
 Dim Q(3) As Single
 
 TempMat(0, 0) = MatFrom.rc11
 TempMat(0, 1) = MatFrom.rc12
 TempMat(0, 2) = MatFrom.rc13
 TempMat(0, 3) = MatFrom.rc14
 
 TempMat(1, 0) = MatFrom.rc21
 TempMat(1, 1) = MatFrom.rc22
 TempMat(1, 2) = MatFrom.rc23
 TempMat(1, 3) = MatFrom.rc24
 
 TempMat(2, 0) = MatFrom.rc31
 TempMat(2, 1) = MatFrom.rc32
 TempMat(2, 2) = MatFrom.rc33
 TempMat(2, 3) = MatFrom.rc34
 
 TempMat(3, 0) = MatFrom.rc41
 TempMat(3, 1) = MatFrom.rc42
 TempMat(3, 2) = MatFrom.rc43
 TempMat(3, 3) = MatFrom.rc44



   tr = TempMat(0, 0) + TempMat(1, 1) + TempMat(2, 2)

   If (tr > 0#) Then
   
      S = Sqr(tr + 1#)
      QuatTo.S = S / 2#
      S = 0.5 / S
      QuatTo.v.X = (TempMat(2, 1) - TempMat(1, 2)) * S
      QuatTo.v.Y = (TempMat(0, 2) - TempMat(2, 0)) * S
      QuatTo.v.Z = (TempMat(1, 0) - TempMat(0, 1)) * S
   
   Else
   
      I = 0
      
      If (TempMat(1, 1) > TempMat(0, 0)) Then _
         I = 1
   
      If (TempMat(2, 2) > TempMat(I, I)) Then _
         I = 2
   
      J = nxt(I)
      K = nxt(J)

      S = Sqr((TempMat(I, I) - (TempMat(J, J) + TempMat(K, K))) + 1#)
      
      Q(I) = S * 0.5
            
      If (S <> 0#) Then _
         S = 0.5 / S

      Q(3) = (TempMat(K, J) - TempMat(J, K)) * S
      Q(J) = (TempMat(J, I) + TempMat(I, J)) * S
      Q(K) = (TempMat(K, I) + TempMat(I, K)) * S

       QuatTo.v.X = Q(0)
       QuatTo.v.Y = Q(1)
       QuatTo.v.Z = Q(2)
       QuatTo.S = Q(3)
   End If




Erase TempMat
Erase Q
End Sub


'Quaternion Function


Sub Quaternion_Normalize(Quat As D3DRMQUATERNION)
 Dim Dot As Single
 Dot = (Quat.v.X * Quat.v.X) + (Quat.v.Y * Quat.v.Y) + (Quat.v.Z * Quat.v.Z) + (Quat.S * Quat.S)

If Dot = 0 Then
  Exit Sub
End If
Dim Scal As Single
  Scal = 1# / Sqr(Dot)
 With Quat
    .v.X = .v.X * Scal
    .v.Y = .v.Y * Scal
    .v.Z = .v.Z * Scal
    .S = .S * Scal
 End With
 
End Sub




Sub Quaternion_ToMatrix(Quat As D3DRMQUATERNION, RetMat As D3DMATRIX)

Dim wx, wy, wz, XX, yY, yz, xy, xz, zz, x2, Y2, z2

   x2 = Quat.v.X + Quat.v.X
   Y2 = Quat.v.Y + Quat.v.Y
   z2 = Quat.v.Z + Quat.v.Z

   XX = Quat.v.X * x2
   xy = Quat.v.X * Y2
   xz = Quat.v.X * z2
   yY = Quat.v.Y * Y2
   yz = Quat.v.Y * z2
   zz = Quat.v.Z * z2
   wx = Quat.S * x2
   wy = Quat.S * Y2
   wz = Quat.S * z2

   
   RetMat.rc11 = 1# - (yY + zz)
   RetMat.rc12 = xy - wz
   RetMat.rc13 = xz + wy
   RetMat.rc14 = 0#
   RetMat.rc21 = xy + wz
   RetMat.rc22 = 1# - (XX + zz)
   RetMat.rc23 = yz - wx
   RetMat.rc24 = 0#
   RetMat.rc31 = xz - wy
   RetMat.rc32 = yz + wx
   RetMat.rc33 = 1# - (XX + yY)
   RetMat.rc34 = 0#
   RetMat.rc41 = 0
   RetMat.rc42 = 0
   RetMat.rc43 = 0
   RetMat.rc44 = 1

End Sub












':) Ulli's VB Code Formatter V2.3.18 (17/10/2001 20:53:03) 0 + 291 = 291 Lines
Private Sub Class_Initialize()
 PIFactor = 3.14598745148 / 180
 
End Sub


Function DegToRad(val) As Double
       DegToRad = val * PIFactor
End Function

Function RadToDeg(val) As Double
       RadToDeg = val / PIFactor
End Function


Public Function Vrotate(v As D3DVECTOR, xA As Double, yA As Double, zA As Double) As D3DVECTOR
   Dim XPP1 As Double, YPP1 As Double, ZPP3 As Double, XPP2 As Double, ZPP2 As Double, YPP3 As Double
   Dim X                          As Double
   Dim Y                          As Double
   Dim Z                          As Double
   Dim cXA                        As Double
   Dim cYA                        As Double
   Dim cZA                        As Double
   Dim sXA                        As Double
   Dim sYA                        As Double
   Dim sZA                        As Double
   cXA = Cos(xA)
   cYA = Cos(yA)
   cZA = Cos(zA)
   sXA = Sin(xA)
   sYA = Sin(yA)
   sZA = Sin(zA)
   X = v.X
   Y = v.Y
   Z = v.Z
   XPP1 = X * cXA + Y * sXA
   YPP1 = Y * cXA - X * sXA
   XPP2 = XPP1 * cYA + Z * sYA
   ZPP2 = Z * cYA - XPP1 * sYA
   YPP3 = YPP1 * cZA - ZPP2 * sZA
   ZPP3 = ZPP2 * cZA + YPP1 * sZA
   Vrotate.X = XPP2
   Vrotate.Y = YPP3
   Vrotate.Z = ZPP3
End Function


Function VERTEXtoVEC(vert As D3DVERTEX) As D3DVECTOR
VERTEXtoVEC.X = vert.X
VERTEXtoVEC.Y = vert.Y
VERTEXtoVEC.Z = vert.Z



End Function
Function LVERTEXtoVEC(vert As D3DLVERTEX) As D3DVECTOR
LVERTEXtoVEC.X = vert.X
LVERTEXtoVEC.Y = vert.Y
LVERTEXtoVEC.Z = vert.Z



End Function

' returns the addition of 2 vectors
Function Vector_Add(A As D3DVECTOR, B As D3DVECTOR) As D3DVECTOR
Vector_Add.X = A.X + B.X
Vector_Add.Y = A.Y + B.Y
Vector_Add.Z = A.Z + B.Z
End Function

' returns the subraction of one vector from another
Function SubtractVector(A As D3DVECTOR, B As D3DVECTOR) As D3DVECTOR
SubtractVector.X = A.X - B.X
SubtractVector.Y = A.Y - B.Y
SubtractVector.Z = A.Z - B.Z
End Function

' puts the subtraction of two vectors into a destination vector
Sub Vector_Subtract(Dest As D3DVECTOR, A As D3DVECTOR, B As D3DVECTOR)
  Dest.X = A.X - B.X
  Dest.Y = A.Y - B.Y
  Dest.Z = A.Z - B.Z
End Sub




' puts the cross product of two vectors in a destination vector
Sub Vector_CrossProduct(Dest As D3DVECTOR, A As D3DVECTOR, B As D3DVECTOR)
   Dest.X = A.Y * B.Z - A.Z * B.Y
   Dest.Y = A.Z * B.X - A.X * B.Z
   Dest.Z = A.X * B.Y - A.Y * B.X
End Sub

' returns the dot product of two vectors
Function Vector_DotProduct(A As D3DVECTOR, B As D3DVECTOR) As Single
  Vector_DotProduct = A.X * B.X + A.Y * B.Y + A.Z * B.Z
End Function


'=================================
' VectorNormalize
'=================================
' creates a vector of length 1 in the same direction
'
Sub Vector_Normalize(Dest As D3DVECTOR)
  On Local Error Resume Next
  Dim L As Double
  L = Dest.X * Dest.X + Dest.Y * Dest.Y + Dest.Z * Dest.Z
  L = Sqr(L)
  If L = 0 Then
    Dest.X = 0
    Dest.Y = 0
    Dest.Z = 0
    Exit Sub
  End If
  Dest.X = Dest.X / L
  Dest.Y = Dest.Y / L
  Dest.Z = Dest.Z / L
End Sub

Function Vector_CalculateNormal(p0 As D3DVECTOR, p1 As D3DVECTOR, p2 As D3DVECTOR) As D3DVECTOR
'//0. Any variables
    Dim vNorm As D3DVECTOR
    Dim v01 As D3DVECTOR
    Dim v02 As D3DVECTOR

'//1. Subtract vectors
    
    VectorSubtract v01, p1, p0
    VectorSubtract v02, p2, p0
    
'//2. Perform Cross Product
     
    VectorCrossProduct vNorm, v01, v02

'//3. Normalize
    VectorNormalize vNorm
     
'//4. Return normal
    Vector_CalculateNormal = vNorm
End Function

Sub OBJECT_getBoundingBOX(lpVert() As D3DVERTEX, ByRef RetBox As D3DRMBOX)
Dim I, J, zz
Dim Vec As D3DVECTOR

' bounding box
   Dim min As D3DVECTOR
   Dim max As D3DVECTOR
   min = Vector(99999999, 999999999, 999999999)
   max = Vector(-999999999, -999999999, -999999999)
   
 I = LBound(lpVert)
 J = UBound(lpVert)
 
   
For zz = I To J
   With lpVert(zz)
       If .X > max.X Then max.X = .X
       If .Y > max.Y Then max.Y = .Y
       If .Z > max.Z Then max.Z = .Z
       If .X < min.X Then min.X = .X
       If .Y < min.Y Then min.Y = .Y
       If .Z < min.Z Then min.Z = .Z
       
      End With
Next zz
RetBox.max = max
RetBox.min = min
End Sub





Public Function Arcsin(X)
   Dim T
   T = X / Sqr(-X * X + 1)
   Arcsin = Atn(T)
End Function
Public Function Arccos(X)
  Arccos = Atn(-X / Sqr(-X * X + 1)) + 2 * Atn(1)

End Function

Public Function Arcsec(X)
   Arcsec = Atn(X / Sqr(X * X - 1)) + Sgn((X) - 1) * (2 * Atn(1))

End Function

Public Function Arccosec(X)
   Arccosec = Atn(X / Sqr(X * X - 1)) + (Sgn(X) - 1) * (2 * Atn(1))

End Function

Public Function Arccotan(X)
   Arccotan = Atn(X) + 2 * Atn(1)
End Function

Public Function HSin(X)
  HSin = (Exp(X) - Exp(-X)) / 2
End Function

Public Function HCos(X)
   HCos = (Exp(X) + Exp(-X)) / 2
End Function

Public Function HTan(X)
  HTan = (Exp(X) - Exp(-X)) / (Exp(X) + Exp(-X))

End Function
 
Public Function HSec(X)
   HSec = 2 / (Exp(X) + Exp(-X))
End Function

Public Function HCosec(X)
    HCosec = 2 / (Exp(X) - Exp(-X))
End Function

Public Function HCotan(X)
   HCotan = (Exp(X) + Exp(-X)) / (Exp(X) - Exp(-X))
End Function

Public Function HArcsin(X)
    HArcsin = Log(X + Sqr(X * X + 1))
End Function

Public Function HArccos(X)
  HArccos = Log(X + Sqr(X * X - 1))
End Function
Public Function HArctan(X)
   HArctan = Log((1 + X) / (1 - X)) / 2
End Function


Public Function HArcsec(X)
      HArcsec = Log((Sqr(-X * X + 1) + 1) / X)
End Function

Public Function HArccosec(X)
     HArccosec = Log((Sgn(X) * Sqr(X * X + 1) + 1) / X)
End Function

Public Function HArccotan(X)
   HArccotan = Log((X + 1) / (X - 1)) / 2
End Function

Public Function LogN(X)
    LogN = Log(X) / Log(10)
End Function




Public Function Secante(X)
    Secante = 1 / Cos(X)
End Function

Public Function Cosecante(X)
    Cosecante = 1 / Sin(X)
End Function


Public Function Cotangente(X)
  Cotangente = 1 / Tan(X)
End Function




'colision Detection
Function BOX_GetBoxCollision(Box1 As D3DRMBOX, Box2 As D3DRMBOX) As Boolean
Dim vec1 As D3DVECTOR
Dim vec2 As D3DVECTOR
Dim vec3 As D3DVECTOR
Dim vec4 As D3DVECTOR
Dim vec5 As D3DVECTOR
Dim Vec6 As D3DVECTOR

With Box2
vec1 = VICTOR(.min.X, .min.Y, .max.Z)
vec2 = VICTOR(.max.X, .min.Y, .max.Z)
vec3 = VICTOR(.min.X, .max.Y, .min.Z)
vec4 = VICTOR(.min.X, .max.Y, .max.Z)

vec5 = VICTOR(.max.X, .min.Y, .min.Z)
Vec6 = VICTOR(.max.X, .max.Y, .min.Z)

End With

If BOX_GetPointBOXCollision(Box1, Box2.max) Then
  BOX_GetBoxCollision = True
  Exit Function
ElseIf BOX_GetPointBOXCollision(Box1, Box2.min) Then
  BOX_GetBoxCollision = True
  Exit Function
ElseIf BOX_GetPointBOXCollision(Box1, vec1) Then
  BOX_GetBoxCollision = True
  Exit Function
ElseIf BOX_GetPointBOXCollision(Box1, vec2) Then
  BOX_GetBoxCollision = True
  Exit Function
ElseIf BOX_GetPointBOXCollision(Box1, vec3) Then
  BOX_GetBoxCollision = True
  Exit Function

ElseIf BOX_GetPointBOXCollision(Box1, vec4) Then
  BOX_GetBoxCollision = True
  Exit Function

ElseIf BOX_GetPointBOXCollision(Box1, vec5) Then
  BOX_GetBoxCollision = True
  Exit Function

ElseIf BOX_GetPointBOXCollision(Box1, Vec6) Then
  BOX_GetBoxCollision = True
  Exit Function
  
  
End If


End Function


Function BOX_GetPointBOXCollision(OBJbox As D3DRMBOX, Tpoint As D3DVECTOR) As Boolean

 '===============Teste de colision

If Tpoint.X > OBJbox.min.X And Tpoint.X < OBJbox.max.X And _
 Tpoint.Y > OBJbox.min.Y And Tpoint.Y < OBJbox.max.Y And _
 Tpoint.Z > OBJbox.min.Z And Tpoint.Z < OBJbox.max.Z Then _
 BOX_GetPointBOXCollision = True



End Function

