VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cJohna_Particle"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'==
'== CJohna_Particle
'== Copyright (c) 2001 John Company Inc. All rights reserved.
'==

'version 0.5 beta 4 march 2002

Private Const MAX_VB_PARTICLES = 15
Private Const JO_PI = 3.14958745741541

'==============================================================================
'== Types
'==============================================================================

Private Type PARTICLE_VERTEX
       m_vecPos As D3DVECTOR
       m_dwDiffuse As D3DCOLORVALUE
       m_vecTex As D3DVECTOR
End Type

Public Enum Johna_PARTICLE_FX_preset
  Johna_STATIC_LOCATION = &HF1
  Johna_DYNAMIC_TORNADO = &HF2
  Johna_DYNAMIC_ATOMIC = &HF3



End Enum




Private Type Joh_PARK
       Vpos As D3DVECTOR
       m_clrDiffuse As D3DCOLORVALUE ' Initial diffuse color
       m_clrFade As D3DCOLORVALUE   ' Faded diffuse color
       Speed As Single
       Is_on As Boolean
       Is_MAX As Boolean
       angle As Single
       Ray As Single
       Zdan As Single
       Vdir As D3DVECTOR
       Life As Single
End Type



Public NUM_Indices
Public NUM_VERTEX

Private Vertex(3) As D3DVERTEX
Private LVertex(3) As D3DLVERTEX
Public PARTICLE_SIZE As Single
Private Explo_Vspeed As Single

Public m_fRadius As Single
Public Max_POS As Single
Private PARTICLE_FX As Johna_PARTICLE_STYLE
Public PARTICLE_preset As Johna_PARTICLE_FX_preset

Public m_uParticles
Public m_uParticlesLim
Private pTexture As DirectDrawSurface7
Private Vorigin As D3DVECTOR
Dim Part() As Joh_PARK

Private PAL_FIRE(1 To 12) As D3DVECTOR
Private PAL_SNOW(1 To 12) As D3DVECTOR
Private PAL_Portal(1 To 12) As D3DVECTOR


Public Enum Johna_PARTICLE_STYLE
         Johna_POINT_emitting = &H2147
         Johna_EXPLOSION = &H2148
         
         Johna_SNOW = &H2150
         Johna_SMOKE = &H2151
         Johna_FONTAIN = &H2153
         Johna_FIRE = &H2154
         
         Johna_EXPLOSION_RING = &H2156
         'Johna_BOIDS = &H2157
       
End Enum

Public is_ACTIVE As Boolean


'==============================================================================
'== Types for EXPLOSION PARTICLE
'==============================================================================




Private slowdown As Single                  'higher the value, the slower particle moves
Private zoom As Single                      'zoom variable
Private xspeed As Single                    'speed in x (right) direction
Private yspeed As Single                   'speed in y (left) direction
Private zspeed As Single                   'speed in y (left) direction
Private Speed As Single                   'speed in y (left) direction
Private angle_tweak As Single
'Private col                       'current color selection

Private Type ParticleType                   'properties of one particle
    Active As Boolean                       'is this particle visible (enabled) ?
    Life As Single                          'time to live
    Fade As Single                          'brightness of this particle
    R As Single                             'particle color
        G As Single
            B As Single
   
    Vpos As D3DVECTOR 'particle position
    Vdir As D3DVECTOR 'particle direction vector
    Vgravity As D3DVECTOR 'particle gravity
    
End Type

Private Type TparticleTYP
   Partic() As ParticleType
   Vgravity As Single
   Size As Single
   COLOR As D3DCOLORVALUE
   Life As Single
   BoxWidth As Single
   BoxHeight As Single
   BoxDepht As Single
End Type

Private Type planedata
     loc As D3DVECTOR         'current location of plane
     goal As D3DVECTOR        'where the plane is going to
     Delta As D3DVECTOR       'unit vector of plane direction
     yaw As Single      'plane yaw
     pitch As Single    'plane pitch
     roll As Single     'plane roll
     dyaw As Single     'change in yaw
     Life As Single
     Fade As Single
     Speed As Single
End Type

Private PARTICLE As TparticleTYP
Private PLANZ() As planedata

'===============================================
'  other PARTICLE_preset
'
'
'
'================================================

'//---------------------------------------------------------------------------

'// TParticle
'//      Describes a single particle
Private Type TParticle


     Position  As D3DVECTOR        '// Position of particle in world-space
     OldPos  As D3DVECTOR          '// Position in last frame
     Velocity   As D3DVECTOR      '// Velocity along the three axes
     Acceleration  As D3DVECTOR    '// Acceleration along the three axes
     Age As Single                 '// Age of particle (sum of TimePassed passed to UpdateSystem)
     Size As Single                '// Size of particle
     Alive As Boolean                '// Does this particle need to be updated?
     COLOR As D3DCOLORVALUE

End Type





'//---------------------------------------------------------------------------
'//---- TParticleSystem  SNOW --------------------
'//--------------------------------------------------------------------


Private Type Tsnow
  width As Single
  DEPTH As Single
  GROUND As Single
  ALTITUDE As Single
  PARTIK() As TParticle
  Spark_size As Single
End Type



Private SNOW As Tsnow

Private GIdentityMatrix As D3DMATRIX



'//---------------------------------------------------------------------------
'//---- TParticleSystem  SMOKE --------------------
'//--------------------------------------------------------------------


Private Type Tsmoke
  Height As Single
  PARTIK() As TParticle

End Type


Private SMOKE As Tsmoke






'//---------------------------------------------------------------------------
'//---- TParticleSystem  FONTAIN --------------------
'//--------------------------------------------------------------------


Private Type Tfontain
  
  PARTIK() As TParticle
  Red As Single
  Blue As Single
  Green As Single
  Gezer_POWER As Single
  Water_SIZE As Single
End Type


Private FONTAIN As Tfontain



'//---------------------------------------------------------------------------
'//---- TParticleSystem  BLASTING --------------------
'//--------------------------------------------------------------------


Private Type Tblast
  Tcos() As Single
  Tsin() As Single
  PARTIK() As TParticle
  Velocity As Single
  Max_Extent As Single
End Type


Private BLAST As Tblast


Public Num_PARTICLE As Integer
Private M_LIGHT As D3DLIGHT7
Private LIGHTindex As Long

'entry initialised point for the particle engine


Sub Init(JOX As johna_DX7, Vpos As D3DVECTOR, TexTurefile As String, Optional NumPARTICLE As Integer = MAX_VB_PARTICLES, Optional PARTICLE_SIZ As Single = 1, Optional Jstyle As Johna_PARTICLE_STYLE = Johna_POINT_emitting, Optional ExplosionSpeed As Single = 100, Optional GROUND_LEVEL As Integer = 0, Optional WHEATER_PERIMETER_WIDTH As Integer = 200, Optional WHEATER_PERIMETER_DEPTH As Integer = 200, Optional WHEATER_MAX_ALTITUDE As Integer = 100, Optional FOUNTAIN_GEZER_POWER As Integer = 1)



m_fRadius = Rayon

Set pTexture = JOX.CreateTextureEX(TexTurefile, 16, 16)
Vorigin = Vpos


Num_PARTICLE = NumPARTICLE

Dim Vindex, IndEXX


PARTICLE_SIZE = PARTICLE_SIZ

Dim Z
Dim zA As Single
Dim Zy As Single
Randomize Timer
Dim COLP As D3DCOLORVALUE
COLP = JOX.Create_RND_D3Dcolor


If Jstyle = Johna_POINT_emitting Then
    
    For Z = 1 To Num_PARTICLE
          
          ReDim Preserve Part(1 To Z)
          
          
          Part(Z).angle = (Rnd * 360 * JO_PI) / 180
          'PART(z).Vpos = Vorigin
          'PART(z).Vpos.Y = PART(z).Vpos.Y + Zy
          Part(Z).Speed = Abs(Rnd() * 2) / 2
          Part(Z).m_clrFade = COLP
          Part(Z).m_clrDiffuse = COLP
          Part(Z).Vdir = VICTOR(Rnd * 2, Rnd * 1, Rnd * 1.5)
          Part(Z).Life = 1 * Rnd
         
          Part(Z).Vpos.X = Cos(Part(Z).angle * (2 * Part(Z).Speed) * joh_pi / 360) + Vorigin.X
          Part(Z).Vpos.Y = Sin(Part(Z).angle * (2 * Part(Z).Speed) * joh_pi / 360) + Vorigin.Y
          Part(Z).Vpos.Z = Vorigin.Z
      Next Z
    
    
ElseIf Jstyle = Johna_EXPLOSION Then
    
     INIT_EXPLOSION
ElseIf Jstyle = Johna_EXPLOSION_RING Then
     Explo_Vspeed = ExplosionSpeed
     INIT_EXPLOSION_RING
ElseIf Jstyle = Johna_BOIDS Then
     
     'Optional GROUND_LEVEL As Integer = 0, Optional WHEATER_PERIMETER_WIDTH As Integer = 200, Optional WHEATER_PERIMETER_DEPTH As Integer = 200, Optional WHEATER_MAX_ALTITUDE As Integer = 100,
     INIT_BOIDS WHEATER_PERIMETER_WIDTH, WHEATER_MAX_ALTITUDE, WHEATER_PERIMETER_DEPTH
ElseIf Jstyle = Johna_FIRE Then
    
     INIT_FIRE
  
ElseIf Jstyle = Johna_SNOW Then

  SNOW.GROUND = GROUND_LEVEL
  SNOW.DEPTH = WHEATER_PERIMETER_DEPTH * 10
  SNOW.width = WHEATER_PERIMETER_WIDTH * 10
  SNOW.ALTITUDE = WHEATER_MAX_ALTITUDE
  GIdentityMatrix = JOX.ID_Matrix
  SNOW.Spark_size = PARTICLE_SIZ
  
  INIT_SNOW Vorigin
  
ElseIf Jstyle = Johna_SMOKE Then
  GIdentityMatrix = JOX.ID_Matrix
  INIT_SMOKE Vorigin, PARTICLE_SIZ

ElseIf Jstyle = Johna_FONTAIN Then
  GIdentityMatrix = JOX.ID_Matrix
  FONTAIN.Red = 64 / 255
  FONTAIN.Green = 255 / 255
  FONTAIN.Blue = 192 / 255
  FONTAIN.Water_SIZE = PARTICLE_SIZE
  FONTAIN.Gezer_POWER = FOUNTAIN_GEZER_POWER
  INIT_FONTAIN Vorigin
  
ElseIf Jstyle = Johna_BLAST Then
  GIdentityMatrix = JOX.ID_Matrix
  INIT_BLAST Vorigin, PARTICLE_SIZ, JOX
  PARTICLE_FX = Jstyle
  PARTICLE_preset = FX_preset
  Exit Sub
End If






PARTICLE_FX = Jstyle
PARTICLE_preset = FX_preset




'======for vertices
     Dim V1 As D3DVECTOR
     Dim V2 As D3DVECTOR
     Dim Sx As Single, sy As Single, Sz As Single
     
     Sx = 2 / 2
     sy = 2 / 2
     Sz = 2 / 2
     
     V1 = VICTOR(-Sx, -sy, -Sz)
     V2 = VICTOR(Sx, sy, Sz)
           
    ' Create vertices describing the front face
    JOX.DX_7.CreateD3DLVertex V1.X, V2.Y, V1.Z, 0, 0, 0, 0, LVertex(0)
    JOX.DX_7.CreateD3DLVertex V2.X, V2.Y, V1.Z, 0, 0, 1, 0, LVertex(1)
    JOX.DX_7.CreateD3DLVertex V1.X, V1.Y, V1.Z, 0, 0, 0, 1, LVertex(2)
    JOX.DX_7.CreateD3DLVertex V2.X, V1.Y, V1.Z, 0, 0, 1, 1, LVertex(3)

   is_ACTIVE = True
   
   
   'activate light
  
   

End Sub



Private Sub INIT_EXPLOSION()
    ReDim PARTICLE.Partic(Num_PARTICLE - 1)
    Dim INDX
    
    
    For I = 0 To Num_PARTICLE - 1

    PARTICLE.Partic(I).Active = True              'set all particles to true
    PARTICLE.Partic(I).Life = 1                   'give all particles full life
    PARTICLE.Partic(I).Fade = (Rnd * 100) / 1000 + 0.003   'give random
    
    INDX = Int(I / (Num_PARTICLE / 12)) + 1
    If INDX < 0 Then INDX = 1: If INDX > 12 Then INDX = 12
    
    PARTICLE.Partic(I).R = PAL_FIRE(INDX).X
    'rainbow colors
    PARTICLE.Partic(I).G = PAL_FIRE(INDX).Y
    PARTICLE.Partic(I).B = PAL_FIRE(INDX).Z
     
     PARTICLE.COLOR.R = PAL_FIRE(INDX).X
    'rainbow colors
    PARTICLE.COLOR.G = PAL_FIRE(INDX).Y
    PARTICLE.COLOR.B = PAL_FIRE(INDX).Z
    
    PARTICLE.Partic(I).Vdir.X = ((Rnd * 50) - 26) * 10 'random speed on x-axis
    PARTICLE.Partic(I).Vdir.Y = ((Rnd * 50) - 26) * 10 'random speed on x-axis
    PARTICLE.Partic(I).Vdir.Z = ((Rnd * 50) - 26) * 10 'random speed on x-axis
    
    PARTICLE.Partic(I).Vgravity.X = 0                      'only y-gravity pulling particles down
    PARTICLE.Partic(I).Vgravity.Y = 1
    PARTICLE.Partic(I).Vgravity.Z = 0
    
    'pos
    PARTICLE.Partic(I).Vpos.X = Vorigin.X
    PARTICLE.Partic(I).Vpos.Y = Vorigin.Y
    PARTICLE.Partic(I).Vpos.Z = Vorigin.Z
    
    slowdown = 0.4                  'default values
    zoom = -40

Next I
   


End Sub





Private Sub INIT_EXPLOSION_RING()
    ReDim PARTICLE.Partic(Num_PARTICLE - 1)
    Dim INDX
    
    PARTICLE.COLOR.R = PAL_FIRE(1).X
    'rainbow colors
    PARTICLE.COLOR.G = PAL_FIRE(2).Y
    PARTICLE.COLOR.B = PAL_FIRE(3).Z
    For I = 0 To Num_PARTICLE - 1

    PARTICLE.Partic(I).Active = True              'set all particles to true
     
    With PARTICLE.Partic(I)
     Dim yaw, pitch
            Randomize Timer
            yaw = DegToRad(Rnd * 360)
            pitch = DegToRad(Rnd * 360)
            .Life = 1                                 'regenerate
            .Fade = (Rnd * 100) / 1000 + 0.003          'setting new life
            
            .Vpos.X = Vorigin.X
            .Vpos.Y = Vorigin.Y
            .Vpos.Z = Vorigin.Z
            
            .Vdir.X = Cos(pitch) * Explo_Vspeed         'setting new random speed
            .Vdir.Y = Sin(pitch) * Cos(yaw) * Explo_Vspeed
            .Vdir.Z = Sin(pitch) * Sin(yaw) * Explo_Vspeed
     End With
    slowdown = 0.4                  'default values
    zoom = -40

Next I
   


End Sub



Private Sub INIT_FIRE()
    ReDim PARTICLE.Partic(Num_PARTICLE - 1)
    Dim INDX
    
    
    For I = 0 To Num_PARTICLE - 1

    PARTICLE.Partic(I).Active = True              'set all particles to true
    PARTICLE.Partic(I).Life = 1                   'give all particles full life
    PARTICLE.Partic(I).Fade = (Rand * 100) / 7500 + 0.0075 'give random
    
    INDX = Int(I / (Num_PARTICLE / 12)) + 1
    If INDX < 0 Then INDX = 1: If INDX > 12 Then INDX = 12
    
    PARTICLE.Partic(I).R = PAL_FIRE(INDX).X
    'rainbow colors
    PARTICLE.Partic(I).G = PAL_FIRE(INDX).Y
    PARTICLE.Partic(I).B = PAL_FIRE(INDX).Z
    
    
    Dim v, Ang
    v = (Rnd * 25) ''// Speed of the particle
    Ang = (Rnd * 360) ''// Angle of the particle
    PARTICLE.Partic(I).Vgravity.X = 0                      'only y-gravity pulling particles down
    PARTICLE.Partic(I).Vgravity.Y = -Abs((3 * Rnd) + 2)
    PARTICLE.Partic(I).Vgravity.Z = 0
    PARTICLE.Partic(I).Vdir.X = Sin(angle) * v  '// Set X velocity
    PARTICLE.Partic(I).Vdir.Y = Cos(angle) * v  '// Set Y velocity
    PARTICLE.Partic(I).Vdir.Z = (((Rnd * 10) - 5) / 10) * v '// Set Z velocity

    'pos
    PARTICLE.Partic(I).Vpos.X = Vorigin.X
    PARTICLE.Partic(I).Vpos.Y = Vorigin.Y
    PARTICLE.Partic(I).Vpos.Z = Vorigin.Z
    
    slowdown = 0.4                  'default values
    zoom = -40

Next I
   


End Sub


Private Sub INIT_BOIDS(BoxW, BoxH, BoxD)
    ReDim PARTICLE.Partic(1)
    ReDim PLANZ(Num_PARTICLE - 1)

    PARTICLE.BoxWidth = BoxW
    PARTICLE.BoxHeight = BoxH
    PARTICLE.BoxDepht = BoxD
    
    
    For I = 0 To Num_PARTICLE - 1

    PARTICLE.Partic(0).Active = True              'set all particles to true
   
    INDX = Int(I / (Num_PARTICLE / 12)) + 1
    If INDX < 0 Then INDX = 1: If INDX > 12 Then INDX = 12
    
    PARTICLE.Partic(1).R = PAL_FIRE(INDX).X
    'rainbow colors
    PARTICLE.Partic(1).G = PAL_FIRE(INDX).Y
    PARTICLE.Partic(1).B = PAL_FIRE(INDX).Z
    Speed = 4
    angle_tweak = 4 / 100
    With PLANZ(I)
    Randomize Timer
        .loc.X = Vorigin.X + 0# * (Rnd() - Rnd())
        .loc.Y = Vorigin.Y + 0# * Rnd
        .loc.Z = Vorigin.Z + 0# * (Rnd() - Rnd())
        
        
        .goal.X = PARTICLE.BoxWidth / 2 * (Rnd() - Rnd())
        .goal.Y = PARTICLE.BoxHeight * Rnd
        .goal.Z = PARTICLE.BoxDepht / 2 * (Rnd() - Rnd())
        
        .Delta.X = 0
        .Delta.Y = 0
        .Delta.Z = 1
        
        .yaw = 0#
        .pitch = 0#
        .roll = 0#
        .dyaw = 0#
       .Life = 1                   'give all particles full life
       .Fade = (Rand * 100) / 7500 + 0.0075 'give random
       .Speed = Rnd * 0.05 + 0.4
    
    End With
    

Next I
   


End Sub



Private Sub INIT_SNOW(Vlocation As D3DVECTOR)


ReDim Preserve Part(Num_PARTICLE)
Vorigin = Vlocation
Dim I

ReDim SNOW.PARTIK(Num_PARTICLE - 1)


For I = 0 To Num_PARTICLE - 1


            SNOW.PARTIK(I).Position = VAdd(VICTOR((SNOW.width / 2) * (Rand), SNOW.ALTITUDE, (SNOW.DEPTH / 2) * (Rand)), Vorigin)
            SNOW.PARTIK(I).Velocity = VICTOR(Rand_S * 0.001 - 0.0005, -(Rand_S * 0.0049 + 0.0049), Rand_S * 0.001 - 0.0005)
            SNOW.PARTIK(I).Acceleration = VICTOR(0, -Abs(Rand_S), 0)
            SNOW.PARTIK(I).Size = PARTICLE_SIZE


Next I


End Sub



Private Sub INIT_SMOKE(Vlocation As D3DVECTOR, siz)



Vorigin = Vlocation
Dim I

ReDim SMOKE.PARTIK(Num_PARTICLE - 1)
SMOKE.Height = 50

For I = 0 To Num_PARTICLE - 1


            SMOKE.PARTIK(I).Position = VAdd(VICTOR(0, 0, 0), Vorigin)
            SMOKE.PARTIK(I).Velocity = VICTOR(Rand * 0.05 - 0.025, 0.2 + Rand * 0.2, Rand * 0.05 - 0.025)
            SMOKE.PARTIK(I).Size = siz


Next I


End Sub






Private Sub INIT_BLAST(Vlocation As D3DVECTOR, siz, JOX As johna_DX7)



Vorigin = Vlocation
Dim I
Dim angle
Dim RAD_angle As Single

For angle = 0 To 360
  ReDim Preserve BLAST.Tcos(angle)
  ReDim Preserve BLAST.Tsin(angle)
  
  '//convert angle to radians since the math library just doesnt
  '//seem to like to use normal degrees
   RAD_angle = angle * (3.14159 / 180)

  '//fill in the entries in the COS/SIN tables
  BLAST.Tcos(angle) = Cos(RAD_angle)
  BLAST.Tsin(angle) = Sin(RAD_angle)
Next angle

ReDim Preserve BLAST.PARTIK(Num_PARTICLE - 1)

BLAST.Max_Extent = 500

For I = 0 To Num_PARTICLE - 1


            BLAST.PARTIK(I).Position = Vorigin
            BLAST.PARTIK(I).Size = siz
            BLAST.PARTIK(I).Age = Rnd * BLAST.Max_Extent
            BLAST.PARTIK(I).Velocity = VICTOR(Rnd * 4 / 3, Rnd * 4 / 3, Rnd * 4 / 3)

Next I



'======for vertices
     Dim V1 As D3DVECTOR
     Dim V2 As D3DVECTOR
     Dim Sx As Single, sy As Single, Sz As Single
     
     Sx = siz / 2
     sy = siz / 2
     Sz = siz / 2
     
     V1 = VICTOR(-Sx, -sy, -Sz)
     V2 = VICTOR(Sx, sy, Sz)
           
    ' Create vertices describing the front face of the cube.
    JOX.DX_7.CreateD3DLVertex V1.X, V2.Y, V1.Z, 0, 0, 0, 0, LVertex(0)
    JOX.DX_7.CreateD3DLVertex V2.X, V2.Y, V1.Z, 0, 0, 1, 0, LVertex(1)
    JOX.DX_7.CreateD3DLVertex V1.X, V1.Y, V1.Z, 0, 0, 0, 1, LVertex(2)
    JOX.DX_7.CreateD3DLVertex V2.X, V1.Y, V1.Z, 0, 0, 1, 1, LVertex(3)
   is_ACTIVE = 1

End Sub







Private Sub INIT_FONTAIN(Vlocation As D3DVECTOR)



Vorigin = Vlocation
Dim I

ReDim FONTAIN.PARTIK(Num_PARTICLE - 1)


For I = 0 To Num_PARTICLE - 1


            FONTAIN.PARTIK(I).Position = VAdd(VICTOR(0, 0, 0), Vorigin)
            FONTAIN.PARTIK(I).Velocity = VICTOR(Rand * 0.3 - 0.15, 2 + Rand * 1, Rand * 0.3 - 0.15)
            FONTAIN.PARTIK(I).Acceleration = VICTOR(0, -0.2, 0)
             FONTAIN.PARTIK(I).Age = 0


Next I


End Sub










Private Function Rand_S() As Single
    Randomize Timer
    Rand_S = (Rnd * 100 Mod 1001) / 1000

End Function

Private Function Rand() As Single
   Randomize Timer
   Rand = (Rnd - Rnd)
End Function


Sub SetPosition(VecPos As D3DVECTOR)
  Vorigin = VecPos
End Sub

Sub SetPositionEX(X, Y, Z)
  Vorigin.X = X
  Vorigin.Y = Y
  Vorigin.Z = Z
  
End Sub


Sub Set_ParticleSize(Size)
  PARTICLE.Size = Size

End Sub


Sub Set_Gravity(Gforce)
  PARTICLE.Vgravity = -Gforce

End Sub

Sub Set_ParticleColor(R As Byte, G As Byte, B As Byte)
   PARTICLE.COLOR.R = R / 255
   PARTICLE.COLOR.G = G / 255
   PARTICLE.COLOR.B = B / 255
   
End Sub

Sub Set_Texture(lpTexture As DirectDrawSurface7)
 Set pTexture = lpTexture
 

End Sub


Function GetPosition() As D3DVECTOR
  GetPosition = Vorigin
End Function




Sub Render(JOX As johna_DX7)
If Not is_ACTIVE Then Exit Sub
Dim FOG As Boolean
Dim Clock As Long
Clock = JOX.D3D_DEV.GetRenderState(D3DRENDERSTATE_CULLMODE)

JOX.D3D_DEV.SetRenderState D3DRENDERSTATE_CULLMODE, D3DCULL_NONE

FOG = JOX.D3D_DEV.GetRenderState(D3DRENDERSTATE_FOGENABLE)
If FOG Then _
 JOX.D3D_DEV.SetRenderState D3DRENDERSTATE_FOGENABLE, False

If PARTICLE_FX = Johna_EXPLOSION Then
 render_EXPLOSION JOX
 GoTo LITTT
ElseIf PARTICLE_FX = Johna_EXPLOSION_RING Then
  
  render_EXPLOSION_RING JOX
 GoTo LITTT
ElseIf PARTICLE_FX = Johna_BOIDS Then
  
  render_BOIDS JOX
 GoTo LITTT
 
ElseIf PARTICLE_FX = Johna_FIRE Then
 render_FIRE JOX
 GoTo LITTT
ElseIf PARTICLE_FX = Johna_SNOW Then
  Render_SNOW JOX

ElseIf PARTICLE_FX = Johna_SMOKE Then
  Render_SMOKE JOX
  GoTo LITTT
  
ElseIf PARTICLE_FX = Johna_FONTAIN Then
  Render_FONTAIN JOX
  GoTo LITTT

ElseIf PARTICLE_FX = Johna_BLAST Then
  render_BLAST JOX
  GoTo LITTT
  
End If








'==========================================
'
' default code for johna pointing effetc
'=================================
Dim I
Dim ZDEG
Dim MTR As D3DMATERIAL7

JOX.D3D_DEV.SetTexture 0, pTexture
My_renderstate JOX

JOX.D3D_DEV.SetRenderState D3DRENDERSTATE_LIGHTING, 0
JOX.D3D_DEV.SetRenderState D3DRENDERSTATE_ZWRITEENABLE, 0

Static Zdang As Single
Dim Lindex
Lindex = 1
Dim AngleTHEta_X
Dim AngleTHEta_Y
'AngleTHEta_Y = 180
For I = 1 To Num_PARTICLE
       'orientaion des particles
        AngleTHEta_X = AngleTHEta_X + 1
        If AngleTHEta_X > 359 Then AngleTHEta_X = 0
        AngleTHEta_Y = AngleTHEta_Y + 1
        If AngleTHEta_Y > 359 Then AngleTHEta_Y = 0
        
        Part(I).Ray = Ray + Part(I).Speed
        Part(I).Zdan = Part(I).Zdan + (1 * JO_PI) / 180
        'If PART(I).Zdan > (360 * JO_PI) / 180 Then PART(I).Zdan = 0
        
        'PART(I).Vpos.x = PART(I).Vpos.x + Cos(AngleTHEta_X * 0.01745)
        'PART(I).Vpos.Y = PART(I).Vpos.Y + Sin(AngleTHEta_Y * JO_PI / 180)
        'PART(I).Vpos.z = PART(I).Vpos.z + Sin(AngleTHEta_X * 0.01745)
        Part(I).Vpos = VAdd(Part(I).Vpos, Part(I).Vdir)
        Part(I).Life = Part(I).Life - Part(I).Speed
        If Part(I).Life < 0 Then
           Part(I).Vpos = Vorigin
           Part(I).Ray = 0
           Part(I).Speed = (Abs(Rnd * 10) / 10)
          
           Part(I).Zdan = 0
           Dim v
           v = Rnd * 9 - 1
           Dim ANGZ
           ANGZ = rind * 360
           Part(I).Vdir = VICTOR(Cos(v * 0.25), Sin(AngleTHEta_Y), Sin((v * 0.5)))
           Part(I).Vpos.X = Cos(ANGZ * (2 * Part(I).Speed) * JO_PI / 360) + Vorigin.X
           Part(I).Vpos.Z = Sin(ANGZ * (2 * Part(I).Speed) * JO_PI / 360) + Vorigin.Z
           Part(I).Vpos.Y = Vorigin.Y
           Part(I).Life = Rnd * 0.5
        End If
     

    

ZDEG = JOX.CAM_angleBilBOARD
JOX.CLearMATRIX
JOX.OBJECT_Scale_Rotate_MOV PARTICLE_SIZE, PARTICLE_SIZE, PARTICLE_SIZE, 0, ZDEG, 0, Part(I).Vpos.Y, Part(I).Vpos.Y, Part(I).Vpos.Z

Dim Mat As D3DMATERIAL7
Dim COLL As D3DCOLORVALUE
COLL.R = PAL_FIRE(Lindex).X

COLL.G = PAL_FIRE(Lindex).Y
COLL.B = PAL_FIRE(Lindex).Z
COLL.A = Part(I).Life
Part(I).m_clrDiffuse = COLL


'for vertices color
Dim COL As Long

COL = JOX.DX_7.CreateColorRGBA(COLL.R, COLL.G, COLL.B, COLL.A)

            LVertex(0).COLOR = COL 'RGB(R, G, B)
                                
            
            LVertex(1).COLOR = LVertex(0).COLOR
            LVertex(2).COLOR = LVertex(0).COLOR
            LVertex(3).COLOR = LVertex(0).COLOR
            
            
            LVertex(0).specular = LVertex(0).COLOR
            LVertex(1).specular = LVertex(0).COLOR
            LVertex(2).specular = LVertex(0).COLOR
            LVertex(3).specular = LVertex(0).COLOR


Mat = JOX.Create_Material2(Part(I).m_clrDiffuse, COLL)


JOX.D3D_DEV.SetMaterial Mat

JOX.D3D_DEV.DrawPrimitive D3DPT_TRIANGLESTRIP, D3DFVF_LVERTEX, _
                                    LVertex(0), 4, D3DDP_DEFAULT
Next I



JOX.CLearMATRIX
JOX.USE_defaultMaterial
'JOX.USE_default_RENDERSTATE
JOX.D3D_DEV.SetRenderState D3DRENDERSTATE_ZWRITEENABLE, 1

Lindex = 10 'Lindex + 1
If Lindex > 12 Then Lindex = 0











LITTT:

If FOG Then _
 JOX.D3D_DEV.SetRenderState D3DRENDERSTATE_FOGENABLE, True

'restore the previous cullmode
JOX.D3D_DEV.SetRenderState D3DRENDERSTATE_CULLMODE, Clock

End Sub

















Private Sub render_EXPLOSION(JOX As johna_DX7)

Dim X As Single, Y As Single, Z As Single
Dim I As Integer
Dim COLINDEX
COLINDEX = 1

'update renderstate
JOX.D3D_DEV.SetTexture 0, pTexture
'My_renderstate JOX
JOX.D3D_DEV.SetRenderState D3DRENDERSTATE_LIGHTING, 0
JOX.D3D_DEV.SetRenderState D3DRENDERSTATE_ZWRITEENABLE, 0
Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_ALPHABLENDENABLE, True)


Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_SRCBLEND, D3DBLEND_ONE)
Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_DESTBLEND, D3DBLEND_ONE)
    
Dim ZDEG As Single
      ZDEG = JOX.CAM_angleBilBOARD

Dim Mat As D3DMATERIAL7
Dim COLL As D3DCOLORVALUE

Static Vangle As D3DVECTOR
Dim Radius '= velocity * age;
Dim magdt '= magnitude * dt;
Dim oneOverSigma '= 1.0f / stdev;
Dim inexp '= -0.5f*fsqr(oneOverSigma);
Dim outexp '= ONEOVERSQRT2PI * oneOverSigma;
Dim VC As D3DVECTOR
Dim DistFromWaveSqr
Dim radi



For I = 0 To Num_PARTICLE - 1                      'loop through all particles
    Vangle = VAdd(Vangle, VICTOR(1, 1, 1))
If Vangle.X > 360 Then Vangle.X = 0
If Vangle.Y > 360 Then Vangle.Y = 0
If Vangle.Z > 360 Then Vangle.Z = 0
    With PARTICLE.Partic(I)                                'saves a lot of writing
    
        'storing position
        X = .Vpos.X
        Y = .Vpos.Y
        Z = .Vpos.Z '+ zoom
        
        'fade the particle according to its life
        
        
        'using a triangle strip to speed up calcs,
        'use .r,.g,.b instead of 1,1,1 to create colorful stars
      
      



            
COLL.R = .R
COLL.G = .G
COLL.B = .B
COLL.A = .Life



'for vertices color
'Dim COL As Long
'Dim R, G, B
'R = Int(COLL.R * 255)
'G = Int(COLL.G * 255)
'B = Int(COLL.B * 255)
COL = JOX.DX_7.CreateColorRGBA(COLL.R, COLL.G, COLL.B, COLL.A)

            LVertex(0).COLOR = COL 'RGB(R, G, B)
                                
            
            LVertex(1).COLOR = LVertex(0).COLOR
            LVertex(2).COLOR = LVertex(0).COLOR
            LVertex(3).COLOR = LVertex(0).COLOR
            
            
            LVertex(0).specular = LVertex(0).COLOR
            LVertex(1).specular = LVertex(0).COLOR
            LVertex(2).specular = LVertex(0).COLOR
            LVertex(3).specular = LVertex(0).COLOR


Mat = JOX.Create_Material2(COLL, COLL)

'JOX.D3D_DEV.SetMaterial Mat

'JOX.CLearMATRIX
JOX.OBJECT_Scale_Rotate_MOV PARTICLE_SIZE, PARTICLE_SIZE, PARTICLE_SIZE, 0, ZDEG, 0, .Vpos.X, .Vpos.Y, .Vpos.Z

JOX.D3D_DEV.DrawPrimitive D3DPT_TRIANGLESTRIP, D3DFVF_LVERTEX, _
                                    LVertex(0), 4, D3DDP_DEFAULT
        
        'now we can beginning moving particles for next loop
        
                '.Vdir = GLOB.VectorRADtoDEG(Vangle)

        .Vpos.X = X + .Vdir.X / (slowdown * 1000)
        .Vpos.Y = Y + .Vdir.Y / (slowdown * 1000)
        .Vpos.Z = .Vpos.Z + .Vdir.Z / (slowdown * 1000)
        
        'gravity is pulling incremental speed of particle down
        .Vdir.X = .Vdir.X  '+ '.Vgravity.X
        .Vdir.Y = .Vdir.Y + PARTICLE.Vgravity
        .Vdir.Z = .Vdir.Z  '+ .Vgravity.z
        
        Radius = Abs(.Vdir.X + .Vdir.Y + .Vdir.Z) * .Life
        magdt = 0.54 * 50
        oneOverSigma = 1 / 8
         inexp = -0.5 * oneOverSigma
     outexp = (1 / 2.50662827463) * oneOverSigma
     VC = Vsub(.Vpos, Vorigin)
     radi = Sqr(Vlenght2(VC))
     DistFromWaveSqr = Sqr(Abs(Radius - radi))
     radi = Exp(DistFromWaveSqr * inexp) * outexp * 30
     .Vdir = Vmult(.Vdir, radi)
     'GLOB.VectorAddAndScale .Vdir, Rnd * 5, .Vdir, 1 / 50000, Vangle
        'reducing particles' life
        .Life = .Life - .Fade
        If .Life < 0 Then                               'particle is burned out
            Explo_Vspeed = 5
             Dim yaw, pitch
            Randomize Timer
            yaw = DegToRad(Rnd * 360)
            pitch = DegToRad(Rnd * 360)
            .Life = 1                                 'regenerate
            .Fade = (Rnd * 100) / 1000 + 0.003          'setting new life
            
            .Vpos.X = Vorigin.X
            .Vpos.Y = Vorigin.Y
            .Vpos.Z = Vorigin.Z
            
           .Vdir.X = Cos(pitch) * Explo_Vspeed         'setting new random speed
            .Vdir.Y = Sin(pitch) * Cos(yaw) * Explo_Vspeed
            .Vdir.Z = Sin(pitch) * Sin(yaw) * Explo_Vspeed
            
            .R = PARTICLE.COLOR.R
            .G = PARTICLE.COLOR.G
            .B = PARTICLE.COLOR.B
            
            
        End If
       
    End With
    
Next I

JOX.D3D_DEV.SetRenderState D3DRENDERSTATE_ZWRITEENABLE, 1
JOX.CLearMATRIX
JOX.USE_defaultMaterial
''JOX.USE_default_RENDERSTATE
Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_ALPHABLENDENABLE, False)
    Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_LIGHTING, True)
    Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_ZWRITEENABLE, 1)
    'Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_DITHERENABLE, 1)
    
    
    'Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_SRCBLEND, BLEND_SRC)
    'Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_DESTBLEND, BLEND_DST)
    

End Sub





Private Sub render_EXPLOSION2(JOX As johna_DX7)

Dim X As Single, Y As Single, Z As Single
Dim I As Integer
Dim COLINDEX
COLINDEX = 1

'update renderstate
JOX.D3D_DEV.SetTexture 0, pTexture
My_renderstate JOX
JOX.D3D_DEV.SetRenderState D3DRENDERSTATE_LIGHTING, 0
JOX.D3D_DEV.SetRenderState D3DRENDERSTATE_ZWRITEENABLE, 0
'Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_ALPHABLENDENABLE, True)


  'Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_SRCBLEND, D3DBLEND_ONE)
    'Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_DESTBLEND, D3DBLEND_ONE)
    

For I = 0 To Num_PARTICLE - 1                      'loop through all particles
    
    With PARTICLE.Partic(I)                                'saves a lot of writing
    
        'storing position
        X = .Vpos.X
        Y = .Vpos.Y
        Z = .Vpos.Z '+ zoom
        
        'fade the particle according to its life
        
        
        'using a triangle strip to speed up calcs,
        'use .r,.g,.b instead of 1,1,1 to create colorful stars
      
      
Dim ZDEG As Single
      ZDEG = JOX.CAM_angleBilBOARD

Dim Mat As D3DMATERIAL7
Dim COLL As D3DCOLORVALUE


            
COLL.R = .R
COLL.G = .G
COLL.B = .B
COLL.A = .Life



'for vertices color
'Dim COL As Long
'Dim R, G, B
'R = Int(COLL.R * 255)
'G = Int(COLL.G * 255)
'B = Int(COLL.B * 255)
COL = JOX.DX_7.CreateColorRGBA(COLL.R, COLL.G, COLL.B, COLL.A)

            LVertex(0).COLOR = COL 'RGB(R, G, B)
                                
            
            LVertex(1).COLOR = LVertex(0).COLOR
            LVertex(2).COLOR = LVertex(0).COLOR
            LVertex(3).COLOR = LVertex(0).COLOR
            
            
            LVertex(0).specular = LVertex(0).COLOR
            LVertex(1).specular = LVertex(0).COLOR
            LVertex(2).specular = LVertex(0).COLOR
            LVertex(3).specular = LVertex(0).COLOR


Mat = JOX.Create_Material2(COLL, COLL)

'JOX.D3D_DEV.SetMaterial Mat

'JOX.CLearMATRIX
JOX.OBJECT_Scale_Rotate_MOV PARTICLE_SIZE, PARTICLE_SIZE, PARTICLE_SIZE, 0, ZDEG, 0, .Vpos.X, .Vpos.Y, .Vpos.Z

JOX.D3D_DEV.DrawPrimitive D3DPT_TRIANGLESTRIP, D3DFVF_LVERTEX, _
                                    LVertex(0), 4, D3DDP_DEFAULT
        
        
        'now we can beginning moving particles for next loop
        .Vpos.X = X + .Vdir.X / (slowdown * 1000)
        .Vpos.Y = Y + .Vdir.Y / (slowdown * 1000)
        .Vpos.Z = .Vpos.Z + .Vdir.Z / (slowdown * 1000)
        
        'gravity is pulling incremental speed of particle down
        .Vdir.X = .Vdir.X '+ '.Vgravity.X
        .Vdir.Y = .Vdir.Y + PARTICLE.Vgravity
        .Vdir.Z = .Vdir.Z '+ .Vgravity.z
        
        'reducing particles' life
        .Life = .Life - .Fade
        If .Life < 0 Then                               'particle is burned out
            
            .Life = 1                                 'regenerate
            .Fade = (Rnd * 100) / 1000 + 0.003          'setting new life
            
            .Vpos.X = Vorigin.X
            .Vpos.Y = Vorigin.Y
            .Vpos.Z = Vorigin.Z
            
            .Vdir.X = xspeed + (Rnd * 60 - 32)              'setting new random speed
            .Vdir.Y = yspeed + (Rnd * 60 - 32)
            .Vdir.Z = (Rnd * 60 - 32)
            
            .R = PARTICLE.COLOR.R
            .G = PARTICLE.COLOR.G
            .B = PARTICLE.COLOR.B
            
            
        End If
        'code for individual particle changes (gravity only) goes here, but I
        'didn't implemented that, because this particle is to slow as it is now
        
    End With
    
Next I

JOX.D3D_DEV.SetRenderState D3DRENDERSTATE_ZWRITEENABLE, 1
JOX.CLearMATRIX
JOX.USE_defaultMaterial
''JOX.USE_default_RENDERSTATE
Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_ALPHABLENDENABLE, False)
    Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_LIGHTING, True)
    Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_ZWRITEENABLE, 1)
    Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_DITHERENABLE, 1)
    
    
    Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_SRCBLEND, BLEND_SRC)
    Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_DESTBLEND, BLEND_DST)
    

End Sub




Private Sub render_EXPLOSION_RING(JOX As johna_DX7)

Dim X As Single, Y As Single, Z As Single
Dim I As Integer
Dim COLINDEX
COLINDEX = 1

'update renderstate
JOX.D3D_DEV.SetTexture 0, pTexture
My_renderstate JOX
JOX.D3D_DEV.SetRenderState D3DRENDERSTATE_LIGHTING, 0
JOX.D3D_DEV.SetRenderState D3DRENDERSTATE_ZWRITEENABLE, 0
'Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_ALPHABLENDENABLE, True)


  'Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_SRCBLEND, D3DBLEND_ONE)
    'Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_DESTBLEND, D3DBLEND_ONE)
    

For I = 0 To Num_PARTICLE - 1                      'loop through all particles
    
    With PARTICLE.Partic(I)                                'saves a lot of writing
    
        'storing position
        X = .Vpos.X
        Y = .Vpos.Y
        Z = .Vpos.Z + zoom
        
        'fade the particle according to its life
        
        
        'using a triangle strip to speed up calcs,
        'use .r,.g,.b instead of 1,1,1 to create colorful stars
      
      
Dim ZDEG As Single
      ZDEG = JOX.CAM_angleBilBOARD

Dim Mat As D3DMATERIAL7
Dim COLL As D3DCOLORVALUE

COLL.R = .R
COLL.G = .G
COLL.B = .B
COLL.A = .Life
COL = JOX.DX_7.CreateColorRGBA(COLL.R, COLL.G, COLL.B, COLL.A)

            LVertex(0).COLOR = COL 'RGB(R, G, B)
                                
            
            LVertex(1).COLOR = LVertex(0).COLOR
            LVertex(2).COLOR = LVertex(0).COLOR
            LVertex(3).COLOR = LVertex(0).COLOR
            
            
            LVertex(0).specular = LVertex(0).COLOR
            LVertex(1).specular = LVertex(0).COLOR
            LVertex(2).specular = LVertex(0).COLOR
            LVertex(3).specular = LVertex(0).COLOR


Mat = JOX.Create_Material2(COLL, COLL)

'JOX.D3D_DEV.SetMaterial Mat

'JOX.CLearMATRIX
JOX.OBJECT_Scale_Rotate_MOV PARTICLE_SIZE, PARTICLE_SIZE, PARTICLE_SIZE, 0, ZDEG, 0, .Vpos.X, .Vpos.Y, .Vpos.Z

JOX.D3D_DEV.DrawPrimitive D3DPT_TRIANGLESTRIP, D3DFVF_LVERTEX, _
                                    LVertex(0), 4, D3DDP_DEFAULT
        
        
        'now we can beginning moving particles for next loop
        .Vpos.X = X + .Vdir.X / (slowdown * 1000)
        .Vpos.Y = Y + .Vdir.Y / (slowdown * 1000)
        .Vpos.Z = .Vpos.Z + .Vdir.Z / (slowdown * 1000)
        
        'gravity is pulling incremental speed of particle down
        .Vdir.X = .Vdir.X '+ .Vgravity.X
        .Vdir.Y = .Vdir.Y + PARTICLE.Vgravity
        .Vdir.Z = .Vdir.Z '+ .Vgravity.z
        
        'reducing particles' life
        .Life = .Life - .Fade
        If .Life < 0 Then                               'particle is burned out
            Dim yaw, pitch
            Randomize Timer
            yaw = DegToRad(Rnd * 360)
            pitch = DegToRad(Rnd * 360)
            .Life = 1                                 'regenerate
            .Fade = (Rnd * 100) / 1000 + 0.003          'setting new life
            
            .Vpos.X = Vorigin.X
            .Vpos.Y = Vorigin.Y
            .Vpos.Z = Vorigin.Z
            
           .Vdir.X = Cos(pitch) * Explo_Vspeed         'setting new random speed
            .Vdir.Y = Sin(pitch) * Cos(yaw) * Explo_Vspeed
            .Vdir.Z = Sin(pitch) * Sin(yaw) * Explo_Vspeed
            
            .R = PARTICLE.COLOR.R
            .G = PARTICLE.COLOR.G
            .B = PARTICLE.COLOR.B
            
            
        End If
        'code for individual particle changes (gravity only) goes here, but I
        'didn't implemented that, because this particle is to slow as it is now
        
    End With
    
Next I

JOX.D3D_DEV.SetRenderState D3DRENDERSTATE_ZWRITEENABLE, 1
JOX.CLearMATRIX
JOX.USE_defaultMaterial
''JOX.USE_default_RENDERSTATE
Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_ALPHABLENDENABLE, False)
    Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_LIGHTING, True)
    Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_ZWRITEENABLE, 1)
    Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_DITHERENABLE, 1)
    
    
    Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_SRCBLEND, BLEND_SRC)
    Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_DESTBLEND, BLEND_DST)
    

End Sub




Private Sub render_BOIDS(JOX As johna_DX7)

Dim X As Single, Y As Single, Z As Single
Dim I As Integer
Dim COLINDEX
COLINDEX = 1

'update renderstate
JOX.D3D_DEV.SetTexture 0, pTexture
My_renderstate JOX
JOX.D3D_DEV.SetRenderState D3DRENDERSTATE_LIGHTING, 0
JOX.D3D_DEV.SetRenderState D3DRENDERSTATE_ZWRITEENABLE, 0
'Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_ALPHABLENDENABLE, True)


  'Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_SRCBLEND, D3DBLEND_ONE)
    'Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_DESTBLEND, D3DBLEND_ONE)
    

For I = 0 To Num_PARTICLE - 1                      'loop through all particles
    
    With PARTICLE.Partic(0)                                'saves a lot of writing
    
        'storing position
        X = .Vpos.X
        Y = .Vpos.Y
        Z = .Vpos.Z '+ zoom
        
        'fade the particle according to its life
        
        
        'using a triangle strip to speed up calcs,
        'use .r,.g,.b instead of 1,1,1 to create colorful stars
      
      
Dim ZDEG As Single
      ZDEG = JOX.CAM_angleBilBOARD

Dim Mat As D3DMATERIAL7
Dim COLL As D3DCOLORVALUE


            
COLL.R = 0.8 '.R
COLL.G = 0.5
COLL.B = 0.8 '.B
COLL.A = PLANZ(I).Life



'for vertices color
'Dim COL As Long
'Dim R, G, B
'R = Int(COLL.R * 255)
'G = Int(COLL.G * 255)
'B = Int(COLL.B * 255)
COL = JOX.DX_7.CreateColorRGBA(COLL.R, COLL.G, COLL.B, COLL.A)

            LVertex(0).COLOR = 4564555 'COL 'RGB(R, G, B)
                                
            
            LVertex(1).COLOR = LVertex(0).COLOR
            LVertex(2).COLOR = LVertex(0).COLOR
            LVertex(3).COLOR = LVertex(0).COLOR
            
            
            LVertex(0).specular = LVertex(0).COLOR
            LVertex(1).specular = LVertex(0).COLOR
            LVertex(2).specular = LVertex(0).COLOR
            LVertex(3).specular = LVertex(0).COLOR


Mat = JOX.Create_Material2(COLL, COLL)

'JOX.D3D_DEV.SetMaterial Mat

'JOX.CLearMATRIX
JOX.OBJECT_Scale_Rotate_MOV PARTICLE_SIZE, PARTICLE_SIZE, PARTICLE_SIZE, 0, ZDEG, 0, .Vpos.X, .Vpos.Y, .Vpos.Z

JOX.D3D_DEV.DrawPrimitive D3DPT_TRIANGLESTRIP, D3DFVF_LVERTEX, _
                                    LVertex(0), 4, D3DDP_DEFAULT
        
      
    End With
    
    
    
    
    
    
    
    
 'for the planes
    
Dim Offset      As D3DVECTOR
    Dim loc         As D3DVECTOR
    Dim goal        As D3DVECTOR
    Dim Delta       As D3DVECTOR
    Dim Result      As D3DVECTOR
    Dim from        As D3DVECTOR
    Dim At          As D3DVECTOR
    Dim local_up    As D3DVECTOR
    Dim Up          As D3DVECTOR

    Dim Dot         As Single
    Dim pitch       As Single
    Dim yaw         As Single
    Dim roll        As Single
    Dim dyaw         As Single
    Dim RotZMatrix As D3DMATRIX
    Dim RotYMatrix As D3DMATRIX
    Dim RotXMatrix As D3DMATRIX
    Dim RotYXMatrix As D3DMATRIX
    Dim RotYXZMatrix As D3DMATRIX
    Dim MSCA As D3DMATRIX
    Dim transMatrix As D3DMATRIX
    
    
    
    
    
    
    
    
    
     With PLANZ(I)
            VectorCopy loc, .loc
            VectorCopy goal, .goal
            VectorCopy Delta, .Delta
            pitch = .pitch
            yaw = .yaw
            roll = .roll
            dyaw = .dyaw
        End With
        
        ' tweek orientation based on last position and goal
        Call VectorSubtract(Offset, goal, loc)
        
        
        ' first, tweak the pitch
        If (Offset.Y > 1) Then
            pitch = pitch + angle_tweak
            If (pitch > 0.8) Then pitch = 0.8
        ElseIf (Offset.Y < -1) Then
            pitch = pitch - angle_tweak
            If (pitch < -0.8) Then pitch = -0.8
        Else
            ' add damping
            pitch = pitch * 0.95
        End If

        ' now figure out yaw changes in xz plane
        Offset.Y = 0#
        Delta.Y = 0#
    
        Call VectorNormalize(Delta)
        Call VectorNormalize(Offset)
        Dot = VectorDotProduct(Offset, Delta)
        Call VectorCrossProduct(Result, Offset, Delta)
        Call VectorCopy(Offset, Result)
        
         
        Dot = ((1# - Dot) / 2#) * angle_tweak * 10#
        If (Offset.Y > 0.01) Then
            dyaw = (dyaw * 9# + Dot) * 0.1
        ElseIf (Offset.Y < 0.01) Then
            dyaw = (dyaw * 9# - Dot) * 0.1
        End If
        
        yaw = yaw + dyaw
        roll = -dyaw * 9#

        '5% chance of changing direction
        If PLANZ(I).Life < 0 Then
            Randomize Timer
            
            goal.Z = (Rnd() - Rnd()) * PARTICLE.BoxDepht / 2 'JOX.WORDL_MAX_UP.z
            Randomize Timer
            goal.X = (Rnd() - Rnd()) * PARTICLE.BoxWidth / 2 'JOX.WORDL_MAX_UP.x
            Randomize Timer
            goal.Y = Rnd * PARTICLE.BoxHeight
             PLANZ(I).Life = 1                   'give all particles full life
            PLANZ(I).Fade = (Rand * 100) / 7500 + 0.0075 'give random
            PLANZ(I).Speed = Rnd * 0.05 + 0.4
    
           
        End If

        ' build the an orientation matrix for the pplane
        Call RotateZMatrix(RotZMatrix, roll)
        Call RotateXMatrix(RotXMatrix, pitch)
        Call RotateYMatrix(RotYMatrix, yaw)
        Call MatrixMult(RotYXMatrix, RotXMatrix, RotYMatrix)
        Call MatrixMult(RotYXZMatrix, RotZMatrix, RotYXMatrix)
              
        Delta.X = RotYXZMatrix.rc31
        Delta.Y = RotYXZMatrix.rc32
        Delta.Z = RotYXZMatrix.rc33
        
                
        
        ' update position
        'LOC = 1*LOC + speed * delta
        Call VectorAddAndScale(loc, 1, loc, Speed, Delta)
        GLOB.VectorAdd loc, loc, Vorigin
   'loc = VICTOR(loc.x + Cos(roll / RAIAN) * 40, loc.y, loc.z + Sin(RAIAN) * 40)
                
                
                
        'save info back into array
        With PLANZ(I)
            VectorCopy .loc, loc
            VectorCopy .Delta, Delta
            VectorCopy .goal, goal
            
            .yaw = yaw
            .dyaw = dyaw
            .roll = roll
            .pitch = pitch
            .Life = .Life - .Fade
        End With
    
    
    
    
      PARTICLE.Partic(0).Vpos = PLANZ(I).loc
      
    
    
    
    
Next I

JOX.D3D_DEV.SetRenderState D3DRENDERSTATE_ZWRITEENABLE, 1
JOX.CLearMATRIX
JOX.USE_defaultMaterial
''JOX.USE_default_RENDERSTATE
Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_ALPHABLENDENABLE, False)
    Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_LIGHTING, True)
    Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_ZWRITEENABLE, 1)
    Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_DITHERENABLE, 1)
    
    
    Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_SRCBLEND, BLEND_SRC)
    Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_DESTBLEND, BLEND_DST)
    

End Sub





Private Sub render_FIRE(JOX As johna_DX7)

Dim X As Single, Y As Single, Z As Single
Dim I As Integer
Dim COLINDEX
COLINDEX = 1

'update renderstate
JOX.D3D_DEV.SetTexture 0, pTexture
My_renderstate JOX
JOX.D3D_DEV.SetRenderState D3DRENDERSTATE_LIGHTING, 0
JOX.D3D_DEV.SetRenderState D3DRENDERSTATE_ZWRITEENABLE, 0

    Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_SRCBLEND, D3DBLEND_ONE)
    Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_DESTBLEND, D3DBLEND_ONE)
    

For I = 0 To Num_PARTICLE - 1                      'loop through all particles
    
    With PARTICLE.Partic(I)                                'saves a lot of writing
    
        'storing position
        X = .Vpos.X
        Y = .Vpos.Y
        Z = .Vpos.Z + zoom
        
        'fade the particle according to its life
        
        
        'using a triangle strip to speed up calcs,
        'use .r,.g,.b instead of 1,1,1 to create colorful stars
      
      
Dim ZDEG As Single
      ZDEG = JOX.CAM_angleBilBOARD

Dim Mat As D3DMATERIAL7
Dim COLL As D3DCOLORVALUE


COLL.R = .R
COLL.G = .G
COLL.B = .B
COLL.A = .Life
COL = JOX.DX_7.CreateColorRGBA(COLL.R, COLL.G, COLL.B, COLL.A)

            LVertex(0).COLOR = COL 'RGB(R, G, B)
                                
            
            LVertex(1).COLOR = LVertex(0).COLOR
            LVertex(2).COLOR = LVertex(0).COLOR
            LVertex(3).COLOR = LVertex(0).COLOR
            
            
            LVertex(0).specular = LVertex(0).COLOR
            LVertex(1).specular = LVertex(0).COLOR
            LVertex(2).specular = LVertex(0).COLOR
            LVertex(3).specular = LVertex(0).COLOR


Mat = JOX.Create_Material2(COLL, COLL)


'JOX.D3D_DEV.SetMaterial Mat



JOX.CLearMATRIX
Dim TransPos As D3DVECTOR
Dim siz
siz = PARTICLE_SIZE * 2
JOX.OBJECT_Scale_Rotate_MOV siz * 2, siz, siz * 2, 0, ZDEG, 0, .Vpos.X, .Vpos.Y, .Vpos.Z
JOX.D3D_DEV.DrawPrimitive D3DPT_TRIANGLESTRIP, D3DFVF_LVERTEX, _
                                    LVertex(0), 4, D3DDP_DEFAULT
        
        
        'now we can beginning moving particles for next loop
        .Vpos.X = X + (.Vdir.X) / (10)
        .Vpos.Y = Y + (.Vdir.Y) / (10)
        .Vpos.Z = .Vpos.Z + (.Vdir.Z) / (10)
 
        
        
        'gravity is pulling incremental speed of particle down
        '.vdir.x = .vdir.x + .Vgravity.x
        .Vdir.Y = .Vdir.Y + 0.00011
        '.vdir.z = .vdir.z + .Vgravity.z
        
        'reducing particles' life
        .Life = .Life - .Fade
        If .Life < 0 Then                               'particle is burned out
                    .Life = 0.5 '// Give It New Life
            .Fade = (Rnd * 100) / 7500 + 0.0004 '// Random Fade Value
            .Vpos.X = Vorigin.X '// Center On X Axis
            .Vpos.Y = Vorigin.Y '// Center On Y Axis
            .Vpos.Z = Vorigin.Z '// Center On Z Axis
            
            Dim v, Ang
            Randomize Timer
            v = ((Rnd * 5)) + 1
            Ang = (Rnd * 360)
        
            .Vdir.X = Sin(Ang) * v
            .Vdir.Y = Cos(Ang) * v
            .Vdir.Z = ((Rnd * 10) - 5) / 5
            
        
                    
                   
            
        End If
                   
                    
        'code for individual particle changes (gravity only) goes here, but I
        'didn't implemented that, because this particle is to slow as it is now
        
    End With
    
Next I

JOX.D3D_DEV.SetRenderState D3DRENDERSTATE_ZWRITEENABLE, 1
JOX.CLearMATRIX
JOX.USE_defaultMaterial
'JOX.USE_default_RENDERSTATE

End Sub




Private Sub Render_SNOW(JOX As johna_DX7)

Dim I
Dim ZSTATE
Dim BLEND_SRC
Dim BLEND_DST

ZSTATE = JOX.D3D_DEV.GetRenderState(D3DRENDERSTATE_ZWRITEENABLE)
BLEND_SRC = JOX.D3D_DEV.GetRenderState(D3DRENDERSTATE_SRCBLEND)
BLEND_DST = JOX.D3D_DEV.GetRenderState(D3DRENDERSTATE_DESTBLEND)


'// Set render states:
   '// (We should probably save the old ones...)
    Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_ALPHABLENDENABLE, True)
    Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_SRCBLEND, D3DBLEND_ONE)
    Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_DESTBLEND, D3DBLEND_ONE)
    Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_LIGHTING, 0)
    Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_ZWRITEENABLE, 0)

   '// Store current view matrix and disable view transformation):
    Dim matViewBak As D3DMATRIX
   
    Call JOX.D3D_DEV.GetTransform(D3DTRANSFORMSTATE_VIEW, matViewBak)
    Call JOX.D3D_DEV.SetTransform(D3DTRANSFORMSTATE_VIEW, GIdentityMatrix)

   '// Disable world transformation:
    Call JOX.D3D_DEV.SetTransform(D3DTRANSFORMSTATE_WORLD, GIdentityMatrix)

   '// Set particle texture:
    Call JOX.D3D_DEV.SetTexture(0, pTexture)

     Dim TransPos As D3DVECTOR
     
     
   For I = 0 To Num_PARTICLE - 1

       
       
       
       
        SNOW.PARTIK(I).Position.X = SNOW.PARTIK(I).Position.X + SNOW.PARTIK(I).Velocity.X
        SNOW.PARTIK(I).Position.Y = SNOW.PARTIK(I).Position.Y + SNOW.PARTIK(I).Velocity.Y
        SNOW.PARTIK(I).Position.Z = SNOW.PARTIK(I).Position.Z + SNOW.PARTIK(I).Velocity.Z
        
                
        SNOW.PARTIK(I).Velocity.X = SNOW.PARTIK(I).Acceleration.X + SNOW.PARTIK(I).Velocity.X
        SNOW.PARTIK(I).Velocity.Y = SNOW.PARTIK(I).Acceleration.Y + SNOW.PARTIK(I).Velocity.Y
        SNOW.PARTIK(I).Velocity.Z = SNOW.PARTIK(I).Acceleration.Z + SNOW.PARTIK(I).Velocity.Z
        
        
        '//================================
        '  ground collision
        '
        If (SNOW.PARTIK(I).Position.Y < SNOW.GROUND) Then
        
        
            SNOW.PARTIK(I).Position = VAdd(VICTOR((SNOW.width / 2) * (Rand), SNOW.ALTITUDE, (SNOW.DEPTH / 2) * (Rand)), Vorigin)
            SNOW.PARTIK(I).Velocity = VICTOR(Rand_S * 0.001 - 0.0005, -(Rand_S * 0.0049 + 0.0049), Rand_S * 0.001 - 0.0005)
            SNOW.PARTIK(I).Acceleration = VICTOR(0, -Abs(Rand) * 10 / SNOW.ALTITUDE, 0)
            SNOW.PARTIK(I).Size = PARTICLE_SIZE
            
        
        
        End If
       
       
       
       
       
       
       
       '// Transform particle position (apply stored view matrix):
       Call VectorMatrixMultiply(TransPos, SNOW.PARTIK(I).Position, matViewBak)

       '// Set up billboard of specified size:
        
        LVertex(0) = retLvertex(VAdd(TransPos, VICTOR(-1# * SNOW.PARTIK(I).Size, 1# * SNOW.PARTIK(I).Size, 0#)), _
            &HE0FFFFFF, &HFFFFFFFF, 0#, 0#)
        LVertex(1) = retLvertex(VAdd(TransPos, VICTOR(1# * SNOW.PARTIK(I).Size, 1# * SNOW.PARTIK(I).Size, 0#)), _
            &HE0FFFFFF, &HFFFFFFFF, 1#, 0#)
        LVertex(2) = retLvertex(VAdd(TransPos, VICTOR(-1# * SNOW.PARTIK(I).Size, -1# * SNOW.PARTIK(I).Size, 0#)), _
            &HE0FFFFFF, &HFFFFFFFF, 0#, 1#)
        LVertex(3) = retLvertex(VAdd(TransPos, VICTOR(1# * SNOW.PARTIK(I).Size, -1# * SNOW.PARTIK(I).Size, 0#)), _
            &HE0FFFFFF, &HFFFFFFFF, 1#, 1#)

       '// Draw the shape:
         Call JOX.D3D_DEV.DrawPrimitive(D3DPT_TRIANGLESTRIP, D3DFVF_LVERTEX, LVertex(0), 4, D3DDP_DEFAULT)
 Next I

   '// Reset render states and view matrix:
    'Call JOX.D3D_DEV.SetTexture(0, Nothing)
    Call JOX.D3D_DEV.SetTransform(D3DTRANSFORMSTATE_VIEW, matViewBak)
    Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_ALPHABLENDENABLE, False)
    Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_LIGHTING, True)
    Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_ZWRITEENABLE, ZSTATE)
    
    
    'Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_SRCBLEND, BLEND_SRC)
    'Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_DESTBLEND, BLEND_DST)
    
    
    
    'JOX.Disable_MULTITEXTURING 0
    'JOX.USE_default_RENDERSTATE
    
    
    
    




End Sub







Private Sub Render_SMOKE(JOX As johna_DX7)

Dim I
Dim ZSTATE
Dim BLEND_SRC
Dim BLEND_DST

'JOX.USE_default_RENDERSTATE
'JOX.USE_defaultMaterial
'// Set particle texture:
    Call JOX.D3D_DEV.SetTexture(0, pTexture)
'My_renderstate JOX
ZSTATE = JOX.D3D_DEV.GetRenderState(D3DRENDERSTATE_ZWRITEENABLE)
BLEND_SRC = JOX.D3D_DEV.GetRenderState(D3DRENDERSTATE_SRCBLEND)
BLEND_DST = JOX.D3D_DEV.GetRenderState(D3DRENDERSTATE_DESTBLEND)


'// Set render states:
   Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_ALPHABLENDENABLE, True)
    'for black smoke
    
        Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_DESTBLEND, D3DBLEND_ONE)

    'Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_SRCBLEND, D3DBLEND_ZERO)
    Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_DESTBLEND, D3DBLEND_INVSRCCOLOR)
    Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_LIGHTING, False)
    Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_ZWRITEENABLE, False)
   '// Store current view matrix and disable view transformation):
    Dim matViewBak As D3DMATRIX
   
    Call JOX.D3D_DEV.GetTransform(D3DTRANSFORMSTATE_VIEW, matViewBak)
    Call JOX.D3D_DEV.SetTransform(D3DTRANSFORMSTATE_VIEW, GIdentityMatrix)

   '// Disable world transformation:
    Call JOX.D3D_DEV.SetTransform(D3DTRANSFORMSTATE_WORLD, GIdentityMatrix)

   

     Dim TransPos As D3DVECTOR
     Dim alpha As Single
     
     
   For I = 0 To Num_PARTICLE - 1

       
       
       
       
        SMOKE.PARTIK(I).Position.X = SMOKE.PARTIK(I).Position.X + SMOKE.PARTIK(I).Velocity.X + Vorigin.X
        SMOKE.PARTIK(I).Position.Y = SMOKE.PARTIK(I).Position.Y + SMOKE.PARTIK(I).Velocity.Y + Vorigin.Y
        SMOKE.PARTIK(I).Position.Z = SMOKE.PARTIK(I).Position.Z + SMOKE.PARTIK(I).Velocity.Z + Vorigin.Z
        
        
        

                
        SMOKE.PARTIK(I).Velocity.X = SMOKE.PARTIK(I).Acceleration.X + SMOKE.PARTIK(I).Velocity.X
        'SMOKE.PARTIK(I).Velocity.Y = SMOKE.PARTIK(I).Acceleration.Y + SMOKE.PARTIK(I).Velocity.Y
        'SMOKE.PARTIK(I).Velocity.Z = SMOKE.PARTIK(I).Acceleration.Z + SMOKE.PARTIK(I).Velocity.Z
        
        
        '//================================
        '  Maximum Height for smoke
        '
        If (SMOKE.PARTIK(I).Position.Y > SMOKE.Height + Vorigin.Y) Then
        
            
            SMOKE.PARTIK(I).Position.X = VAdd(VICTOR(0, 0, 0), Vorigin).X
            SMOKE.PARTIK(I).Position.Y = VAdd(VICTOR(0, 0, 0), Vorigin).Y
            SMOKE.PARTIK(I).Position.Z = VAdd(VICTOR(0, 0, 0), Vorigin).Z
            
            Dim SPE
            SPE = 1 / 1
            SMOKE.PARTIK(I).Velocity = VICTOR((Rand * 0.5 - 0.25) * SPE, (2 + Rand * 2) * SPE, (Rand * 0.5 - 0.25) * SPE)
            
        
        
        End If
       
        SMOKE.PARTIK(I).Size = 3.5 / SMOKE.Height * (SMOKE.PARTIK(I).Position.Y - Vorigin.Y) + 1.5
       SMOKE.PARTIK(I).Size = SMOKE.PARTIK(I).Size * 5
       
       
       
       
       '// Transform particle position (apply stored view matrix):
       Call VectorMatrixMultiply(TransPos, SMOKE.PARTIK(I).Position, matViewBak)


       '//color calculus
        alpha = 255 - (255# / SMOKE.Height * (SMOKE.PARTIK(I).Position.Y - Vorigin.Y))
        'ALPHA = 120
        alpha = (alpha * 1 / 255) '* 1 / 6
        Dim KOLA As Long
        KOLA = JOX.DX_7.CreateColorRGBA(alpha, alpha, alpha, 0.1)

       '// Set up billboard of specified size:
        
        LVertex(0) = retLvertex(VAdd(TransPos, VICTOR(-1# * SMOKE.PARTIK(I).Size, 1# * SMOKE.PARTIK(I).Size, 0#)), _
            KOLA, 0, 0#, 0#)
        LVertex(1) = retLvertex(VAdd(TransPos, VICTOR(1# * SMOKE.PARTIK(I).Size, 1# * SMOKE.PARTIK(I).Size, 0#)), _
            KOLA, 0, 1#, 0#)
        LVertex(2) = retLvertex(VAdd(TransPos, VICTOR(-1# * SMOKE.PARTIK(I).Size, -1# * SMOKE.PARTIK(I).Size, 0#)), _
            KOLA, 0, 0#, 1#)
        LVertex(3) = retLvertex(VAdd(TransPos, VICTOR(1# * SMOKE.PARTIK(I).Size, -1# * SMOKE.PARTIK(I).Size, 0#)), _
            KOLA, 0, 1#, 1#)
      
'JOX.CLearMATRIX
'JOX.OBJECT_Scale_Rotate_MOV SMOKE.PARTIK(I).Size, SMOKE.PARTIK(I).Size, SMOKE.PARTIK(I).Size, 0, ZDEG, 0, .Vpos.x, .Vpos.y, .Vpos.z


'for vertices color
Dim COL As Long
Dim R, G, B
R = alpha
G = alpha
B = alpha
COL = JOX.DX_7.CreateColorRGBA(R, G, B, 1)

            LVertex(0).COLOR = COL 'RGB(R, G, B)
                                
            
            LVertex(1).COLOR = LVertex(0).COLOR
            LVertex(2).COLOR = LVertex(0).COLOR
            LVertex(3).COLOR = LVertex(0).COLOR
            
            
            LVertex(0).specular = LVertex(0).COLOR
            LVertex(1).specular = LVertex(0).COLOR
            LVertex(2).specular = LVertex(0).COLOR
            LVertex(3).specular = LVertex(0).COLOR





'JOX.D3D_DEV.DrawPrimitive D3DPT_TRIANGLESTRIP, D3DFVF_LVERTEX, _
                                    LVertex(0), 4, D3DDP_DEFAULT



       '// Draw the shape:
         Call JOX.D3D_DEV.DrawPrimitive(D3DPT_TRIANGLESTRIP, D3DFVF_LVERTEX, LVertex(0), 4, D3DDP_DEFAULT)
 Next I

   '// Reset render states and view matrix:
    'Call JOX.D3D_DEV.SetTexture(0, Nothing)
    Call JOX.D3D_DEV.SetTransform(D3DTRANSFORMSTATE_VIEW, matViewBak)
    Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_ALPHABLENDENABLE, False)
    Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_LIGHTING, True)
    Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_ZWRITEENABLE, ZSTATE)
    'Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_DITHERENABLE, 1)
    
    
    Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_SRCBLEND, BLEND_SRC)
    Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_DESTBLEND, BLEND_DST)
    
    
    
    'JOX.Disable_MULTITEXTURING 0
    'JOX.USE_default_RENDERSTATE
    JOX.CLearMATRIX
End Sub







Private Sub Render_FONTAIN(JOX As johna_DX7)

Dim I
Dim ZSTATE
Dim BLEND_SRC
Dim BLEND_DST

'JOX.USE_default_RENDERSTATE
'My_renderstate JOX
ZSTATE = JOX.D3D_DEV.GetRenderState(D3DRENDERSTATE_ZWRITEENABLE)
BLEND_SRC = JOX.D3D_DEV.GetRenderState(D3DRENDERSTATE_SRCBLEND)
BLEND_DST = JOX.D3D_DEV.GetRenderState(D3DRENDERSTATE_DESTBLEND)


'// Set render states:
   '// (We should probably save the old ones...)
    Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_ALPHABLENDENABLE, True)
    'Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_SRCBLEND, D3DBLEND_SRCALPHA)
    'Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_DESTBLEND, D3DBLEND_INVSRCALPHA)
   
    Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_SRCBLEND, D3DBLEND_ONE)
    Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_DESTBLEND, D3DBLEND_ONE)
    
    Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_LIGHTING, 0)
    Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_ZWRITEENABLE, False)
   '// Store current view matrix and disable view transformation):
    Dim matViewBak As D3DMATRIX
   
    Call JOX.D3D_DEV.GetTransform(D3DTRANSFORMSTATE_VIEW, matViewBak)
    Call JOX.D3D_DEV.SetTransform(D3DTRANSFORMSTATE_VIEW, GIdentityMatrix)





   '// Disable world transformation:
    Call JOX.D3D_DEV.SetTransform(D3DTRANSFORMSTATE_WORLD, GIdentityMatrix)

   '// Set particle texture:
    Call JOX.D3D_DEV.SetTexture(0, pTexture)

     Dim TransPos As D3DVECTOR
     Dim alpha As Single
     Dim fALPHA As Single
     
   For I = 0 To Num_PARTICLE - 1

       
       
       
       
        FONTAIN.PARTIK(I).Position.X = FONTAIN.PARTIK(I).Position.X + FONTAIN.PARTIK(I).Velocity.X
        FONTAIN.PARTIK(I).Position.Y = FONTAIN.PARTIK(I).Position.Y + FONTAIN.PARTIK(I).Velocity.Y
        FONTAIN.PARTIK(I).Position.Z = FONTAIN.PARTIK(I).Position.Z + FONTAIN.PARTIK(I).Velocity.Z
        
                
        FONTAIN.PARTIK(I).Velocity.X = FONTAIN.PARTIK(I).Acceleration.X + FONTAIN.PARTIK(I).Velocity.X
        FONTAIN.PARTIK(I).Velocity.Y = FONTAIN.PARTIK(I).Acceleration.Y + FONTAIN.PARTIK(I).Velocity.Y
        FONTAIN.PARTIK(I).Velocity.Z = FONTAIN.PARTIK(I).Acceleration.Z + FONTAIN.PARTIK(I).Velocity.Z
        
        
        '//================================
        '  ground collision
        '
        If (FONTAIN.PARTIK(I).Position.Y < 0) Or FONTAIN.PARTIK(I).Age > 2000 Then
        
            FONTAIN.PARTIK(I).Position = VAdd(VICTOR(0, 0, 0), Vorigin)
            FONTAIN.PARTIK(I).Velocity = VICTOR(Rand * 0.3 - 0.15, 2 + Rand * 1, Rand * 0.3 - 0.15)
            FONTAIN.PARTIK(I).Acceleration = VICTOR(0, -0.08 * (1 / FONTAIN.Gezer_POWER), 0)
           FONTAIN.PARTIK(I).Age = 0
        
        
        End If
       
       FONTAIN.PARTIK(I).Age = FONTAIN.PARTIK(I).Age + 1
       FONTAIN.PARTIK(I).Size = (0.5 * 2 + (FONTAIN.PARTIK(I).Age / 2000#)) * FONTAIN.Water_SIZE * 1.5
       
       
       fALPHA = 255# - (255# / 500#) * FONTAIN.PARTIK(I).Age
       If fALPHA < 0 Then fALPHA = 0
       '// Transform particle position (apply stored view matrix):
       Call VectorMatrixMultiply(TransPos, FONTAIN.PARTIK(I).Position, matViewBak)
       
       Dim KOLA As Long
       '// Set up billboard of specified size:
        KOLA = JOX.DX_7.CreateColorRGBA(FONTAIN.Red, FONTAIN.Green, FONTAIN.Blue, fALPHA)
        Dim Mat As D3DMATERIAL7
        Dim COLL As D3DCOLORVALUE
        
       COLL.A = fALPHA
       COLL.R = FONTAIN.Red
       COLL.G = FONTAIN.Green
       COLL.B = FONTAIN.Blue
       
       Mat.Ambient = COLL
       Mat.diffuse = COLL
       JOX.SetMaterial COLL, COLL

        
        
        
        LVertex(0) = retLvertex(VAdd(TransPos, VICTOR(-1# * FONTAIN.PARTIK(I).Size, 1# * FONTAIN.PARTIK(I).Size, 0#)), _
            KOLA, &H1, 0#, 0#)
        LVertex(1) = retLvertex(VAdd(TransPos, VICTOR(1# * FONTAIN.PARTIK(I).Size, 1# * FONTAIN.PARTIK(I).Size, 0#)), _
            KOLA, &H1, 1#, 0#)
        LVertex(2) = retLvertex(VAdd(TransPos, VICTOR(-1# * FONTAIN.PARTIK(I).Size, -1# * FONTAIN.PARTIK(I).Size, 0#)), _
            KOLA, &H1, 0#, 1#)
        LVertex(3) = retLvertex(VAdd(TransPos, VICTOR(1# * FONTAIN.PARTIK(I).Size, -1# * FONTAIN.PARTIK(I).Size, 0#)), _
            KOLA, &H1, 1#, 1#)

       '// Draw the shape:
         Call JOX.D3D_DEV.DrawPrimitive(D3DPT_TRIANGLESTRIP, D3DFVF_LVERTEX, LVertex(0), 4, D3DDP_DEFAULT)
 Next I

   '// Reset render states and view matrix:
    'Call JOX.D3D_DEV.SetTexture(0, Nothing)
    Call JOX.D3D_DEV.SetTransform(D3DTRANSFORMSTATE_VIEW, matViewBak)
    Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_ALPHABLENDENABLE, False)
    Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_LIGHTING, True)
    Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_ZWRITEENABLE, True)
    
    
    
    
    
    
    
    
    
    JOX.D3D_DEV.SetRenderState D3DRENDERSTATE_ZWRITEENABLE, 1
    JOX.CLearMATRIX
    JOX.USE_defaultMaterial
    
    JOX.CLearMATRIX
    
End Sub








Private Sub render_BLAST(JOX As johna_DX7)

Dim X As Single, Y As Single, Z As Single
Dim I As Integer
Dim COLINDEX
COLINDEX = 1

'update renderstate
JOX.D3D_DEV.SetTexture 0, pTexture
My_renderstate JOX
JOX.D3D_DEV.SetRenderState D3DRENDERSTATE_LIGHTING, 1
JOX.D3D_DEV.SetRenderState D3DRENDERSTATE_ZWRITEENABLE, 0

    Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_SRCBLEND, D3DBLEND_ONE)
    Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_DESTBLEND, D3DBLEND_ONE)
    
    
'// Store current view matrix and disable view transformation):
    Dim matViewBak As D3DMATRIX
   
    Call JOX.D3D_DEV.GetTransform(D3DTRANSFORMSTATE_VIEW, matViewBak)
    Call JOX.D3D_DEV.SetTransform(D3DTRANSFORMSTATE_VIEW, GIdentityMatrix)

   '// Disable world transformation:
    Call JOX.D3D_DEV.SetTransform(D3DTRANSFORMSTATE_WORLD, GIdentityMatrix)

   '// Set particle texture:
    Call JOX.D3D_DEV.SetTexture(0, pTexture)

Dim Jangle As Single
For I = 0 To Num_PARTICLE - 1                      'loop through all particles
    Jangle = Int(Rnd * 360)
 
    With BLAST.PARTIK(I)                                'saves a lot of writing
    
         If .Age > BLAST.Max_Extent Then
            
            BLAST.PARTIK(I).Position = Vorigin
            BLAST.PARTIK(I).Size = 1
            BLAST.PARTIK(I).Age = Rnd * 50
            BLAST.PARTIK(I).Velocity = VICTOR(Rnd * 4 / 3, Rnd * 4 / 3, Rnd * 4 / 3)
         Else
           Dim Vel
           Vel = Rnd * 2
           .Position = VICTOR(.Position.X + BLAST.Tcos(Jangle) * Vel, .Position.Y + BLAST.Tsin(Jangle) * Vel, .Position.Z + BLAST.Tsin(Jangle) * Vel)
           .Age = .Age + .Velocity.Z
         End If
      
        
        'fade the particle according to its life
        
        
        'using a triangle strip to speed up calcs,
        'use .r,.g,.b instead of 1,1,1 to create colorful stars
      
      
      Dim ZDEG As Single
      ZDEG = JOX.CAM_angleBilBOARD

        Dim Mat As D3DMATERIAL7
        Dim COLL As D3DCOLORVALUE



                COLINDEX = COLINDEX + 1
                If COLINDEX < 1 Then COLINDEX = 1
                If COLINDEX > 12 Then COLINDEX = 12
                    .COLOR.R = PAL_FIRE(COLINDEX).X     'setting new color
                    .COLOR.G = PAL_FIRE(COLINDEX).Y
                    .COLOR.B = PAL_FIRE(COLINDEX).Z
COLL.R = .COLOR.R
COLL.G = .COLOR.G
COLL.B = .COLOR.B
COLL.A = BLAST.Max_Extent - (.Age / BLAST.Max_Extent)







'for vertices color
Dim COL As Long
Dim R, G, B
R = Int(COLL.R * 255)
G = Int(COLL.G * 255)
B = Int(COLL.B * 255)
COL = JOX.DX_7.CreateColorRGBA(COLL.R, COLL.G, COLL.B, COLL.A)

            LVertex(0).COLOR = COL 'RGB(R, G, B)
                                
            
            LVertex(1).COLOR = LVertex(0).COLOR
            LVertex(2).COLOR = LVertex(0).COLOR
            LVertex(3).COLOR = LVertex(0).COLOR
            
            
            LVertex(0).specular = LVertex(0).COLOR
            LVertex(1).specular = LVertex(0).COLOR
            LVertex(2).specular = LVertex(0).COLOR
            LVertex(3).specular = LVertex(0).COLOR


Mat = JOX.Create_Material2(COLL, COLL)


JOX.D3D_DEV.SetMaterial Mat




Dim TransPos As D3DVECTOR
Dim siz
'// Transform particle position (apply stored view matrix):
Call VectorMatrixMultiply(TransPos, BLAST.PARTIK(I).Position, matViewBak)

'JOX.OBJECT_MOV_rotate .POSITION.x, .POSITION.Y, .POSITION.Z, 0, JOX.CAM_angleBilBOARD, 0
JOX.D3D_DEV.DrawPrimitive D3DPT_TRIANGLESTRIP, D3DFVF_LVERTEX, _
                                    LVertex(0), 4, D3DDP_DEFAULT
        
      
                   
            
       
                    'COLINDEX = Int(Rnd * 12) + 1
                    '.r = PAL_FIRE(COLINDEX).x     'setting new color
                    '.g = PAL_FIRE(COLINDEX).y
                    '.b = PAL_FIRE(COLINDEX).z
                    
       
    End With
   

Next I

    Call JOX.D3D_DEV.SetTransform(D3DTRANSFORMSTATE_VIEW, matViewBak)

JOX.D3D_DEV.SetRenderState D3DRENDERSTATE_ZWRITEENABLE, 1
JOX.CLearMATRIX
JOX.USE_defaultMaterial
'JOX.USE_default_RENDERSTATE

End Sub




















Private Sub RESTORE_Renderstate(JOX As johna_DX7)
  Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_ALPHATESTENABLE, False)
  Call JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_ALPHABLENDENABLE, False)
End Sub

















Private Sub My_renderstate(CX As johna_DX7)
            CX.D3D_DEV.SetRenderState D3DRENDERSTATE_ALPHABLENDENABLE, True

           'CX.D3D_DEV.SetRenderState D3DRENDERSTATE_AMBIENT, HFFFFFF
           CX.D3D_DEV.SetRenderState D3DRENDERSTATE_SRCBLEND, D3DBLEND_ONE
           CX.D3D_DEV.SetRenderState D3DRENDERSTATE_DESTBLEND, D3DBLEND_ONE
           
            'CX.D3D_DEV.SetRenderState D3DRENDERSTATE_SRCBLEND, D3DBLEND_SRCCOLOR
            'CX.D3D_DEV.SetRenderState D3DRENDERSTATE_DESTBLEND, D3DBLEND_INVSRCCOLOR
           CX.D3D_DEV.SetRenderState D3DRENDERSTATE_DITHERENABLE, 1
           CX.D3D_DEV.SetRenderState D3DRENDERSTATE_SPECULARENABLE, 0
           
 End Sub

















 

Private Function Arcsin(X)
   Dim T
   T = X / Sqr(-X * X + 1)
   Arcsin = Atn(T)
End Function
Private Function Arccos(X)
  Arccos = Atn(-X / Sqr(-X * X + 1)) + 2 * Atn(1)

End Function

Private Function Arcsec(X)
   Arcsec = Atn(X / Sqr(X * X - 1)) + Sgn((X) - 1) * (2 * Atn(1))

End Function

Private Function Arccosec(X)
   Arccosec = Atn(X / Sqr(X * X - 1)) + (Sgn(X) - 1) * (2 * Atn(1))

End Function

Private Function Arccotan(X)
   Arccotan = Atn(X) + 2 * Atn(1)
End Function

Private Function HSin(X)
  HSin = (Exp(X) - Exp(-X)) / 2
End Function

Private Function HCos(X)
   HCos = (Exp(X) + Exp(-X)) / 2
End Function

Private Function HTan(X)
  HTan = (Exp(X) - Exp(-X)) / (Exp(X) + Exp(-X))

End Function
 
Private Function HSec(X)
   HSec = 2 / (Exp(X) + Exp(-X))
End Function

Private Function HCosec(X)
    HCosec = 2 / (Exp(X) - Exp(-X))
End Function

Private Function HCotan(X)
   HCotan = (Exp(X) + Exp(-X)) / (Exp(X) - Exp(-X))
End Function

Private Function HArcsin(X)
    HArcsin = Log(X + Sqr(X * X + 1))
End Function

Private Function HArccos(X)
  HArccos = Log(X + Sqr(X * X - 1))
End Function
Private Function HArctan(X)
   HArctan = Log((1 + X) / (1 - X)) / 2
End Function


Private Function HArcsec(X)
      HArcsec = Log((Sqr(-X * X + 1) + 1) / X)
End Function

Private Function HArccosec(X)
     HArccosec = Log((Sgn(X) * Sqr(X * X + 1) + 1) / X)
End Function

Private Function HArccotan(X)
   HArccotan = Log((X + 1) / (X - 1)) / 2
End Function

Private Function LogN(X)
    LogN = Log(X) / Log(10)
End Function




Private Function Secante(X)
    Secante = 1 / Cos(X)
End Function

Private Function Cosecante(X)
    Cosecante = 1 / Sin(X)
End Function


Private Function Cotangente(X)
  Cotangente = 1 / Tan(X)
End Function


Private Function VAdd(A As D3DVECTOR, B As D3DVECTOR) As D3DVECTOR
  Dim Dest As D3DVECTOR
  Dest.X = A.X + B.X
  Dest.Y = A.Y + B.Y
  Dest.Z = A.Z + B.Z
  VAdd = Dest
End Function

Private Function VectorAdd(A As D3DVECTOR, B As D3DVECTOR) As D3DVECTOR
  Dim Dest As D3DVECTOR
  Dest.X = A.X + B.X
  Dest.Y = A.Y + B.Y
  Dest.Z = A.Z + B.Z
  VectorAdd = Dest
End Function

Private Function VectorMatrixMultiply(vDest As D3DVECTOR, _
                                vSrc As D3DVECTOR, _
                                 Mat As D3DMATRIX)
Dim X, Y, Z, W

 X = vSrc.X * Mat.rc11 + vSrc.Y * Mat.rc21 + vSrc.Z * Mat.rc31 + Mat.rc41
 Y = vSrc.X * Mat.rc12 + vSrc.Y * Mat.rc22 + vSrc.Z * Mat.rc32 + Mat.rc42
Z = vSrc.X * Mat.rc13 + vSrc.Y * Mat.rc23 + vSrc.Z * Mat.rc33 + Mat.rc43
 W = vSrc.X * Mat.rc14 + vSrc.Y * Mat.rc24 + vSrc.Z * Mat.rc34 + Mat.rc44
    
    If Abs(W) < 0.00001 Then
        VectorMatrixMultiply = 0
        Exit Function
    End If
    
    On Error Resume Next
    vDest.X = X / W
    On Error Resume Next
    vDest.Y = Y / W
    On Error Resume Next

    vDest.Z = Z / W

    VectorMatrixMultiply = 1




End Function



Private Function retLvertex(Vpos As D3DVECTOR, COLOR As Long, COLspec As Long, tu, tv) As D3DLVERTEX
    retLvertex.COLOR = COLOR
    retLvertex.specular = COLspec
    retLvertex.tu = tu
    retLvertex.tv = tv
    retLvertex.X = Vpos.X
    retLvertex.Y = Vpos.Y
    retLvertex.Z = Vpos.Z

End Function


'=================================
' RotateXMatrix
'=================================
' rotate an object about x axis rad radians

Private Sub RotateXMatrix(RET As D3DMATRIX, rads As Single)
  Dim cosine As Single
  Dim sine As Single
  cosine = Cos(rads)
  sine = Sin(rads)
  Call IdentityMatrix(RET)
  RET.rc22 = cosine
  RET.rc33 = cosine
  RET.rc23 = -sine
  RET.rc32 = sine
End Sub

Private Function RetRotateXMatrix(rads As Single) As D3DMATRIX
  Dim cosine As Single
  Dim sine As Single
  Dim RET As D3DMATRIX
  cosine = Cos(rads)
  sine = Sin(rads)
  Call IdentityMatrix(RET)
  RET.rc22 = cosine
  RET.rc33 = cosine
  RET.rc23 = -sine
  RET.rc32 = sine
  RetRotateXMatrix = RET
End Function

'=================================
' RotateYMatrix
'=================================
' rotate an object about y axis rad radians

Private Sub RotateYMatrix(RET As D3DMATRIX, rads As Single)
  Dim cosine As Single
  Dim sine As Single
  cosine = Cos(rads)
  sine = Sin(rads)
  Call IdentityMatrix(RET)
  RET.rc11 = cosine
  RET.rc33 = cosine
  RET.rc13 = sine
  RET.rc31 = -sine
End Sub

'=================================
' RotateZMatrix
'=================================
' rotate an object about z axis rad radians

Private Sub RotateZMatrix(RET As D3DMATRIX, rads As Single)
  Dim cosine As Single
  Dim sine As Single
  cosine = Cos(rads)
  sine = Sin(rads)
  Call IdentityMatrix(RET)
  
  RET.rc11 = cosine
  RET.rc22 = cosine
  RET.rc12 = -sine
  RET.rc21 = sine
End Sub


Private Sub MatrixMult(Result As D3DMATRIX, A As D3DMATRIX, B As D3DMATRIX)
  Dim RET As D3DMATRIX
  Dim Tmp As Double
  Dim I As Integer
  Dim J As Integer
  Dim K As Integer
  
  Call ZeroMatrix(RET)
  RET.rc11 = B.rc11 * A.rc11 + B.rc21 * A.rc12 + B.rc31 * A.rc13 + B.rc41 * A.rc14
  RET.rc12 = B.rc12 * A.rc11 + B.rc22 * A.rc12 + B.rc32 * A.rc13 + B.rc42 * A.rc14
  RET.rc13 = B.rc13 * A.rc11 + B.rc23 * A.rc12 + B.rc33 * A.rc13 + B.rc43 * A.rc14
  RET.rc14 = B.rc14 * A.rc11 + B.rc24 * A.rc12 + B.rc34 * A.rc13 + B.rc44 * A.rc14
  RET.rc21 = B.rc11 * A.rc21 + B.rc21 * A.rc22 + B.rc31 * A.rc23 + B.rc41 * A.rc24
  RET.rc22 = B.rc12 * A.rc21 + B.rc22 * A.rc22 + B.rc32 * A.rc23 + B.rc42 * A.rc24
  RET.rc23 = B.rc13 * A.rc21 + B.rc23 * A.rc22 + B.rc33 * A.rc23 + B.rc43 * A.rc24
  RET.rc24 = B.rc14 * A.rc21 + B.rc24 * A.rc22 + B.rc34 * A.rc23 + B.rc44 * A.rc24
  RET.rc31 = B.rc11 * A.rc31 + B.rc21 * A.rc32 + B.rc31 * A.rc33 + B.rc41 * A.rc34
  RET.rc32 = B.rc12 * A.rc31 + B.rc22 * A.rc32 + B.rc32 * A.rc33 + B.rc42 * A.rc34
  RET.rc33 = B.rc13 * A.rc31 + B.rc23 * A.rc32 + B.rc33 * A.rc33 + B.rc43 * A.rc34
  RET.rc34 = B.rc14 * A.rc31 + B.rc24 * A.rc32 + B.rc34 * A.rc33 + B.rc44 * A.rc34
  RET.rc41 = B.rc11 * A.rc41 + B.rc21 * A.rc42 + B.rc31 * A.rc43 + B.rc41 * A.rc44
  RET.rc42 = B.rc12 * A.rc41 + B.rc22 * A.rc42 + B.rc32 * A.rc43 + B.rc42 * A.rc44
  RET.rc43 = B.rc13 * A.rc41 + B.rc23 * A.rc42 + B.rc33 * A.rc43 + B.rc43 * A.rc44
  RET.rc44 = B.rc14 * A.rc41 + B.rc24 * A.rc42 + B.rc34 * A.rc43 + B.rc44 * A.rc44
  Result = RET
End Sub


Private Sub Class_Initialize()
Dim aa, I, Z



'============================
'  for fire palettte
'
'=================
aa = Array(1#, 0.5, 0.25, 1#, 0.5, 0.25, 1#, 0.5, 0.25, 1#, 0.5, 0.25, _
    1#, 0.5, 0.25, 1#, 0.5, 0.25, 1#, 0.65, 0.25, 1#, 0.65, 0.25, _
    1#, 0.5, 0.25, 1#, 0.5, 0.25, 1#, 0.55, 0.25, 1#, 0.55, 0.25)
Z = 0
For I = 0 To (12 * 3) - 1 Step 3
  Z = Z + 1
  PAL_FIRE(Z).X = aa(I)
  PAL_FIRE(Z).Y = aa(I + 1)
  PAL_FIRE(Z).Z = aa(I + 2)

Next I

Erase aa


'============================
'  for portal palettte
'
'=================
aa = Array(0.25, 0.5, 1#, 0.25, 0.5, 1#, 0.25, 0.5, 1#, 0.25, 0.5, 1#, _
    0.25, 0.5, 1#, 0.25, 0.5, 1#, 0.25, 0.65, 1#, 0.25, 0.65, 1#, _
    0.25, 0.5, 1#, 0.25, 0.5, 1#, 0.25, 0.55, 1#, 0.25, 0.55, 1#)

Z = 0
For I = 0 To (12 * 3) - 1 Step 3
  Z = Z + 1
  PAL_Portal(Z).X = aa(I)
  PAL_Portal(Z).Y = aa(I + 1)
  PAL_Portal(Z).Z = aa(I + 2)

Next I


'============================
'  for snow palettte
'
'=================
Erase aa
aa = Array(1#, 1#, 1#, 0.75, 0.75, 0.75, 0.5, 0.5, 0.5, 0.25, 0.25, 0.25, _
    1#, 1#, 1#, 0.75, 0.75, 0.75, 0.5, 0.5, 0.5, 0.25, 0.25, 0.25, _
    1#, 1#, 1#, 0.75, 0.75, 0.75, 0.5, 0.5, 0.5, 0.25, 0.25, 0.25)

Z = 0
For I = 0 To (12 * 3) - 1 Step 3
  Z = Z + 1
  PAL_SNOW(Z).X = aa(I)
  PAL_SNOW(Z).Y = aa(I + 1)
  PAL_SNOW(Z).Z = aa(I + 2)

Next I


Erase aa

End Sub

Private Sub Class_Terminate()
Erase PAL_FIRE
Erase PAL_Portal
Erase PAL_SNOW

End Sub
