VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cJohna_landScape"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'==============================
' Johna landsacpe engine version 1.04
'
'24/10/2001
'   Add water collision
'
'30/01/2002
'
'
'
'15/03/2002
'   Material setting for terrain
'   Start of Multi terrain engine
'==========================
Private Declare Function GetPixel Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long) As Long

Private Const EPSILON = 0.0001
Private Type IntersectTest
  T As Double
  U As Double
  v As Double
End Type


Dim CollisionNormal As D3DVECTOR
Dim CollisionImpact As D3DVECTOR
Public PrecisionCollide As Single
Public CHECK_Colision As Boolean


Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" ( _
    lpvDest As Any, lpvSource As Any, ByVal cbCopy As Long)








'==============================================
' For terrain Generating
'
'
'=============================================


Private TXT As Integer
Private Land As TerrainType

Private width As Integer, Height As Integer, stepXX, stepYY
Public is_ACTIVE As Boolean

Private Type TWater
 ALTITUDE As Single
 Alphablended As Boolean
 AlphaFactor As Single
 Enabled As Boolean
 Texture As Integer
 Animated As Boolean
 AnimKey As Single
 TextureScale As Single
 Vertex(4) As D3DLVERTEX
End Type



Public Enum Johna_LANDSCAPE_QUALITY
  Johna_LOW = 32
  Johna_NORMAL = 16
  Johna_SMOOTH = 9
  Johna_PRETY = 8
  Johna_ULTRA_PRECISION = 5.5


End Enum




Public Visible As Integer
Private MaterialIndex As Integer

Public Enum CONST_Johna_VERTEX_TYPE
  Johna_LVERTEX = 1
  Johna_VERTEX = 2
  Johna_TLVERTEX = 3
End Enum



Private D_JOX As johna_DX7



'for translating and scaling terrain
Private Type VerTEX_PARAM
  vPosition As D3DVECTOR
  Vscal As D3DVECTOR
  Vrotate As D3DVECTOR
  

End Type

Private Type TerrainType
 Map() As Single
 Vertex() As D3DVERTEX
 LVertex() As D3DLVERTEX
 
 VertexIndex() As Integer
 VT As Integer
 Material As D3DMATERIAL7
 Matrix As D3DMATRIX
 Center As D3DVECTOR
 Radius As Single
 WaterEffect As TWater
 Surface As DirectDrawSurface7
 Water_SURface As DirectDrawSurface7
 Water_Texture_OK As Boolean
 Mini As D3DVECTOR
 maxi As D3DVECTOR
 TailleX As Single
 TailleZ As Single
 Water_Param As VerTEX_PARAM
 Water_Width As Single
 Water_Depth As Single
 BilBoard_VERT(1 To 4) As D3DVERTEX
End Type

Private OBJET As VerTEX_PARAM
Private landtexture As DirectDrawSurface7
Private bBOX As D3DRMBOX









'==============================================
'  TERRAIN FUNCTIONs
'
'
'==========================================

Sub INITIALIZE(cJOX As johna_DX7)
Set D_JOX = cJOX
OBJET.vPosition = VICTOR(0, 0, 0)
OBJET.Vscal = VICTOR(1, 1, 1)
Land.Material.Ambient = DXColor(1, 1, 1, 1)
Land.Material.diffuse = DXColor(1, 1, 1, 1)
Land.Material.power = 1
Land.Material.specular = DXColor(1, 1, 1, 1)

End Sub



Function CheckIfVisible() As Boolean
   'the great visibility check with the sphere!
   'mesh sphere must be computed before calling this function
   Dim ClipStatus
   
   CheckIfVisible = False
  ClipStatus = D_JOX.D3D_DEV.ComputeSphereVisibility(Land.Center, Land.Radius)
 If ClipStatus And &HFFF000 Then
   'not visible
   Visible = 0
 Else
  If ClipStatus And &HFFF Then
   'partially visible :
   CheckIfVisible = True
   Visible = 1
  Else
   CheckIfVisible = True
   'entirely visible
   Visible = 2
 End If
 
 End If
End Function

Private Function DetectCollision(Origin As D3DVECTOR, Dest As D3DVECTOR) As Boolean
   Dim T As Double, U As Double, v As Double, t1 As Double, u1 As Double, V1 As Double
    Dim xpos, ypos, V2, V3, v4, V5, V6
    
    
 Dim Vec As D3DVECTOR
    
  Dim VC As D3DVECTOR
 VC = OBJET.Vscal
 Dim Ptx As Single
 Dim PTz As Single
 Dim PTy As Single
 Dim ALL As Single
 Vec = Origin
'Check by Interpolation with the Vscal Facteur
 
 If Vec.X > vPosition.X And _
     Vec.Z > vPosition.Z And _
     Vec.X < vPosition.X + (bBOX.max.X - bBOX.min.X) * VC.X And _
     Vec.Z < vPosition.Z + (bBOX.max.Z - bBOX.min.Z) * VC.Z Then
      
        Ptx = (Vec.X - vPosition.X) / ((bBOX.max.X - bBOX.min.X) * VC.X)
        PTz = (Vec.Z - vPosition.Z) / ((bBOX.max.Z - bBOX.min.Z) * VC.Z)
        PTy = (Vec.Y - vPosition.Y) / ((bBOX.max.Y - bBOX.min.Y) * VC.Y)
       
        Ptx = Ptx * (bBOX.max.X - bBOX.min.X) + bBOX.min.X
        PTz = PTz * (bBOX.max.Z - bBOX.min.Z) + bBOX.min.Z
        PTy = PTy * (bBOX.max.Y - bBOX.min.Y) + bBOX.min.Y
        
      Origin = Vector(Ptx, PTy, PTz)
      
      
  End If
    
    

Vec = Dest
'Check by Interpolation with the Vscal Facteur
 
 If Vec.X > vPosition.X And _
     Vec.Z > vPosition.Z And _
     Vec.X < vPosition.X + (bBOX.max.X - bBOX.min.X) * VC.X And _
     Vec.Z < vPosition.Z + (bBOX.max.Z - bBOX.min.Z) * VC.Z Then
      
        Ptx = (Vec.X - vPosition.X) / ((bBOX.max.X - bBOX.min.X) * VC.X)
        PTz = (Vec.Z - vPosition.Z) / ((bBOX.max.Z - bBOX.min.Z) * VC.Z)
        PTy = (Vec.Y - vPosition.Y) / ((bBOX.max.Y - bBOX.min.Y) * VC.Y)
       
        Ptx = Ptx * (bBOX.max.X - bBOX.min.X) + bBOX.min.X
        PTz = PTz * (bBOX.max.Z - bBOX.min.Z) + bBOX.min.Z
        PTy = PTy * (bBOX.max.Y - bBOX.min.Y) + bBOX.min.Y
        
      Dest = Vector(Ptx, PTy, PTz)
      
      
  End If
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    'compute the ray direction
    
    If Not Me.is_ACTIVE Then Exit Function
    
    
    Dest = Vsub(Dest, Origin)
     D_JOX.DX_7.VectorNormalize Dest
    
    'compute the position of the player on the terrain
    xpos = Int((Origin.X - Land.LVertex(1).X) / stepXX)
    ypos = Int((Origin.Z - Land.LVertex(1).Z) / stepYY)
   
    
   For X = xpos - 1 To xpos + 1
    For Y = ypos - 1 To ypos + 1
     If Y >= 0 And Y < Height - 1 And X > 1 And X < width Then
       'select the good vertexes
       V3 = (X - 1) * Height + Y
       V2 = X * Height + Y
       V1 = (X - 1) * Height + Y + 1
       V6 = X * Height + Y
       V5 = X * Height + Y + 1
       v4 = (X - 1) * Height + Y + 1
     
       G = Ray_TriangleCollision(Origin, Dest, vert(Land.LVertex(V1)), vert(Land.LVertex(V2)), vert(Land.LVertex(V3)), T, U, v)
       g1 = Ray_TriangleCollision(Origin, Dest, vert(Land.LVertex(v4)), vert(Land.LVertex(V5)), vert(Land.LVertex(V6)), t1, u1, V1)
     
       If (G = 1 And T < PrecisionCollide And T >= 0) Or (g1 = 1 And t1 < PrecisionCollide And t1 >= 0) Then
         DetectCollision = True
       Exit Function
      End If
     End If
    Next Y
   Next X
  
End Function



'for collision detection ! Find the intersection of a ray with a triangle
Private Function Ray_TriangleCollision(orig As D3DVECTOR, Dir As D3DVECTOR, vert0 As D3DVECTOR, Vert1 As D3DVECTOR, Vert2 As D3DVECTOR, T As Double, U As Double, v As Double, Optional NoCollideI As Boolean = False) As Byte
Dim edge1 As D3DVECTOR
Dim edge2 As D3DVECTOR
Dim tvec As D3DVECTOR
Dim pvec As D3DVECTOR
Dim qvec As D3DVECTOR
Dim inv_det As Double
Dim det As Double
On Error Resume Next

   '/* find vectors for two edges sharing vert0 *'/
   edge1 = VSubtract(Vert1, vert0)
   edge2 = VSubtract(Vert2, vert0)

   '/* begin calculating determinant - also used to calculate U parameter *'/
   pvec = VCrossProduct(Dir, edge2)

   '/* if determinant is near zero, ray lies in plane of triangle *'/
   det = VDotProduct(edge1, pvec)
 
   If det > -EPSILON And det < EPSILON Then
      Ray_TriangleCollision = 0
      Exit Function
   End If
   inv_det = 1 / det
   
   'calculate distance from vert0 to ray origin
   tvec = VSubtract(orig, vert0)

   'calculate u parameter and test bounds
   U = VDotProduct(tvec, pvec) * inv_det
   If U < 0 Or U > 1 Then
      Ray_TriangleCollision = 0
      Exit Function
   End If
   
   'Prepare to test v parameter
   qvec = VCrossProduct(tvec, edge1)

   'Calculate v parameter and test bounds
   v = VDotProduct(Dir, qvec) * inv_det
   If v < 0 Or U + v > 1 Then
      Ray_TriangleCollision = 0
      Exit Function
   End If
   
   'Calculate t, ray intersects triangle
   T = VDotProduct(edge2, qvec) * inv_det
   If NoCollideI = True Then
   CollisionNormal = VCrossProduct(edge1, edge2)
   CollisionImpact = VAdd(orig, VScale(Dir, CSng(T)))
   End If
   Ray_TriangleCollision = 1
      
    

End Function
Private Function VCrossProduct(dV1 As D3DVECTOR, dV2 As D3DVECTOR) As D3DVECTOR
     D_JOX.DX_7.VectorCrossProduct VCrossProduct, dV1, dV2
End Function

Private Function VDotProduct(dV1 As D3DVECTOR, dV2 As D3DVECTOR) As Single
    VDotProduct = D_JOX.DX_7.VectorDotProduct(dV1, dV2)
End Function

Private Function VSubtract(dV1 As D3DVECTOR, dV2 As D3DVECTOR) As D3DVECTOR
    VSubtract.X = dV1.X - dV2.X
    VSubtract.Y = dV1.Y - dV2.Y
    VSubtract.Z = dV1.Z - dV2.Z
End Function




Private Function Get_Altitude(Vec As D3DVECTOR) As Single
If Not Me.is_ACTIVE Then Exit Function
 'still a great accurate thing !
 
  Dim T As Double, U As Double, v As Double, t1 As Double, u1 As Double, V1 As Double
  Dim Dest As D3DVECTOR
  Dim Origin As D3DVECTOR
   
   'calculate the ray direction (bottom -. top)
   Origin = VICTOR(Vec.X, 0, Vec.Z)
   Dest = VICTOR(0, 1, 0)

     D_JOX.DX_7.VectorNormalize Dest
    
    'compute the position of the player on the terrain
      xpos = Int((Origin.X - Land.LVertex(1).X) / stepXX)
    ypos = Int((Origin.Z - Land.LVertex(1).Z) / stepYY)
   
    
   For xq = xpos - 1 To xpos + 1
    For yq = ypos - 1 To ypos + 1
     If yq >= 0 And yq < Height - 1 And xq > 1 And xq < width Then
     'select good vertexes
     V3 = (xq - 1) * Height + yq
     V2 = xq * Height + yq
     V1 = (xq - 1) * Height + yq + 1
     V6 = xq * Height + yq
     V5 = xq * Height + yq + 1
     v4 = (xq - 1) * Height + yq + 1
     
     G = Ray_TriangleCollision(Origin, Dest, vert(Land.LVertex(V1)), vert(Land.LVertex(V2)), vert(Land.LVertex(V3)), T, U, v)
     g1 = Ray_TriangleCollision(Origin, Dest, vert(Land.LVertex(v4)), vert(Land.LVertex(V5)), vert(Land.LVertex(V6)), t1, u1, V1)
     
     If (G = 1 And T >= 0) Or (g1 = 1 And t1 >= 0) Then
     'if we have a collision (I hope we'll have a collision else we'll a big problem : GetHeight = 00)
     If T = 0 Then Get_Altitude = t1 Else Get_Altitude = T
     Exit Function
    End If
   End If
    Next yq
   Next xq
Exit Function


End Function



Private Function Get_Altitude_U(Vec As D3DVECTOR) As Single
If Not Me.is_ACTIVE Then Exit Function
 'still a great accurate thing !
 
  Dim T As Double, U As Double, v As Double, t1 As Double, u1 As Double, V1 As Double
  Dim Dest As D3DVECTOR
  Dim Origin As D3DVECTOR
   
   'calculate the ray direction (bottom -. top)
   Origin = VICTOR(Vec.X, 0, Vec.Z)
   Dest = VICTOR(0, 1, 0)

     D_JOX.DX_7.VectorNormalize Dest
    
    'compute the position of the player on the terrain
      xpos = Int((Origin.X - Land.LVertex(1).X) / stepXX)
    ypos = Int((Origin.Z - Land.LVertex(1).Z) / stepYY)
   
    
   For xq = xpos - 1 To xpos + 1
    For yq = ypos - 1 To ypos + 1
     If yq >= 0 And yq < Height - 1 And xq > 1 And xq < width Then
     'select good vertexes
     V3 = (xq - 1) * Height + yq
     V2 = xq * Height + yq
     V1 = (xq - 1) * Height + yq + 1
     V6 = xq * Height + yq
     V5 = xq * Height + yq + 1
     v4 = (xq - 1) * Height + yq + 1
     
     G = Ray_TriangleCollision(Origin, Dest, vert(Land.LVertex(V1)), vert(Land.LVertex(V2)), vert(Land.LVertex(V3)), T, U, v)
     g1 = Ray_TriangleCollision(Origin, Dest, vert(Land.LVertex(v4)), vert(Land.LVertex(V5)), vert(Land.LVertex(V6)), t1, u1, V1)
     
     If (G = 1 And T >= 0) Or (g1 = 1 And t1 >= 0) Then
     'if we have a collision (I hope we'll have a collision else we'll a big problem : GetHeight = 00)
     If T = 0 Then Get_Altitude_U = t1 Else Get_Altitude_ = U
     Exit Function
    End If
   End If
    Next yq
   Next xq
Exit Function


End Function






Private Function Get_Altitude_V(Vec As D3DVECTOR) As Single
If Not Me.is_ACTIVE Then Exit Function
 'still a great accurate thing !
 
  Dim T As Double, U As Double, v As Double, t1 As Double, u1 As Double, V1 As Double
  Dim Dest As D3DVECTOR
  Dim Origin As D3DVECTOR
   
   'calculate the ray direction (bottom -. top)
   Origin = VICTOR(Vec.X, 0, Vec.Z)
   Dest = VICTOR(0, 1, 0)

     D_JOX.DX_7.VectorNormalize Dest
    
    'compute the position of the player on the terrain
      xpos = Int((Origin.X - Land.LVertex(1).X) / stepXX)
    ypos = Int((Origin.Z - Land.LVertex(1).Z) / stepYY)
   
    
   For xq = xpos - 1 To xpos + 1
    For yq = ypos - 1 To ypos + 1
     If yq >= 0 And yq < Height - 1 And xq > 1 And xq < width Then
     'select good vertexes
     V3 = (xq - 1) * Height + yq
     V2 = xq * Height + yq
     V1 = (xq - 1) * Height + yq + 1
     V6 = xq * Height + yq
     V5 = xq * Height + yq + 1
     v4 = (xq - 1) * Height + yq + 1
     
     G = Ray_TriangleCollision(Origin, Dest, vert(Land.LVertex(V1)), vert(Land.LVertex(V2)), vert(Land.LVertex(V3)), T, U, v)
     g1 = Ray_TriangleCollision(Origin, Dest, vert(Land.LVertex(v4)), vert(Land.LVertex(V5)), vert(Land.LVertex(V6)), t1, u1, V1)
     
     If (G = 1 And T >= 0) Or (g1 = 1 And t1 >= 0) Then
     'if we have a collision (I hope we'll have a collision else we'll a big problem : GetHeight = 00)
     If T = 0 Then Get_Altitude_V = t1 Else Get_Altitude_V = v
     Exit Function
    End If
   End If
    Next yq
   Next xq
Exit Function


End Function







Function Get_Altitude_EX(Vec As D3DVECTOR) As Single
 Dim VC As D3DVECTOR
 VC = OBJET.Vscal
 Dim Ptx As Single
 Dim PTz As Single
 Dim ALL As Single

'Check by Interpolation with the Vscal Facteur
 
 If Vec.X > vPosition.X And _
     Vec.Z > vPosition.Z And _
     Vec.X < vPosition.X + (bBOX.max.X - bBOX.min.X) * VC.X And _
     Vec.Z < vPosition.Z + (bBOX.max.Z - bBOX.min.Z) * VC.Z Then
      
        Ptx = (Vec.X - vPosition.X) / ((bBOX.max.X - bBOX.min.X) * VC.X)
        PTz = (Vec.Z - vPosition.Z) / ((bBOX.max.Z - bBOX.min.Z) * VC.Z)
       
        Ptx = Ptx * (bBOX.max.X - bBOX.min.X) + bBOX.min.X
        PTz = PTz * (bBOX.max.Z - bBOX.min.Z) + bBOX.min.Z
        
       ALL = Get_Altitude(VICTOR(Ptx, 0, PTz))
     
     Get_Altitude_EX = ALL * VC.Y
     Exit Function
  End If

Get_Altitude_EX = 0

End Function


Function Get_Angle_U(Vec As D3DVECTOR) As Single
 Dim VC As D3DVECTOR
 VC = OBJET.Vscal
 Dim Ptx As Single
 Dim PTz As Single
 Dim ALL As Single

 
 If Vec.X > vPosition.X And _
     Vec.Z > vPosition.Z And _
     Vec.X < vPosition.X + (bBOX.max.X - bBOX.min.X) * VC.X And _
     Vec.Z < vPosition.Z + (bBOX.max.Z - bBOX.min.Z) * VC.Z Then
      
        Ptx = (Vec.X - vPosition.X) / ((bBOX.max.X - bBOX.min.X) * VC.X)
        PTz = (Vec.Z - vPosition.Z) / ((bBOX.max.Z - bBOX.min.Z) * VC.Z)
       
        Ptx = Ptx * (bBOX.max.X - bBOX.min.X) + bBOX.min.X
        PTz = PTz * (bBOX.max.Z - bBOX.min.Z) + bBOX.min.Z
        
       ALL = Get_Altitude_U(VICTOR(Ptx, 0, PTz))
     
     Get_Angle_U = ALL '* VC.Y
     Exit Function
  End If

Get_Angle_U = 0

End Function





Function Get_Angle_V(Vec As D3DVECTOR) As Single
 Dim VC As D3DVECTOR
 VC = OBJET.Vscal
 Dim Ptx As Single
 Dim PTz As Single
 Dim ALL As Single

 
 If Vec.X > vPosition.X And _
     Vec.Z > vPosition.Z And _
     Vec.X < vPosition.X + (bBOX.max.X - bBOX.min.X) * VC.X And _
     Vec.Z < vPosition.Z + (bBOX.max.Z - bBOX.min.Z) * VC.Z Then
      
        Ptx = (Vec.X - vPosition.X) / ((bBOX.max.X - bBOX.min.X) * VC.X)
        PTz = (Vec.Z - vPosition.Z) / ((bBOX.max.Z - bBOX.min.Z) * VC.Z)
       
        Ptx = Ptx * (bBOX.max.X - bBOX.min.X) + bBOX.min.X
        PTz = PTz * (bBOX.max.Z - bBOX.min.Z) + bBOX.min.Z
        
       ALL = Get_Altitude_V(VICTOR(Ptx, 0, PTz))
     
     Get_Angle_V = ALL '* VC.Y
     Exit Function
  End If

Get_Angle_V = 0

End Function






Private Function VAdd(A As D3DVECTOR, B As D3DVECTOR) As D3DVECTOR
  Dim Dest As D3DVECTOR
  Dest.X = A.X + B.X
  Dest.Y = A.Y + B.Y
  Dest.Z = A.Z + B.Z
  VAdd = Dest
End Function

Private Function VScale(src As D3DVECTOR, S As Single) As D3DVECTOR
  Dim Dest As D3DVECTOR
  Dest.X = src.X * S
  Dest.Y = src.Y * S
  Dest.Z = src.Z * S
  VScale = Dest
End Function

Private Function VScaleVec(src As D3DVECTOR, Vscalz As D3DVECTOR) As D3DVECTOR
  Dim Dest As D3DVECTOR
  Dest.X = src.X * Vscalz.X
  Dest.Y = src.Y * Vscalz.Y
  Dest.Z = src.Z * Vscalz.Z
  VScaleVec = Dest
End Function




Public Sub LoadTerrain(HeightMapFile As String, ByVal precision As Johna_LANDSCAPE_QUALITY, YFactor, tu As Single, tv As Single, Optional TexTurefile As String)
   Dim vertextype As CONST_Johna_VERTEX_TYPE
   vertextype = Johna_VERTEX
   
   D_JOX.DX_7.IdentityMatrix Land.Matrix
 
  Dim X, Y, MapX, MapY, U, v, H
  Dim DIB As New cDIBSection
  DIB.CreateFromPicture LoadPicture(HeightMapFile)
  On Error GoTo 0
   '----------------
  ' Load the terrain from a height surface
  ' Charge le terrain  partir d'une surface de hauteur.
  '------------------
  
  If TexTurefile <> "" Then
     Set Land.Surface = D_JOX.CreateTextureEX(TexTurefile, 256, 256)
     Set landtexture = Land.Surface
  End If
  Dim vy() As Single
 
  ' Compute rows and columns
  MapX = Int(DIB.width / precision)
  MapY = Int(DIB.Height / precision)
  stepXX = precision
  stepYY = precision
  width = MapX
  Height = MapY
  'Dim Arrays
  
  ReDim Land.Map(MapX, MapY)
  ReDim Land.Vertex(MapX * MapY)
  ReDim Land.LVertex(MapX * MapY)
  ReDim vy(MapX * MapY)
   '
   '
   ' bounding box
   Dim min As D3DVECTOR
   Dim max As D3DVECTOR
   min = Vector(99999999, 999999999, 999999999)
   max = Vector(-999999999, -999999999, -999999999)
     
   H = 0
   'For each point in the surface
   Dim VV
   For X = 1 To MapX
    For Y = 1 To MapY
     'Find the color of the point
      Land.Map(X, Y) = GetPixel(DIB.hdc, (X - 1) * precision, (Y - 1) * precision) Mod 256
      
      vy(VV) = (Land.Map(X, Y) And &HFF) * 1 'land factor
      VV = VV + 1
      'Change Index / Incrmente l'index
      H = H + 1
      
      'Compose the D3DLVERTEX / Compose le vertex
       U = X / MapX * tu
       v = Y / MapY * tv

       'Land.Vertex(H) = Vertex(X * Precision, YFactor * Land.Map(X, Y), Y * Precision, 0, 1, 0, U, V)
       Land.Vertex(H) = vecVertex(Vector(X * precision, YFactor * Land.Map(X, Y), Y * precision), U, v)
       
       Randomize Timer
       'Land.LVertex(H) = LVertex(X * Precision, YFactor * Land.Map(X, Y), Y * Precision,  d_jox.DX_7.CreateColorRGBA(1, 1, 1, 1), U, V)
      Land.LVertex(H) = vecLVertex(Vector(X * precision, YFactor * Land.Map(X, Y), Y * precision), RGB(153, 153, 153), U, v)
      With Land.LVertex(H)
       If .X > max.X Then max.X = .X
       If .Y > max.Y Then max.Y = .Y
       If .Z > max.Z Then max.Z = .Z
       If .X < min.X Then min.X = .X
       If .Y < min.Y Then min.Y = .Y
       If .Z < min.Z Then min.Z = .Z
      End With
 
    Next Y
   Next X
   
Dim SmoothTerrain As Boolean
SmoothTerrain = 1
  
   ' normalize everything for smoothing level
    Dim ave As Single, A As Long, B As Long
With Land
  If SmoothTerrain = True Then
    For Y = 0 To Height - 1
     For X = 0 To width - 1
        If vy((Y * Height + X)) <> -1 Then
         ave = 0
         B = 0
         For xl = -1 To 1
          For yl = -1 To 1
           If xl + X >= 0 And yl + Y >= 0 And xl + X <= width - 2 And yl + Y <= Height - 2 Then
             If vy((Y + yl) * Height + X + xl) <> -1 Then
              ave = ave + vy((Y + yl) * Height + X + xl)
             Else
             End If
             B = B + 1
           End If
          Next yl
         Next xl
         .Vertex(Y * Height + X).Y = ave / B
         .LVertex(Y * Height + X).Y = ave / B
        
        Else

         .Vertex(Y * Height + X).Y = -1
          .LVertex(Y * Height + X).Y = -1

        End If
        
     Next X
    Next Y
   Else
    For Y = 0 To Height - 1
     For X = 0 To width - 1
         .Vertex(Y * Height + X).Y = vy(Y * Height + X)
         .LVertex(Y * Height + X).Y = vy(Y * Height + X)
     
     Next X
    Next Y
   End If
   
 End With
   J = 0
  
   ' Now Indexes for DrawIndexedPrimitive / Maintenant les index pour la mthode DrawIndexedPrimitive
   ' 2 Triangles per face / 2 triangles par face
   ReDim Land.VertexIndex(MapX * MapY * 6)
   For X = 1 To MapX - 1
    For Y = 1 To MapY - 1
     Land.VertexIndex(J + 2) = (X - 1) * MapY + Y
     Land.VertexIndex(J + 1) = X * MapY + Y
     Land.VertexIndex(J + 0) = (X - 1) * MapY + Y + 1
     Land.VertexIndex(J + 5) = X * MapY + Y
     Land.VertexIndex(J + 4) = X * MapY + Y + 1
     Land.VertexIndex(J + 3) = (X - 1) * MapY + Y + 1
     J = J + 6
    Next Y
   Next X
   ReDim Preserve Land.VertexIndex(J - 1)
   
   'compute sphere
   '
     Dim RAD As D3DVECTOR
   RAD.X = Abs((max.X - min.X) / 2)
   RAD.Y = Abs((max.Y - min.Y) / 2)
   RAD.Z = Abs((max.Z - min.Z) / 2)
 Land.Center = Vector((max.X + min.X) / 2, (max.Y + min.Y) / 2, (max.Z + min.Z) / 2)
 'take the most big radius
 If RAD.X >= RAD.Y And RAD.X >= RAD.Z Then
  Land.Radius = RAD.X * Sqr(2)
 End If
 If RAD.Y >= RAD.X And RAD.Y >= RAD.Z Then
  Land.Radius = RAD.Y * Sqr(2)
 End If
 If RAD.Z >= RAD.X And RAD.Z >= RAD.Y Then
  Land.Radius = RAD.Z * Sqr(2)
 End If
 Land.Mini = min
 Land.maxi = max
 Land.TailleX = max.X - min.X
 Land.TailleZ = max.Z - min.Z
 

 
 
 
 '
  Land.VT = vertextype
  
  With Land.WaterEffect
   .Vertex(2) = LVertex(Vector(0, 0, 0), D_JOX.DX_7.CreateColorRGBA(1, 1, 1, 1), 0, 1)
   .Vertex(1) = LVertex(Vector(MapX * stepXX, 0, 0), D_JOX.DX_7.CreateColorRGBA(1, 1, 1, 1), 1, 1)
   .Vertex(4) = LVertex(Vector(0, 0, MapY * stepYY), D_JOX.DX_7.CreateColorRGBA(1, 1, 1, 1), 0, 0)
   .Vertex(3) = LVertex(Vector(MapX * stepXX, 0, MapY * stepYY), D_JOX.DX_7.CreateColorRGBA(1, 1, 1, 1), 1, 0)
  End With
  
  Land.Water_Width = MapX * stepXX
  Land.Water_Depth = MapY * stepYY
  

  
  Land.WaterEffect.ALTITUDE = 0
  Land.WaterEffect.AnimKey = 0.05
  Land.WaterEffect.TextureScale = 1
  J = H

PrecisionCollide = 5
Me.is_ACTIVE = True
Set DIB = Nothing
OBJECT_getBoundingBOX Land.Vertex, bBOX



'===============
' create The Bilboard vertex
'
'===========

  Dim V1 As D3DVECTOR
     Dim V2 As D3DVECTOR
     Dim Sx, Sy, Sz
     
     Sx = 2 / 2
     Sy = 2 / 2
     Sz = 2 / 2
     
     V1 = Vector(-1, -1, -1)
     V2 = Vector(1, 1, 1)
     
           
    ' Create vertices describing the front face of the cube.
    D_JOX.DX_7.CreateD3DVertex V1.X, V2.Y, V1.Z, 0, 0, -1, 0, 0, Land.BilBoard_VERT(1)
    D_JOX.DX_7.CreateD3DVertex V2.X, V2.Y, V1.Z, 0, 0, -1, 1, 0, Land.BilBoard_VERT(2)
    D_JOX.DX_7.CreateD3DVertex V1.X, V1.Y, V1.Z, 0, 0, -1, 0, 1, Land.BilBoard_VERT(3)
    D_JOX.DX_7.CreateD3DVertex V2.X, V1.Y, V1.Z, 0, 0, -1, 1, 1, Land.BilBoard_VERT(4)
        


End Sub

Private Sub OBJECT_getBoundingBOX(lpVert() As D3DVERTEX, ByRef RetBox As D3DRMBOX)
Dim I, J
Dim RET As D3DRMBOX
Dim Vec As D3DVECTOR

I = LBound(lpVert)
RET.min = VICTOR(lpVert(I).X, lpVert(I).Y, lpVert(I).Z)
RET.max = VICTOR(lpVert(I).X, lpVert(I).Y, lpVert(I).Z)

For I = I + 1 To UBound(lpVert)
   Vec = VICTOR(lpVert(I).X, lpVert(I).Y, lpVert(I).Z)
   
   If Vec.X < RET.min.X Then RET.min.X = Vec.X
   If Vec.Y < RET.min.Y Then RET.min.Y = Vec.Y
   If Vec.Z < RET.min.Z Then RET.min.Z = Vec.Z

   If Vec.X > RET.max.X Then RET.max.X = Vec.X
   If Vec.Y > RET.max.Y Then RET.max.Y = Vec.Y
   If Vec.Z > RET.max.Z Then RET.max.Z = Vec.Z


Next I

RetBox = RET
End Sub

'  transforms a lvertex to a vector
Private Function vert(Vertex As D3DLVERTEX) As D3DVECTOR
  vert.X = Vertex.X
  vert.Y = Vertex.Y
  vert.Z = Vertex.Z
End Function

Private Function VERTE(Vertex As D3DVERTEX) As D3DVECTOR
  VERTE.X = Vertex.X
  VERTE.Y = Vertex.Y
  VERTE.Z = Vertex.Z
End Function


Function vecLVertex(v As D3DVECTOR, COLOR As Long, tu, tv) As D3DLVERTEX
 vecLVertex.X = v.X
 vecLVertex.Y = v.Y
 vecLVertex.Z = v.Z
 vecLVertex.COLOR = COLOR
 vecLVertex.specular = COLOR
 vecLVertex.tu = tu
 vecLVertex.tv = tv
End Function
Function vecVertex(v As D3DVECTOR, tu, tv) As D3DVERTEX
 vecVertex.X = v.X
 vecVertex.Y = v.Y
 vecVertex.Z = v.Z
 
 vecVertex.tu = tu
 vecVertex.tv = tv
End Function

Function RVertex(Vect As D3DVECTOR, vNorm As D3DVECTOR, tu As Single, tv As Single) As D3DVERTEX
    Dim RET As D3DVERTEX
    With RET
        .nx = vNorm.X
        .ny = vNorm.Y
        .nz = vNorm.Z
        .tu = tu
        .tv = tv
        .X = Vect.X
        .Y = Vect.Y
        .Z = Vect.Z
    End With
    RVertex = RET
End Function



Public Sub RenderAll(Optional LIGH As Boolean = False)

 Dim p
 'P = D_JOX.D3D_DEV.GetRenderState(D3DRENDERSTATE_CULLMODE)
 'D_JOX.D3D_DEV.SetRenderState D3DRENDERSTATE_CULLMODE,
 D_JOX.D3D_DEV.SetRenderState D3DRENDERSTATE_ALPHABLENDENABLE, 0
D_JOX.CLearMATRIX
 D_JOX.OBJECT_Scale_MOV OBJET.Vscal.X, OBJET.Vscal.Y, OBJET.Vscal.Z, OBJET.vPosition.X, OBJET.vPosition.Y, OBJET.vPosition.Z
 
 If Not Me.CheckIfVisible Then Exit Sub
 
 If Not Land.Surface Is Nothing Then D_JOX.D3D_DEV.SetTexture 0, Land.Surface
 
 If Not LIGH Then
   D_JOX.D3D_DEV.SetRenderState D3DRENDERSTATE_LIGHTING, True
   D_JOX.D3D_DEV.SetMaterial Land.Material
    D_JOX.D3D_DEV.DrawIndexedPrimitive D3DPT_TRIANGLELIST, D3DFVF_VERTEX, Land.Vertex(0), UBound(Land.Vertex), Land.VertexIndex(), UBound(Land.VertexIndex) - 2, D3DDP_DEFAULT
    D_JOX.USE_defaultMaterial
 End If
 If LIGH Then
  D_JOX.D3D_DEV.SetRenderState D3DRENDERSTATE_LIGHTING, False
    D_JOX.D3D_DEV.DrawIndexedPrimitive D3DPT_TRIANGLELIST, D3DFVF_LVERTEX, Land.LVertex(0), UBound(Land.LVertex), Land.VertexIndex(), UBound(Land.VertexIndex) - 2, D3DDP_DEFAULT
 End If
 
 D_JOX.CLearMATRIX
 'D_JOX.USE_default_RENDERSTATE
 'D_JOX.USE_defaultMaterial
End Sub
Sub Render_Water()
  
 'render water effect
 If Land.WaterEffect.Enabled = True Then
  Dim p
  Dim Alp As Long
  Alp = D_JOX.D3D_DEV.GetRenderState(D3DRENDERSTATE_ALPHABLENDENABLE)
  p = D_JOX.D3D_DEV.GetRenderState(D3DRENDERSTATE_LIGHTING)
   D_JOX.D3D_DEV.SetRenderState D3DRENDERSTATE_LIGHTING, False
  
   D_JOX.OBJECT_Scale_MOV Land.Water_Param.Vscal.X, Land.Water_Param.Vscal.Y, Land.Water_Param.Vscal.Z, Land.Water_Param.vPosition.X, Land.Water_Param.vPosition.Y, Land.Water_Param.vPosition.Z

  If Land.Water_Texture_OK Then D_JOX.D3D_DEV.SetTexture 0, Land.Water_SURface
 
  If Land.WaterEffect.Animated = True Then
   Land.WaterEffect.AnimKey = Land.WaterEffect.AnimKey + D_JOX.ElapseFrame * 0.001
   A = Land.WaterEffect.AnimKey: ST = Land.WaterEffect.TextureScale
   'calculate Water "animation"
   
   
   Land.WaterEffect.Vertex(1).tu = ST + Cos(A) * ST / 100
   Land.WaterEffect.Vertex(1).tv = ST
   Land.WaterEffect.Vertex(2).tu = 0 + Cos(A) * ST / 100
   Land.WaterEffect.Vertex(2).tv = ST
   Land.WaterEffect.Vertex(3).tu = ST + Cos(A) * ST / 100
   Land.WaterEffect.Vertex(3).tv = 0
   Land.WaterEffect.Vertex(4).tu = 0 + Cos(A) * ST / 100
   Land.WaterEffect.Vertex(4).tv = 0
  If A > 3 * 360 Then Land.WaterEffect.AnimKey = -360 * 2
  End If
  'alpha setting
   D_JOX.D3D_DEV.SetRenderState D3DRENDERSTATE_ALPHABLENDENABLE, Land.WaterEffect.Alphablended
   D_JOX.D3D_DEV.SetRenderState D3DRENDERSTATE_SRCBLEND, D3DBLEND_SRCALPHA
   D_JOX.D3D_DEV.SetRenderState D3DRENDERSTATE_DESTBLEND, D3DBLEND_ONE
  
  'water rendering
   D_JOX.D3D_DEV.DrawPrimitive D3DPT_TRIANGLESTRIP, D3DFVF_LVERTEX, Land.WaterEffect.Vertex(1), 4, D3DDP_DEFAULT
  
  'restore states
  D_JOX.D3D_DEV.SetRenderState D3DRENDERSTATE_LIGHTING, 1
  D_JOX.D3D_DEV.SetRenderState D3DRENDERSTATE_ALPHABLENDENABLE, False
  
   D_JOX.D3D_DEV.SetRenderState D3DRENDERSTATE_SRCBLEND, D3DBLEND_SRCCOLOR
   D_JOX.D3D_DEV.SetRenderState D3DRENDERSTATE_DESTBLEND, D3DBLEND_ZERO
  
 End If
 
 
 

End Sub


Sub Render_BilBoard(ObjPos As D3DVECTOR, Widt As Single, Heig As Single)
 ''// Store current view matrix and disable view transformation):
    Dim matViewBak As D3DMATRIX
    Dim IdentityMatrix As D3DMATRIX
    Dim TransPos As D3DVECTOR
    D_JOX.DX_7.IdentityMatrix IdentityMatrix
    'Dim VERT(4) As D3DVERTEX
    Dim I
    'VERT = Land.BilBoard_VERT
    
    'CopyMemory VERT(0), Land.BilBoard_VERT(0), 5
    
   Dim D
   D = D_JOX.CAM_angleBilBOARD
   'D_JOX.Set_Light 1
 
 'check for alpha state
  
    ' Set diffuse blending for alpha set in vertices.
    Call D_JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_ALPHABLENDENABLE, True)
    Call D_JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_SRCBLEND, D3DBLEND_SRCALPHA)
    Call D_JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_DESTBLEND, D3DBLEND_INVSRCALPHA)

    ' Enable alpha testing
    Call D_JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_ALPHATESTENABLE, m_bUseAlphaTest)
    Call D_JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_ALPHAREF, &H8&)
    Call D_JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_ALPHAFUNC, D3DCMP_GREATEREQUAL)

 
    
   D_JOX.OBJECT_Scale_Rotate_MOV Widt / 3, Heig / 3, 1, 0, D, 0, ObjPos.X, ObjPos.Y + 1 / 3 * Heig, ObjPos.Z

   D_JOX.D3D_DEV.DrawPrimitive D3DPT_TRIANGLESTRIP, D3DFVF_VERTEX, Land.BilBoard_VERT(1), 4, D3DDP_DEFAULT
  D_JOX.CLearMATRIX
  
   
    'Call D_JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_LIGHTING, True)
    ' Restore state
    Call D_JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_ALPHATESTENABLE, False)
    Call D_JOX.D3D_DEV.SetRenderState(D3DRENDERSTATE_ALPHABLENDENABLE, False)

End Sub









Public Sub SetTextureCoordinates(tu, tv)
  H = 0
     For X = 1 To width
    For Y = 1 To Height
      H = H + 1
       U = X / width * tu
       v = Y / Height * tv
       Land.Vertex(H).tu = U
       Land.Vertex(H).tv = v
       Land.LVertex(H).tu = U
       Land.LVertex(H).tv = v
    Next Y
   Next X
End Sub





Sub SetWaterAltitude(ALTITUDE As Single)
 Land.WaterEffect.ALTITUDE = ALTITUDE
 For I = 1 To 4
  Land.WaterEffect.Vertex(I).Y = ALTITUDE
 Next I
End Sub

Sub Load_Watertexture(WtexFile As String)
   On Error GoTo Terror
   Set Land.Water_SURface = D_JOX.CreateTextureEX(WtexFile, 256, 256)
   Land.Water_Texture_OK = True
   
   Exit Sub
Terror:
   
  Land.Water_Texture_OK = False
End Sub

Sub SetWaterEffect(alpha As Boolean, Optional AlphaFactor As Single = 0.4, Optional Animated As Boolean = False)
 Land.WaterEffect.Alphablended = alpha
 Land.WaterEffect.Animated = Animated
 Land.WaterEffect.AlphaFactor = AlphaFactor
 For I = 1 To 4
  Land.WaterEffect.Vertex(I).COLOR = D_JOX.DX_7.CreateColorRGBA(1, 1, 1, AlphaFactor)
 Next I
 
End Sub

Sub SetWaterEnable(OnOff As Boolean)
 Land.WaterEffect.Enabled = True
End Sub



Sub SetWaterTextureScale(ScaleTexture As Single)
  If Land.WaterEffect.Animated = False Then
  For I = 1 To 4
   Land.WaterEffect.Vertex(I).tu = Sgn(Land.WaterEffect.Vertex(I).tu) * ScaleTexture
   Land.WaterEffect.Vertex(I).tv = Sgn(Land.WaterEffect.Vertex(I).tv) * ScaleTexture
  Next I
 
  End If
  Land.WaterEffect.TextureScale = ScaleTexture
End Sub







Public Property Let Vscal(vNew As D3DVECTOR)
      OBJET.Vscal = vNew

End Property

Public Property Get Vscal() As D3DVECTOR
      Vscal = OBJET.Vscal

End Property

Public Property Get vPosition() As D3DVECTOR
      vPosition = OBJET.vPosition
End Property

Public Property Let vPosition(vNew As D3DVECTOR)
      OBJET.vPosition = vNew

End Property


Sub Set_TerrainMaterial(SrcMat As D3DMATERIAL7)
     Land.Material = SrcMat
End Sub

Sub Set_Position(X, Y, Z)
  OBJET.vPosition.X = X
  OBJET.vPosition.Y = Y
  OBJET.vPosition.Z = Z
End Sub

Sub Set_Rotation(X, Y, Z)
  OBJET.Vrotate.X = X
  OBJET.Vrotate.Y = Y
  OBJET.Vrotate.Z = Z
End Sub

Sub Set_Scale(X, Y, Z)
  OBJET.Vscal.X = X
  OBJET.Vscal.Y = Y
  OBJET.Vscal.Z = Z
End Sub



Public Property Let Water_scal(vNew As D3DVECTOR)
       Land.Water_Param.Vscal = vNew
     
End Property

Function Water_Collision(Vpos As D3DVECTOR, Optional Max_OverWaterAltitude As Single = 5) As Boolean
  If Vpos.Y < Max_OverWaterAltitude + Land.Water_Param.vPosition.Y Then
    If Vpos.X >= Land.Water_Param.vPosition.X And _
       Vpos.Z >= Land.Water_Param.vPosition.Z And _
       Vpos.X <= Land.Water_Param.vPosition.X + Land.Water_Width * Land.Water_Param.Vscal.X And _
       Vpos.Z <= Land.Water_Param.vPosition.Z + Land.Water_Depth * Land.Water_Param.Vscal.Z Then
       
       Water_Collision = True
       Exit Function
   End If
  
  
  End If
  
    
End Function


Public Property Get Water_scal() As D3DVECTOR
      Water_scal = Land.Water_Param.Vscal

End Property

Public Property Get Water_Position() As D3DVECTOR
      Water_Position = Land.Water_Param.vPosition
End Property

Public Property Let Water_Position(vNew As D3DVECTOR)
       Land.Water_Param.vPosition = vNew

End Property




'*******************************
'*  Vector arithmtic
'***********
Private Function Vector(A As Single, B As Single, C As Single) As D3DVECTOR
    Dim vecOut As D3DVECTOR
    
    With vecOut
        .X = A
        .Y = B
        .Z = C
    End With
    
    Vector = vecOut
    
End Function

Private Function vNormal(VA As D3DVECTOR, VB As D3DVECTOR) As Single
vNormal = Sqr((VB.X - VA.X) ^ 2 + (VB.Y - VA.Y) ^ 2 + (VB.Z - VA.Z) ^ 2)




End Function

Private Function Vsub(A As D3DVECTOR, B As D3DVECTOR) As D3DVECTOR
  Dim Dest As D3DVECTOR
  Dest.X = A.X - B.X
  Dest.Y = A.Y - B.Y
  Dest.Z = A.Z - B.Z
  Vsub = Dest
End Function


Private Function Vmiddle(VA As D3DVECTOR, VB As D3DVECTOR) As D3DVECTOR
Vmiddle.X = (VA.X + VB.X) / 2
Vmiddle.Y = (VA.Y + VB.Y) / 2
Vmiddle.Z = (VA.Z + VB.Z) / 2

End Function






Private Function LVertex(v As D3DVECTOR, COLOR As Long, tu, tv) As D3DLVERTEX
 LVertex.X = v.X
 LVertex.Y = v.Y
 LVertex.Z = v.Z
 LVertex.COLOR = COLOR
 LVertex.specular = COLOR
 LVertex.tu = tu
 LVertex.tv = tv
End Function


Private Function CalculateNormal(p0 As D3DVECTOR, p1 As D3DVECTOR, p2 As D3DVECTOR) As D3DVECTOR
'//0. Any variables
    Dim vNorm As D3DVECTOR
    Dim v01 As D3DVECTOR
    Dim v02 As D3DVECTOR

'//1. Subtract vectors
    
    D_JOX.DX_7.VectorSubtract v01, p1, p0
    D_JOX.DX_7.VectorSubtract v02, p2, p0
    
'//2. Perform Cross Product
     
    D_JOX.DX_7.VectorCrossProduct vNorm, v01, v02

'//3. Normalize
    D_JOX.DX_7.VectorNormalize vNorm

'//4. Return normal
    CalculateNormal = vNorm
End Function

Private Sub Class_Initialize()
  Land.Water_Param.Vscal = Vector(1, 1, 1)
End Sub


Function FreeRessource()
 Erase Land.Vertex
 Erase Land.LVertex
 Erase Land.VertexIndex
End Function



Private Function VectorMatrixMultiply(vDest As D3DVECTOR, _
                                vSrc As D3DVECTOR, _
                                 Mat As D3DMATRIX)
Dim X, Y, Z, W

 X = vSrc.X * Mat.rc11 + vSrc.Y * Mat.rc21 + vSrc.Z * Mat.rc31 + Mat.rc41
 Y = vSrc.X * Mat.rc12 + vSrc.Y * Mat.rc22 + vSrc.Z * Mat.rc32 + Mat.rc42
Z = vSrc.X * Mat.rc13 + vSrc.Y * Mat.rc23 + vSrc.Z * Mat.rc33 + Mat.rc43
 W = vSrc.X * Mat.rc14 + vSrc.Y * Mat.rc24 + vSrc.Z * Mat.rc34 + Mat.rc44
    
    If Abs(W) < 0.00001 Then
        VectorMatrixMultiply = 0
        Exit Function
    End If

    vDest.X = X / W
    vDest.Y = Y / W
    vDest.Z = Z / W

    VectorMatrixMultiply = 1




End Function

Private Sub Class_Terminate()
 Call Me.FreeRessource
End Sub
