VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cJohna_Sphere"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

'
Private Const ParticleSize As Single = 1
Private Const PI = 3.14159265
Private Const RAD = PI / 180              'mul


' Sphere parameters.
Private Const SPHERE_RADIUS = 6
Private Const NUM_PHI = 5
Private Const DPHI = PI / NUM_PHI
Private Const NUM_THETA = 2 * NUM_PHI
Private Const DTHETA = 2 * PI / NUM_THETA

Private m_FirstRingVertex As Long
Private m_FirstCapVertex As Long
Private M_Tex As DirectDrawSurface7
Private TEXT_OK As Boolean

Dim SphereTest() As D3DVERTEX
Dim NumSphereVer As Long

Public Enum Johna_SPHERE_QUALITY
   LOW_QUALITY = &HF0
   NORMAL_QUALITY = &HF1
   HIGH_QUALITY = &HF2
   SMOOTH_QUALITY = &HF3
   
   

End Enum

'for translating and scaling terrain
Private Type VerTEX_PARAM
  vPosition As D3DVECTOR
  Vscal As D3DVECTOR
  Vrotate As D3DVECTOR
  

End Type

Private OBJET As VerTEX_PARAM

Function InitSPhere(DXengine As johna_DX7, Optional TexTurefile As String, Optional Quality As Johna_SPHERE_QUALITY, Optional BaseXscale As Single = 1, Optional BaseYscale As Single = 1, Optional BaseZscale As Single = 1) As Boolean
     If TexTurefile <> "" Then
       Set M_Tex = DXengine.CreateTextureEX(TexTurefile, 256, 256)
       TEXT_OK = True
     End If
     Dim I As Long, J As Long
     If Quality = LOW_QUALITY Then
        I = 10: J = 10
     ElseIf Quality = NORMAL_QUALITY Then
        I = 15: J = 15
     ElseIf Quality = HIGH_QUALITY Then
        I = 20: J = 20
     ElseIf Quality = SMOOTH_QUALITY Then
        I = 28: J = 28
     End If
     
     Me.Set_Scale 1, 1, 1
     Me.Set_Position 0, 0, 0
     GenerateEllipse SphereTest, I, J, BaseXscale, BaseYscale, BaseZscale, NumSphereVer, False, False, 1
     If NumSphereVer > 0 Then InitSPhere = True
     
End Function


Sub Render(DXengine As johna_DX7, Optional ForceDomeSky As Boolean = True)
  If TEXT_OK Then DXengine.D3D_DEV.SetTexture 0, M_Tex
  Dim p As Long
  
   
  If ForceDomeSky Then
    p = DXengine.D3D_DEV.GetRenderState(D3DRENDERSTATE_CULLMODE)
    DXengine.D3D_DEV.SetRenderState D3DRENDERSTATE_CULLMODE, 2 'D3DCULL_NONE
  End If
  
  DXengine.CLearMATRIX
  DXengine.OBJECT_Scale_MOV OBJET.Vscal.X, OBJET.Vscal.Y, OBJET.Vscal.Z, OBJET.vPosition.X, OBJET.vPosition.Y, OBJET.vPosition.Z
  DXengine.D3D_DEV.DrawPrimitive D3DPT_TRIANGLESTRIP, D3DFVF_VERTEX, SphereTest(0), NumSphereVer, D3DDP_DEFAULT
  DXengine.CLearMATRIX

  If ForceDomeSky Then
    DXengine.D3D_DEV.SetRenderState D3DRENDERSTATE_CULLMODE, p
  End If
    
   
End Sub



Sub Set_Position(X, Y, Z)
  OBJET.vPosition.X = X
  OBJET.vPosition.Y = Y
  OBJET.vPosition.Z = Z
End Sub

Sub Set_Rotation(X, Y, Z)
  OBJET.Vrotate.X = X
  OBJET.Vrotate.Y = Y
  OBJET.Vrotate.Z = Z
End Sub

Sub Set_Scale(X, Y, Z)
  OBJET.Vscal.X = X
  OBJET.Vscal.Y = Y
  OBJET.Vscal.Z = Z
End Sub












Private Sub GenerateEllipse(pV() As D3DVERTEX, NumRings As Long, NumSegments As Long, fXScale As Single, fZScale As Single, fYScale As Single, NumVertices As Long, Optional bBend As Boolean = False, Optional bInside As Boolean = False, Optional TexScale As Single = 1#)
    Dim fDeltaRingAngle As Single
    Dim fDeltaSegAngle As Single
    Dim ppVert As Long
    Dim Ring As Long
    Dim Seg As Long
    Dim r0 As Single
    Dim x0 As Single
    Dim y0 As Single
    Dim z0 As Single
    Dim r1 As Single
    Dim x1 As Single
    Dim y1 As Single
    Dim z1 As Single
    Dim V1 As D3DVECTOR
    Dim V2 As D3DVECTOR
    
    '// Allocate space for the sphere
    ReDim pV(2 * NumRings * (NumSegments + 1))
    NumVertices = 2 * NumRings * (NumSegments + 1)

    '// Establish constants used in sphere generation
    fDeltaRingAngle = PI / NumRings
    fDeltaSegAngle = 2 * PI / NumSegments
    '// Generate the group of rings for the sphere
    For Ring = IIf(bInside, NumRings - 1, 0) To IIf(bInside, 0, NumRings - 1) Step IIf(bInside, -1, 1)
        r0 = Sin(Ring * fDeltaRingAngle)
        r1 = Sin((Ring + 1) * fDeltaRingAngle)
        y0 = Cos(Ring * fDeltaRingAngle)
        y1 = Cos((Ring + 1) * fDeltaRingAngle)

        '// Generate the group of segments for the current ring
        For Seg = IIf(bInside, NumSegments, 0) To IIf(bInside, 0, NumSegments) Step IIf(bInside, -1, 1)
            x0 = r0 * Sin(Seg * fDeltaSegAngle)
            z0 = r0 * Cos(Seg * fDeltaSegAngle)
            x1 = r1 * Sin(Seg * fDeltaSegAngle)
            z1 = r1 * Cos(Seg * fDeltaSegAngle)
            
            If bBend Then
                ' bend slightly :-)
                x0 = x0 + (y0 * y0 * 2)
                x1 = x1 + (y1 * y1 * 2)
            End If
            
            ' Add two vertices to the strip which makes up the sphere
            'If Not bInside Then
                V1 = Vector(fXScale * x0, fYScale * y0, fZScale * z0)
                V2 = Vector(x0, y0, z0)
                pV(ppVert) = vD3DVertex(V1, V2, -Seg / NumSegments * TexScale, Ring / NumRings * TexScale, bInside)
                ppVert = ppVert + 1
            'End If
            
            V1 = Vector(fXScale * x1, fYScale * y1, fZScale * z1)
            V2 = Vector(x1, y1, z1)
            pV(ppVert) = vD3DVertex(V1, V2, -Seg / NumSegments * TexScale, (Ring + 1) / NumRings * TexScale, bInside)
            ppVert = ppVert + 1
            
        Next
    Next

End Sub
Private Function vD3DVertex(p1 As D3DVECTOR, vNorm As D3DVECTOR, tu As Single, tv As Single, bInside As Boolean) As D3DVERTEX
    
    With vD3DVertex
        .X = p1.X
        .Y = p1.Y
        .Z = p1.Z
        If bInside = False Then
            .nx = vNorm.X
            .ny = vNorm.Y
            .nz = vNorm.Z
        Else
            .nx = -vNorm.X
            .ny = -vNorm.Y
            .nz = -vNorm.Z
        End If
        .tu = tu
        .tv = tv
    End With
End Function

Private Sub GenerateRing(pV() As D3DVERTEX, NumSegments As Long, NumVertices As Long, Optional TexScale As Single = 1#)
    Dim fDeltaRingAngle As Single
    Dim fDeltaSegAngle As Single
    Dim ppVert As Long
    Dim Ring As Long
    Dim Seg As Long
    Dim r0 As Single
    Dim x0 As Single
    Dim y0 As Single
    Dim z0 As Single
    Dim r1 As Single
    Dim x1 As Single
    Dim y1 As Single
    Dim z1 As Single
    Dim V1 As D3DVECTOR
    Dim V2 As D3DVECTOR
    Dim bInside As Boolean
    
    '// Allocate space for the sphere
    ReDim pV(4 * (NumSegments + 1))
    NumVertices = 4 * (NumSegments + 1)
    r0 = 1
    r1 = 2
    y0 = -0.001
    bInside = False
    '// Establish constants used in ring generation
    fDeltaSegAngle = 2 * PI / NumSegments
    
    '// Generate the group of segments for the current ring
    For Seg = 0 To NumSegments
        x0 = r0 * Sin(Seg * fDeltaSegAngle)
        z0 = r0 * Cos(Seg * fDeltaSegAngle)
        x1 = r1 * Sin(Seg * fDeltaSegAngle)
        z1 = r1 * Cos(Seg * fDeltaSegAngle)
                    
        V1 = Vector(x0, y0, z0)
        pV(ppVert) = vD3DVertex(V1, Vector(0, 1, 0), Seg / NumSegments * TexScale, 0, bInside)
        ppVert = ppVert + 1
        
        V1 = Vector(x1, y0, z1)
        pV(ppVert) = vD3DVertex(V1, Vector(0, 1, 0), Seg / NumSegments * TexScale, 1, bInside)
        ppVert = ppVert + 1
    Next
    bInside = True
    y0 = 0.001
    For Seg = NumSegments To 0 Step -1
        x0 = r0 * Sin(Seg * fDeltaSegAngle)
        z0 = r0 * Cos(Seg * fDeltaSegAngle)
        x1 = r1 * Sin(Seg * fDeltaSegAngle)
        z1 = r1 * Cos(Seg * fDeltaSegAngle)
                    
        V1 = Vector(x0, y0, z0)
        pV(ppVert) = vD3DVertex(V1, Vector(0, -1, 0), -Seg / NumSegments * TexScale, 0, bInside)
        ppVert = ppVert + 1
        
        V1 = Vector(x1, y0, z1)
        pV(ppVert) = vD3DVertex(V1, Vector(0, -1, 0), -Seg / NumSegments * TexScale, 1, bInside)
        ppVert = ppVert + 1
    Next


End Sub
Private Function Vector(X As Single, Y As Single, Z As Single) As D3DVECTOR
    With Vector
        .X = X
        .Y = Y
        .Z = Z
    End With
End Function

Private Sub Class_Terminate()
If NumSphereVer > 0 Then Erase SphereTest
End Sub
