VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "johna_DX7"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

'==============================================
'Johna DX7 engine version 1.04
'  this engine was developed by Johna
' I finaly decide to provide the source code for helping people
'  to realize great 3d engine inside VB
'
' for use or any question or suggestion
'  mail me at johna.pop@caramail.com
'
'
'  - version 0.018 24/09/2001 Texture_SPHEREmapping add
'        - Add boundingBOX from a poly vertice list
'        - Add good multiple boundingBOX colision for Xfiles mesh
'        - Add collision class engine
'  -Version 0.019 24/09/2001
'
'  -version 0.020 27/09/2001
'        -  Add an enueration dialogue Box for 3d device
'
'  -Version 0.021 28/09/2001
'        -  Add Initialization by Device GUID
'        -  Add Initialize_EngineEX
'
'
'  -Version 0.022 29/09/2001
'        -  Add Bug fixing in the 3ds mesh loader class
'        -  Add A new Sound Engine class based on Unlimited and
'              separeted buffer for playing soundFX and moving soundFX
'
'        -  Add artificial intelligence for moving Vehicles
'  -Version 0.023
'        - Complete rebuilt of the sound engine
'
'
' -version 0.30 31/01/2002
'        - Add a new AABB colision detection
'        - An improved landscape Engine with smooth tesselation
'
'
'
'===============================================

Const VERSIO = 1.031




'=====================
'  Direct Draw Variables
'========================

Private INIT_ok As Boolean
Public DX_7 As New DirectX7
Public ddraw As DirectDraw7
Public PrimaryBuffer As DirectDrawSurface7
Public BackBuffer As DirectDrawSurface7
Private CLIP As DirectDrawClipper
Public PAUSE_is_on As Boolean
Public Pause_DC As Long
Public Check_Mouse_cam As Boolean

Private IS_GammaOK As Boolean



Dim GammaControler As DirectDrawGammaControl    'The object that gets/sets gamma ramps
Dim GammaRamp As DDGAMMARAMP                    'The gamma ramp we'll use to alter the screen state
Dim OriginalRamp As DDGAMMARAMP                 'The gamma ramp we'll use to store the original screen state



Public MEMORY As Long


'=====================
'  Direct 3d
'========================

Public D3d As Direct3D7


Private ZBuffer As DirectDrawSurface7
Public D3D_DEV As Direct3DDevice7
Private g_d3drcViewport(0) As D3DRECT
Private ViewPort As D3DVIEWPORT7
Private m_bUseAlphaTest As Boolean
Public lheight As Long
Public lWidth As Long
Public PIFactor  As Single
Private MODULATE_timer As Long


Private MA_World As D3DMATRIX
Private MA_View As D3DMATRIX
Private MA_Projection As D3DMATRIX
Public device_CLEAR_COLOR As Long

 Private P_dCalculatorMatrix As D3DMATRIX    ' Matrix used for calculations
 
 Private Type LOGA
    Message() As String
    NB_message As Integer
 
 End Type

Private msg As LOGA
Public LOG_console_is_ON As Boolean

Private Type Dpoint
     X As Single
     Y As Single

End Type




Private Type ENGINE_world
     Col_rect As Drect
     X_min As Single
     X_max As Single
     Y_min As Single
     Y_max As Single
     Z_min As Single
     Z_max As Single
     


End Type


'for future engine parameters setting
Public Enum Johna_PIPELINE_parms
         Johna_ZBUFFER_enable = &H0
         Johna_ZWRITER_enable = &H1
         Johna_LIGHT_enable = &H2
         Johna_ALPHA_enable = &H3
         Johna_FOG_enable = &H4
         

End Enum

Private World_BOTTOM_Left As D3DVECTOR
Private World_TOP_Right As D3DVECTOR

Private MONDE As ENGINE_world

'===================
'   GDI32
'======================

Private Declare Function StretchBlt Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal dwRop As Long) As Long
Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function GetPixel Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long) As Long
Private Declare Function GetDC Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Private Declare Function IntersectRect Lib "user32" (lpDestRect As RECT, lpSrc1Rect As RECT, lpSrc2Rect As RECT) As Long
Private Declare Function SetCursorPos Lib "user32" (ByVal X As Long, ByVal Y As Long) As Long

Private Declare Function LoadTargaFile Lib "johny.dll" (ByVal STfile As String, ByVal DC As Long) As Long



'=====================
'  Direct sound now is in a Class
'========================

'Public DsounD As DirectSound


'Private Type DSound_johna
 '     WaveName As String
  '    VOl As Long
   '   Index_buf As Long
    '  DSounD_buf As DirectSoundBuffer
     ' BUF3d As DirectSound3DBuffer
      'Pos As D3DVECTOR
      'IS_Playing As Boolean
'End Type

'Private SoundBUF() As DSound_johna
'Public Total_SoundBUF As Integer
'Public IS_DSound3D As Boolean
'Public DS_Listener As DirectSound3DListener
'Private m_dsPrimaryBuffer As DirectSoundBuffer



'=====================
'  Direct input
'========================


Private KEY_board As DIKEYBOARDSTATE
Public Dinput_DEV As DirectInputDevice
Public Dinput As DirectInput

Private Mouse_device As DirectInputDevice
Private Mouse_state As DIMOUSESTATE
Public Dinput_isINIT As Boolean

Private Type COORD
        X As Integer
        Y As Integer
End Type
Private Type MOUSE_EVENT_RECORD
        dwMousePosition As COORD
        dwButtonState As Long
        dwControlKeyState As Long
        dwEventFlags As Long
End Type

Public Enum MOSS
    Left_Button = 0
    Right_Button = 1
    Middle = 2
    

End Enum
Private Type POINTAPI
        X As Long
        Y As Long
End Type

Private Pos As POINTAPI




Public Enum Johna_KEY_CONST
 
  Johna_KEY_0 = DIK_0
  Johna_KEY_1 = DIK_1
  Johna_KEY_2 = DIK_2
  Johna_KEY_3 = DIK_3
  Johna_KEY_4 = DIK_4
  Johna_KEY_5 = DIK_5
  Johna_KEY_6 = DIK_6
  Johna_KEY_7 = DIK_7
  Johna_KEY_8 = DIK_8
  Johna_KEY_9 = DIK_9
  Johna_KEY_A = DIK_A
  'Johna_KEY_ABNT_C1 = DIK_ABNT_C1
  'Johna_KEY_ABNT_C2 = DIK_ABNT_C2
  Johna_KEY_ADD = DIK_ADD
  Johna_KEY_APOSTROPHE = DIK_APOSTROPHE
  Johna_KEY_APPS = DIK_APPS
  Johna_KEY_AT = DIK_AT
  Johna_KEY_AX = DIK_AX
  Johna_KEY_B = DIK_B
  Johna_KEY_BACKSPACE = DIK_BACK
  Johna_KEY_BACKSLASH = DIK_BACKSLASH
  Johna_KEY_C = DIK_C
  'Johna_KEY_CALCULATOR = DIK_CALCULATOR
  Johna_KEY_CAPITAL = DIK_CAPITAL
  'Johna_KEY_CAPSLOCK = DIK_CAPSLOCK
  Johna_KEY_CIRCUMFLEX = DIK_CIRCUMFLEX
  Johna_KEY_COLON = DIK_COLON
  Johna_KEY_COMMA = DIK_COMMA
  Johna_KEY_CONVERT = DIK_CONVERT
  Johna_KEY_D = DIK_D
  Johna_KEY_DECIMAL = DIK_DECIMAL
  Johna_KEY_DELETE = DIK_DELETE
  Johna_KEY_DIVIDE = DIK_DIVIDE
  Johna_KEY_DOWN = DIK_DOWN
  'Johna_KEY_DOWNARROW = DIK_DOWNARROW
  Johna_KEY_E = DIK_E
  Johna_KEY_END = DIK_END
  Johna_KEY_EQUALS = DIK_EQUALS
  johna_KEY_ESCAPE = DIK_ESCAPE
  Johna_KEY_F = DIK_F
  Johna_KEY_F1 = DIK_F1
  Johna_KEY_F2 = DIK_F2
  Johna_KEY_F3 = DIK_F3
  Johna_KEY_F4 = DIK_F4
  Johna_KEY_F5 = DIK_F5
  Johna_KEY_F6 = DIK_F6
  Johna_KEY_F7 = DIK_F7
  Johna_KEY_F8 = DIK_F8
  Johna_KEY_F9 = DIK_F9
  Johna_KEY_F10 = DIK_F10
  Johna_KEY_F11 = DIK_F11
  Johna_KEY_F12 = DIK_F12
  Johna_KEY_F13 = DIK_F13
  Johna_KEY_F14 = DIK_F14
  Johna_KEY_F15 = DIK_F15
  Johna_KEY_G = DIK_G
  Johna_KEY_GRAVE = DIK_GRAVE
  Johna_KEY_H = DIK_H
  Johna_KEY_HOME = DIK_HOME
  Johna_KEY_I = DIK_I
  Johna_KEY_INSERT = DIK_INSERT
  Johna_KEY_J = DIK_J
  Johna_KEY_K = DIK_K
  Johna_KEY_KANA = DIK_KANA
  Johna_KEY_KANJI = DIK_KANJI
  Johna_KEY_L = DIK_L
  'Johna_KEY_ALT_LEFT = DIK_LALT
  Johna_KEY_LEFTBRACKET = DIK_LBRACKET
  Johna_KEY_LEFTCONTROL = DIK_LCONTROL
  Johna_KEY_LEFT = DIK_LEFT
  'Johna_KEY_LEFTARROW = DIK_LEFTARROW
  Johna_KEY_LEFTMENU = DIK_LMENU
  Johna_KEY_LEFTSHIFT = DIK_LSHIFT
  Johna_KEY_LEFTWINDOWS = DIK_LWIN
  Johna_KEY_M = DIK_M
  'Johna_KEY_MAIL = DIK_MAIL
  'Johna_KEY_MEDIASELECT = DIK_MEDIASELECT
  'Johna_KEY_MEDIASTOP = DIK_MEDIASTOP
  Johna_KEY_MINUS = DIK_MINUS
  Johna_KEY_MULTIPLY = DIK_MULTIPLY
  'Johna_KEY_MUTE = DIK_MUTE
  'Johna_KEY_MYCOMPUTER = DIK_MYCOMPUTER
  Johna_KEY_N = DIK_N
  Johna_KEY_NEXT = DIK_NEXT
  'Johna_KEY_NEXTTRACK = DIK_NEXTTRACK
  Johna_KEY_NOCONVERT = DIK_NOCONVERT
  Johna_KEY_NUMLOCK = DIK_NUMLOCK
  Johna_KEY_NUMPAD0 = DIK_NUMPAD0
  Johna_KEY_NUMPAD1 = DIK_NUMPAD1
  Johna_KEY_NUMPAD2 = DIK_NUMPAD2
  Johna_KEY_NUMPAD3 = DIK_NUMPAD3
  Johna_KEY_NUMPAD4 = DIK_NUMPAD4
  Johna_KEY_NUMPAD5 = DIK_NUMPAD5
  Johna_KEY_NUMPAD6 = DIK_NUMPAD6
  Johna_KEY_NUMPAD7 = DIK_NUMPAD7
  Johna_KEY_NUMPAD8 = DIK_NUMPAD8
  Johna_KEY_NUMPAD9 = DIK_NUMPAD9
  Johna_KEY_NUMPADCOMMA = DIK_NUMPADCOMMA
  Johna_KEY_NUMPADENTER = DIK_NUMPADENTER
  Johna_KEY_NUMPADEQUALS = DIK_NUMPADEQUALS
 
  Johna_KEY_O = DIK_O
  
  johna_KEY_P = DIK_P
  Johna_KEY_PAUSE = DIK_PAUSE
  Johna_KEY_PERIOD = DIK_PERIOD
  
  Johna_KEY_Q = DIK_Q
  Johna_KEY_R = DIK_R
  'Johna_KEY_ALT_RIGHT = DIK_RALT
  Johna_KEY_RIGHTBRACKET = DIK_RBRACKET
  Johna_KEY_RCONTROL = DIK_RCONTROL
  Johna_KEY_RETURN = DIK_RETURN
  Johna_KEY_RIGHT = DIK_RIGHT
  'Johna_KEY_RIGHTARROW = DIK_RIGHTARROW
  Johna_KEY_RIGHTMENU = DIK_RMENU
  Johna_KEY_RIGHTSHIFT = DIK_RSHIFT
  Johna_KEY_RWIN = DIK_RWIN
  Johna_KEY_S = DIK_S
  Johna_KEY_SCROLL = DIK_SCROLL
  Johna_KEY_SEMICOLON = DIK_SEMICOLON
  Johna_KEY_SLASH = DIK_SLASH
  'Johna_KEY_SLEEP = DIK_SLEEP
  Johna_KEY_SPACE = DIK_SPACE
  Johna_KEY_STOP = DIK_STOP
  Johna_KEY_SUBTRACT = DIK_SUBTRACT
  Johna_KEY_SYSRQ = DIK_SYSRQ
  Johna_KEY_T = DIK_T
  Johna_KEY_TAB = DIK_TAB
  Johna_KEY_U = DIK_U
  Johna_KEY_UNDERLINE = DIK_UNDERLINE
  Johna_KEY_UNLABELED = DIK_UNLABELED
  Johna_KEY_UP = DIK_UP
  'Johna_KEY_UPARROW = DIK_UPARROW
  Johna_KEY_V = DIK_V
  
  Johna_KEY_W = DIK_W
 
  Johna_KEY_X = DIK_X
  Johna_KEY_Y = DIK_Y
  Johna_KEY_YEN = DIK_YEN
  Johna_KEY_Z = DIK_Z
 
End Enum





Private Declare Function GetCursor Lib "user32" () As Long
Private Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long
Private Declare Function GetAsyncKeyState Lib "user32" (ByVal vKey As Long) As Integer

'===========================================
'   For the camera
'================================


Private Type CAM
    EYE As D3DVECTOR
    View_AT As D3DVECTOR
    Dest_at As D3DVECTOR
    M As Variant
    p As Variant
    Vector_siZE As Variant
    DEG As Double
    Angy As Double
    ANGZ As Double
    
    Mouse_Prev_X As Long
    Mouse_Prev_Y As Long
    JUMPY As Boolean
    JUMP_step As Single
    JUMP_MAX As Single
    JUMP_loc As Single
    LastY As Single
End Type



Private Type xTra
    Minprojection As Single
    Maxprojection As Single
    angle As Double
    CullMode As Long

End Type







Private Data As xTra

'camera vars
Private Eyes As CAM
Private LAST_cam As CAM
Private Camera As D3DVECTOR
Private VIEW_at_Point As D3DVECTOR
Private Const JOHNA_PI = 3.13987644547878

Private Const RAIAN = JOHNA_PI / 180



Private rcDest As RECT
Private rcSrc As RECT

'**************************
'*  for the frames per seconde calcul
'*************************
Private Iclip_count
Private tLast As Single
Private fps As Single



Private Ang As Single, FPS_2 As Single, OldFPS As Long, NbIMage As Integer
Private OldTime
Public NBFrame

Public Enum MODA
   NOt_init = -1
   FullScreeen = 0
   Windowed = 1

End Enum
Public wType As MODA

'===================================
'   for the Fog
'=====================================
Public FOGdensity As Double



'=====================
'  for texture creation transparent color
'===============
Public Enum TEXTUREFLAGS
 D3DTEXTR_DEFAULT = 0
 D3DTEXTR_TRANSPARENTBLACK = 1
 D3DTEXTR_TRANSPARENTWHITE = 2
End Enum






'==============================
' pour les collision
'
'==========================

Private Const EPSILON = 0.0001
Private Type IntersectTest
  T As Double
  U As Double
  v As Double
End Type
Private ColScore As IntersectTest

Dim CollisionNormal As D3DVECTOR
Dim CollisionImpact As D3DVECTOR
Public PrecisionCollide As Single
Public CHECK_terrain_Colision As Boolean







'=======enum for vertexttype
Public Enum Johna_VERTEX_type
    vertex_TYPE = 0
    Light_vertex_TYPE = 1
    

End Enum





'==============================================
' For the LIGHT
'
'
'=============================================

Private Type LITT
   LIGH() As D3DLIGHT7
   Bound As Integer
   FreeMAT_index As Integer

End Type


Private Light As LITT



'==============================================
' For flashing the screen
'
'
'=============================================
Private FlareSprite(4) As D3DTLVERTEX
Private FADE_time As Single

'==============================================
' For Cloud
'
'
'=============================================


Private Type CLODY
    CIEL(3) As D3DVERTEX
    Texture As DirectDrawSurface7
    Size As Single
    ALTITUDE As Single
End Type


Public HORIZON_z As Single
Private HORIZON_TEX As DirectDrawSurface7
Public CLOUD_is_Active As Boolean
Private CLOUD As CLODY


Private Type PLUIE
    vert() As D3DVERTEX
    ALTITUDE As Single
    SOL As Single
    Mx As Single
    p As Single
    Speed As Double
    Size As Single
    intensity As Double
    Nvertice As Long
    NB_goute As Integer
    
End Type

Private RAIN As PLUIE
Public RAIN_ison As Boolean


'===========================
' for OBJECT CONSTRUCTION OPERATION
'
'
'===============================


Public Enum JOHNA_CONSTRUCTION_CONST
   MUR_EST = 1
   MUR_NORD = 2
   MUR_OUEST = 3
   MUR_SUD = 4
   MUR_EST_OUEST = 5
   MUR_NORD_SUD = 6
   MUR_SUD_OUEST_NORD = 7
   MUR_OUEST_NORD_EST = 8
   MUR_NORD_EST_SUD = 9
   MUR_EST_SUD_OUEST = 10
   MUR_PLAFOND_SOL = 11
   MUR_SUD_OUEST = 12
   MUR_OUEST_NORD = 13
   MUR_NORD_EST = 14
   MUR_EST_SUD = 15

End Enum













Private Function ConvToSignedValue(lngValue As Long) As Integer

    'Cheezy method for converting to signed integer
    If lngValue <= 32767 Then
        ConvToSignedValue = CInt(lngValue)
        Exit Function
    End If
    
    ConvToSignedValue = CInt(lngValue - 65535)

End Function

Private Function ConvToUnSignedValue(intValue As Integer) As Long

    'Cheezy method for converting to unsigned integer
    If intValue >= 0 Then
        ConvToUnSignedValue = intValue
        Exit Function
    End If
    
    ConvToUnSignedValue = intValue + 65535

End Function


'----------------------------------------------------------------------
'Procedure   : CLearMATRIX()
'----------------------------------------------------------------------
'Author      : johna
'----------------------------------------------------------------------

Public Sub CLearMATRIX()
Dim Temp As D3DMATRIX
    DX_7.IdentityMatrix Temp
    D3D_DEV.SetTransform D3DTRANSFORMSTATE_WORLD, Temp
 
End Sub












Function Rand()
   Randomize Timer
   Rand = Rnd
End Function





Public Sub Flashing(COLOR As Long)
Dim ColorFlashe As Long

ColorFlashe = COLOR
DX_7.CreateD3DTLVertex 0, lheight - 1, 0, 0.5, ColorFlashe, 0, 0, 0, FlareSprite(1)
DX_7.CreateD3DTLVertex 0, 0, 0, 0.5, ColorFlashe, 0, 0, 0, FlareSprite(2)
DX_7.CreateD3DTLVertex lWidth - 1, lheight - 1, 0, 0.5, ColorFlashe, 0, 0, 0, FlareSprite(3)
DX_7.CreateD3DTLVertex lWidth - 1, 0, 0, 0.5, ColorFlashe, 0, 0, 0, FlareSprite(4)




D3D_DEV.SetRenderState D3DRENDERSTATE_ALPHABLENDENABLE, True
D3D_DEV.SetRenderState D3DRENDERSTATE_SRCBLEND, D3DBLEND_ONE
D3D_DEV.SetRenderState D3DRENDERSTATE_DESTBLEND, D3DBLEND_ONE

D3D_DEV.SetTexture 0, Nothing
D3D_DEV.DrawPrimitive D3DPT_TRIANGLESTRIP, D3DFVF_TLVERTEX, FlareSprite(1), 4, 0
D3D_DEV.SetRenderState D3DRENDERSTATE_ALPHABLENDENABLE, False
Me.alphaBLEND_1 0
End Sub




Public Sub FaDE_IN(Optional Activate As Boolean = True)
Dim ColorFlashe, zz
Randomize Timer
zz = Rnd

ColorFlashe = RGBA(0, 0, 0, 1 - zz) 'on peut changer la couleur
DX_7.CreateD3DTLVertex 0, lheight - 1, 0, 0.5, ColorFlashe, 0, 0, 0, FlareSprite(1)
DX_7.CreateD3DTLVertex 0, 0, 0, 0.5, ColorFlashe, 0, 0, 0, FlareSprite(2)
DX_7.CreateD3DTLVertex lWidth - 1, lheight - 1, 0, 0.5, ColorFlashe, 0, 0, 0, FlareSprite(3)
DX_7.CreateD3DTLVertex lWidth - 1, 0, 0, 0.5, ColorFlashe, 0, 0, 0, FlareSprite(4)




D3D_DEV.SetRenderState D3DRENDERSTATE_ALPHABLENDENABLE, True
D3D_DEV.SetRenderState D3DRENDERSTATE_SRCBLEND, D3DBLEND_ONE
D3D_DEV.SetRenderState D3DRENDERSTATE_DESTBLEND, D3DBLEND_ONE

D3D_DEV.SetTexture 0, Nothing
D3D_DEV.DrawPrimitive D3DPT_TRIANGLESTRIP, D3DFVF_TLVERTEX, FlareSprite(1), 4, 0
D3D_DEV.SetRenderState D3DRENDERSTATE_ALPHABLENDENABLE, False




End Sub


Function RGBA(R, G, B, A) As Long
RGBA = DX_7.CreateColorRGBA(R, G, B, A)

End Function


Function random_RGBA() As Long
Randomize Timer
random_RGBA = DX_7.CreateColorRGBA(Rnd, Rnd, Rnd, Rnd)

End Function


'=====================
'  miscelaneous info
'========================

'*---------Free video memory available---------*
Function FreeVideo_MEMORY() As Long
Dim A As DDSCAPS2
  A.lCaps = DDSCAPS_VIDEOMEMORY
  FreeVideo_MEMORY = ddraw.GetFreeMem(A)
End Function


Property Get INFO_videoFREE() As String
Dim dddesc As DDCAPS, Temp As DDCAPS
  ddraw.GetCaps dddesc, Temp
  INFO_videoFREE = CStr(dddesc.lVidMemFree)
End Property

Property Get INFO_FreeMemory() As Long
Dim dddesc As DDCAPS, Temp As DDCAPS
  ddraw.GetCaps dddesc, Temp
  INFO_FreeMemory = dddesc.lVidMemFree
End Property


Property Get INFO_ZbufferBIT() As String
Dim dddesc As DDCAPS, Temp As DDCAPS
  ddraw.GetCaps dddesc, Temp
Dim ST As String
ST = "Zbuffer bit deph: "

If (dddesc.lZBufferBitDepths And DDBD_16) Then _
  ST = ST + "16"
If (dddesc.lZBufferBitDepths And DDBD_24) Then _
  ST = ST + ", 24"
If (dddesc.lZBufferBitDepths And DDBD_32) Then _
  ST = ST + ", 32"
 INFO_ZbufferBIT = ST

End Property

Property Get INFO_MULTI_texturingOK() As Boolean
 
 Dim DEVDSC As D3DDEVICEDESC7
 D3D_DEV.GetCaps DEVDSC
 
 If DEVDSC.nMaxTextureBlendStages > 1 Then
   If DEVDSC.nMaxSimultaneousTextures > 1 Then
   
     If (DEVDSC.lTextureOpCaps And D3DTEXOPCAPS_MODULATE) Then
       INFO_MULTI_texturingOK = True
     End If
    End If
 End If

End Property


Property Get INFO_MULTI_texturing() As String
 
 Dim DEVDSC As D3DDEVICEDESC7
 D3D_DEV.GetCaps DEVDSC
 Dim BO As Boolean
 Dim msg As String
 
 If DEVDSC.nMaxTextureBlendStages > 1 Then
   If DEVDSC.nMaxSimultaneousTextures > 1 Then
   
     If (DEVDSC.lTextureOpCaps And D3DTEXOPCAPS_MODULATE) Then
       BO = True
     End If
    End If
 End If
 
 If BO Then
   msg = msg + "Multitexturing OK" + Chr(10)
   msg = msg + "Number Texture steges=" + Str(DEVDSC.nMaxTextureBlendStages)
   msg = msg + "Number simultaneous Texture =" + Str(DEVDSC.nMaxSimultaneousTextures)
   INFO_MULTI_texturing = msg
    
 Else
 
   msg = msg + "Multitexturing unAVAILABLE" + Chr(10)
   
   INFO_MULTI_texturing = msg
 
 End If
 
 

End Property






Property Get Engine_Version() As Single
    Engine_Version = VERSIO
    
End Property


Property Get INFO_SufaceCAPS1() As String

Dim dddesc As DDCAPS, Temp As DDCAPS
  ddraw.GetCaps dddesc, Temp
Dim ST As String
ST = "CAPABILITIES : Surface lCaps :  "

INFO_SufaceCAPS1 = ST + CStr(dddesc.ddsCaps.lCaps)

End Property


Property Get INFO_TAG_CAPS() As String
Dim Caps As D3DDEVICEDESC7
 D3D_DEV.GetCaps Caps
 
 T$ = "// BLEND CAPS // " + vbCrLf + vbCrLf
 If Caps.dpcTriCaps.lSrcBlendCaps And D3DPBLENDCAPS_ONE Then T$ = T$ + " * BLEND SUPPORT : SRCBLEND_ONE " + vbCrLf
 If Caps.dpcTriCaps.lSrcBlendCaps And D3DPBLENDCAPS_SRCALPHA Then T$ = T$ + " * BLEND SUPPORT : SRCBLEND_ALPHA " + vbCrLf
 If Caps.dpcTriCaps.lSrcBlendCaps And D3DPBLENDCAPS_SRCCOLOR Then T$ = T$ + " * BLEND SUPPORT : SRCBLEND_COLOR " + vbCrLf
 If Caps.dpcTriCaps.lSrcBlendCaps And D3DPBLENDCAPS_INVSRCALPHA Then T$ = T$ + " * BLEND SUPPORT : SRCBLEND_INVALPHA " + vbCrLf
 If Caps.dpcTriCaps.lSrcBlendCaps And D3DPBLENDCAPS_INVSRCCOLOR Then T$ = T$ + " * BLEND SUPPORT : SRCBLEND_INVCOLOR " + vbCrLf
 
 If Caps.dpcTriCaps.lDestBlendCaps And D3DPBLENDCAPS_ONE Then T$ = T$ + " * BLEND SUPPORT : DESTBLEND_ONE " + vbCrLf
 If Caps.dpcTriCaps.lDestBlendCaps And D3DPBLENDCAPS_DESTALPHA Then T$ = T$ + " * BLEND SUPPORT : DESTBLEND_ALPHA " + vbCrLf
 If Caps.dpcTriCaps.lDestBlendCaps And D3DPBLENDCAPS_DESTCOLOR Then T$ = T$ + " * BLEND SUPPORT : DESTBLEND_COLOR " + vbCrLf
 If Caps.dpcTriCaps.lDestBlendCaps And D3DPBLENDCAPS_INVDESTALPHA Then T$ = T$ + " * BLEND SUPPORT : DESTBLEND_INVALPHA " + vbCrLf
 If Caps.dpcTriCaps.lDestBlendCaps And D3DPBLENDCAPS_INVDESTCOLOR Then T$ = T$ + " * BLEND SUPPORT : DESTBLEND_INVCOLOR " + vbCrLf
  INFO_TAG_CAPS = T$


End Property






Public Sub SetFog(ON_it As Boolean, Optional density As Double, Optional COLOR As Long, Optional FogMode As CONST_D3DFOGMODE = D3DFOG_EXP)
If density > 0 Then
    FOGdensity = density
    D3D_DEV.SetRenderStateSingle D3DRENDERSTATE_FOGDENSITY, FOGdensity
End If

D3D_DEV.SetRenderState D3DRENDERSTATE_FOGCOLOR, COLOR
D3D_DEV.SetRenderState D3DRENDERSTATE_FOGVERTEXMODE, FogMode
D3D_DEV.SetRenderState D3DRENDERSTATE_FOGENABLE, ON_it

End Sub
Sub SetFog_EX(FogStart, FogEnd, Optional density As Double = 1 / 1000, Optional COLOR As Long)
 '' Turn on fog
   
   With D3D_DEV
   'On Local Error Resume Next
        .SetRenderState D3DRENDERSTATE_FOGENABLE, True
        .SetRenderState D3DRENDERSTATE_FOGCOLOR, COLOR
        
        'Dim StartFog As Single, EndFog As Single
    
        ' For linear mode.
       
            D3D_DEV.SetRenderStateSingle D3DRENDERSTATE_FOGDENSITY, density

    
        ' Set fog parameters.
        ' D3DFOG_LINEAR
        .SetRenderState D3DRENDERSTATE_FOGVERTEXMODE, D3DFOG_LINEAR 'D3DFOG_EXP
        .SetRenderStateSingle D3DRENDERSTATE_FOGSTART, FogStart
        .SetRenderStateSingle D3DRENDERSTATE_FOGEND, FogEnd
    End With



End Sub





Public Sub Kill_Fog()
'et bien sur pour arrter l'effet
D3D_DEV.SetRenderState D3DRENDERSTATE_FOGENABLE, False
End Sub


Public Property Get RADIAN() As Double
   RADIAN = RAIAN
End Property




'=========================================
'  initialize Dinput first
'
'=============================================


Private Sub init_DINPUT(HD As Long)
Set Dinput = DX_7.DirectInputCreate()
     Set Dinput_DEV = Dinput.CreateDevice("GUID_SysKeyboard")
     Dinput_DEV.SetCommonDataFormat DIFORMAT_KEYBOARD
     Dinput_DEV.SetCooperativeLevel HD, DISCL_BACKGROUND Or DISCL_NONEXCLUSIVE
     Dinput_DEV.Acquire

     Set Mouse_device = Dinput.CreateDevice("GUID_SysMouse")
     Mouse_device.SetCommonDataFormat DIFORMAT_MOUSE
     Mouse_device.SetCooperativeLevel Hnd, DISCL_BACKGROUND Or DISCL_NONEXCLUSIVE
     
     Mouse_device.Acquire

     Dinput_isINIT = True
End Sub

'=========================================
'  Getkey from DXinput keyboard device
'
'=============================================



Public Function GetKEY(Key As Johna_KEY_CONST) As Boolean
   Dinput_DEV.GetDeviceStateKeyboard KEY_board
   If KEY_board.Key(Key) <> 0 Then GetKEY = True Else GetKEY = False
   
End Function

'=========================================
'  Getkey from Win32 API keyboard device
'
'=============================================



Function GetKEY_API(Key As KeyCodeConstants) As Boolean

  GetKEY_API = GetAsyncKeyState(Key)
  
End Function


Property Get Mouse_X()
  Mouse_device.GetDeviceStateMouse Mouse_state
   Mouse_X = Mouse_state.X
           
End Property
Property Get Mouse_Y()
  Mouse_device.GetDeviceStateMouse Mouse_state
  Mouse_Y = Mouse_state.Y
           
End Property
Property Get Mouse_Z()
  Mouse_device.GetDeviceStateMouse Mouse_state
  Mouse_Z = Mouse_state.Z
           
End Property



Property Get MOUSE_Cursor_API_X()
 Call GetCursorPos(Pos)
 MOUSE_Cursor_API_X = Pos.X
End Property
Property Get MOUSE_Cursor_API_Y()
Call GetCursorPos(Pos)
 MOUSE_Cursor_API_Y = Pos.Y
End Property




Public Function Mousse_PressedButton(BUTT As MOSS) As Boolean
  Mouse_device.GetDeviceStateMouse Mouse_state
  If Mouse_state.buttons(BUTT) <> 0 Then _
  Mousse_PressedButton = True
   

End Function




















Public Sub Clear_3D()
    'Call D3D_DEV.SetTransform(D3DTRANSFORMSTATE_VIEW, MA_View)
    On Error Resume Next
    D3D_DEV.Clear 1, g_d3drcViewport(), D3DCLEAR_TARGET Or D3DCLEAR_ZBUFFER, Me.device_CLEAR_COLOR, 1, 0

End Sub



Public Function INIT_ShowDialog(HAND As Long)



DeviceDIALOGUE.INIT_enum Me, HAND




End Function








Public Function Initialize_fullscreen(HAND As Long, Optional width As Integer = 640, Optional Height As Integer = 480, Optional Bpp As Byte = 16) As Boolean
    Dim DDsD As DDSURFACEDESC2
    Dim Caps As DDSCAPS2
    Dim DEnum As Direct3DEnumDevices
    Dim GUID As String
    
    ' Create the DirectDraw object and set the application
    ' cooperative level.
  
    Set ddraw = DX_7.DirectDrawCreate("")
    
    'Make a fullscreen, exclusive application
    ddraw.SetCooperativeLevel HAND, DDSCL_EXCLUSIVE Or DDSCL_FULLSCREEN Or DDSCL_ALLOWREBOOT
    ddraw.SetDisplayMode width, Height, Bpp, 0, DDSDM_DEFAULT
    
    
    
    ' Prepare and create the PrimaryBuffer surface.
    DDsD.lFlags = DDSD_BACKBUFFERCOUNT Or DDSD_CAPS
    DDsD.ddsCaps.lCaps = DDSCAPS_PRIMARYSURFACE Or DDSCAPS_FLIP Or DDSCAPS_COMPLEX Or DDSCAPS_3DDEVICE
    DDsD.lBackBufferCount = 1
    
    Set PrimaryBuffer = ddraw.CreateSurface(DDsD)
    
    'Attach the backbuffer. the DDSCAPS_3DDEVICE tells the
    'backbuffer that its to be used for 3D stuff
    Caps.lCaps = DDSCAPS_BACKBUFFER Or DDSCAPS_3DDEVICE
    Set BackBuffer = PrimaryBuffer.GetAttachedSurface(Caps)
    
   
    'Initialise Direct3D
    Initialize_DX_fullscreen = True
    'Me.WriteLOG "Direct draw fullscreen est initialis....", Hand
    INIT_ok = True
    wType = FullScreeen
    Call init_DINPUT(HAND)
    'Me.WriteLOG "Direct input est activ....", Hand
    
    IS_GammaOK = ISgamma
    INiT_D3D HAND
    Initialize_fullscreen = True
End Function

Public Function Initialize_Windowed(HAND As Long) As Boolean
 ' Create the DirectDraw object and set the application
    ' cooperative level.
    
    Dim DDsD As DDSURFACEDESC2
    
    Set ddraw = DX_7.DirectDrawCreate("")
    
    ddraw.SetCooperativeLevel HAND, DDSCL_NORMAL
    
    ' Prepare and create the PrimaryBuffer surface.
    DDsD.lFlags = DDSD_CAPS
    DDsD.ddsCaps.lCaps = DDSCAPS_PRIMARYSURFACE
    
    Set PrimaryBuffer = ddraw.CreateSurface(DDsD)
    
    ' Now create the render-target surface. We are reusing DDsd here.
    DDsD.lFlags = DDSD_HEIGHT Or DDSD_WIDTH Or DDSD_CAPS
    DDsD.ddsCaps.lCaps = DDSCAPS_OFFSCREENPLAIN Or DDSCAPS_3DDEVICE
    
    ' Use the size of the form to determine the size of the render target
    ' and viewport rectangle.
    Dim DEC As RECT
    DX_7.GetWindowRect HAND, DEC
    
    rcDest = DEC
    
    
    
    ' Set the dimensions of the surface description
    DDsD.lWidth = rcDest.Right - rcDest.Left
    DDsD.lheight = rcDest.Bottom - rcDest.Top
    
    
    ' Create the render-target surface
    Set BackBuffer = ddraw.CreateSurface(DDsD)
        
    ' Cache the dimensions of the render target. We'll use
    ' it for blitting operations.
    With rcSrc
        .Left = 0: .Top = 0
        .Bottom = DDsD.lheight
        .Right = DDsD.lWidth
    End With
    
    ' Create a DirectDrawClipper and attach it to the PrimaryBuffer surface.
    
    
    Set CLIP = ddraw.CreateClipper(0)
    CLIP.SetHWnd HAND
    
    PrimaryBuffer.SetClipper CLIP
    Initialize_DX_Windowed = True
        Me.WriteLOG "Direct Draw en mode fenetr est activ....", HAND

     INIT_ok = True
    wType = Windowed
     Call init_DINPUT(HAND)
         Me.WriteLOG "Direct input est activ....", HAND
    IS_GammaOK = ISgamma
    INiT_D3D HAND
End Function



Private Function ISgamma() As Boolean

Dim hwCaps As DDCAPS
Dim helCaps As DDCAPS

    
    
    'Check for Gamma Ramp Support
    ddraw.GetCaps hwCaps, helCaps
    If (hwCaps.lCaps2 And DDCAPS2_PRIMARYGAMMA) = 0 Then
        Exit Function
    End If
    
    ISgamma = True
    
    'Make a new gamma controler
    Set GammaControler = PrimaryBuffer.GetDirectDrawGammaControl

    'Fill out the original gamma ramps
    GammaControler.GetGammaRamp DDSGR_DEFAULT, OriginalRamp
    GammaRamp = OriginalRamp

End Function

Public Sub Set_GammaRamp(GammaPercent As Integer)
  
  If Not IS_GammaOK Then Exit Sub
  SetGamma GammaPercent, GammaPercent, GammaPercent
  
End Sub



Private Sub SetGamma(intRed As Integer, intGreen As Integer, intBlue As Integer)

Dim I As Integer
intGreen = intRed
intBlue = intRed
    'Alter the gamma ramp to the percent given by comparing to original state
    'A value of zero ("0") for intRed, intGreen, or intBlue will result in the
    'gamma level being set back to the original levels. Anything ABOVE zero will
    'fade towards FULL colour, anything below zero will fade towards NO colour
    For I = 0 To 255
        If intRed < 0 Then GammaRamp.Red(I) = ConvToSignedValue(ConvToUnSignedValue(OriginalRamp.Red(I)) * (100 - Abs(intRed)) / 100)
        If intRed = 0 Then GammaRamp.Red(I) = OriginalRamp.Red(I)
        If intRed > 0 Then GammaRamp.Red(I) = ConvToSignedValue(65535 - ((65535 - ConvToUnSignedValue(OriginalRamp.Red(I))) * (100 - intRed) / 100))
        If intGreen < 0 Then GammaRamp.Green(I) = ConvToSignedValue(ConvToUnSignedValue(OriginalRamp.Green(I)) * (100 - Abs(intGreen)) / 100)
        If intGreen = 0 Then GammaRamp.Green(I) = OriginalRamp.Green(I)
        If intGreen > 0 Then GammaRamp.Green(I) = ConvToSignedValue(65535 - ((65535 - ConvToUnSignedValue(OriginalRamp.Green(I))) * (100 - intGreen) / 100))
        If intBlue < 0 Then GammaRamp.Blue(I) = ConvToSignedValue(ConvToUnSignedValue(OriginalRamp.Blue(I)) * (100 - Abs(intBlue)) / 100)
        If intBlue = 0 Then GammaRamp.Blue(I) = OriginalRamp.Blue(I)
        If intBlue > 0 Then GammaRamp.Blue(I) = ConvToSignedValue(65535 - ((65535 - ConvToUnSignedValue(OriginalRamp.Blue(I))) * (100 - intBlue) / 100))
    Next
    GammaControler.SetGammaRamp DDSGR_DEFAULT, GammaRamp

End Sub





Function Initialize_EngineEX(HAND As Long, Ddraw_GUID As String, D3D_GUID As String, Optional isWindoWED As Boolean = True, Optional Screen_WIDTH As Integer = 640, Optional Screen_HEIGHT As Integer = 480, Optional ByteBP As Byte = 16) As Boolean

Dim DEnum As Direct3DEnumDevices
    Dim GUID As String
Dim DDsD As DDSURFACEDESC2

'If the method succeeds, the return value is a string label"IID_IDirect3DHALDevice", "IID_IDirect3DTnLHalDevice", or "IID_IDirect3DRGBDevice

'If D3D_GUID <> "IID_IDirect3DHALDevice" And _
   D3D_GUID <> "IID_IDirect3DRGBDevice" Then _
   D3D_GUID = "IID_IDirect3DTnLHalDevice"
   MEMORY = DDSCAPS_VIDEOMEMORY
   If D3D_GUID = "IID_IDirect3DRGBDevice" Then MEMORY = DDSCAPS_SYSTEMMEMORY
   
If isWindoWED Then

    ' Create the DirectDraw object and set the application
        ' cooperative level.
        
        
        
        Set ddraw = DX_7.DirectDrawCreate(Ddraw_GUID)
        
        ddraw.SetCooperativeLevel HAND, DDSCL_NORMAL
        
        ' Prepare and create the PrimaryBuffer surface.
        DDsD.lFlags = DDSD_CAPS
        DDsD.ddsCaps.lCaps = DDSCAPS_PRIMARYSURFACE
        
        Set PrimaryBuffer = ddraw.CreateSurface(DDsD)
        
        ' Now create the render-target surface. We are reusing DDsd here.
        DDsD.lFlags = DDSD_HEIGHT Or DDSD_WIDTH Or DDSD_CAPS
        DDsD.ddsCaps.lCaps = DDSCAPS_OFFSCREENPLAIN Or DDSCAPS_3DDEVICE
        
        ' Use the size of the form to determine the size of the render target
        ' and viewport rectangle.
        Dim DEC As RECT
        DX_7.GetWindowRect HAND, DEC
        
        rcDest = DEC
        
        
        
        ' Set the dimensions of the surface description
        DDsD.lWidth = rcDest.Right - rcDest.Left
        DDsD.lheight = rcDest.Bottom - rcDest.Top
        
        
        ' Create the render-target surface
        Set BackBuffer = ddraw.CreateSurface(DDsD)
            
        ' Cache the dimensions of the render target. We'll use
        ' it for blitting operations.
        With rcSrc
            .Left = 0: .Top = 0
            .Bottom = DDsD.lheight
            .Right = DDsD.lWidth
        End With
        
        ' Create a DirectDrawClipper and attach it to the PrimaryBuffer surface.
        
        
        Set CLIP = ddraw.CreateClipper(0)
        CLIP.SetHWnd HAND
        
        PrimaryBuffer.SetClipper CLIP
        
            Me.WriteLOG "Direct Draw en mode fenetr est activ....", HAND
    
         INIT_ok = True
        
         Call init_DINPUT(HAND)
             Me.WriteLOG "Direct input est activ....", HAND
        Me.wType = Windowed
        
        'END for windowed DirectDraw
        
ElseIf Not isWindoWED Then
        
        
        
    Dim Caps As DDSCAPS2
    
    
    ' Create the DirectDraw object and set the application
    ' cooperative level.
  
    Set ddraw = DX_7.DirectDrawCreate(Ddraw_GUID)
    
    'Make a fullscreen, exclusive application
    ddraw.SetCooperativeLevel HAND, DDSCL_EXCLUSIVE Or DDSCL_FULLSCREEN Or DDSCL_ALLOWREBOOT
    ddraw.SetDisplayMode Screen_WIDTH, Screen_HEIGHT, ByteBP, 0, DDSDM_DEFAULT
    
    
    
    ' Prepare and create the PrimaryBuffer surface.
    DDsD.lFlags = DDSD_BACKBUFFERCOUNT Or DDSD_CAPS
    DDsD.ddsCaps.lCaps = DDSCAPS_PRIMARYSURFACE Or DDSCAPS_FLIP Or DDSCAPS_COMPLEX Or DDSCAPS_3DDEVICE
    DDsD.lBackBufferCount = 1
    
    Set PrimaryBuffer = ddraw.CreateSurface(DDsD)
    
    'Attach the backbuffer. the DDSCAPS_3DDEVICE tells the
    'backbuffer that its to be used for 3D stuff
    Caps.lCaps = DDSCAPS_BACKBUFFER Or DDSCAPS_3DDEVICE
    Set BackBuffer = PrimaryBuffer.GetAttachedSurface(Caps)
    
   
    'Initialise Direct3D
    'Initialize_DX_fullscreen = True
    Me.WriteLOG "Direct draw fullscreen est initialis....", HAND
    INIT_ok = True
    wType = FullScreeen
    Call init_DINPUT(HAND)
    Me.WriteLOG "Direct input est activ....", HAND
    
        
End If   'END for fullscreen DirectDraw



IS_GammaOK = ISgamma


'===============================================
'  Init the D3d device and
'  default viewport
'  Zbuffer
'  Renderstate
'
'=================================================


Check_Mouse_cam = 1
   
   Dim HI, WI
   Dim des As DDSURFACEDESC2
   
   
   
   BackBuffer.GetSurfaceDesc des
   WI = des.lWidth
   HI = des.lheight
   
  
    'Dim DDsD As DDSURFACEDESC2
   'Dim DEnum As Direct3DEnumDevices
    'Dim Guid As String
    
    
        
    ' Retrieve a reference to the Direct3D7 class from the
    ' DirectDraw7 object.
    Set D3d = ddraw.GetDirect3D
    
    ' Query DirectDraw for the current display mode. For simplicity, this
    ' does not support palleted display modes (8-bit and lower).
    ddraw.GetDisplayMode DDsD
    
    If DDsD.ddpfPixelFormat.lRGBBitCount <= 8 Then
        MsgBox "This application does not support screen display " & _
               "modes lower than 16-bit."
        Exit Function
    End If
    
   
   
    
    Dim ddpfZBuffer As DDPIXELFORMAT
    Dim d3dEnumPFs As Direct3DEnumPixelFormats
        
 
    Set d3dEnumPFs = D3d.GetEnumZBufferFormats(D3D_GUID)
    
    
    Dim I As Long
          
    For I = 1 To d3dEnumPFs.GetCount()
        Call d3dEnumPFs.GetItem(I, ddpfZBuffer)
        If ddpfZBuffer.lFlags = DDPF_ZBUFFER Then
            Exit For
        End If
    Next I
    
 
    ' Prepare and create the z-buffer surface.
    DDsD.lFlags = DDSD_CAPS Or DDSD_WIDTH Or DDSD_HEIGHT Or DDSD_PIXELFORMAT
    DDsD.ddsCaps.lCaps = DDSCAPS_ZBUFFER
 
    DDsD.lWidth = WI
    DDsD.lheight = HI
 
  
  DDsD.ddpfPixelFormat = ddpfZBuffer
    ' Specify DDSCAPS_VIDEOMEMORY if your surface exists in display memory.
    ' See the SDK documentation for more information.
    'DDsD.ddsCaps.lCaps = DDsD.ddsCaps.lCaps Or DDSCAPS_VIDEOMEMORY
        
     If D3D_GUID = "IID_IDirect3DHALDevice" Or D3D_GUID <> "IID_IDirect3DRGBDevice" Then
        DDsD.ddsCaps.lCaps = DDsD.ddsCaps.lCaps Or DDSCAPS_VIDEOMEMORY
    Else
        DDsD.ddsCaps.lCaps = DDsD.ddsCaps.lCaps Or DDSCAPS_SYSTEMMEMORY
    End If
        
        
        
    Set ZBuffer = ddraw.CreateSurface(DDsD)
        Me.WriteLOG "Zbuffer trouv et activ....", HAND
   
    ' Attach the z-buffer surface to the back buffer surface.
    BackBuffer.AddAttachedSurface ZBuffer
    Me.WriteLOG "Zbuffer attach ....", HAND

    
    
    
    
    
    
    
    '
    ' Create the device. The GUID is hardcoded for now, but should come from
    ' device enumeration, which is the topic of a tutorial. The device
    ' is created off of our back buffer, which becomes the render target for
    ' the newly created device.
    '
    On Error Resume Next
    Set D3D_DEV = D3d.CreateDevice(D3D_GUID, BackBuffer)
    
    If D3D_DEV Is Nothing Then
        Set D3D_DEV = D3d.CreateDevice("IID_IDirect3DRGBDevice", BackBuffer)
    End If
    
           Me.WriteLOG "Direct3D activ....", HAND

    ' Define the viewport rectangle.
    
        
    ViewPort.lWidth = WI
    ViewPort.lheight = HI
    ViewPort.minz = 0#
    ViewPort.maxz = 1#
    lheight = HI
    lWidth = WI
    
    D3D_DEV.SetViewport ViewPort
    Me.WriteLOG "Viewport DE " & Str(WI) & " x " & Str(HI) + " Activ.....", HAND
    
    
    ' Cache the viewport rectangle for use in clearing operations later.
    With g_d3drcViewport(0)
        .x1 = 0: .y1 = 0
        .x2 = WI
        .Y2 = HI
    End With
        
        
        
         ' For simplicity, use ambient lighting and a white material.
    Dim Mtrl As D3DMATERIAL7
   
    Mtrl.diffuse.R = 1#: Mtrl.diffuse.G = 1#: Mtrl.diffuse.B = 1#
    Mtrl.Ambient.R = 1: Mtrl.Ambient.G = 1: Mtrl.Ambient.B = 1
    
    Mtrl.emissive = Mtrl.Ambient
    Mtrl.specular = Mtrl.Ambient
    
    
    ' Commit the material to the device.
    D3D_DEV.SetMaterial Mtrl
        
    D3D_DEV.SetRenderState D3DRENDERSTATE_AMBIENT, DX_7.CreateColorRGBA(1#, 1#, 1#, 1#)
    Me.WriteLOG "matriel de rendu cr et activ....", HAND
   
        
        
        
        
        
        
        
        Dim matProj As D3DMATRIX
     Data.angle = 3.1456978454 / 4#
    Data.Maxprojection = 30000
    Data.Minprojection = 1
    
    DX_7.IdentityMatrix matProj
    'DX_7.ViewMatrix MA_View, Vector(0, 0, -5), Vector(0, 0, 0), Vector(0, 1, 0), 0
    'DX_7.ProjectionMatrix MA_Projection, DATA.Minprojection, DATA.Maxprojection, DATA.Angle
    'DX_7.IdentityMatrix MA_World
    
    'D3D_DEV.SetTransform D3DTRANSFORMSTATE_PROJECTION, MA_Projection
    'D3D_DEV.SetTransform D3DTRANSFORMSTATE_WORLD, MA_World
    'D3D_DEV.SetTransform D3DTRANSFORMSTATE_VIEW, MA_View
    
    
    Call DX_7.ProjectionMatrix(matProj, Data.Minprojection, Data.Maxprojection, Data.angle)
    D3D_DEV.SetTransform D3DTRANSFORMSTATE_PROJECTION, matProj
    Me.WriteLOG "Matrix de projection activ....", HAND

   
   
    'Call D3D_DEV.SetTextureStageState(0, D3DTSS_COLORARG1, D3DTA_TEXTURE)
    'Call D3D_DEV.SetTextureStageState(0, D3DTSS_COLORARG2, D3DTA_DIFFUSE)
    'Call D3D_DEV.SetTextureStageState(0, D3DTSS_COLOROP, D3DTOP_MODULATE)
    'Call D3D_DEV.SetTextureStageState(0, D3DTSS_ALPHAOP, D3DTOP_SELECTARG1)
    'Call D3D_DEV.SetTextureStageState(0, D3DTSS_ALPHAARG1, D3DTA_TEXTURE)
    Call D3D_DEV.SetTextureStageState(0, D3DTSS_MINFILTER, D3DTFN_LINEAR)
    Call D3D_DEV.SetTextureStageState(0, D3DTSS_MAGFILTER, D3DTFG_LINEAR)
    Call D3D_DEV.SetRenderState(D3DRENDERSTATE_DITHERENABLE, True)





'=====================================
'  check device capabilities
'
'
'====================================



Dim devdesc As D3DDEVICEDESC7

    D3D_DEV.GetCaps devdesc
    m_bUseAlphaTest = ((devdesc.dpcTriCaps.lAlphaCmpCaps And D3DPCMPCAPS_GREATEREQUAL) = D3DPCMPCAPS_GREATEREQUAL)
    Me.WriteLOG "Mlange Alpha autoris......." + Str(m_bUseAlphaTest), HAND


Data.CullMode = D3D_DEV.GetRenderState(D3DRENDERSTATE_CULLMODE)

'init camera
Eyes.DEG = 0
Eyes.JUMP_MAX = 50
Eyes.JUMP_step = 8


Light.FreeMAT_index = -1


End Function


Sub Set_ViewFrustrum(near, far, Optional angle = PI / 4)
   Dim Matz As D3DMATRIX
    DX_7.IdentityMatrix Matz
    
    
    Call DX_7.ProjectionMatrix(Matz, near, far, angle)
    D3D_DEV.SetTransform D3DTRANSFORMSTATE_PROJECTION, Matz
End Sub

Private Function INiT_D3D(HAND As Long)
   Check_Mouse_cam = 1
   
   Dim HI, WI
   Dim des As DDSURFACEDESC2
   
   
   
   BackBuffer.GetSurfaceDesc des
   WI = des.lWidth
   HI = des.lheight
   
  
    Dim DDsD As DDSURFACEDESC2
   Dim DEnum As Direct3DEnumDevices
    Dim GUID As String
    
    
        
    ' Retrieve a reference to the Direct3D7 class from the
    ' DirectDraw7 object.
    Set D3d = ddraw.GetDirect3D
    
    ' Query DirectDraw for the current display mode. For simplicity, this
    ' does not support palleted display modes (8-bit and lower).
    ddraw.GetDisplayMode DDsD
    
    If DDsD.ddpfPixelFormat.lRGBBitCount <= 8 Then
        MsgBox "This application does not support screen display " & _
               "modes lower than 16-bit."
        Exit Function
    End If
    
   
   
    
    Dim ddpfZBuffer As DDPIXELFORMAT
    Dim d3dEnumPFs As Direct3DEnumPixelFormats
        
 
    Set d3dEnumPFs = D3d.GetEnumZBufferFormats("IID_IDirect3DHALDevice")
    
    ' For this tutorial we are only interested in z-buffers, so ignore any other
    ' formats (e.g. DDPF_STENCILBUFFER) the get enumerated. An application could also
    ' check the depth fo the z-buffer (16-bit, etc. and make a choice based on that,
    ' as well. For this tutorial, we'll take the first one that we get.
    Dim I As Long
          
    For I = 1 To d3dEnumPFs.GetCount()
        Call d3dEnumPFs.GetItem(I, ddpfZBuffer)
        If ddpfZBuffer.lFlags = DDPF_ZBUFFER Then
            Exit For
        End If
    Next I
    
 
    ' Prepare and create the z-buffer surface.
    DDsD.lFlags = DDSD_CAPS Or DDSD_WIDTH Or DDSD_HEIGHT Or DDSD_PIXELFORMAT
    DDsD.ddsCaps.lCaps = DDSCAPS_ZBUFFER
 
    DDsD.lWidth = WI
    DDsD.lheight = HI
 
  
  DDsD.ddpfPixelFormat = ddpfZBuffer
    ' Specify DDSCAPS_VIDEOMEMORY if your surface exists in display memory.
    ' See the SDK documentation for more information.
    DDsD.ddsCaps.lCaps = DDsD.ddsCaps.lCaps Or DDSCAPS_VIDEOMEMORY
        
    Set ZBuffer = ddraw.CreateSurface(DDsD)
        Me.WriteLOG "Zbuffer trouv et activ....", HAND
   
    ' Attach the z-buffer surface to the back buffer surface.
    BackBuffer.AddAttachedSurface ZBuffer
    Me.WriteLOG "Zbuffer attach ....", HAND

    
    
    
    
    
    
    
    '
    ' Create the device. The GUID is hardcoded for now, but should come from
    ' device enumeration, which is the topic of a tutorial. The device
    ' is created off of our back buffer, which becomes the render target for
    ' the newly created device.
    '
    On Error Resume Next
    MEMORY = DDSCAPS_VIDEOMEMORY
    Set D3D_DEV = D3d.CreateDevice("IID_IDirect3DHALDevice", BackBuffer)
    
    If D3D_DEV Is Nothing Then
        Set D3D_DEV = D3d.CreateDevice("IID_IDirect3DRGBDevice", BackBuffer)
        MEMORY = DDSCAPS_SYSTEMMEMORY
    End If
    
           Me.WriteLOG "Direct3D activ....", HAND

    ' Define the viewport rectangle.
    
        
    ViewPort.lWidth = WI
    ViewPort.lheight = HI
    ViewPort.minz = 0#
    ViewPort.maxz = 1#
    lheight = HI
    lWidth = WI
    
    D3D_DEV.SetViewport ViewPort
    Me.WriteLOG "Viewport DE " & Str(WI) & " x " & Str(HI) + " Activ.....", HAND
    
    
    ' Cache the viewport rectangle for use in clearing operations later.
    With g_d3drcViewport(0)
        .x1 = 0: .y1 = 0
        .x2 = WI
        .Y2 = HI
    End With
        
        
        
         ' For simplicity, use ambient lighting and a white material.
    Dim Mtrl As D3DMATERIAL7
   
    Mtrl.diffuse.R = 1#: Mtrl.diffuse.G = 1#: Mtrl.diffuse.B = 1#
    Mtrl.Ambient.R = 1: Mtrl.Ambient.G = 1: Mtrl.Ambient.B = 1
    
    Mtrl.emissive = Mtrl.Ambient
    Mtrl.specular = Mtrl.Ambient
    
    
    ' Commit the material to the device.
    D3D_DEV.SetMaterial Mtrl
        
    D3D_DEV.SetRenderState D3DRENDERSTATE_AMBIENT, DX_7.CreateColorRGBA(1#, 1#, 1#, 1#)
    Me.WriteLOG "matriel de rendu cr et activ....", HAND
   
        
        
        
        
        
        
        
        Dim matProj As D3DMATRIX
     Data.angle = 3.1456978454 / 4#
    Data.Maxprojection = 10000
    Data.Minprojection = 1
    
    DX_7.IdentityMatrix matProj
    'DX_7.ViewMatrix MA_View, Vector(0, 0, -5), Vector(0, 0, 0), Vector(0, 1, 0), 0
    'DX_7.ProjectionMatrix MA_Projection, DATA.Minprojection, DATA.Maxprojection, DATA.Angle
    'DX_7.IdentityMatrix MA_World
    
    'D3D_DEV.SetTransform D3DTRANSFORMSTATE_PROJECTION, MA_Projection
    'D3D_DEV.SetTransform D3DTRANSFORMSTATE_WORLD, MA_World
    'D3D_DEV.SetTransform D3DTRANSFORMSTATE_VIEW, MA_View
    
    
    Call DX_7.ProjectionMatrix(matProj, Data.Minprojection, Data.Maxprojection, Data.angle)
    D3D_DEV.SetTransform D3DTRANSFORMSTATE_PROJECTION, matProj
    Me.WriteLOG "Matrix de projection activ....", HAND

   
   
    'Call D3D_DEV.SetTextureStageState(0, D3DTSS_COLORARG1, D3DTA_TEXTURE)
    'Call D3D_DEV.SetTextureStageState(0, D3DTSS_COLORARG2, D3DTA_DIFFUSE)
    'Call D3D_DEV.SetTextureStageState(0, D3DTSS_COLOROP, D3DTOP_MODULATE)
    'Call D3D_DEV.SetTextureStageState(0, D3DTSS_ALPHAOP, D3DTOP_SELECTARG1)
    'Call D3D_DEV.SetTextureStageState(0, D3DTSS_ALPHAARG1, D3DTA_TEXTURE)
    Call D3D_DEV.SetTextureStageState(0, D3DTSS_MINFILTER, D3DTFN_LINEAR)
    Call D3D_DEV.SetTextureStageState(0, D3DTSS_MAGFILTER, D3DTFG_LINEAR)
    Call D3D_DEV.SetRenderState(D3DRENDERSTATE_DITHERENABLE, True)





'=====================================
'  check device capabilities
'
'
'====================================



Dim devdesc As D3DDEVICEDESC7

    D3D_DEV.GetCaps devdesc
    m_bUseAlphaTest = ((devdesc.dpcTriCaps.lAlphaCmpCaps And D3DPCMPCAPS_GREATEREQUAL) = D3DPCMPCAPS_GREATEREQUAL)
    Me.WriteLOG "Mlange Alpha autoris......." + Str(m_bUseAlphaTest), HAND



'init camera
Eyes.DEG = 0
Eyes.JUMP_MAX = 50
Eyes.JUMP_step = 8

Data.CullMode = D3D_DEV.GetRenderState(D3DRENDERSTATE_CULLMODE)
Light.FreeMAT_index = -1




End Function







Public Function CreateTexture(sFIle As String, Optional WE As Long, Optional HE As Long) As DirectDrawSurface7
    Dim ddsTexture As DirectDrawSurface7
    Dim I As Long
    Dim bIsFound As Boolean
    
    ' Prepare the texture surface.
    Dim DDsD As DDSURFACEDESC2
    If WE <> 0 And HE <> 0 Then
      DDsD.lheight = HE
      DDsD.lWidth = WE
    ElseIf sFIle = "" And HE = 0 And WE = 0 Then
     DDsD.lheight = 256
      DDsD.lWidth = 256
    End If
    
    
    DDsD.lFlags = DDSD_CAPS Or DDSD_HEIGHT Or DDSD_WIDTH Or DDSD_PIXELFORMAT Or DDSD_TEXTURESTAGE
    
    ' Enumerate the texture formats, and find a device-supported texture pixel format. This
    ' simple tutorial is simply looking for a 16-bit texture. Real applications may be interested in
    ' other formats, for alpha textures, bumpmaps, etc..
    Dim TextureEnum As Direct3DEnumPixelFormats
    
    Set TextureEnum = D3D_DEV.GetTextureFormatsEnum()
    
    For I = 1 To TextureEnum.GetCount()
        bIsFound = True
        Call TextureEnum.GetItem(I, DDsD.ddpfPixelFormat)
        
        With DDsD.ddpfPixelFormat
            ' Skip unusual modes.
            'If .lFlags And (DDPF_LUMINANCE Or DDPF_BUMPLUMINANCE Or DDPF_BUMPDUDV) Then bIsFound = False
            
            ' Skip any FourCC formats.
            If .lFourCC <> 0 Then bIsFound = False
            
            'Skip alpha modes.
            'If .lFlags And DDPF_ALPHAPIXELS Then bIsFound = False
            
            'We only want 16-bit formats, so skip all others.
            'If .lRGBBitCount <> 16 Then bIsFound = False
        End With
        
        If bIsFound Then Exit For
        
    Next I
    
    ' If we did not find surface support, we should exit the application.
    If Not bIsFound Then
        MsgBox "Unable to locate 16-bit surface support on your hardware."
        Exit Function
    End If
        
        
    ' Turn on texture managment for the device
If (MEMORY = DDSCAPS_SYSTEMMEMORY) Or (INFO_FreeMemory < 65536) Then
       DDsD.ddsCaps.lCaps = DDSCAPS_TEXTURE Or DDSCAPS_SYSTEMMEMORY
      DDsD.ddsCaps.lCaps2 = 0
    
Else
    DDsD.ddsCaps.lCaps = DDSCAPS_TEXTURE
    DDsD.ddsCaps.lCaps2 = DDSCAPS2_TEXTUREMANAGE
    DDsD.lTextureStage = 0
End If
    
    ' Create a new surface for the texture.
    
    If sFIle = "" Then
      Set CreateTexture = ddraw.CreateSurface(DDsD)
      Exit Function
    End If
    
    On Error GoTo NOFIL
    Set ddsTexture = ddraw.CreateSurfaceFromFile(sFIle, DDsD)
    
    ' Return the newly created texture.
    Set CreateTexture = ddsTexture
    Exit Function
NOFIL:
    On Error Resume Next
    Set CreateTexture = ddraw.CreateSurface(DDsD)
      Exit Function
End Function


Public Function CreateTexture_ALPHA(sFIle As String, extraFlags As TEXTUREFLAGS, W As Long, H As Long) As DirectDrawSurface7

    Dim bOK As Boolean
    Dim enumTex As Direct3DEnumPixelFormats
    Dim sLoadFile As String
    Dim I As Long
    Dim DDsD As DDSURFACEDESC2
    Dim SurfaceObject As DirectDrawSurface7
    Dim Init As Boolean
    
    DDsD.lFlags = DDSD_CAPS Or DDSD_TEXTURESTAGE Or DDSD_PIXELFORMAT
    If ((H <> 0) And (W <> 0)) Then
        DDsD.lFlags = DDsD.lFlags Or DDSD_HEIGHT Or DDSD_WIDTH
        DDsD.lheight = H
        DDsD.lWidth = W
    End If
    
     
    Set enumTex = D3D_DEV.GetTextureFormatsEnum()
    
   
    For I = 1 To enumTex.GetCount()
        bOK = True
        Call enumTex.GetItem(I, DDsD.ddpfPixelFormat)
            
        With DDsD.ddpfPixelFormat
            
            If .lRGBBitCount <> 16 Then bOK = False
            If .lFourCC <> 0 Then bOK = False
                        
            
            If ((D3DTEXTR_TRANSPARENTBLACK And extraFlags) _
                  Or (D3DTEXTR_TRANSPARENTWHITE And extraFlags)) Then
                  If (.lRGBAlphaBitMask = 0) Then bOK = False
                  'DDPF_ALPHAPIXELS
            Else
                  If (.lRGBAlphaBitMask <> 0) Then bOK = False
            End If
                  
            
        End With
        If bOK = True Then Exit For
    Next
    
    If bOK = False Then
        Debug.Print "Unable to find 16bit surface support on your hardware - exiting"
        Init = False
    End If
    
    If (((D3DTEXTR_TRANSPARENTBLACK And extraFlags) _
          Or (D3DTEXTR_TRANSPARENTWHITE And extraFlags))) Then
        DDsD.ddpfPixelFormat.lFlags = DDPF_ALPHAPIXELS Or DDPF_RGB
        DDsD.lFlags = DDsD.lFlags Or DDSD_PIXELFORMAT
        
    Else
        DDsD.ddpfPixelFormat.lFlags = DDPF_RGB
  
    End If
    
    If D3D_DEV.GetDeviceGuid() = "IID_IDirect3DHALDevice" Then
            DDsD.ddsCaps.lCaps = DDSCAPS_TEXTURE
            DDsD.ddsCaps.lCaps2 = DDSCAPS2_TEXTUREMANAGE
            DDsD.lTextureStage = 0
    Else
            DDsD.ddsCaps.lCaps = DDSCAPS_TEXTURE Or DDSCAPS_SYSTEMMEMORY
            DDsD.ddsCaps.lCaps2 = 0
            DDsD.lTextureStage = 0
    End If

    If sFIle = "" Then
        Set SurfaceObject = ddraw.CreateSurface(DDsD)
    Else
        Set SurfaceObject = ddraw.CreateSurfaceFromFile(sFIle, DDsD)
    End If
    
    
    Set CreateTexture_ALPHA = SurfaceObject
    
    If Not (((D3DTEXTR_TRANSPARENTBLACK = extraFlags) _
        Or (D3DTEXTR_TRANSPARENTWHITE = extraFlags)) _
        ) Then Exit Function

        
        
    Dim ddsd3 As DDSURFACEDESC2
    Dim mem() As Integer
    Dim lAlphaMask As Long
    Dim lRGBMask As Long
    Dim lColorKey As Long
    Dim C As Long
    Dim X As Long
    Dim Y As Long
    Dim r1 As RECT
    
    ReDim mem(DDsD.lheight * DDsD.lPitch)
                        
    With DDsD.ddpfPixelFormat
        lAlphaMask = .lRGBAlphaBitMask
        lRGBMask = .lRBitMask Or .lGBitMask Or .lBBitMask
    End With
    If (extraFlags And D3DTEXTR_TRANSPARENTWHITE) Then
        lColorKey = lRGBMask     'color key on white
    End If
    If (extraFlags And D3DTEXTR_TRANSPARENTBLACK) Then
        lColorKey = 0                  'color key on black
    End If
    
    'pixel format should be 16 bit because thats what we selected
    Dim rl As RECT
    
    r1.Bottom = DDsD.lheight
    r1.Right = DDsD.lWidth
    SurfaceObject.Lock r1, ddsd3, DDLOCK_WAIT, 0
    
    ' Add an opaque alpha value to each non-colorkeyed pixel
    For Y = 0 To ddsd3.lheight - 1
        For X = 0 To ddsd3.lWidth - 1
            C = SurfaceObject.GetLockedPixel(X, Y)
            If C And lRGBMask <> lColorKey Then
                SurfaceObject.SetLockedPixel X, Y, C Or lAlphaMask
            End If
        Next
    Next

    SurfaceObject.Unlock r1
        
    
End Function






Public Function CreateTexture_BUMPmap(sFIle As String, W As Long, H As Long) As DirectDrawSurface7

    Dim bOK As Boolean
    Dim enumTex As Direct3DEnumPixelFormats
    Dim sLoadFile As String
    Dim I As Long
    Dim DDsD As DDSURFACEDESC2
    Dim SurfaceObject As DirectDrawSurface7
    Dim Init As Boolean
    
    DDsD.lFlags = DDSD_CAPS Or DDSD_TEXTURESTAGE Or DDSD_PIXELFORMAT
    If ((H <> 0) And (W <> 0)) Then
        DDsD.lFlags = DDsD.lFlags Or DDSD_HEIGHT Or DDSD_WIDTH
        DDsD.lheight = H
        DDsD.lWidth = W
    End If
    
     
    Set enumTex = D3D_DEV.GetTextureFormatsEnum()
    
   
    For I = 1 To enumTex.GetCount()
        bOK = True
        Call enumTex.GetItem(I, DDsD.ddpfPixelFormat)
            
        With DDsD.ddpfPixelFormat
            
            If .lRGBBitCount <> 16 Then bOK = False
            If .lFourCC <> 0 Then bOK = False
                        
            
            If ((D3DTEXTR_TRANSPARENTBLACK And extraFlags) _
                  Or (D3DTEXTR_TRANSPARENTWHITE And extraFlags)) Then
                  If (.lRGBAlphaBitMask = 0) Then bOK = False
                  'DDPF_ALPHAPIXELS
            Else
                  If (.lRGBAlphaBitMask <> 0) Then bOK = False
            End If
                  
            
        End With
        If bOK = True Then Exit For
    Next
    
    If bOK = False Then
        Debug.Print "Unable to find 16bit surface support on your hardware - exiting"
        Init = False
    End If
    
    
        DDsD.lFlags = DDSD_PIXELFORMAT
        
        'ddsd.ddpfPixelFormat.dwSize = sizeof(DDPIXELFORMAT)
        DDsD.ddpfPixelFormat.lFlags = DDPF_BUMPDUDV 'Or DDPF_BUMPLUMINANCE
        DDsD.ddpfPixelFormat.lBumpBitCount = 16
        DDsD.ddpfPixelFormat.lBumpDuBitMask = &HFF&
        DDsD.ddpfPixelFormat.lBumpDvBitMask = &HFF00&
        DDsD.ddpfPixelFormat.lBumpLuminanceBitMask = &H0&
    
    
    
    
    
    
    
    
    
    If D3D_DEV.GetDeviceGuid() = "IID_IDirect3DHALDevice" Then
            DDsD.ddsCaps.lCaps = DDSCAPS_TEXTURE
            DDsD.ddsCaps.lCaps2 = DDSCAPS2_TEXTUREMANAGE
            DDsD.lTextureStage = 0
    Else
            DDsD.ddsCaps.lCaps = DDSCAPS_TEXTURE Or DDSCAPS_SYSTEMMEMORY
            DDsD.ddsCaps.lCaps2 = 0
            DDsD.lTextureStage = 0
    End If

    If sFIle = "" Then
        Set SurfaceObject = ddraw.CreateSurface(DDsD)
    Else
        Set SurfaceObject = ddraw.CreateSurfaceFromFile(sFIle, DDsD)
    End If
    
    
    Set CreateTexture_BUMPmap = SurfaceObject
    
    
        
        
    Dim ddsd3 As DDSURFACEDESC2
    Dim mem() As Integer
    Dim lAlphaMask As Long
    Dim lRGBMask As Long
    Dim lColorKey As Long
    Dim C As Long
    Dim X As Long
    Dim Y As Long
    Dim r1 As RECT
    Dim FX, fY, iDu, R, iDv As Single
    
    ReDim mem(DDsD.lheight * DDsD.lPitch)
                        
    
    
    'pixel format should be 16 bit because thats what we selected
    Dim rl As RECT
    
    r1.Bottom = DDsD.lheight
    r1.Right = DDsD.lWidth
    SurfaceObject.Lock r1, ddsd3, DDLOCK_WAIT, 0
    
    ' Add an opaque alpha value to each non-colorkeyed pixel
    For Y = 0 To ddsd3.lheight - 1
        For X = 0 To ddsd3.lWidth - 1
            
            FX = X / DDsD.lWidth - 0.5
            fY = Y / DDsD.lheight - 0.5

            R = Sqr(FX * FX + fY * fY)
            iDu = ((32 * Cos(300# * R)) * Exp(-R * 5#))
            iDv = ((32 * Sin(300# * R)) * Exp(-R * 5#))

            iDu = iDu + (16 * Cos(300# * (FX + fY) * 0.5))
            iDv = iDv + (16 * Sin(300# * (FX + fY) * 0.5))
      
            iDu = iDu + (7 * Cos(280# * (FX * 0.85 - fY) * 0.5))
            iDv = iDv + (7 * Sin(280# * (FX * 0.85 - fY) * 0.5))
             C = SurfaceObject.GetLockedPixel(iDu, iDv)
                
                
                SurfaceObject.SetLockedPixel X, Y, C
            
        Next
    Next

    SurfaceObject.Unlock r1
        
  
End Function







Function LoadSimpleTexture(BitmapFile As String, width As Long, Height As Long, Optional TestSquared As Boolean) As DirectDrawSurface7

   Dim W As Long, H As Long
 '  If IsMissing(Width) = True Then w = 0 Else w = Width
 '  If IsMissing(Height) = True Then h = 0 Else h = Height
  ' If IsMissing(ColorKey) = True Then ColorKey = 0
    Dim bOK As Boolean
    Dim enumTex As Direct3DEnumPixelFormats
    Dim sLoadFile As String
    Dim I As Long
    Dim ddsd3 As DDSURFACEDESC2
    Dim SurfaceObject As DirectDrawSurface7
    Dim Init As Boolean
    On Error GoTo 789
    ddsd3.lFlags = DDSD_CAPS Or DDSD_TEXTURESTAGE Or DDSD_PIXELFORMAT
    If IsMissing(width) Then W = 0: H = 0 Else W = width: H = Height
    If ((H <> 0) And (W <> 0)) Then
        ddsd3.lFlags = ddsd3.lFlags Or DDSD_HEIGHT Or DDSD_WIDTH
        ddsd3.lheight = H
        ddsd3.lWidth = W
    End If
    
     
    Set enumTex = D3D_DEV.GetTextureFormatsEnum()
    
   
    For I = 1 To enumTex.GetCount()
        bOK = True
        Call enumTex.GetItem(I, ddsd3.ddpfPixelFormat)
            
        With ddsd3.ddpfPixelFormat
            
            If .lRGBBitCount <> 16 Then bOK = False
            If .lFourCC <> 0 Then bOK = False
            If (.lRGBAlphaBitMask <> 0) Then bOK = False
        End With
        If bOK = True Then Exit For
    Next
    
    If bOK = False Then
         
         Init = False
    End If

    
    ' voodoo 2 change
    If D3D_DEV.GetDeviceGuid() <> "IID_IDirect3DRGBDevice" Then
            ddsd3.ddsCaps.lCaps = DDSCAPS_TEXTURE
            ddsd3.ddsCaps.lCaps2 = DDSCAPS2_TEXTUREMANAGE
            ddsd3.lTextureStage = 0

    Else
            ddsd3.ddsCaps.lCaps = DDSCAPS_TEXTURE Or DDSCAPS_SYSTEMMEMORY
            ddsd3.ddsCaps.lCaps2 = 0
            ddsd3.lTextureStage = 0

    End If

    If BitmapFile = "" Then
        Set SurfaceObject = ddraw.CreateSurface(ddsd3)
    Else
        
        If UCase(Right(BitmapFile, 3)) = "JPG" Or UCase(Right(BitmapFile, 3)) = "GIF" Then
          Set SurfaceObject = KreateSurfaceFromFile(BitmapFile, ddsd3)
        Else
          Set SurfaceObject = ddraw.CreateSurfaceFromFile(BitmapFile, ddsd3)
        End If
        
    End If
     'AddLog "Result : Create Texture success " + BitmapFile + " " + CStr(ddsd3.ddsCaps.lCaps And DDSCAPS_TEXTURE)
     
     
     
     Set LoadSimpleTexture = SurfaceObject
     Exit Function
789:

 Resume Next
End Function



Public Function KreateSurfaceFromFile(ByVal filename As String, SurfaceDesc As DDSURFACEDESC2) As DirectDrawSurface7
On Error GoTo errs
    Dim Picture As StdPicture
    Dim width As Long
    Dim Height As Long
    Dim Surface As DirectDrawSurface7
    Dim hdcPicture As Long  ' Picture device context
    Dim hdcSurface As Long  ' Surface device context
    ' Load picture
    Set Picture = LoadPicture(filename)
    ' Convert from vbHimetric to vbPixels
    width = CLng((Picture.width * 0.001) * 567 / Screen.TwipsPerPixelX)
    Height = CLng((Picture.Height * 0.001) * 567 / Screen.TwipsPerPixelY)
    ' Update surface description
    With SurfaceDesc
        If .lFlags = 0 Then .lFlags = DDSD_CAPS
        .lFlags = .lFlags Or DDSD_WIDTH Or DDSD_HEIGHT
        If .ddsCaps.lCaps = 0 Then .ddsCaps.lCaps = DDSCAPS_OFFSCREENPLAIN
        If .lWidth = 0 Then .lWidth = width
        If .lheight = 0 Then .lheight = Height
    End With
    ' Create surface
    Set Surface = ddraw.CreateSurface(SurfaceDesc)
    ' Create memory device
    hdcPicture = CreateCompatibleDC(0)
    ' Select the bitmap in this memory device
    SelectObject hdcPicture, Picture.handle
    ' Get the surface's DC
    hdcSurface = Surface.GetDC
    ' Copy from the memory device to the DirectDrawSurface
    StretchBlt hdcSurface, 0, 0, SurfaceDesc.lWidth, SurfaceDesc.lheight, hdcPicture, 0, 0, width, Height, vbSrcCopy
    ' Release the surface's DC
    Surface.ReleaseDC hdcSurface
    ' Release the memory device and the bitmap
    DeleteDC hdcPicture
    Set Picture = Nothing
    Set KreateSurfaceFromFile = Surface
    Set Surface = Nothing
  Exit Function
errs:
  
 Resume Next
  
End Function





Public Function CreateTextureEX(ByVal filename As String, WI As Long, HI As Long) As DirectDrawSurface7
'On Error GoTo errs
Dim Text_surf As DirectDrawSurface7
Dim CDI As New cDIBSection

'for BMP,GIF,JPG,JPEG
If InStr(UCase(filename), "BMP") > 0 Or InStr(UCase(filename), "GIF") > 0 Or InStr(UCase(filename), "JPG") > 0 Then
  CDI.CreateFromPicture LoadPicture(filename)
   Set CDI = CDI.Resample(WI, HI)

'for PCX
ElseIf InStr(UCase(filename), "PCX") > 0 Then
  'CDI.CreateFromPicture LoadPCX(filename)
   'Set CDI = CDI.Resample(WI, HI)

'for TGA
ElseIf InStr(filename, "tga") > 0 Then
   'Dim IMk As ImageFile
   'PCX.LoadTGA filename, IMk
   'CDI.Create IMk.ImageWidth, IMk.ImageHeight
   'PCX.DrawImage CDI.hdc, IMk
   'CDI.Resample WI, HI
   'On Error Resume Next
   'Erase IMk.ImageData
   
End If

   
   
Set Text_surf = Me.CreateTexture("", WI, HI)
Dim DC As Long
DC = Text_surf.GetDC
BitBlt DC, 0, 0, WI, HI, CDI.hdc, 0, 0, vbSrcCopy
Text_surf.ReleaseDC DC


   
    Set CreateTextureEX = Text_surf
    Set Text_surf = Nothing
    Set CDI = Nothing
    Set CT = Nothing
End Function



Public Function Create_SPHEREmap(lpVERTEX() As D3DVERTEX) As Boolean

'// Get the current world-view matrix
    'D3DMATRIX MAT_w, MAT_v, MAT_wv
    Dim MAT_w As D3DMATRIX
    Dim MAT_v As D3DMATRIX
    Dim MAT_wv As D3DMATRIX
    Dim M
    Dim nx As Single, ny As Single, nz As Single
    
    Call D3D_DEV.GetTransform(D3DTRANSFORMSTATE_VIEW, MAT_v)
    Call D3D_DEV.GetTransform(D3DTRANSFORMSTATE_WORLD, MAT_w)
    
    Call DX_7.MatrixMultiply(MAT_wv, MAT_w, MAT_v)
    
    '// Extract world-view matrix elements for speed
     'm11 = MAT_wv.rc11, m21 = MAT_wv.rc21, m31 = MAT_wv.rc31
     'm12 = MAT_wv.rc12, m22 = MAT_wv.rc22, m32 = MAT_wv.rc32
     'm13 = MAT_wv.rc13, m23 = MAT_wv.rc23, m33 = MAT_wv.rc33

    '// Loop through the vertices, transforming each one and calculating
    '// the correct texture coordinates.
    'for( WORD i = 0 i < dwNumVertices i++ )
    For I = LBound(lpVERTEX()) To UBound(lpVERTEX)
         nx = lpVERTEX(I).nx
         ny = lpVERTEX(I).ny
         nz = lpVERTEX(I).nz

        '// Check the z-component, to skip any vertices that face backwards
        If (nx * MAT_wv.rc13 + ny * MAT_wv.rc23 + nz * MAT_wv.rc33 > 0#) Then GoTo nexta
            'continue

        '// Assign the sphereMAT_wv.rcap's texture coordinates
        lpVERTEX(I).tu = 0.5 * (1# + (nx * MAT_wv.rc11 + ny * MAT_wv.rc21 + nz * MAT_wv.rc31))
        lpVERTEX(I).tv = 0.5 * (1# - (nx * MAT_wv.rc12 + ny * MAT_wv.rc22 + nz * MAT_wv.rc32))
nexta:
    Next I

   Create_SPHEREmap = True

End Function





Function Create_Material(R, G, B, A) As D3DMATERIAL7
   Dim Mtrl As D3DMATERIAL7
   
    Mtrl.diffuse.R = R: Mtrl.diffuse.G = G: Mtrl.diffuse.B = B
    Mtrl.Ambient.R = R: Mtrl.Ambient.G = G: Mtrl.Ambient.B = B
    

   Create_Material = Mtrl
End Function



'*******************************


Public Sub FreeDX(HAND As Long)
If Me.wType = NOt_init Then
  
  Exit Sub
End If


 
    Call ddraw.SetCooperativeLevel(HAND, DDSCL_NORMAL)
    Call ddraw.RestoreDisplayMode

Set ZBuffer = Nothing
Set D3D_DEV = Nothing
Set PrimaryBuffer = Nothing
Set ddraw = Nothing
Set Back = Nothing
Set DC_DIB = Nothing





'for dinput
If Dinput_isINIT Then
   Me.Dinput_DEV.Unacquire
    Mouse_device.Unacquire
    
    Set Mouse_device = Nothing
    Set Mouse_device = Nothing
End If
  Exit Sub
End Sub

Sub WriteLOG(ST As String, HAND As Long)

BackBuffer.SetForeColor RGB(255, 255, 255)

If ST = "" Then GoTo KRI
Dim I
msg.NB_message = msg.NB_message + 1
ReDim Preserve msg.Message(1 To msg.NB_message)
msg.Message(msg.NB_message) = ST

KRI:
On Error GoTo KUIT
BackBuffer.BltColorFill REC(0, 0, 0, 0), 0
For I = 1 To msg.NB_message
 
 If (I * 15) - 15 > rcSrc.Bottom Then
 BackBuffer.DrawText Int(rcSrc.Right / 2.7), (I * 15 + 10) - rcSrc.Bottom, msg.Message(I), False
 ElseIf 2 * ((I * 15) - 15) > 2 * rcSrc.Bottom Then
  BackBuffer.DrawText Int(rcSrc.Right * (2 / 3)), (2 * (I * 15 + 10)) - (2 * rcSrc.Bottom), msg.Message(I), False
 
 Else
 BackBuffer.DrawText 10, I * 15 + 10, msg.Message(I), False
End If

Next
FLIPP HAND, True
KUIT:

End Sub


Public Sub FLIPP(Optional HAND As Long, Optional LOG_USE As Boolean = False, Optional Testlimit As Boolean = False)
     
'=============== Check for jumping camera
If Eyes.JUMPY Then Call Camera_update
     
   
     
     Dim J, TT
     '*****************************
     '*  for Frames per seconde
     '***************************
     
       If Iclip_count = 30 Then
        TT = (Timer - tLast)
        If tLast <> 0 And TT <> 0 Then fps = 30 / TT
        tLast = Timer
        Iclip_count = 0
    End If
    Iclip_count = Iclip_count + 1
  
  Dim Ree As RECT
      DX_7.GetWindowRect HAND, Ree
      lWidth = Ree.Right - Ree.Left
      lheight = Ree.Bottom - Ree.Top
  
  
  
 ' _
  If Not Me.PAUSE_is_on Then
    'Me.Pause_DC = Me.BackBuffer.GetDC _
       StretchBlt DC_DIB.hdc, 0, 0, DC_DIB.width, DC_DIB.Height, Pause_DC, 0, 0, lWidth, lheight, vbSrcCopy
    
    
    'Me.BackBuffer.ReleaseDC Me.Pause_DC _
  End If _
If Me.PAUSE_is_on Then _
  Me.Pause_DC = Me.BackBuffer.GetDC
       'StretchBlt Me.Pause_DC, 0, 0, lWidth, lheight, DC_DIB.hdc, 0, 0, DC_DIB.Width, DC_DIB.Height, vbSrcCopy
    
    
'Me.BackBuffer.ReleaseDC Me.Pause_DC
 
 
 'End If
       
       
       
       'fpersec version 2
    
   NbIMage = NbIMage + 1
   If DX_7.TickCount - 1000 > OldFPS Then
     calc = DX_7.TickCount - OldFPS
     OldFPS = DX_7.TickCount
     FPS_2 = Int(NbIMage / (calc / 1000))
     NbIMage = 0
   End If
   
  If LOG_USE Then GoTo FORLOG
   
'************* test les colision avec les limites de la camra


FORLOG:
NBFrame = DX_7.TickCount - OldTime + 1
  OldTime = DX_7.TickCount
       
      
   'apply gamma
  'If IS_GammaOK Then GammaControler.SetGammaRamp DDSGR_DEFAULT, GammaRamp

       
       
       
       If Me.wType = FullScreeen Then   'Fullscreen
         Me.PrimaryBuffer.Flip Nothing, DDFLIP_WAIT
       
       End If
      If Me.wType = Windowed Then  'Windowed
        DX_7.GetWindowRect HAND, rcDest
           
           
           
          J = PrimaryBuffer.Blt(rcDest, BackBuffer, rcSrc, DDBLT_WAIT)
          If J <> DD_OK Then
            MsgBox "Couldn't copy the source rectangle to the destination surface." & Chr$(13) & Hex(J)
            Exit Sub
          End If
      
      End If
      
      
     
End Sub

Public Property Get FramesPerSec() As Single
  FramesPerSec = fps
End Property

Public Property Get ImparSeconde() As Single
  ImparSeconde = FPS_2
End Property

Public Property Get ElapseFrame() As Single
  ElapseFrame = NBFrame
End Property


'*******************************
'*  Vector arithmtic
'***********
Public Function johna_MakeVector(A As Double, B As Double, C As Double) As D3DVECTOR
    Dim vecOut As D3DVECTOR
    
    With vecOut
        .X = A
        .Y = B
        .Z = C
    End With
    
    johna_MakeVector = vecOut
    
End Function

Function Vector(A, B, C) As D3DVECTOR
    Dim vecOut As D3DVECTOR
    
    With vecOut
        .X = A
        .Y = B
        .Z = C
    End With
    
    Vector = vecOut
    
End Function














Public Function SET_camera(Vec_From As D3DVECTOR, Optional VEC_to As Variant)
 Dim matView  As D3DMATRIX
    
    DX_7.IdentityMatrix matView
    
    
    Call DX_7.ViewMatrix(matView, Vec_From, johna_MakeVector(0, 0, 150), _
                         johna_MakeVector(0, 1, 0), 0)
    
   
    
    Dim matSpinY As D3DMATRIX

    Call DX_7.RotateYMatrix(matSpinY, 0)
    Call D3D_DEV.SetTransform(D3DTRANSFORMSTATE_VIEW, matView)
    Eyes.EYE = Vec_From
    Me.Camera_update
End Function

Sub SET_cameraEYE(xVEC As D3DVECTOR)
Eyes.EYE = xVEC
Me.Camera_update

End Sub


Public Function GET_camera(ByRef C_from As D3DVECTOR, ByRef C_To As D3DVECTOR)
  C_from = Eyes.EYE
  C_To = Eyes.View_AT

End Function

Public Function GET_CameraEYE() As D3DVECTOR
   GET_CameraEYE = Eyes.EYE
End Function

Public Function Get_CameraDIR2() As D3DVECTOR
  Dim VC As D3DVECTOR
  VC = Vsub(Eyes.EYE, LAST_cam.EYE)
 VectorNormalize VC
  Get_CameraDIR2 = VC
  
End Function

Public Function Get_CameraDIR() As D3DVECTOR
  Get_CameraDIR = GLOB.Vector_Dir(Eyes.DEG, Eyes.Angy)
End Function

Public Function GET_LastEYE() As D3DVECTOR
   GET_LastEYE = LAST_cam.EYE
End Function



Public Function GET_CameraAT() As D3DVECTOR
   GET_CameraAT = Eyes.View_AT
End Function



Public Sub Camera_Turn_Left(StepAngle)
   SaveCAM
   Eyes.DEG = Eyes.DEG + StepAngle * NBFrame
   
   
   Camera_update
End Sub


Public Sub Camera_Turn_Right(StepAngle)
   SaveCAM
   Eyes.DEG = Eyes.DEG - StepAngle * NBFrame
   
   
   Camera_update
   
End Sub


Public Sub Camera_Move_Foward(StepZ)
  SaveCAM
  Eyes.EYE.X = Eyes.EYE.X + Cos(Eyes.DEG * RAIAN) * StepZ
  'Eyes.EYE.Y = Eyes.EYE.Y + Sin(Eyes.Angy * RAIAN) * StepZ
  Eyes.EYE.Z = Eyes.EYE.Z + Sin(Eyes.DEG * RAIAN) * StepZ

  Camera_update

End Sub

Public Sub Camera_Move_Backward(StepZ)
  SaveCAM
   Eyes.EYE.X = Eyes.EYE.X - Cos(Eyes.DEG * RAIAN) * StepZ
    'Eyes.EYE.Y = Eyes.EYE.Y - Sin(Eyes.Angy * RAIAN) * StepZ
  Eyes.EYE.Z = Eyes.EYE.Z - Sin(Eyes.DEG * RAIAN) * StepZ
  
  Camera_update

End Sub


Public Sub Camera_Turn_UP(StepAngle)
  SaveCAM
  Eyes.Angy = Eyes.Angy + StepAngle * NBFrame
    'If Eyes.Angy > 180 * Rad Then Eyes.Angy = 180 * Rad
    
    Camera_update
End Sub

Public Sub Camera_Turn_DOWN(StepAngle)
  SaveCAM
  Eyes.Angy = Eyes.Angy - StepAngle * NBFrame
  Eyes.Dest_at = Eyes.EYE
    Eyes.Dest_at.Y = Eyes.Dest_at.Y - StepY
    
    Camera_update
End Sub

Public Sub Camera_Elevator_UP(StepY)
    SaveCAM
    Eyes.EYE.Y = Eyes.EYE.Y + StepY
    Eyes.Dest_at = Eyes.EYE
    Eyes.Dest_at.Y = Eyes.Dest_at.Y - StepY
    
    Camera_update 0
End Sub
Public Sub Camera_Elevator_DOWN(StepY)
    SaveCAM
    Eyes.EYE.Y = Eyes.EYE.Y - StepY
    Eyes.Dest_at = Eyes.EYE
    Eyes.Dest_at.Y = Eyes.Dest_at.Y - StepY
    Camera_update 0
End Sub


Public Sub Camera_Roll_Left(SetpAngle)
    Eyes.ANGZ = Eyes.ANGZ - SetpAngle
    Camera_update 0
End Sub
Public Sub Camera_Roll_Right(SetpAngle)
    Camera_Roll_Left -SetpAngle
    Camera_update 0
End Sub

Property Get CAM_angle()
   CAM_angle = Eyes.DEG
End Property
Property Set CAM_angle(Ang)
   Eyes.DEG = Ang
End Property

Property Get CAM_angleDEGRE()
  CAM_angleDEGRE = Eyes.DEG
End Property

Property Get CAM_angleBilBOARD()
  CAM_angleBilBOARD = (Eyes.DEG) - 90
End Property



Property Set CAM_angleDEGRE(ANG_degree)
  Eyes.DEG = ANG_degree
End Property



Sub Camera_set_EYE(Veye As D3DVECTOR)
   Eyes.EYE = Veye
   Me.Camera_update
   
End Sub


Function Camera_GetLookAt() As D3DVECTOR
   Camera_GetLookAt = Eyes.View_AT
End Function


Sub Camera_SetXRotation(Xdeg)
  
  Eyes.DEG = Xdeg
  
  Me.Camera_update
End Sub

Sub Camera_SetYRotation(Ydeg)
  
  Eyes.Angy = Ydeg
  
  Me.Camera_update
End Sub

Sub Camera_SetZRotation(ZDEG)
  
  Eyes.ANGZ = ZDEG
  
  Me.Camera_update
End Sub


Sub Camera_SetRotation(Xdeg, Ydeg, ZDEG)
  Eyes.Angy = Ydeg
  Eyes.DEG = Xdeg
  Eyes.ANGZ = ZDEG
  Me.Camera_update
End Sub




Property Get CAM_angleYdeg()
  CAM_angleYdeg = Eyes.Angy
End Property





Private Sub SaveCAM()
 If LAST_cam.EYE.X <> Eyes.EYE.X And _
     LAST_cam.EYE.Y <> Eyes.EYE.Y And _
      LAST_cam.EYE.Z <> Eyes.EYE.Z Then
   
    LAST_cam = Eyes
End If

End Sub
Function get_ORIGIN_kam() As D3DVECTOR
  get_ORIGIN_kam = LAST_cam.EYE
End Function

Private Function VECpoint(Vtor As D3DVECTOR) As Dpoint
      VECpoint.X = Vtor.X
      VECpoint.Y = Vtor.Z
End Function







 Sub REcallCAM()
 Eyes = LAST_cam
 Camera_update

End Sub


Sub CAM_jump()
If Not Eyes.JUMPY Then
   Eyes.JUMPY = True
   Eyes.JUMP_loc = 0
   Eyes.JUMP_step = Abs(Eyes.JUMP_step)
   Eyes.LastY = Eyes.EYE.Y
End If
  Camera_update
End Sub

Sub CAM_step_LEFT(Step As Single)
Dim VC As D3DVECTOR
Dim Ndeg

Step = -Step
LAST_cam = Eyes
Ndeg = (Eyes.DEG / RAIAN) - 90
LAST_cam.DEG = Ndeg * RAIAN



LAST_cam.View_AT.X = LAST_cam.EYE.X + Cos(LAST_cam.DEG)
LAST_cam.View_AT.Y = LAST_cam.EYE.Y + Sin(LAST_cam.Angy) '* 2
LAST_cam.View_AT.Z = LAST_cam.EYE.Z + Sin(LAST_cam.DEG)

LAST_cam.EYE.X = LAST_cam.EYE.X + Cos(LAST_cam.DEG) * Step
LAST_cam.EYE.Z = LAST_cam.EYE.Z + Sin(LAST_cam.DEG) * Step
  

Eyes.EYE = LAST_cam.EYE
Me.Camera_update

End Sub

Sub CAM_step_RIGHT(Step As Single)
Dim Ndeg


LAST_cam = Eyes
Ndeg = (Eyes.DEG / RAIAN) - 90
LAST_cam.DEG = Ndeg * RAIAN



LAST_cam.View_AT.X = LAST_cam.EYE.X + Cos(LAST_cam.DEG)
LAST_cam.View_AT.Y = LAST_cam.EYE.Y + Sin(LAST_cam.Angy) '* 2
LAST_cam.View_AT.Z = LAST_cam.EYE.Z + Sin(LAST_cam.DEG)

LAST_cam.EYE.X = LAST_cam.EYE.X + Cos(LAST_cam.DEG) * Step
LAST_cam.EYE.Z = LAST_cam.EYE.Z + Sin(LAST_cam.DEG) * Step
  

Eyes.EYE = LAST_cam.EYE
Me.Camera_update


End Sub



Function Get_cam_Forward_VECTOR(Step As Single) As D3DVECTOR
Dim v As D3DVECTOR

v.X = Eyes.EYE.X + Cos(Eyes.DEG) * Step
v.Y = Eyes.EYE.Y + Sin(Eyes.Angy) * Step * 2
v.Z = Eyes.EYE.Z + Sin(Eyes.DEG) * Step
Get_cam_Forward_VECTOR = v

End Function

Sub CAM_CheckMouse()
Dim C
Dim Ang




'IF there's a bigger change than 1 pixels, change horizontal angle... modify the 1 for sensitivity settings...
  If (Mouse_X - Eyes.Mouse_Prev_X) < -1 Or (Mouse_X - Eyes.Mouse_Prev_X) > 1 Then
    
    Ang = Mouse_X - Eyes.Mouse_Prev_X
    If Ang > 0 And Ang <= 0 Then
          Eyes.DEG = Eyes.DEG + NBFrame * (Ang / 2) * 0.005

    ElseIf Ang < 0 And Ang >= -0 Then
      Eyes.DEG = Eyes.DEG - NBFrame * (Abs(Ang) / 2) * 0.005

    End If
    Eyes.Mouse_Prev_X = Me.lWidth / 2
    C = 1
  
  End If



'IF there's a bigger change than 1 pixels, change vertical angle... modify the 1 for sensitivity settings...
  If (Mouse_Y - Eyes.Mouse_Prev_Y) < -1 Or (Mouse_Y - Eyes.Mouse_Prev_Y) > 1 Then
    Eyes.Angy = Eyes.Angy + NBFrame * (Eyes.Mouse_Prev_Y - Mouse_Y) / 100000
    
     Ang = Mouse_Y - Eyes.Mouse_Prev_Y
    If Ang > 0 And Ang <= 2 Then
          Eyes.Angy = Eyes.Angy + NBFrame * (Ang / 2) * 0.0005

    ElseIf Ang < 0 And Ang >= -2 Then
     Eyes.Angy = Eyes.Angy - NBFrame * (Abs(Ang) / 2) * 0.0005

    End If
    
    
    
    Eyes.Mouse_Prev_Y = lheight / 2
    C = 1
  End If
  
  If C = 1 Then SetCursorPos Int(Me.lWidth / 2), Int(Me.lheight / 2)
 
  Call Camera_update
 



End Sub


 Sub Camera_update(Optional Check_Terrain As Boolean = True)
    
    
    

'=============Check for Jumping

If Eyes.JUMPY Then
    Eyes.EYE.Y = Eyes.EYE.Y + Eyes.JUMP_step
    Eyes.JUMP_loc = Eyes.JUMP_loc + (Eyes.JUMP_step / 100) * Me.ElapseFrame
    
    If Eyes.JUMP_loc >= Eyes.JUMP_MAX Then Eyes.JUMP_step = -Abs(Eyes.JUMP_step)
   If Eyes.JUMP_loc <= 0 Then
      Eyes.JUMPY = False
      Eyes.EYE.Y = Eyes.LastY
   End If
End If




Eyes.View_AT.X = Eyes.EYE.X + Cos(Eyes.DEG * RAIAN)
Eyes.View_AT.Y = Eyes.EYE.Y + Sin(Eyes.Angy * RAIAN) '* 2 '* 2
Eyes.View_AT.Z = Eyes.EYE.Z + Sin(Eyes.DEG * RAIAN) '* 2

'Eyes.View_AT = GLOB.Vector_RotateAroundVector(Eyes.View_AT, Eyes.DEG, Eyes.Angy, Eyes.ANGZ, Eyes.EYE)

'Eyes.View_AT.x = Eyes.EYE.x + Cos(Eyes.DEG * RAIAN)
'Eyes.View_AT.Y = Eyes.EYE.Y + Sin(Eyes.Angy * RAIAN) '* 2
'Eyes.View_AT.Z = Eyes.EYE.Z + Sin(Eyes.DEG * RAIAN)


Dim V1 As D3DVECTOR
'V1 = Eyes.View_AT
'V1 = Me.RotateYVectorAroundVector(V1, CSng(Eyes.DEG), Eyes.EYE)
'V1 = Me.RotateXVectorAroundVector(V1, CSng(Eyes.DEG), Eyes.EYE)

'Eyes.View_AT = V1

'*****actualise les quations de droites camra***


    Call DX_7.ViewMatrix(MA_View, Eyes.EYE, Eyes.View_AT, _
                         johna_MakeVector(0, 1, 0), Eyes.ANGZ * RAD)
    
   
    
   
    Call D3D_DEV.SetTransform(D3DTRANSFORMSTATE_VIEW, MA_View)
    

End Sub







Public Function Set_Light(OnN As Boolean)
D3D_DEV.SetRenderState D3DRENDERSTATE_LIGHTING, OnN
End Function

Public Function SET_camera_DirectioN(Vec_From As D3DVECTOR, VEC_to As D3DVECTOR)
 'Dim matView  As D3DMATRIX
    
    'DX_7.IdentityMatrix MA_View
    
    
    Call DX_7.ViewMatrix(MA_View, Vec_From, VEC_to, _
                         johna_MakeVector(0, 1, 0), 0)
    
   
    
   
    Call D3D_DEV.SetTransform(D3DTRANSFORMSTATE_VIEW, MA_View)
    Eyes.EYE = Vec_From
    Eyes.View_AT = VEC_to
End Function

Public Sub alphaBLEND_1(Optional Is_on As Boolean)

If Not Is_on Then
   D3D_DEV.SetRenderState D3DRENDERSTATE_ALPHABLENDENABLE, 0
   Exit Sub
End If

      D3D_DEV.SetRenderState D3DRENDERSTATE_SPECULARENABLE, 0
      D3D_DEV.SetRenderState D3DRENDERSTATE_LIGHTING, 0
      D3D_DEV.SetRenderState D3DRENDERSTATE_ALPHABLENDENABLE, 1
      D3D_DEV.SetRenderState D3DRENDERSTATE_SRCBLEND, D3DBLEND_SRCCOLOR
      D3D_DEV.SetRenderState D3DRENDERSTATE_DESTBLEND, D3DBLEND_INVSRCCOLOR
      D3D_DEV.SetTextureStageState 0, D3DTSS_COLORARG1, D3DTA_TEXTURE
      D3D_DEV.SetTextureStageState 0, D3DTSS_COLORARG2, D3DTA_DIFFUSE
      D3D_DEV.SetTextureStageState 0, D3DTSS_COLOROP, D3DTOP_MODULATE

     
     
     
End Sub



Public Sub Make_Multitexturing()
   D3D_DEV.SetRenderState D3DRENDERSTATE_ALPHABLENDENABLE, 1
      D3D_DEV.SetRenderState D3DRENDERSTATE_SRCBLEND, D3DBLEND_INVSRCALPHA
      D3D_DEV.SetRenderState D3DRENDERSTATE_DESTBLEND, D3DBLEND_SRCALPHA
      D3D_DEV.SetTextureStageState 0, D3DTSS_COLORARG1, D3DTA_TEXTURE
      D3D_DEV.SetTextureStageState 0, D3DTSS_ALPHAARG1, D3DTA_TEXTURE
      D3D_DEV.SetTextureStageState 0, D3DTSS_COLOROP, D3DTOP_SELECTARG1
      D3D_DEV.SetTextureStageState 0, D3DTSS_ALPHAOP, D3DTOP_SELECTARG1

     

End Sub


Sub Set_TextureSTATE(STATE As Long, levelSTATE As CONST_D3DTEXTURESTAGESTATETYPE, Blend_effect As Long)
     D3D_DEV.SetTextureStageState STATE, levelSTATE, Blend_effect
     
   
End Sub

Sub MULTITEXTURE_FX_Dark_Mapping(Optional Activate As Boolean = True, Optional TEX1 As DirectDrawSurface7)
If Activate Then

Me.Enable_Blendstage 1
'If USE_stage0 Then Call D3D_DEV.SetTexture(0, TEX1)
Call D3D_DEV.SetTextureStageState(0, D3DTSS_COLORARG1, D3DTA_TEXTURE)
Call D3D_DEV.SetTextureStageState(0, D3DTSS_COLOROP, D3DTOP_SELECTARG1)

'' Set darkmap
Call D3D_DEV.SetTexture(1, TEX1)
Call D3D_DEV.SetTextureStageState(1, D3DTSS_COLORARG1, D3DTA_TEXTURE)
Call D3D_DEV.SetTextureStageState(1, D3DTSS_COLORARG2, D3DTA_CURRENT)

Else
 Call D3D_DEV.SetTextureStageState(1, D3DTSS_COLORARG1, D3DTOP_DISABLE)
 Me.USE_default_RENDERSTATE
 Me.Disable_MULTITEXTURING 1


End If

End Sub


Sub MULTITEXTURE_FX_smooth_satur(Optional Activate As Boolean = True, Optional TEX1 As DirectDrawSurface7)
If Activate Then

Me.Enable_Blendstage 1
'If USE_stage0 Then Call D3D_DEV.SetTexture(0, TEX1)
   Call D3D_DEV.SetTextureStageState(0, D3DTSS_COLORARG1, D3DTA_TEXTURE)
   Call D3D_DEV.SetTextureStageState(0, D3DTSS_COLOROP, D3DTOP_MODULATE)
   Call D3D_DEV.SetTextureStageState(0, D3DTSS_COLORARG2, D3DTA_DIFFUSE)
   Call D3D_DEV.SetTextureStageState(0, D3DTSS_ALPHAOP, D3DTOP_SELECTARG2)
   Call D3D_DEV.SetTextureStageState(0, D3DTSS_ALPHAARG2, D3DTA_DIFFUSE)

   
'' Set darkmap
Call D3D_DEV.SetTexture(1, TEX1)
   Call D3D_DEV.SetTextureStageState(1, D3DTSS_COLORARG1, D3DTA_TEXTURE)
   Call D3D_DEV.SetTextureStageState(1, D3DTSS_COLOROP, D3DTOP_ADD)
   Call D3D_DEV.SetTextureStageState(1, D3DTSS_COLORARG2, D3DTA_CURRENT)
   Call D3D_DEV.SetTextureStageState(1, D3DTSS_ALPHAARG1, D3DTA_TEXTURE)
   Call D3D_DEV.SetTextureStageState(1, D3DTSS_ALPHAOP, D3DTOP_SELECTARG1)
   
Else
 
 Me.USE_default_RENDERSTATE
 Me.Disable_MULTITEXTURING 1


End If

End Sub




Sub MULTITEXTURE_FX_DetailMODULATE(Optional Activate As Boolean = True, Optional TEX1_stage1 As DirectDrawSurface7)
If Activate Then

Me.Enable_Blendstage 1
'If USE_stage0 Then Call D3D_DEV.SetTexture(0, TEX1)
   Call D3D_DEV.SetTextureStageState(0, D3DTSS_COLORARG1, D3DTA_TEXTURE)
   Call D3D_DEV.SetTextureStageState(0, D3DTSS_COLOROP, D3DTOP_MODULATE)
   Call D3D_DEV.SetTextureStageState(0, D3DTSS_COLORARG2, D3DTA_DIFFUSE)
   Call D3D_DEV.SetTextureStageState(0, D3DTSS_ALPHAOP, D3DTOP_SELECTARG2)
   Call D3D_DEV.SetTextureStageState(0, D3DTSS_ALPHAARG2, D3DTA_DIFFUSE)
   
'' Set darkmap
Call D3D_DEV.SetTexture(1, TEX1_stage1)
    Call D3D_DEV.SetTextureStageState(1, D3DTSS_COLORARG1, D3DTA_TEXTURE)
   Call D3D_DEV.SetTextureStageState(1, D3DTSS_COLOROP, D3DTOP_MODULATE2X)
   Call D3D_DEV.SetTextureStageState(1, D3DTSS_COLORARG2, D3DTA_CURRENT)
   Call D3D_DEV.SetTextureStageState(1, D3DTSS_ALPHAARG1, D3DTA_TEXTURE)
   Call D3D_DEV.SetTextureStageState(1, D3DTSS_ALPHAOP, D3DTOP_SELECTARG1)
Else
 
 Me.USE_default_RENDERSTATE
 Me.Disable_MULTITEXTURING 1


End If

End Sub



Sub MULTITEXTURE_Normal(Text_LEV_1 As DirectDrawSurface7)
    Call D3D_DEV.SetTextureStageState(0, D3DTSS_COLORARG1, D3DTA_TEXTURE)
Call D3D_DEV.SetTextureStageState(0, D3DTSS_COLORARG2, D3DTA_DIFFUSE)
Call D3D_DEV.SetTextureStageState(0, D3DTSS_COLOROP, D3DTOP_ADDSIGNED)
 Call D3D_DEV.SetTextureStageState(0, D3DTSS_COLORARG2, D3DTA_DIFFUSE)
   'Call D3D_DEV.SetTextureStageState(0, D3DTSS_ALPHAOP, D3DTOP_SELECTARG2)
   'Call D3D_DEV.SetTextureStageState(0, D3DTSS_ALPHAARG2, D3DTA_DIFFUSE)
   

    
    
    Call D3D_DEV.SetTexture(1, Text_LEV_1)
    Call D3D_DEV.SetTextureStageState(1, D3DTSS_COLORARG1, D3DTA_TEXTURE)
    Call D3D_DEV.SetTextureStageState(1, D3DTSS_COLORARG2, D3DTA_DIFFUSE)
    'Call D3D_DEV.SetTextureStageState(1, D3DTSS_COLORARG2, D3DTA_CURRENT)
   'Call D3D_DEV.SetTextureStageState(1, D3DTSS_ALPHAARG1, D3DTA_TEXTURE)
   'Call D3D_DEV.SetTextureStageState(1, D3DTSS_ALPHAOP, D3DTOP_SELECTARG1)
   


End Sub





Sub MULTITEXTURE_Dark_Diffu_color_ligh(Optional Activate As Boolean = True, Optional TEX1 As DirectDrawSurface7)
If Activate Then

Me.Enable_Blendstage 1
'If USE_stage0 Then Call D3D_DEV.SetTexture(0, TEX1)
Call D3D_DEV.SetTextureStageState(0, D3DTSS_COLORARG1, D3DTA_TEXTURE)
Call D3D_DEV.SetTextureStageState(0, D3DTSS_COLORARG2, D3DTA_DIFFUSE)
Call D3D_DEV.SetTextureStageState(0, D3DTSS_COLOROP, D3DTOP_ADDSIGNED)


'' Set darkmap
Call D3D_DEV.SetTexture(1, TEX1)
Call D3D_DEV.SetTextureStageState(1, D3DTSS_COLORARG1, D3DTA_TEXTURE)
Call D3D_DEV.SetTextureStageState(1, D3DTSS_COLORARG2, D3DTA_CURRENT)
Call D3D_DEV.SetTextureStageState(1, D3DTSS_COLOROP, D3DTOP_MODULATE)

Else

Call D3D_DEV.SetTextureStageState(0, D3DTSS_COLORARG1, D3DTOP_DISABLE)
Call D3D_DEV.SetTextureStageState(0, D3DTSS_COLORARG2, D3DTOP_DISABLE)
Call D3D_DEV.SetTextureStageState(0, D3DTSS_COLOROP, D3DTOP_DISABLE)
Me.USE_default_RENDERSTATE
Me.Disable_MULTITEXTURING 1



End If

End Sub




Sub MULTITEXTURE_Specular_mapping(TEX0 As DirectDrawSurface7, TEX1 As DirectDrawSurface7)


    '// Program Stage 0:
    Call D3D_DEV.SetTexture(0, TEX0)
    Call D3D_DEV.SetTextureStageState(0, D3DTSS_COLORARG1, D3DTA_TEXTURE)
    Call D3D_DEV.SetTextureStageState(0, D3DTSS_COLORARG2, D3DTA_DIFFUSE)
    Call D3D_DEV.SetTextureStageState(0, D3DTSS_COLOROP, D3DTOP_MODULATE)
    
    
    '// Program Stage 1:
    Call D3D_DEV.SetTexture(1, TEX1)
    Call D3D_DEV.SetTextureStageState(1, D3DTSS_COLORARG1, D3DTA_TEXTURE)
    Call D3D_DEV.SetTextureStageState(1, D3DTSS_COLORARG2, D3DTA_CURRENT)
    Call D3D_DEV.SetTextureStageState(1, D3DTSS_COLOROP, D3DTOP_ADD)



End Sub



Sub MULTITEXTURING_OFF()
   Call D3D_DEV.SetTextureStageState(1, D3DTSS_COLORARG1, D3DTOP_DISABLE)
   Call D3D_DEV.SetTextureStageState(1, D3DTSS_COLOROP, D3DTOP_DISABLE)
   Call D3D_DEV.SetTextureStageState(1, D3DTSS_COLORARG2, D3DTOP_DISABLE)
   Call D3D_DEV.SetTextureStageState(1, D3DTSS_ALPHAARG1, D3DTOP_DISABLE)
   Call D3D_DEV.SetTextureStageState(1, D3DTSS_ALPHAOP, D3DTOP_DISABLE)
   Me.USE_default_RENDERSTATE
   
End Sub















Sub FX_blend_COLOR_lighting(Optional Activate As Boolean = True, Optional STAGE_ As Long = 0)


If Activate Then
' set the first color argument to the texture associated with this stage
Call D3D_DEV.SetTextureStageState(STAGE_, D3DTSS_COLORARG1, D3DTA_TEXTURE)

' set the second color argument to diffuse lightning information
Call D3D_DEV.SetTextureStageState(STAGE_, D3DTSS_COLORARG2, D3DTA_DIFFUSE)

' set the color operation to the addition mode
Call D3D_DEV.SetTextureStageState(STAGE_, D3DTSS_COLOROP, D3DTOP_ADD)

Else
  Call D3D_DEV.SetTextureStageState(STAGE_, D3DTSS_COLORARG1, D3DTOP_DISABLE)
  Call D3D_DEV.SetTextureStageState(STAGE_, D3DTSS_COLORARG2, D3DTOP_DISABLE)
  Call D3D_DEV.SetTextureStageState(STAGE_, D3DTSS_COLOROP, D3DTOP_DISABLE)
  Me.Disable_MULTITEXTURING 1
  Me.USE_default_RENDERSTATE
  
  


End If


End Sub



Sub FX_blend_COLOR_darking(Optional Activate As Boolean = True, Optional STAGE_ As Long = 0, Optional ANIKY As Long = 100)


If Activate Then
' set the first color argument to the texture associated with this stage
Call D3D_DEV.SetTextureStageState(STAGE_, D3DTSS_COLORARG1, D3DTA_TEXTURE)

' set the second color argument to diffuse lightning information
Call D3D_DEV.SetTextureStageState(STAGE_, D3DTSS_COLORARG2, D3DTA_DIFFUSE)

' set the color operation to the addition mode
        If MODULATE_timer < 4 * ANIKY Then
          Call D3D_DEV.SetTextureStageState(1, D3DTSS_COLOROP, D3DTOP_MODULATE)
        ElseIf MODULATE_timer < 8 * anyky Then
          Call D3D_DEV.SetTextureStageState(1, D3DTSS_COLOROP, D3DTOP_MODULATE2X)
        ElseIf MODULATE_timer < 12 * ANIKY Then
            Call D3D_DEV.SetTextureStageState(1, D3DTSS_COLOROP, D3DTOP_MODULATE4X)
        ElseIf MODULATE_timer = 16 * ANIKY Then
            MODULATE_timer = 0
        End If
        MODULATE_timer = MODULATE_timer + 1

Else
  Call D3D_DEV.SetTextureStageState(STAGE_, D3DTSS_COLORARG1, D3DTOP_DISABLE)
  Call D3D_DEV.SetTextureStageState(STAGE_, D3DTSS_COLORARG2, D3DTOP_DISABLE)
  Call D3D_DEV.SetTextureStageState(STAGE_, D3DTSS_COLOROP, D3DTOP_DISABLE)
  Me.Disable_MULTITEXTURING 1
  Me.USE_default_RENDERSTATE
  
  


End If


End Sub
























Sub FX_alphaBlend_FrameTransparency(Optional Activate As Boolean = True)
If Activate Then

Call D3D_DEV.SetRenderState(D3DRENDERSTATE_ALPHABLENDENABLE, True)

' Set the source blend state.
Call D3D_DEV.SetRenderState(D3DRENDERSTATE_SRCBLEND, D3DBLEND_SRCCOLOR)

' Set the destination blend state.
Call D3D_DEV.SetRenderState(D3DRENDERSTATE_DESTBLEND, D3DBLEND_INVSRCCOLOR)

Else
 Call D3D_DEV.SetRenderState(D3DRENDERSTATE_ALPHABLENDENABLE, False)


End If
End Sub




Sub USE_default_Blendstage0()
    Call D3D_DEV.SetTextureStageState(0, D3DTSS_COLORARG1, D3DTA_TEXTURE)
    Call D3D_DEV.SetTextureStageState(0, D3DTSS_COLORARG2, D3DTA_DIFFUSE)
    Call D3D_DEV.SetTextureStageState(0, D3DTSS_COLOROP, D3DTOP_MODULATE)
    Call D3D_DEV.SetTextureStageState(0, D3DTSS_ALPHAOP, D3DTOP_SELECTARG1)
    Call D3D_DEV.SetTextureStageState(0, D3DTSS_ALPHAARG1, D3DTA_TEXTURE)
    Call D3D_DEV.SetTextureStageState(0, D3DTSS_MINFILTER, D3DTFN_LINEAR)
    Call D3D_DEV.SetTextureStageState(0, D3DTSS_MAGFILTER, D3DTFG_LINEAR)
    Call D3D_DEV.SetRenderState(D3DRENDERSTATE_DITHERENABLE, True)


End Sub

Sub Enable_Blendstage(Stage As Long)
    Call D3D_DEV.SetTextureStageState(Stage, D3DTSS_COLORARG1, D3DTA_TEXTURE)
    Call D3D_DEV.SetTextureStageState(Stage, D3DTSS_COLORARG2, D3DTA_DIFFUSE)
    Call D3D_DEV.SetTextureStageState(Stage, D3DTSS_COLOROP, D3DTOP_MODULATE)
    Call D3D_DEV.SetTextureStageState(Stage, D3DTSS_ALPHAOP, D3DTOP_SELECTARG1)
    Call D3D_DEV.SetTextureStageState(Stage, D3DTSS_ALPHAARG1, D3DTA_TEXTURE)
    Call D3D_DEV.SetTextureStageState(Stage, D3DTSS_MINFILTER, D3DTFN_LINEAR)
    Call D3D_DEV.SetTextureStageState(Stage, D3DTSS_MAGFILTER, D3DTFG_LINEAR)


End Sub




Sub Disable_MULTITEXTURING(Stage As Long)
       
   Call D3D_DEV.SetTextureStageState(Stage, D3DTSS_COLORARG1, D3DTOP_DISABLE)
   Call D3D_DEV.SetTextureStageState(Stage, D3DTSS_COLOROP, D3DTOP_DISABLE)
   Call D3D_DEV.SetTextureStageState(Stage, D3DTSS_COLORARG2, D3DTOP_DISABLE)
   Call D3D_DEV.SetTextureStageState(Stage, D3DTSS_ALPHAARG1, D3DTOP_DISABLE)
   Call D3D_DEV.SetTextureStageState(Stage, D3DTSS_ALPHAOP, D3DTOP_DISABLE)

End Sub

Sub Disable_MULTITEXTURE()
       
   Call D3D_DEV.SetTextureStageState(1, D3DTSS_COLORARG1, D3DTOP_DISABLE)
   Call D3D_DEV.SetTextureStageState(1, D3DTSS_COLOROP, D3DTOP_DISABLE)
   Call D3D_DEV.SetTextureStageState(1, D3DTSS_COLORARG2, D3DTOP_DISABLE)
   Call D3D_DEV.SetTextureStageState(1, D3DTSS_ALPHAARG1, D3DTOP_DISABLE)
   Call D3D_DEV.SetTextureStageState(1, D3DTSS_ALPHAOP, D3DTOP_DISABLE)
   Me.USE_default_RENDERSTATE

   
End Sub

Sub Disable_FX_blend(Stage As Long)
    Call D3D_DEV.SetTextureStageState(Stage, D3DTSS_COLOROP, D3DTOP_DISABLE)
    Call D3D_DEV.SetTextureStageState(Stage, D3DTSS_ALPHAOP, D3DTOP_DISABLE)
   Call D3D_DEV.SetTextureStageState(Stage, D3DTSS_COLORARG2, D3DTOP_DISABLE)
   Call D3D_DEV.SetTextureStageState(Stage, D3DTSS_ALPHAARG1, D3DTOP_DISABLE)
   Call D3D_DEV.SetTextureStageState(Stage, D3DTSS_ALPHAOP, D3DTOP_DISABLE)
   Me.USE_default_RENDERSTATE


End Sub









Public Function MAke_BumpmapinG(anlge As Double)
D3D_DEV.SetTextureStageState 0, D3DTSS_BUMPENVMAT00, CLng(Cos(angle))
D3D_DEV.SetTextureStageState 0, D3DTSS_BUMPENVMAT01, CLng(Sin(angle))
D3D_DEV.SetTextureStageState 0, D3DTSS_BUMPENVMAT10, CLng(-Sin(angle))
D3D_DEV.SetTextureStageState 0, D3DTSS_BUMPENVMAT11, CLng(Cos(angle))


End Function

Sub USE_defaultMaterial()
 Dim Mtrl As D3DMATERIAL7
   
    Mtrl.diffuse.R = 1#: Mtrl.diffuse.G = 1#: Mtrl.diffuse.B = 1#
    Mtrl.Ambient.R = 1: Mtrl.Ambient.G = 1: Mtrl.Ambient.B = 1
    Mtrl.power = 1
    'Mtrl.emissive = Mtrl.Ambient
    'Mtrl.specular = Mtrl.Ambient
    
    ' Commit the material to the device.
    D3D_DEV.SetMaterial Mtrl
        
    D3D_DEV.SetRenderState D3DRENDERSTATE_AMBIENT, DX_7.CreateColorRGBA(1#, 1#, 1#, 1#)
End Sub


'----------------------------------------------------------------------
'Procedure   : USE_default_RENDERSTATE()
'----------------------------------------------------------------------
'Author      : johna
'----------------------------------------------------------------------
Sub USE_default_RENDERSTATE()
    Call D3D_DEV.SetTextureStageState(0, D3DTSS_COLORARG1, D3DTA_TEXTURE)
    Call D3D_DEV.SetTextureStageState(0, D3DTSS_COLORARG2, D3DTA_DIFFUSE)
    Call D3D_DEV.SetTextureStageState(0, D3DTSS_COLOROP, D3DTOP_MODULATE)
    Call D3D_DEV.SetTextureStageState(0, D3DTSS_ALPHAOP, D3DTOP_SELECTARG1)
    Call D3D_DEV.SetTextureStageState(0, D3DTSS_ALPHAARG1, D3DTA_TEXTURE)
    Call D3D_DEV.SetTextureStageState(0, D3DTSS_MINFILTER, D3DTFN_LINEAR)
    Call D3D_DEV.SetTextureStageState(0, D3DTSS_MAGFILTER, D3DTFG_LINEAR)
    Call D3D_DEV.SetRenderState(D3DRENDERSTATE_DITHERENABLE, True)
    Call D3D_DEV.SetRenderState(D3DRENDERSTATE_ALPHATESTENABLE, False)
    Call D3D_DEV.SetRenderState(D3DRENDERSTATE_ALPHABLENDENABLE, False)
    Call D3D_DEV.SetRenderState(D3DRENDERSTATE_SPECULARENABLE, False)
  
  Call D3D_DEV.SetRenderState(D3DRENDERSTATE_ZWRITEENABLE, True)
  

End Sub

Sub USE_defaultPROJECTION()
  
        Dim matProj As D3DMATRIX
    
    DX_7.IdentityMatrix matProj
    
    
    
    Call DX_7.ProjectionMatrix(matProj, Data.Minprojection, Data.Maxprojection, Data.angle)
    D3D_DEV.SetTransform D3DTRANSFORMSTATE_PROJECTION, matProj
End Sub

Sub USE_NULLTEXTURE()
D3D_DEV.SetTexture 0, Nothing

End Sub

Sub USE_DefaultCullMode()
  Call D3D_DEV.SetRenderState(D3DRENDERSTATE_CULLMODE, Data.CullMode)

End Sub

Private Sub Class_Initialize()
  wType = NOt_init
   PIFactor = 3.141592653 / 180
   Eyes.EYE = Vector(0, 0, 0)
   Eyes.View_AT = Vector(0, 0, 0.1)
   
End Sub



'===========================================
'
'  3d routine for drawing primitive
'
'=============================================
Function VAdd(A As D3DVECTOR, B As D3DVECTOR) As D3DVECTOR
  Dim Dest As D3DVECTOR
  Dest.X = A.X + B.X
  Dest.Y = A.Y + B.Y
  Dest.Z = A.Z + B.Z
  VAdd = Dest
End Function

Public Sub Make_PlaneSURF(ByRef Ver() As D3DLVERTEX, Vec_From As D3DVECTOR, VEC_to As D3DVECTOR, R As Long, G As Long, B As Long, Xtile As Long, Ytile As Long)
ReDim Preserve Ver(7)

Dim x1, x2, y1, Y2, z1, z2, Z, X, Y

x1 = Vec_From.X
x2 = VEC_to.X
y1 = Vec_From.Y
Y2 = VEC_to.Y
z1 = Vec_From.Z
z2 = VEC_to.Z



Dim CLR(8) As Long

Dim LUMA As Variant
 LUMA = Array(0.8, 1, 0.5, 1, 0.15, 0.45, 0.35, 0.65)
    For I = 0 To 7
        CLR(I) = RGB(Int(R * LUMA(I)), Int(G * LUMA(I)), Int(B * LUMA(I)))

    Next I
















If Vec_From.Z = VEC_to.Z Then  'Face avant et arrire
  Z = VEC_to.Z
 DX_7.CreateD3DLVertex x1, y1, Z, CLR(0), 0, 0, Ytile, Ver(0)
 DX_7.CreateD3DLVertex x1, Y2, Z, CLR(1), 0, 0, 0, Ver(1)
 DX_7.CreateD3DLVertex x2, y1, Z, CLR(2), 0, Xtile, Ytile, Ver(2)
 DX_7.CreateD3DLVertex x2, Y2, Z, CLR(3), 0, Xtile, 0, Ver(3)
 
 DX_7.CreateD3DLVertex x1, Y2, Z, CLR(3), 0, 0, 0, Ver(4)
 DX_7.CreateD3DLVertex x1, y1, Z, CLR(4), 0, 0, Ytile, Ver(5)
 DX_7.CreateD3DLVertex x2, Y2, Z, CLR(5), 0, Xtile, 0, Ver(6)
 DX_7.CreateD3DLVertex x2, y1, Z, CLR(6), 0, Xtile, Ytile, Ver(7)
 




End If

If VEC_to.Y = Vec_From.Y Then  'TOP and Bottom
 Y = VEC_to.Y
 DX_7.CreateD3DLVertex x1, Y, z1, CLR(0), 0, 0, Ytile, Ver(0)
 DX_7.CreateD3DLVertex x1, Y, z2, CLR(1), 0, 0, 0, Ver(1)
 DX_7.CreateD3DLVertex x2, Y, z1, CLR(2), 0, Xtile, Ytile, Ver(2)
 DX_7.CreateD3DLVertex x2, Y, z2, CLR(3), 0, Xtile, 0, Ver(3)
  ' Create lver describing the bottom face of the cube.
 DX_7.CreateD3DLVertex x1, Y, z1, CLR(4), 0, 0, Ytile, Ver(4)
 DX_7.CreateD3DLVertex x1, Y, z2, CLR(5), 0, 0, 0, Ver(5)
 DX_7.CreateD3DLVertex x2, Y, z1, CLR(6), 0, Xtile, Ytile, Ver(6)
 DX_7.CreateD3DLVertex x2, Y, z2, CLR(7), 0, Xtile, 0, Ver(7)
 
 
 
 
End If

If VEC_to.X = Vec_From.X Then
 X = VEC_to.X
 DX_7.CreateD3DLVertex X, y1, z1, CLR(0), 0, Xtile, Ytile, Ver(0)
 DX_7.CreateD3DLVertex X, y1, z2, CLR(1), 0, 0, Ytile, Ver(1)
 DX_7.CreateD3DLVertex X, Y2, z1, CLR(2), 0, Xtile, 0, Ver(2)
 DX_7.CreateD3DLVertex X, Y2, z2, CLR(3), 0, 0, 0, Ver(3)
 
 DX_7.CreateD3DLVertex X + 0.5, Y2, z1, CLR(4), 0, 0, 0, Ver(4)
 DX_7.CreateD3DLVertex X + 0.5, Y2, z2, CLR(5), 0, Xtile, 0, Ver(5)
 DX_7.CreateD3DLVertex X + 0.5, y1, z1, CLR(6), 0, 0, Ytile, Ver(6)
 DX_7.CreateD3DLVertex X + 0.5, y1, z2, CLR(7), 0, Xtile, Ytile, Ver(7)
 




End If



End Sub

Public Sub MakeAux_SolidCUBE(ByRef Ver() As D3DLVERTEX, Vec_From As D3DVECTOR, VEC_SIZE As D3DVECTOR, R As Long, G As Long, B As Long, Xtile As Long, Ytile As Long)

ReDim Preserve Ver(47)
Dim VEC_to As D3DVECTOR
VEC_to = VAdd(Vec_From, VEC_SIZE)

Dim x1, x2, y1, Y2, z1, z2, Z, X, Y

x1 = Vec_From.X
x2 = VEC_to.X
y1 = Vec_From.Y
Y2 = VEC_to.Y
z1 = Vec_From.Z
z2 = VEC_to.Z



Dim CLR(8) As Long

Dim LUMA As Variant
 LUMA = Array(0.8, 1, 0.5, 1, 0.15, 0.45, 0.35, 0.65)
    For I = 0 To 7
        CLR(I) = RGB(Int(R * LUMA(I)), Int(G * LUMA(I)), Int(B * LUMA(I)))

    Next I









'=============================================================
'   Face et arrire du cube visible en interne et externe
'
'
'=========================================================

  'Face avant
  
 DX_7.CreateD3DLVertex x1, y1, z1, CLR(0), 0, 0, Ytile, Ver(0)
 DX_7.CreateD3DLVertex x1, Y2, z1, CLR(1), 0, 0, 0, Ver(1)
 DX_7.CreateD3DLVertex x2, y1, z1, CLR(2), 0, Xtile, Ytile, Ver(2)
 DX_7.CreateD3DLVertex x2, Y2, z1, CLR(3), 0, Xtile, 0, Ver(3)
 
 DX_7.CreateD3DLVertex x1, Y2, z1, CLR(3), 0, 0, 0, Ver(4)
 DX_7.CreateD3DLVertex x1, y1, z1, CLR(4), 0, 0, Ytile, Ver(5)
 DX_7.CreateD3DLVertex x2, Y2, z1, CLR(5), 0, Xtile, 0, Ver(6)
 DX_7.CreateD3DLVertex x2, y1, z1, CLR(6), 0, Xtile, Ytile, Ver(7)
 'et arrire
DX_7.CreateD3DLVertex x1, y1, z2, CLR(0), 0, 0, Ytile, Ver(8)
 DX_7.CreateD3DLVertex x1, Y2, z2, CLR(1), 0, 0, 0, Ver(9)
 DX_7.CreateD3DLVertex x2, y1, z2, CLR(2), 0, Xtile, Ytile, Ver(10)
 DX_7.CreateD3DLVertex x2, Y2, z2, CLR(3), 0, Xtile, 0, Ver(11)
 
 DX_7.CreateD3DLVertex x1, Y2, z2, CLR(3), 0, 0, 0, Ver(12)
 DX_7.CreateD3DLVertex x1, y1, z2, CLR(4), 0, 0, Ytile, Ver(13)
 DX_7.CreateD3DLVertex x2, Y2, z2, CLR(5), 0, Xtile, 0, Ver(14)
 DX_7.CreateD3DLVertex x2, y1, z2, CLR(6), 0, Xtile, Ytile, Ver(15)
 





'=============================================================
'  HAUT et BAS du cube visible en interne et externe
'
'
'=========================================================
 
 ' haut
 DX_7.CreateD3DLVertex x1, y1, z1, CLR(0), 0, 0, Ytile, Ver(16)
 DX_7.CreateD3DLVertex x1, y1, z2, CLR(1), 0, 0, 0, Ver(17)
 DX_7.CreateD3DLVertex x2, y1, z1, CLR(2), 0, Xtile, Ytile, Ver(18)
 DX_7.CreateD3DLVertex x2, y1, z2, CLR(3), 0, Xtile, 0, Ver(19)
  ' Create lver describing the bottom face of the cube.
 DX_7.CreateD3DLVertex x1, y1, z1, CLR(4), 0, 0, Ytile, Ver(20)
 DX_7.CreateD3DLVertex x1, y1, z2, CLR(5), 0, 0, 0, Ver(21)
 DX_7.CreateD3DLVertex x2, y1, z1, CLR(6), 0, Xtile, Ytile, Ver(22)
 DX_7.CreateD3DLVertex x2, y1, z2, CLR(7), 0, Xtile, 0, Ver(23)
 
  ' Bas
 DX_7.CreateD3DLVertex x1, Y2, z1, CLR(0), 0, 0, Ytile, Ver(24)
 DX_7.CreateD3DLVertex x1, Y2, z2, CLR(1), 0, 0, 0, Ver(25)
 DX_7.CreateD3DLVertex x2, Y2, z1, CLR(2), 0, Xtile, Ytile, Ver(26)
 DX_7.CreateD3DLVertex x2, Y2, z2, CLR(3), 0, Xtile, 0, Ver(27)
  ' Create lver describing the bottom face of the cube.
 DX_7.CreateD3DLVertex x1, Y2, z1, CLR(4), 0, 0, Ytile, Ver(28)
 DX_7.CreateD3DLVertex x1, Y2, z2, CLR(5), 0, 0, 0, Ver(29)
 DX_7.CreateD3DLVertex x2, Y2, z1, CLR(6), 0, Xtile, Ytile, Ver(30)
 DX_7.CreateD3DLVertex x2, Y2, z2, CLR(7), 0, Xtile, 0, Ver(31)
 
 

'=============================================================
'  Face Gauche et Droite du cube visible en interne et externe
'
'
'=========================================================
 'Gauche
 
 DX_7.CreateD3DLVertex x1, y1, z1, CLR(0), 0, Xtile, Ytile, Ver(32)
 DX_7.CreateD3DLVertex x1, y1, z2, CLR(1), 0, 0, Ytile, Ver(33)
 DX_7.CreateD3DLVertex x1, Y2, z1, CLR(2), 0, Xtile, 0, Ver(34)
 DX_7.CreateD3DLVertex x1, Y2, z2, CLR(3), 0, 0, 0, Ver(35)
 
 DX_7.CreateD3DLVertex x1 + 0.5, Y2, z1, CLR(4), 0, 0, 0, Ver(36)
 DX_7.CreateD3DLVertex x1 + 0.5, Y2, z2, CLR(5), 0, Xtile, 0, Ver(37)
 DX_7.CreateD3DLVertex x1 + 0.5, y1, z1, CLR(6), 0, 0, Ytile, Ver(38)
 DX_7.CreateD3DLVertex x1 + 0.5, y1, z2, CLR(7), 0, Xtile, Ytile, Ver(39)
 
'Droite
 
 DX_7.CreateD3DLVertex x2, y1, z1, CLR(0), 0, Xtile, Ytile, Ver(40)
 DX_7.CreateD3DLVertex x2, y1, z2, CLR(1), 0, 0, Ytile, Ver(41)
 DX_7.CreateD3DLVertex x2, Y2, z1, CLR(2), 0, Xtile, 0, Ver(42)
 DX_7.CreateD3DLVertex x2, Y2, z2, CLR(3), 0, 0, 0, Ver(43)
 
 DX_7.CreateD3DLVertex x2 + 0.5, Y2, z1, CLR(4), 0, 0, 0, Ver(44)
 DX_7.CreateD3DLVertex x2 + 0.5, Y2, z2, CLR(5), 0, Xtile, 0, Ver(45)
 DX_7.CreateD3DLVertex x2 + 0.5, y1, z1, CLR(6), 0, 0, Ytile, Ver(46)
 DX_7.CreateD3DLVertex x2 + 0.5, y1, z2, CLR(7), 0, Xtile, Ytile, Ver(47)
 




End Sub


Sub CreateCube(Vertices() As D3DVERTEX, Size As Single)
     ReDim Preserve Vertices(23)
     
     Dim V1 As D3DVECTOR
     Dim V2 As D3DVECTOR
     
     V1 = Me.johna_MakeVector(-Size / 2, -Size / 2, -Size / 2)
     V2 = Me.johna_MakeVector(Size / 2, Size / 2, Size / 2)
           
    ' Create vertices describing the front face of the cube.
    DX_7.CreateD3DVertex V1.X, V2.Y, V1.Z, 0, 0, -1, 0, 0, Vertices(0)
    DX_7.CreateD3DVertex V2.X, V2.Y, V1.Z, 0, 0, -1, 1, 0, Vertices(1)
    DX_7.CreateD3DVertex V1.X, V1.Y, V1.Z, 0, 0, -1, 0, 1, Vertices(2)
    DX_7.CreateD3DVertex V2.X, V1.Y, V1.Z, 0, 0, -1, 1, 1, Vertices(3)
        
    ' Create vertices describing the back face of the cube.
    DX_7.CreateD3DVertex V1.X, V2.Y, V2.Z, 0, 0, 1, 1, 0, Vertices(4)
    DX_7.CreateD3DVertex V1.X, V1.Y, V2.Z, 0, 0, 1, 1, 1, Vertices(5)
    DX_7.CreateD3DVertex V2.X, V2.Y, V2.Z, 0, 0, 1, 0, 0, Vertices(6)
    DX_7.CreateD3DVertex V2.X, V1.Y, V2.Z, 0, 0, 1, 0, 1, Vertices(7)
        
    ' Create vertices describing the top face of the cube.
    DX_7.CreateD3DVertex V1.X, V2.Y, V2.Z, 0, 1, 0, 0, 0, Vertices(8)
    DX_7.CreateD3DVertex V2.X, V2.Y, V2.Z, 0, 1, 0, 1, 0, Vertices(9)
    DX_7.CreateD3DVertex V1.X, V2.Y, V1.Z, 0, 1, 0, 0, 1, Vertices(10)
    DX_7.CreateD3DVertex V2.X, V2.Y, V1.Z, 0, 1, 0, 1, 1, Vertices(11)
        
    ' Create vertices describing the bottom face of the cube.
    DX_7.CreateD3DVertex V1.X, V1.Y, V2.Z, 0, -1, 0, 0, 0, Vertices(12)
    DX_7.CreateD3DVertex V1.X, V1.Y, V1.Z, 0, -1, 0, 0, 1, Vertices(13)
    DX_7.CreateD3DVertex V2.X, V1.Y, V2.Z, 0, -1, 0, 1, 0, Vertices(14)
    DX_7.CreateD3DVertex V2.X, V1.Y, V1.Z, 0, -1, 0, 1, 1, Vertices(15)
        
    ' Create vertices describing the right face of the cube.
    DX_7.CreateD3DVertex V2.X, V2.Y, V1.Z, 1, 0, 0, 0, 0, Vertices(16)
    DX_7.CreateD3DVertex V2.X, V2.Y, V2.Z, 1, 0, 0, 1, 0, Vertices(17)
    DX_7.CreateD3DVertex V2.X, V1.Y, V1.Z, 1, 0, 0, 0, 1, Vertices(18)
    DX_7.CreateD3DVertex V2.X, V1.Y, V2.Z, 1, 0, 0, 1, 1, Vertices(19)
        
    ' Create vertices describing the left face of the cube.
    DX_7.CreateD3DVertex V1.X, V2.Y, V1.Z, -1, 0, 0, 1, 0, Vertices(20)
    DX_7.CreateD3DVertex V1.X, V1.Y, V1.Z, -1, 0, 0, 1, 1, Vertices(21)
    DX_7.CreateD3DVertex V1.X, V2.Y, V2.Z, -1, 0, 0, 0, 0, Vertices(22)
    DX_7.CreateD3DVertex V1.X, V1.Y, V2.Z, -1, 0, 0, 0, 1, Vertices(23)
    
End Sub



Sub CreateCubeEX(Vertices() As D3DVERTEX, Vsize As D3DVECTOR, Optional TileX = 1, Optional TileY = 1)
     ReDim Preserve Vertices(23)
      Dim V1 As D3DVECTOR
     Dim V2 As D3DVECTOR
     Dim Sx, sy, Sz
     
     Sx = Vsize.X / 2
     sy = Vsize.Y / 2
     Sz = Vsize.Z / 2
     
     V1 = Vector(-Sx, -sy, -Sz)
     V2 = Vector(Sx, sy, Sz)
           
    ' Create vertices describing the front face of the cube.
    DX_7.CreateD3DVertex V1.X, V2.Y, V1.Z, 0, 0, -1, 0, 0, Vertices(0)
    DX_7.CreateD3DVertex V2.X, V2.Y, V1.Z, 0, 0, -1, TileX, 0, Vertices(1)
    DX_7.CreateD3DVertex V1.X, V1.Y, V1.Z, 0, 0, -1, 0, TileY, Vertices(2)
    DX_7.CreateD3DVertex V2.X, V1.Y, V1.Z, 0, 0, -1, TileX, TileY, Vertices(3)
        
    ' Create vertices describing the back face of the cube.
    DX_7.CreateD3DVertex V1.X, V2.Y, V2.Z, 0, 0, 1, TileX, 0, Vertices(4)
    DX_7.CreateD3DVertex V1.X, V1.Y, V2.Z, 0, 0, 1, TileX, TileY, Vertices(5)
    DX_7.CreateD3DVertex V2.X, V2.Y, V2.Z, 0, 0, 1, 0, 0, Vertices(6)
    DX_7.CreateD3DVertex V2.X, V1.Y, V2.Z, 0, 0, 1, 0, TileY, Vertices(7)
        
    ' Create vertices describing the top face of the cube.
    DX_7.CreateD3DVertex V1.X, V2.Y, V2.Z, 0, 1, 0, 0, 0, Vertices(8)
    DX_7.CreateD3DVertex V2.X, V2.Y, V2.Z, 0, 1, 0, TileX, 0, Vertices(9)
    DX_7.CreateD3DVertex V1.X, V2.Y, V1.Z, 0, 1, 0, 0, TileY, Vertices(10)
    DX_7.CreateD3DVertex V2.X, V2.Y, V1.Z, 0, 1, 0, TileX, TileY, Vertices(11)
        
    ' Create vertices describing the bottom face of the cube.
    DX_7.CreateD3DVertex V1.X, V1.Y, V2.Z, 0, -1, 0, 0, 0, Vertices(12)
    DX_7.CreateD3DVertex V1.X, V1.Y, V1.Z, 0, -1, 0, 0, TileY, Vertices(13)
    DX_7.CreateD3DVertex V2.X, V1.Y, V2.Z, 0, -1, 0, TileX, 0, Vertices(14)
    DX_7.CreateD3DVertex V2.X, V1.Y, V1.Z, 0, -1, 0, TileX, TileY, Vertices(15)
        
    ' Create vertices describing the right face of the cube.
    DX_7.CreateD3DVertex V2.X, V2.Y, V1.Z, 1, 0, 0, 0, 0, Vertices(16)
    DX_7.CreateD3DVertex V2.X, V2.Y, V2.Z, 1, 0, 0, TileX, 0, Vertices(17)
    DX_7.CreateD3DVertex V2.X, V1.Y, V1.Z, 1, 0, 0, 0, TileY, Vertices(18)
    DX_7.CreateD3DVertex V2.X, V1.Y, V2.Z, 1, 0, 0, TileX, TileY, Vertices(19)
        
    ' Create vertices describing the left face of the cube.
    DX_7.CreateD3DVertex V1.X, V2.Y, V1.Z, -1, 0, 0, TileX, 0, Vertices(20)
    DX_7.CreateD3DVertex V1.X, V1.Y, V1.Z, -1, 0, 0, TileX, TileY, Vertices(21)
    DX_7.CreateD3DVertex V1.X, V2.Y, V2.Z, -1, 0, 0, 0, 0, Vertices(22)
    DX_7.CreateD3DVertex V1.X, V1.Y, V2.Z, -1, 0, 0, 0, TileY, Vertices(23)
    
End Sub











Function GetBOX(Vec_MIN As D3DVECTOR, Vec_MAX As D3DVECTOR) As D3DRMBOX
     GetBOX.min = Vec_MIN
     GetBOX.max = Vec_MAX
End Function










Sub Create_PlaneSurf(Vertices() As D3DVERTEX, Vsize As D3DVECTOR, Optional TileX = 1, Optional TileY = 1)
     ReDim Preserve Vertices(3)
      Dim V1 As D3DVECTOR
     Dim V2 As D3DVECTOR
     Dim Sx, sy, Sz
     
     Sx = Vsize.X / 2
     sy = Vsize.Y / 2
     Sz = Vsize.Z / 2
     
     V1 = Vector(-Sx, -sy, -Sz)
     V2 = Vector(Sx, sy, Sz)
           
    ' Create vertices describing the top face of the cube.
    DX_7.CreateD3DVertex V1.X, V2.Y, V2.Z, 0, 1, 0, 0, 0, Vertices(0)
    DX_7.CreateD3DVertex V2.X, V2.Y, V2.Z, 0, 1, 0, TileX, 0, Vertices(1)
    DX_7.CreateD3DVertex V1.X, V2.Y, V1.Z, 0, 1, 0, 0, TileY, Vertices(2)
    DX_7.CreateD3DVertex V2.X, V2.Y, V1.Z, 0, 1, 0, TileX, TileY, Vertices(3)
        
    
End Sub




Sub Create_Roof_Surf(Vertices() As D3DVERTEX, Vsize As D3DVECTOR, Optional TileX = 1, Optional TileY = 1)
     ReDim Preserve Vertices(3)
      Dim V1 As D3DVECTOR
     Dim V2 As D3DVECTOR
     Dim Sx, sy, Sz
     
     Sx = Vsize.X / 2
     sy = Vsize.Y / 2
     Sz = Vsize.Z / 2
     
     V1 = Vector(-Sx, -sy, -Sz)
     V2 = Vector(Sx, sy, Sz)
           
    ' Create vertices describing the bottom face of the cube.
    DX_7.CreateD3DVertex V1.X, V1.Y, V2.Z, 0, -1, 0, 0, 0, Vertices(0)
    DX_7.CreateD3DVertex V1.X, V1.Y, V1.Z, 0, -1, 0, 0, 1, Vertices(1)
    DX_7.CreateD3DVertex V2.X, V1.Y, V2.Z, 0, -1, 0, 1, 0, Vertices(2)
    DX_7.CreateD3DVertex V2.X, V1.Y, V1.Z, 0, -1, 0, 1, 1, Vertices(3)
           
    
End Sub






















Sub RenderCUBE(VERTIK() As D3DVERTEX)

'D3D_DEV.LightEnable 0, False
'Me.Set_Light 0
 'Me.USE_defaultMaterial
  
  Call D3D_DEV.DrawPrimitive(D3DPT_TRIANGLESTRIP, D3DFVF_VERTEX, VERTIK(0), _
         4, D3DDP_DEFAULT)
    Call D3D_DEV.DrawPrimitive(D3DPT_TRIANGLESTRIP, D3DFVF_VERTEX, VERTIK(4), _
         4, D3DDP_DEFAULT)
         
    ' Draw the top and bottom faces of the cube using texture 2
   
    Call D3D_DEV.DrawPrimitive(D3DPT_TRIANGLESTRIP, D3DFVF_VERTEX, VERTIK(8), _
         4, D3DDP_DEFAULT)
    Call D3D_DEV.DrawPrimitive(D3DPT_TRIANGLESTRIP, D3DFVF_VERTEX, VERTIK(12), _
         4, D3DDP_DEFAULT)
   
    ' Draw the left and right faces of the cube using texture 3
    
    Call D3D_DEV.DrawPrimitive(D3DPT_TRIANGLESTRIP, D3DFVF_VERTEX, VERTIK(16), _
         4, D3DDP_DEFAULT)
    Call D3D_DEV.DrawPrimitive(D3DPT_TRIANGLESTRIP, D3DFVF_VERTEX, VERTIK(20), _
         4, D3DDP_DEFAULT)


End Sub






Sub RenderPlane_SURF(VERTIK() As D3DVERTEX)

'D3D_DEV.LightEnable 0, False
'Me.Set_Light 0
  
  
  Call D3D_DEV.DrawPrimitive(D3DPT_TRIANGLESTRIP, D3DFVF_VERTEX, VERTIK(0), _
         4, D3DDP_DEFAULT)
   

End Sub







Function Vertex(Vect As D3DVECTOR, vNorm As D3DVECTOR, tu As Single, tv As Single) As D3DVERTEX
    Dim RET As D3DVERTEX
    With RET
        .nx = vNorm.X
        .ny = vNorm.Y
        .nz = vNorm.Z
        .tu = tu
        .tv = tv
        .X = Vect.X
        .Y = Vect.Y
        .Z = Vect.Z
    End With
    Vertex = RET
End Function












Public Sub Render_surf(PLA() As D3DLVERTEX, Optional Count As Long = 8)
  D3D_DEV.DrawPrimitive D3DPT_TRIANGLESTRIP, D3DFVF_LVERTEX, PLA(0), Count, D3DDP_WAIT
  'D3D_DEV.DrawPrimitive D3DPT_TRIANGLESTRIP, D3DFVF_LVERTEX, PLA(4), 4, D3DDP_WAIT
  
End Sub


Public Sub Render_AUXcube(PLA() As D3DLVERTEX)
  'face avant et arrire
  D3D_DEV.DrawPrimitive D3DPT_TRIANGLESTRIP, D3DFVF_LVERTEX, PLA(0), 8, D3DDP_WAIT
  'D3D_DEV.DrawPrimitive D3DPT_TRIANGLESTRIP, D3DFVF_LVERTEX, PLA(4), 4, D3DDP_WAIT
  
  D3D_DEV.DrawPrimitive D3DPT_TRIANGLESTRIP, D3DFVF_LVERTEX, PLA(8), 8, D3DDP_WAIT
  'D3D_DEV.DrawPrimitive D3DPT_TRIANGLESTRIP, D3DFVF_LVERTEX, PLA(12), 4, D3DDP_WAIT
  
  'face haut et bas
  D3D_DEV.DrawPrimitive D3DPT_TRIANGLESTRIP, D3DFVF_LVERTEX, PLA(16), 8, D3DDP_WAIT
  'D3D_DEV.DrawPrimitive D3DPT_TRIANGLESTRIP, D3DFVF_LVERTEX, PLA(20), 4, D3DDP_WAIT
  
  D3D_DEV.DrawPrimitive D3DPT_TRIANGLESTRIP, D3DFVF_LVERTEX, PLA(24), 8, D3DDP_WAIT
  'D3D_DEV.DrawPrimitive D3DPT_TRIANGLESTRIP, D3DFVF_LVERTEX, PLA(28), 4, D3DDP_WAIT
  
  'face gauche et doite
  D3D_DEV.DrawPrimitive D3DPT_TRIANGLESTRIP, D3DFVF_LVERTEX, PLA(32), 8, D3DDP_WAIT
  'D3D_DEV.DrawPrimitive D3DPT_TRIANGLESTRIP, D3DFVF_LVERTEX, PLA(36), 4, D3DDP_WAIT
  
  D3D_DEV.DrawPrimitive D3DPT_TRIANGLESTRIP, D3DFVF_LVERTEX, PLA(40), 8, D3DDP_WAIT
  'D3D_DEV.DrawPrimitive D3DPT_TRIANGLESTRIP, D3DFVF_LVERTEX, PLA(44), 4, D3DDP_WAIT
  
  
End Sub



Public Sub TransAlpha_Enable()
    Call D3D_DEV.SetRenderState(D3DRENDERSTATE_ALPHABLENDENABLE, True)
    Call D3D_DEV.SetRenderState(D3DRENDERSTATE_SRCBLEND, D3DBLEND_SRCALPHA)
    Call D3D_DEV.SetRenderState(D3DRENDERSTATE_DESTBLEND, D3DBLEND_INVSRCALPHA)

    ' Enable alpha testing (avoids drawing pixels with less than a certain alpha
    Call D3D_DEV.SetRenderState(D3DRENDERSTATE_ALPHATESTENABLE, m_bUseAlphaTest)
    Call D3D_DEV.SetRenderState(D3DRENDERSTATE_ALPHAREF, &H8&)
    Call D3D_DEV.SetRenderState(D3DRENDERSTATE_ALPHAFUNC, D3DCMP_GREATEREQUAL)

End Sub


Public Sub TransAlpha_Disable()
  Call D3D_DEV.SetRenderState(D3DRENDERSTATE_ALPHATESTENABLE, False)
  Call D3D_DEV.SetRenderState(D3DRENDERSTATE_ALPHABLENDENABLE, False)
End Sub












Private Function LVertex(v As D3DVECTOR, COLOR As Long, tu, tv) As D3DLVERTEX
 LVertex.X = v.X
 LVertex.Y = v.Y
 LVertex.Z = v.Z
 LVertex.COLOR = COLOR
 LVertex.specular = COLOR
 LVertex.tu = tu
 LVertex.tv = tv
End Function


Private Function REC(X, Y, xA, yA) As RECT
 REC.Bottom = yA
 REC.Left = X
 REC.Right = xA
 REC.Top = Y
End Function










Function RayCollision(orig As D3DVECTOR, Dir As D3DVECTOR, vert0 As D3DVECTOR, Vert1 As D3DVECTOR, Vert2 As D3DVECTOR, T As Double, U As Double, v As Double) As Byte
  Dim edge1 As D3DVECTOR
  Dim edge2 As D3DVECTOR
  Dim tvec As D3DVECTOR
  Dim pvec As D3DVECTOR
  Dim qvec As D3DVECTOR
  Dim inv_det As Double
  Dim det As Double

'/* trouve les vecteurs des deux cots en utilisant un des sommets *'/
   DX_7.VectorSubtract edge1, Vert1, vert0
   DX_7.VectorSubtract edge2, Vert2, vert0

'/* commence  calculer *'/
   DX_7.VectorCrossProduct pvec, Dir, edge2
   
'/* si det est prs de zero, alors le vecteur de la ligne et du plan du triangle
'sont colinaires *'/
   det = DX_7.VectorDotProduct(edge1, pvec)

   If det > -EPSILON And det < EPSILON Then
    RayCollision = 0
    Exit Function
   End If
   inv_det = 1 / det

   'calcule la distance entre l'origine et le premier vertex du triangle
   DX_7.VectorSubtract tvec, orig, vert0
   
   'calcule l'lement u
   U = DX_7.VectorDotProduct(edge1, pvec) * inv_det
    
    If U < 0 Or U > 1 Then
      RayCollision = 0
      Exit Function
   End If

    'Prepare to test v parameter
     DX_7.VectorCrossProduct qvec, tvec, edge1
     
    'Calcule le paramtre v
     v = DX_7.VectorDotProduct(Dir, qvec) * inv_det
     
     If v < 0 Or U + v > 1 Then
       RayCollision = 0
       Exit Function
    End If
    
    'calcule la distance entre l'origine et le point de collision.
     T = DX_7.VectorDotProduct(edge1, qvec) * inv_det
     
     RayCollision = 1
    
    ColScore.T = T
    ColScore.U = U
    ColScore.v = v
  End Function
  


Function getdist3d(sphere2 As D3DVECTOR, sphere1 As D3DVECTOR) As Double
getdist3d = Sqr((sphere2.X - sphere1.X) ^ 2 + (sphere2.Y - sphere1.Y) ^ 2 + (sphere2.Z - sphere1.Z) ^ 2)
End Function

  
  
  

Public Function D3Dcolor(R, G, B, A) As D3DCOLORVALUE
  Dim C As D3DCOLORVALUE
  C.A = A
  C.R = R
  C.G = G
  C.B = B
  D3Dcolor = C

End Function


Public Sub SetMaterial(Difu As D3DCOLORVALUE, AMB As D3DCOLORVALUE)
Dim Mtrl As D3DMATERIAL7
   
    Mtrl.diffuse = Difu '.R = 1#: mtrl.diffuse.G = 1#: mtrl.diffuse.B = 1#
    Mtrl.Ambient = AMB '.R = 1: mtrl.Ambient.G = 1: mtrl.Ambient.B = 1
    
    ' Commit the material to the device.
    D3D_DEV.SetMaterial Mtrl
   

End Sub

Function Create_Material2(Difu As D3DCOLORVALUE, AMB As D3DCOLORVALUE) As D3DMATERIAL7
    Create_Material2.diffuse = Difu
    Create_Material2.Ambient = AMB
End Function

Function Create_RND_D3Dcolor() As D3DCOLORVALUE
         Randomize Timer
         Create_RND_D3Dcolor.R = Rnd
         Create_RND_D3Dcolor.G = Rnd
         Create_RND_D3Dcolor.B = Rnd
         Create_RND_D3Dcolor.A = Rnd
End Function



Function Getlight(TYP As CONST_D3DLIGHTTYPE, Position As D3DVECTOR, AMB As D3DCOLORVALUE, DIFFU As D3DCOLORVALUE, Rayon As Single, Directio As D3DVECTOR) As D3DLIGHT7
Dim LITz As D3DLIGHT7

If TYP = D3DLIGHT_POINT Then

  With LITz
    .Ambient = AMB
    .diffuse = DIFFU
    .range = Rayon
    .attenuation0 = 1
    .attenuation1 = 1
    .attenuation2 = 0
    .Position = Position
    .dltType = D3DLIGHT_POINT
    
   End With




End If


If TYP = D3DLIGHT_DIRECTIONAL Then

  With LITz
    .Ambient = AMB
    .diffuse = DIFFU
    '.range = Rayon
    .attenuation0 = 1
    .attenuation1 = 1
    .attenuation2 = 0
    .dltType = D3DLIGHT_DIRECTIONAL
    .direction = Directio
    
   End With




End If




Getlight = LITz








End Function




Sub TransFORM(MATRIXX As D3DMATRIX)
 D3D_DEV.SetTransform D3DTRANSFORMSTATE_WORLD, MATRIXX

End Sub











'=================================
' TranslateMatrix
'=================================
' used to position an object

Sub TranslateMatrix(M As D3DMATRIX, v As D3DVECTOR)
  Call IdentityMatrix(M)
  M.rc41 = v.X
  M.rc42 = v.Y
  M.rc43 = v.Z
End Sub

Function RetTranslateMatrix(v As D3DVECTOR) As D3DMATRIX
  Dim M As D3DMATRIX
  Call IdentityMatrix(M)
  M.rc41 = v.X
  M.rc42 = v.Y
  M.rc43 = v.Z
  RetTranslateMatrix = M
End Function


'=================================
' RotateXMatrix
'=================================
' rotate an object about x axis rad radians

Sub RotateXMatrix(RET As D3DMATRIX, rads As Single)
  Dim cosine As Single
  Dim sine As Single
  cosine = Cos(rads)
  sine = Sin(rads)
  Call IdentityMatrix(RET)
  RET.rc22 = cosine
  RET.rc33 = cosine
  RET.rc23 = -sine
  RET.rc32 = sine
End Sub

Function RetRotateXMatrix(rads As Single) As D3DMATRIX
  Dim cosine As Single
  Dim sine As Single
  Dim RET As D3DMATRIX
  cosine = Cos(rads)
  sine = Sin(rads)
  Call IdentityMatrix(RET)
  RET.rc22 = cosine
  RET.rc33 = cosine
  RET.rc23 = -sine
  RET.rc32 = sine
  RetRotateXMatrix = RET
End Function

'=================================
' RotateYMatrix
'=================================
' rotate an object about y axis rad radians

Sub RotateYMatrix(RET As D3DMATRIX, rads As Single)
  Dim cosine As Single
  Dim sine As Single
  cosine = Cos(rads)
  sine = Sin(rads)
  Call IdentityMatrix(RET)
  RET.rc11 = cosine
  RET.rc33 = cosine
  RET.rc13 = sine
  RET.rc31 = -sine
End Sub

Function RetRotateYMatrix(rads As Single) As D3DMATRIX
  Dim cosine As Single
  Dim sine As Single
  Dim RET As D3DMATRIX
  cosine = Cos(rads)
  sine = Sin(rads)
  Call IdentityMatrix(RET)
  RET.rc11 = cosine
  RET.rc33 = cosine
  RET.rc13 = sine
  RET.rc31 = -sine
  RetRotateYMatrix = RET
End Function

'=================================
' RotateZMatrix
'=================================
' rotate an object about z axis rad radians

Sub RotateZMatrix(RET As D3DMATRIX, rads As Single)
  Dim cosine As Single
  Dim sine As Single
  cosine = Cos(rads)
  sine = Sin(rads)
  Call IdentityMatrix(RET)
  RET.rc11 = cosine
  RET.rc22 = cosine
  RET.rc12 = -sine
  RET.rc21 = sine
End Sub

Function RetRotateZMatrix(rads As Single) As D3DMATRIX
  Dim RET As D3DMATRIX
  Dim cosine As Single
  Dim sine As Single
  cosine = Cos(rads)
  sine = Sin(rads)
  Call IdentityMatrix(RET)
  RET.rc11 = cosine
  RET.rc22 = cosine
  RET.rc12 = -sine
  RET.rc21 = sine
  RetRotateZMatrix = RET
End Function

'=================================
' ViewMatrix
'=================================
' setup the placement of the camera
' from the location of the camera
' at is where its looking toward
' up (usually 0 1 0) is the orientation
' roll is the sideways tilt of the camera
'=================================
' IdentityMatrix
'=================================
Sub IdentityMatrix(Dest As D3DMATRIX)
  
  Dest.rc11 = 1
  Dest.rc12 = 0
  Dest.rc13 = 0
  Dest.rc14 = 0
  Dest.rc21 = 0
  Dest.rc22 = 1
  Dest.rc23 = 0
  Dest.rc24 = 0
  Dest.rc31 = 0
  Dest.rc32 = 0
  Dest.rc33 = 1
  Dest.rc34 = 0
  Dest.rc41 = 0
  Dest.rc42 = 0
  Dest.rc43 = 0
  Dest.rc44 = 1
  
End Sub

Function RetIdentityMatrix() As D3DMATRIX
    Dim RET As D3DMATRIX
    IdentityMatrix RET
End Function

Public Sub MIdentity(dMatrix As D3DMATRIX)
    dMatrix.rc11 = 1
    dMatrix.rc12 = 0
    dMatrix.rc13 = 0
    dMatrix.rc14 = 0
    dMatrix.rc21 = 0
    dMatrix.rc22 = 1
    dMatrix.rc23 = 0
    dMatrix.rc24 = 0
    dMatrix.rc31 = 0
    dMatrix.rc32 = 0
    dMatrix.rc33 = 1
    dMatrix.rc34 = 0
    dMatrix.rc41 = 0
    dMatrix.rc42 = 0
    dMatrix.rc43 = 0
    dMatrix.rc44 = 1
End Sub

' MTRANSLATE: Translates a matrix along the axis
Public Function MTranslate(dSource As D3DMATRIX, ByVal nValueX As Single, ByVal nValueY As Single, ByVal nValueZ As Single) As D3DMATRIX

    ' Reset to identity matrix
    MIdentity P_dCalculatorMatrix
    
    ' Add calculations
    With P_dCalculatorMatrix
        .rc41 = nValueX
        .rc42 = nValueY
        .rc43 = nValueZ
    End With

    ' Apply transformations

    ' Return result
    MTranslate = MMultiply(P_dCalculatorMatrix, dSource)
    
End Function




Public Function MTrans_EX(dSource As D3DMATRIX, Vec As D3DVECTOR) As D3DMATRIX

    ' Reset to identity matrix
    MIdentity P_dCalculatorMatrix
    
    ' Add calculations
    With P_dCalculatorMatrix
        .rc41 = Vec.X
        .rc42 = Vec.Y
        .rc43 = Vec.Z
    End With

    ' Apply transformations

    ' Return result
    MTrans_EX = MMultiply(P_dCalculatorMatrix, dSource)
    
End Function


Function M_Scale_Rotate_MOV(Vscal As D3DVECTOR, Vrot As D3DVECTOR, Vmov As D3DVECTOR) As D3DMATRIX
Dim Matz As D3DMATRIX
Dim ROTz As D3DMATRIX
Dim MOVz As D3DMATRIX
Dim TEMPz As D3DMATRIX

DX_7.IdentityMatrix Matz
DX_7.IdentityMatrix MOVz
DX_7.IdentityMatrix ROTz

Matz = MScale(Matz, Vscal.X, Vscal.Y, Vscal.Z)
ROTz = MRotate(ROTz, Vrot.X, Vrot.Y, Vrot.Z)
MOVz = MTranslate(MOVz, Vmov.X, Vmov.Y, Vmov.Z)

DX_7.MatrixMultiply TEMPz, Matz, ROTz
DX_7.MatrixMultiply Matz, TEMPz, MOVz

M_Scale_Rotate_MOV = Matz


End Function





Public Function MMultiply(dM1 As D3DMATRIX, dM2 As D3DMATRIX) As D3DMATRIX

    ' Calculate multiply ...
     DX_7.MatrixMultiply MMultiply, dM2, dM1
    
End Function

' MSCALE: Scales a matrix along the axis
Public Function MScale(dSource As D3DMATRIX, ByVal nValueX As Single, ByVal nValueY As Single, ByVal nValueZ As Single) As D3DMATRIX

    ' Reset to identity matrix
    MIdentity P_dCalculatorMatrix
    
    ' Add calculations
    With P_dCalculatorMatrix
        .rc11 = nValueX
        .rc22 = nValueY
        .rc33 = nValueZ
    End With
    
    ' Apply transformations

    
    ' Return result
   ' dSource =
    
    MScale = MMultiply(P_dCalculatorMatrix, dSource)
    
End Function


Function OBJECT_scale(Xscal, Yscal, Zscal)
Dim Matz As D3DMATRIX
DX_7.IdentityMatrix Matz
Matz = MScale(Matz, Xscal, Yscal, Zscal)
D3D_DEV.SetTransform D3DTRANSFORMSTATE_WORLD, Matz


End Function


Function OBJECT_move(Xmov, Ymov, Zmov)
Dim Matz As D3DMATRIX
DX_7.IdentityMatrix Matz
Matz = MTranslate(Matz, Xmov, Ymov, Zmov)
D3D_DEV.SetTransform D3DTRANSFORMSTATE_WORLD, Matz


End Function

Function OBJECT_rotate(Xmov, Ymov, Zmov)
Dim Matz As D3DMATRIX
DX_7.IdentityMatrix Matz
Matz = MRotate(Matz, Xmov, Ymov, Zmov)
D3D_DEV.SetTransform D3DTRANSFORMSTATE_WORLD, Matz


End Function


Sub OBJECT_use_BILBOARDdeg()
    Dim I, J, zz, D
    D = (Me.CAM_angleDEGRE - 90)
    Me.OBJECT_rotate 0, D, 0

End Sub



Sub OBJECT_getBoundingBOX(lpVert() As D3DVERTEX, ByRef RetBox As D3DRMBOX)
Dim I, J
Dim RET As D3DRMBOX
Dim Vec As D3DVECTOR

I = LBound(lpVert)
RET.min = VICTOR(lpVert(I).X, lpVert(I).Y, lpVert(I).Z)
RET.max = VICTOR(lpVert(I).X, lpVert(I).Y, lpVert(I).Z)

For I = I + 1 To UBound(lpVert)
   Vec = VICTOR(lpVert(I).X, lpVert(I).Y, lpVert(I).Z)
   
   If Vec.X < RET.min.X Then RET.min.X = Vec.X
   If Vec.Y < RET.min.Y Then RET.min.Y = Vec.Y
   If Vec.Z < RET.min.Z Then RET.min.Z = Vec.Z

   If Vec.X > RET.max.X Then RET.max.X = Vec.X
   If Vec.Y > RET.max.Y Then RET.max.Y = Vec.Y
   If Vec.Z > RET.max.Z Then RET.max.Z = Vec.Z


Next I

RetBox = RET
End Sub


Sub OBJECT_Scale_MOV(Xscal, Yscal, Zscal, Xmov, Ymov, Zmov)
Dim Matz As D3DMATRIX
Dim MOVz As D3DMATRIX
DX_7.IdentityMatrix Matz
DX_7.IdentityMatrix MOVz
Matz = MScale(Matz, Xscal, Yscal, Zscal)
MOVz = MTranslate(MOVz, Xmov, Ymov, Zmov)
DX_7.MatrixMultiply Matz, Matz, MOVz

D3D_DEV.SetTransform D3DTRANSFORMSTATE_WORLD, Matz





End Sub


Sub OBJECT_Scale_Rotate(Xscal, Yscal, Zscal, Xrot, Yrot, Zrot)
Dim Matz As D3DMATRIX
Dim MOVz As D3DMATRIX
DX_7.IdentityMatrix Matz
DX_7.IdentityMatrix MOVz
Matz = MScale(Matz, Xscal, Yscal, Zscal)
MOVz = MRotate(MOVz, Xrot, Yrot, Zrot)
DX_7.MatrixMultiply Matz, Matz, MOVz

D3D_DEV.SetTransform D3DTRANSFORMSTATE_WORLD, Matz





End Sub

Sub OBJECT_Scale_Rotate_MOV(Xscal, Yscal, Zscal, Xrot, Yrot, Zrot, Xmov, Ymov, Zmov)
Dim Matz As D3DMATRIX
Dim ROTz As D3DMATRIX
Dim MOVz As D3DMATRIX
Dim TEMPz As D3DMATRIX

DX_7.IdentityMatrix Matz
DX_7.IdentityMatrix MOVz
DX_7.IdentityMatrix ROTz

Matz = MScale(Matz, Xscal, Yscal, Zscal)
ROTz = MRotate(ROTz, Xrot, Yrot, Zrot)
MOVz = MTranslate(MOVz, Xmov, Ymov, Zmov)

DX_7.MatrixMultiply TEMPz, Matz, ROTz
DX_7.MatrixMultiply Matz, TEMPz, MOVz




D3D_DEV.SetTransform D3DTRANSFORMSTATE_WORLD, Matz





End Sub

Sub OBJECT_MOV_rotate(Xmov, Ymov, Zmov, Xrot, Yrot, Zrot)
Dim Matz As D3DMATRIX
Dim ROTz As D3DMATRIX
Dim MOVz As D3DMATRIX
Dim TEMPz As D3DMATRIX

DX_7.IdentityMatrix Matz
DX_7.IdentityMatrix MOVz
DX_7.IdentityMatrix ROTz

Matz = MTranslate(MOVz, Xmov, Ymov, Zmov)

ROTz = MRotate(ROTz, Xrot, Yrot, Zrot)


DX_7.MatrixMultiply Matz, Matz, ROTz





D3D_DEV.SetTransform D3DTRANSFORMSTATE_WORLD, Matz





End Sub

Sub OBJECT_Scale_Rotate_MovEX(Vscal As D3DVECTOR, Vrot As D3DVECTOR, Vmov As D3DVECTOR)
Dim Matz As D3DMATRIX
Dim ROTz As D3DMATRIX
Dim MOVz As D3DMATRIX
Dim TEMPz As D3DMATRIX

DX_7.IdentityMatrix Matz
DX_7.IdentityMatrix MOVz
DX_7.IdentityMatrix ROTz

Matz = MScale(Matz, Vscal.X, Vscal.Y, Vscal.Z)
ROTz = MRotate(ROTz, Vrot.X, Vrot.Y, Vrot.Z)
MOVz = MTranslate(MOVz, Vmov.X, Vmov.Y, Vmov.Z)

DX_7.MatrixMultiply TEMPz, Matz, ROTz
DX_7.MatrixMultiply Matz, TEMPz, MOVz




D3D_DEV.SetTransform D3DTRANSFORMSTATE_WORLD, Matz





End Sub


Property Get ID_Matrix() As D3DMATRIX
Dim MAZ As D3DMATRIX
DX_7.IdentityMatrix MAZ
ID_Matrix = MAZ

End Property



 Function MRotate(dSource As D3DMATRIX, ByVal nValueX As Single, ByVal nValueY As Single, ByVal nValueZ As Single) As D3DMATRIX

    ' Setup local variables ...
       MRotate = dSource
       ' DirectX.IdentityMatrix MRotate
        Dim L_nCos As Single        ' Holds cosine value of angle
        Dim L_nSin As Single        ' Holds sine value of angle
        
    ' Do rotation around X-Axis ...
        If nValueX <> 0 Then
        
            ' Reset caluculator to identity matrix
            MIdentity P_dCalculatorMatrix
                
            ' Get angle values
            L_nCos = Cos(nValueX * PIFactor)
            L_nSin = Sin(nValueX * PIFactor)
            
            ' Add transformations
            With P_dCalculatorMatrix
                .rc22 = L_nCos
                .rc33 = L_nCos
                .rc23 = -L_nSin
                .rc32 = L_nSin
            End With
            
            ' Apply transformations
            MRotate = MMultiply(P_dCalculatorMatrix, MRotate)
            
        End If
    
    ' Do rotation around Y-Axis ...
        If nValueY <> 0 Then
        
            ' Reset caluculator to identity matrix
            MIdentity P_dCalculatorMatrix
            
            ' Get angle values
            L_nCos = Cos(nValueY * PIFactor)
            L_nSin = Sin(nValueY * PIFactor)
            
            ' Add transformations
            With P_dCalculatorMatrix
                .rc11 = L_nCos
                .rc33 = L_nCos
                .rc13 = L_nSin
                .rc31 = -L_nSin
            End With
            
            ' Apply transformations
            MRotate = MMultiply(P_dCalculatorMatrix, MRotate)
            
        End If
        
    ' Do rotation around Z-Axis ...
        If nValueZ <> 0 Then
        
            ' Reset caluculator to identity matrix
            MIdentity P_dCalculatorMatrix
            
            ' Get angle values
            L_nCos = Cos(nValueZ * PIFactor)
            L_nSin = Sin(nValueZ * PIFactor)
            
            ' Add transformations
            With P_dCalculatorMatrix
                .rc11 = L_nCos
                .rc22 = L_nCos
                .rc12 = -L_nSin
                .rc21 = L_nSin
            End With
            
            ' Apply transformations
            MRotate = MMultiply(P_dCalculatorMatrix, MRotate)
            
        End If
        
    ' Return result ...
     
    
End Function


'=================================
' VectorNegate
'=================================
Sub VectorNegate(v As D3DVECTOR)
  v.X = -v.X
  v.Y = -v.Y
  v.Z = -v.Z
End Sub

Function VNegate(v As D3DVECTOR) As D3DVECTOR
    Dim RET As D3DVECTOR
    RET.X = -v.X
    RET.Y = -v.Y
    RET.Z = -v.Z
    VNegate = RET
End Function

'=================================
' VectorSubtract
'=================================
Sub VectorSubtract(Dest As D3DVECTOR, A As D3DVECTOR, B As D3DVECTOR)
  Dest.X = A.X - B.X
  Dest.Y = A.Y - B.Y
  Dest.Z = A.Z - B.Z
End Sub

Function Vsub(A As D3DVECTOR, B As D3DVECTOR) As D3DVECTOR
  Dim Dest As D3DVECTOR
  Dest.X = A.X - B.X
  Dest.Y = A.Y - B.Y
  Dest.Z = A.Z - B.Z
  Vsub = Dest
End Function

'=================================
' VectorAdd
'=================================
Function VectorAdd(Dest As D3DVECTOR, A As D3DVECTOR) As D3DVECTOR
  VectorAdd.X = A.X + B.X
  VectorAdd.Y = A.Y + B.Y
  VectorAdd.Z = A.Z + B.Z
End Function

Function VertorABS(Vin As D3DVECTOR) As D3DVECTOR
 VertorABS = Vector(Abs(Vin.X), Abs(Vin.Y), Abs(Vin.Z))

End Function


'=================================
' VectorCrossProduct
'=================================
' can be used to compute normals.
'
Function VectorCrossProduct(Dest As D3DVECTOR, A As D3DVECTOR) As D3DVECTOR
   VectorCrossProduct.X = A.Y * B.Z - A.Z * B.Y
   VectorCrossProduct.Y = A.Z * B.X - A.X * B.Z
   VectorCrossProduct.Z = A.X * B.Y - A.Y * B.X
End Function
  
Function VCross(A As D3DVECTOR, B As D3DVECTOR) As D3DVECTOR
   Dim Dest As D3DVECTOR
   Dest.X = A.Y * B.Z - A.Z * B.Y
   Dest.Y = A.Z * B.X - A.X * B.Z
   Dest.Z = A.X * B.Y - A.Y * B.X
   VCross = Dest
End Function

Function VecTIME(Vin As D3DVECTOR, A) As D3DVECTOR
   VecTIME.X = Vin.X * A
   VecTIME.Y = Vin.Y * A
   VecTIME.Z = Vin.Z * A

End Function


  
'=================================
' VectorNormalize
'=================================
' creates a vector of length 1 in the same direction
'
Sub VectorNormalize(Dest As D3DVECTOR)
  On Local Error Resume Next
  Dim L As Double
  L = Dest.X * Dest.X + Dest.Y * Dest.Y + Dest.Z * Dest.Z
  L = Sqr(L)
  If L = 0 Then
    Dest.X = 0
    Dest.Y = 0
    Dest.Z = 0
    Exit Sub
  End If
  Dest.X = Dest.X / L
  Dest.Y = Dest.Y / L
  Dest.Z = Dest.Z / L
End Sub
  
Function VectorNormal(VA As D3DVECTOR, VB As D3DVECTOR) As Single
 VectorNormal = Sqr((VB.X - VA.X) ^ 2 + (VB.Y - VA.Y) ^ 2 + (VB.Z - VA.Z) ^ 2)

End Function
Function VectorMISSING(VA As D3DVECTOR, Norme As Single) As D3DVECTOR
Dim VC As D3DVECTOR
Dim n
n = Norme * Norme




End Function
  
  
  
  
  
Function VNormalize(Dest As D3DVECTOR) As D3DVECTOR

  Dim RET As D3DVECTOR
  
  Dim L As Double
  L = Dest.X * Dest.X + Dest.Y * Dest.Y + Dest.Z * Dest.Z
  L = Sqr(L)
  If L = 0 Then
    RET.X = 0
    RET.Y = 0
    RET.Z = 0
  Else
    RET.X = Dest.X / L
    RET.Y = Dest.Y / L
    RET.Z = Dest.Z / L
  End If
  VNormalize = RET
End Function
  
'=================================
' VectorDotProduct
'=================================
Function VectorDotProduct(A As D3DVECTOR, B As D3DVECTOR) As Single
  VectorDotProduct = A.X * B.X + A.Y * B.Y + A.Z * B.Z
End Function

Function VDot(A As D3DVECTOR, B As D3DVECTOR) As Single
  VDot = A.X * B.X + A.Y * B.Y + A.Z * B.Z
End Function

'=================================
' VectorAddAndScale
'=================================
Sub VectorAddAndScale(Dest As D3DVECTOR, S1 As Single, V1 As D3DVECTOR, s2 As Single, V2 As D3DVECTOR)
  Dest.X = S1 * V1.X + s2 * V2.X
  Dest.Y = S1 * V1.Y + s2 * V2.Y
  Dest.Z = S1 * V1.Z + s2 * V2.Z
End Sub

'=================================
' VectorCopy
'=================================
Sub VectorCopy(Dest As D3DVECTOR, src As D3DVECTOR)
  Dest.X = src.X
  Dest.Y = src.Y
  Dest.Z = src.Z
End Sub

Function VCopy(src As D3DVECTOR) As D3DVECTOR
  Dim Dest As D3DVECTOR
  Dest.X = src.X
  Dest.Y = src.Y
  Dest.Z = src.Z
  VCopy = Dest
End Function

Function VERtoc(vert As D3DVERTEX) As D3DVECTOR
VERtoc.X = vert.X
VERtoc.Y = vert.Y
VERtoc.Z = vert.Z



End Function
Function LVERtoc(vert As D3DLVERTEX) As D3DVECTOR
LVERtoc.X = vert.X
LVERtoc.Y = vert.Y
LVERtoc.Z = vert.Z



End Function

Function Vmiddle(VA As D3DVECTOR, VB As D3DVECTOR) As D3DVECTOR
Vmiddle.X = (VA.X + VB.X) / 2
Vmiddle.Y = (VA.Y + VB.Y) / 2
Vmiddle.Z = (VA.Z + VB.Z) / 2

End Function



'=================================
' VectorScale
'=================================
' scale a vector by a scalar
Sub VectorScale(Dest As D3DVECTOR, src As D3DVECTOR, S As Single)
  Dest.X = src.X * S
  Dest.Y = src.Y * S
  Dest.Z = src.Z * S
End Sub

Function VScale(src As D3DVECTOR, S As Single) As D3DVECTOR
  Dim Dest As D3DVECTOR
  Dest.X = src.X * S
  Dest.Y = src.Y * S
  Dest.Z = src.Z * S
  VScale = Dest
End Function



















Public Function VCrossProduct(dV1 As D3DVECTOR, dV2 As D3DVECTOR) As D3DVECTOR
    DX_7.VectorCrossProduct VCrossProduct, dV1, dV2
End Function

Public Function VDotProduct(dV1 As D3DVECTOR, dV2 As D3DVECTOR) As Single
    VDotProduct = DX_7.VectorDotProduct(dV1, dV2)
End Function

Public Function VSubtract(dV1 As D3DVECTOR, dV2 As D3DVECTOR) As D3DVECTOR
    VSubtract.X = dV1.X - dV2.X
    VSubtract.Y = dV1.Y - dV2.Y
    VSubtract.Z = dV1.Z - dV2.Z
End Function




' Stupid macro function that transforms a lvertex to a vector
Private Function vert(Vertex As D3DLVERTEX) As D3DVECTOR
  vert.X = Vertex.X
  vert.Y = Vertex.Y
  vert.Z = Vertex.Z
End Function

Private Function VERTE(Vertex As D3DVERTEX) As D3DVECTOR
  VERTE.X = Vertex.X
  VERTE.Y = Vertex.Y
  VERTE.Z = Vertex.Z
End Function
Function VectorSETPOS(Vorigin As D3DVECTOR) As D3DVECTOR
  Dim v As D3DVECTOR
  
  

End Function

Function vecLVertex(v As D3DVECTOR, COLOR As Long, tu, tv) As D3DLVERTEX
 vecLVertex.X = v.X
 vecLVertex.Y = v.Y
 vecLVertex.Z = v.Z
 vecLVertex.COLOR = COLOR
 vecLVertex.specular = COLOR
 vecLVertex.tu = tu
 vecLVertex.tv = tv
End Function
Function vecVertex(v As D3DVECTOR, tu, tv) As D3DVERTEX
 vecVertex.X = v.X
 vecVertex.Y = v.Y
 vecVertex.Z = v.Z
 
 vecVertex.tu = tu
 vecVertex.tv = tv
End Function

Function RVertex(Vect As D3DVECTOR, vNorm As D3DVECTOR, tu As Single, tv As Single) As D3DVERTEX
    Dim RET As D3DVERTEX
    With RET
        .nx = vNorm.X
        .ny = vNorm.Y
        .nz = vNorm.Z
        .tu = tu
        .tv = tv
        .X = Vect.X
        .Y = Vect.Y
        .Z = Vect.Z
    End With
    RVertex = RET
End Function












'==============================================
'  LIGHT FUNCTIONs
'
'
'==========================================

Public Function ADD_light(TYP As CONST_D3DLIGHTTYPE, Position As D3DVECTOR, AMB As D3DCOLORVALUE, DIFFU As D3DCOLORVALUE, Rayon As Single, Directio As D3DVECTOR) As Integer
Light.Bound = Light.Bound + 1
ReDim Preserve Light.LIGH(0 To Light.Bound)


If TYP = D3DLIGHT_POINT Then

  With Light.LIGH(Light.Bound - 1)
    .Ambient = AMB
    .diffuse = DIFFU
    .range = Rayon
    .attenuation0 = 1
    .attenuation1 = 1
    .attenuation2 = 0
    .Position = Position
    .dltType = D3DLIGHT_POINT
    
   End With




End If


If TYP = D3DLIGHT_DIRECTIONAL Then

  With Light.LIGH(Light.Bound - 1)
    .Ambient = AMB
    .diffuse = DIFFU
    '.range = Rayon
    .attenuation0 = 1
    .attenuation1 = 1
    .attenuation2 = 0
    .dltType = D3DLIGHT_DIRECTIONAL
    .direction = Directio
    .Position = Position
    
    
   End With




End If


If TYP = D3DLIGHT_SPOT Then

  With Light.LIGH(Light.Bound - 1)
    .Ambient = AMB
    .diffuse = DIFFU
    '.range = Rayon
    .attenuation0 = 1
    .attenuation1 = 1
    .attenuation2 = 0
    .dltType = D3DLIGHT_SPOT
    .direction = Directio
    .Position = Position
    '.Range = d3dlight_range_max
    .falloff = 1#
    .theta = G_PI / 3
    .phi = G_PI * 2 / 3
    .attenuation0 = 1
    
    
    
   End With




End If








Light.FreeMAT_index = Light.FreeMAT_index + 1
D3D_DEV.SetLight Light.FreeMAT_index, Light.LIGH(Light.Bound - 1)
D3D_DEV.LightEnable Light.FreeMAT_index, True


ADD_light = Light.Bound - 1
End Function


Function LIGHT_enable(Pindex, isON As Boolean)
D3D_DEV.LightEnable Pindex, isON
D3D_DEV.SetRenderState D3DRENDERSTATE_LIGHTING, True
End Function


Sub LIGHT_Position(Pindex, Position As D3DVECTOR)
  '##BD Changes the position of a point or spot light.
  '##PD x New position x-coordinate
  '##PD y New position y-coordinate
  '##PD z New position z-coordinate

  Light.LIGH(Pindex).Position = Position
  D3D_DEV.SetLight Pindex, Light.LIGH(Pindex)
D3D_DEV.LightEnable Pindex, True

End Sub

Public Function LIGHT_GETFreeINDEX()
 If Light.FreeMAT_index < 0 Then Light.FreeMAT_index = 0
  LIGHT_GETFreeINDEX = Light.FreeMAT_index

End Function

Public Function LIGHT_SetFreeINDEX(LIGHT_GETFreeINDEX)
   Light.FreeMAT_index = LIGHT_GETFreeINDEX

End Function


'misc functions
Function CheckSphereVIsibility(Vcenter As D3DVECTOR, Radius As Single) As Boolean
  'the great visibility check with the sphere!
   'mesh sphere must be computed before calling this function
   Dim ClipStatus
   
   CheckSphereVIsibility = False
  ClipStatus = D3D_DEV.ComputeSphereVisibility(Vcenter, Radius)
 If ClipStatus And &HFFF000 Then
   'not visible
   
 Else
  If ClipStatus And &HFFF Then
   'partially visible :
   CheckSphereVIsibility = True
  
  Else
   CheckSphereVIsibility = True
   'entirely visible
   
 End If
 
 End If
End Function
