VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cJohna_Sound"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'=====================
'Johna_SoundEngine version 1.04
'
'
'
'
'Direct sound engine
'    Version 1.01
'     new midi file engine added 25-01-2002
'
'   With midi file support
'
'========================

Option Explicit
Const MAX_BUFF = 255
Dim ENGINE_SCAL
Const FACTOR_SCAL = 50

Public DsounD As DirectSound


'a sound structure
Private Type DSound_johna
      WaveName As String
      Index_buf As Long
      DSound_BUFF As DirectSoundBuffer
      Dsound_BUFF3D As DirectSound3DBuffer
      Pos As D3DVECTOR
      Midi_IS_Playing As Boolean
      Is_3d As Boolean
End Type

Private SoundBUF() As DSound_johna
Public Total_SoundBUF As Integer
Public IS_DSound3D As Boolean
Public DS_Listener As DirectSound3DListener
Private DS_PrimaryBuffer As DirectSoundBuffer

Private LpHandle As Long
Private DXx As New DirectX7


Private SOUND_INIT As Boolean


'for midi playing
Dim perf As DirectMusicPerformance
Dim perf2 As DirectMusicPerformance  'These 2 variables are the buffers, "perf" is the master, "perf2" is used to gather 'information about the MIDI file

Dim Seg As DirectMusicSegment
Dim segstate As DirectMusicSegmentState 'Segments, these hold segments of the music!

Dim loader As DirectMusicLoader 'This is an object that helps load the files into the buffers.

Dim GetStartTime As Long
Dim Offset As Long
Dim mtTime As Long

Dim mtLength As Double
Dim dTempo As Double

Dim TimeSig As DMUS_TIMESIGNATURE 'This'll hold the time signiture that the MIDI is in.

Dim IsPlayingCheck As Boolean 'A simple true/false statement as to whether or not it's playing.
Dim msg As String 'Used in the error handler sub.
Dim time As Double
Dim fIsPaused As Boolean
Dim ISITPAUSED As Boolean '--TIME-- These settings are sued in the progress bar section.
Dim Total_Time As Double
Dim Current_Time As Double
Dim Percent_Time As Double
Public Midi_IS_Playing As Boolean
Public Loop_it As Boolean




Public Function INIT_SoundENGINE(appHandle As Long, Optional UNITFACTOR = FACTOR_SCAL) As Boolean
LpHandle = appHandle


ENGINE_SCAL = UNITFACTOR
On Local Error Resume Next
    Set DsounD = DXx.DirectSoundCreate("")
    
    'Tell the user we've got a problem
    If Err.Number <> 0 Then
        MsgBox "Unable to initialise; Either bad soundcard or bad drivers. Quiting"
        INIT_SoundENGINE = False
        SOUND_INIT = False
        Exit Function
    End If



    'Priority gives us greater control.
    DsounD.SetCooperativeLevel LpHandle, DSSCL_PRIORITY
    
    'These two describe what our sound buffer will be like
    Dim primDesc As DSBUFFERDESC, format As WAVEFORMATEX
    
    'Using the CTRL3D flag has speed penalties; dont use it unless
    'you have to - but you have to use it for 3D sounDsounD...
    primDesc.lFlags = DSBCAPS_CTRL3D Or DSBCAPS_PRIMARYBUFFER
    'You can set the Stereo/Mono and Frequency settings here
    'and they will be applied to the primary buffer.
    Set DS_PrimaryBuffer = DsounD.CreateSoundBuffer(primDesc, format)
    'Get a 3D listener device
    Set DS_Listener = DS_PrimaryBuffer.GetDirectSound3DListener()
    
    'The listener is at the 3D coordinate 0,0,0
    '+z is in front of you
    '-Z is behind you
    '-X is to your left
    '+x is to your right
    '+Y is above you
    '-Y is below you
    
    INIT_SoundENGINE = True
    Me.Total_SoundBUF = 0
    SOUND_INIT = True
    SOUND_INIT = DMusic_Init()
    
End Function



Public Function Load_Wav(WavFile As String, Optional Is_3d As Boolean = False, Optional PosX As Single = 0, Optional PosY As Single = 0, Optional PosZ As Single = 0) As Integer
If Not SOUND_INIT Then Exit Function

    Dim bufferDesc1 As DSBUFFERDESC
    Dim waveFormat1 As WAVEFORMATEX
    Dim IndEXX
    
    Me.Total_SoundBUF = Me.Total_SoundBUF + 1
    IndEXX = Me.Total_SoundBUF
    ReDim Preserve SoundBUF(1 To Me.Total_SoundBUF)
    
    If Is_3d Then
       bufferDesc1.lFlags = (DSBCAPS_CTRL3D Or DSBCAPS_CTRLFREQUENCY Or DSBCAPS_CTRLPAN Or DSBCAPS_CTRLVOLUME) Or DSBCAPS_STATIC
       
    Else
       bufferDesc1.lFlags = (DSBCAPS_CTRLFREQUENCY Or DSBCAPS_CTRLPAN Or DSBCAPS_CTRLVOLUME) Or DSBCAPS_STATIC
    End If
    
    Set SoundBUF(IndEXX).DSound_BUFF = DsounD.CreateSoundBufferFromFile(WavFile, bufferDesc1, waveFormat1)
    
    
If Is_3d Then
    'The original buffer (above) must be created before this
    'line; and the original buffer must have the CTRL3D flag present
    Set SoundBUF(IndEXX).Dsound_BUFF3D = SoundBUF(IndEXX).DSound_BUFF.GetDirectSound3DBuffer


    'The angles define how sensitive the sound buffer will be. A
    'narrower cone will result in more sensitive.
    'You can have 0 degrees for no cone
    'You can have 360 degrees for a full sphere
    'Or you can use any of these constants
    'DS3D_MINCONEANGLE
    'DS3D_MAXCONEANGLE
    'DS3D_DEFAULTCONEANGLE - the default is 360 degrees
    SoundBUF(IndEXX).Dsound_BUFF3D.SetConeAngles DS3D_MINCONEANGLE, 100, DS3D_IMMEDIATE
    'the DS3D_IMMEDIATE makes Directsound stop and recalculate ALL
    'Directsound3D Buffers, coordinates and positions. If you use
    'DS3D_DEFFERED flag, you can make several parameter changes before
    'allowing DirectSound to recalculate everything. You have to call;
    'DirectSound3DListener.CommitDefferedSettings before they take effect.
    SoundBUF(IndEXX).Dsound_BUFF3D.SetConeOutsideVolume -400, DS3D_IMMEDIATE
    
    
    SoundBUF(IndEXX).Dsound_BUFF3D.SetPosition PosX / ENGINE_SCAL, PosY / ENGINE_SCAL, PosZ / ENGINE_SCAL, DS3D_IMMEDIATE


    SoundBUF(IndEXX).WaveName = WavFile
    

End If


'Maximize the main Buffer volume
SoundBUF(IndEXX).DSound_BUFF.SetVolume 0
Load_Wav = IndEXX


End Function




Public Function Play_BUF(Buffer_INDEX, Optional LooP_ON As Boolean = False)
If LooP_ON Then
   SoundBUF(Buffer_INDEX).DSound_BUFF.Play 1
Else
   SoundBUF(Buffer_INDEX).DSound_BUFF.Play 0
End If
End Function


Public Sub Stop_BUF(Buffer_INDEX)
   SoundBUF(Buffer_INDEX).DSound_BUFF.Stop
End Sub







Public Function Set_ListenerPosition(SoundPos As D3DVECTOR)
   DS_Listener.SetPosition SoundPos.X / ENGINE_SCAL, SoundPos.Y / ENGINE_SCAL, SoundPos.Z / ENGINE_SCAL, DS3D_IMMEDIATE

End Function


Public Function Set_BufferPosition(BufferINDEX, Vpos As D3DVECTOR)
  Dim V1 As D3DVECTOR
  
    V1.X = Vpos.X / ENGINE_SCAL
    V1.Y = Vpos.Y / ENGINE_SCAL
    V1.Z = Vpos.Z / ENGINE_SCAL
    SoundBUF(BufferINDEX).Dsound_BUFF3D.SetPosition V1.X, V1.Y, V1.Z, DS3D_IMMEDIATE

End Function



Public Function Get_ListenerPosition() As D3DVECTOR
  Dim V1 As D3DVECTOR
  Call DS_Listener.GetPosition(V1)
  V1.X = V1.X * ENGINE_SCAL
  V1.Y = V1.Y * ENGINE_SCAL
  V1.Z = V1.Z * ENGINE_SCAL
  Get_ListenerPosition = V1
End Function

Public Function Get_BufferPosition(BufferINDEX) As D3DVECTOR
   Dim V1 As D3DVECTOR
   
   Call SoundBUF(BufferINDEX).Dsound_BUFF3D.GetPosition(V1)
  V1.X = V1.X * ENGINE_SCAL
  V1.Y = V1.Y * ENGINE_SCAL
  V1.Z = V1.Z * ENGINE_SCAL
  Get_BufferPosition = V1


End Function


Public Sub Set_BufferVolume(BufferINDEX, percent As Single)
  Dim VOl As Long
  VOl = Abs(DSBVOLUME_MIN) - CLng((percent * 1 / 100) * Abs(DSBVOLUME_MIN))
  VOl = -VOl
  
  
  SoundBUF(BufferINDEX).DSound_BUFF.SetVolume VOl

End Sub




Sub Engine_Free()
   'Free all onjects

    Dim I
   If Me.Total_SoundBUF > 0 Then
        For I = 1 To Me.Total_SoundBUF
            Set SoundBUF(I).DSound_BUFF = Nothing
            Set SoundBUF(I).Dsound_BUFF3D = Nothing
        Next I
   End If
  
  If SOUND_INIT Then
    Set DsounD = Nothing
    Set DXx = Nothing
  End If
  'release any midi
  DMusic_StopMidi
End Sub


Private Sub Class_Initialize()
 ENGINE_SCAL = FACTOR_SCAL
End Sub

Private Sub Class_Terminate()
  Engine_Free
End Sub

'=============================================================
'   Midi playing function
'
'
'===============================================================
Private Sub LocalError(ErrorNum As Long, ErrorDesc As String) 'Nothing much to explain here...
    msg = ErrorDesc
    msg = "(" & ErrorNum & ") - " & msg
    MsgBox msg
End Sub

Private Function DMusic_Init() As Boolean
On Error GoTo LocalErrors
     
    Set loader = DXx.DirectMusicLoaderCreate() 'This is the DMusic Main Component
         
    'Creating a Perf2 so that we can get all the segment information without having to play 'the segment
    Set perf2 = DXx.DirectMusicPerformanceCreate() 'Create the Second buffer.
    Call perf2.Init(Nothing, 0)
    perf2.SetPort -1, 80
    Call perf2.GetMasterAutoDownload

    Set perf = DXx.DirectMusicPerformanceCreate() 'create the first Buffer.
    Call perf.Init(Nothing, 0)
    perf.SetPort -1, 80
    Call perf.SetMasterAutoDownload(True)
     
    DMusic_Init = True
Exit Function
LocalErrors:
    Call LocalError(Err.Number, Err.Description) 'We've already written this sub.
    DMusic_Init = False

End Function

Public Function DMusic_OpenMidi(filename As String) As Boolean
Dim Minutes As Integer
Dim A As Integer
Dim Length As Integer
Dim length2 As Integer

On Error GoTo LocalErrors
    
If Not Seg Is Nothing And Not segstate Is Nothing Then ' There is a Segment and a SegmentState
        If perf.IsPlaying(Seg, segstate) = True Then ' Segment currently playing, so exit
        perf.Stop Seg, segstate, 0, 0
        DMusic_OpenMidi = True
       
    ElseIf ISITPAUSED = True Then
          perf.Stop Seg, segstate, 0, 0
    time = 0
        Exit Function
    End If
End If
    
    Set loader = Nothing
    Set loader = DXx.DirectMusicLoaderCreate

'common dialog control
        Set Seg = loader.LoadSegment(filename)
    ' Set the search directory based on the placement of the .mid file that was loaded
    Length = Len(filename)
    length2 = Length
    Dim path As String
    Do While path <> "\"
        path = Mid(filename, Length, 1)
        Length = Length - 1
    Loop
    Dim SearchDir As String
    SearchDir = Left(filename, Length)
    loader.SetSearchDirectory (Left(filename, Length + 1))
    perf2.SetMasterAutoDownload True
     
     
    'Play the segment just long enough to get the info
    mtTime = perf2.GetMusicTime()
    Call perf2.PlaySegment(Seg, 0, mtTime + 2000)
     
    'GetTempo
    dTempo = perf2.GetTempo(mtTime + 2000, 0)
     
    'GetTimeSig
    Call perf2.GetTimeSig(mtTime + 2000, 0, TimeSig)
     
    'GetLength
    mtLength = (((Seg.GetLength() / 768) * 60) / dTempo) 'This is an important set of numbers, this'll result in the total
'number of seconds the file lasts.
    Total_Time = mtLength 'a variable copy, "Total_Time" is used later on in the project
    ' Put the length in a time that we can relate to
     
    ' Now that we retreived all the segment info, we'll stop playing the segment, the user wont here any music being played 'here, as it does it so quickly...
    Call perf2.Stop(Seg, Nothing, 0, 0)
         
        Seg.SetStandardMidiFile
    DMusic_OpenMidi = True
Exit Function
LocalErrors:
DMusic_OpenMidi = False

If Not Seg Is Nothing Then
    Call perf2.Stop(Seg, Nothing, 0, 0) 'If there was an error, stop playing the music
End If
       ' MsgBox ("There was a problem loading the requested file.  No file has been loaded") 'output result to user
        'Filename = vbNullString
End Function

Public Function DMusic_PlayMidi(Optional Repeats As Boolean = False) As Boolean

On Error GoTo LocalErrors
  
  If Repeats Then Me.Loop_it = True
  
  If Seg Is Nothing Then 'The user hasn't clicked "Open" yet.
        MsgBox ("Please open a segment or MIDI file before playing")
        DMusic_PlayMidi = False
        Exit Function
    End If
    
    Seg.SetRepeats CLng(Repeats)
    If fIsPaused Then 'If it is paused, start the file from where it already is.
        Offset = mtTime - GetStartTime + Offset + 1
        Call Seg.SetStartPoint(Offset)
        Set segstate = perf.PlaySegment(Seg, 0, 0)
    Else 'Reset it back to the beggining, then start playing it.
        Offset = 0
        If perf.IsPlaying(Seg, segstate) = True Then
            Call perf.Stop(Seg, segstate, 0, 0)
        End If
        Seg.SetStartPoint (0)
        Seg.SetLoopPoints 0, Seg.GetLength
        Set segstate = perf.PlaySegment(Seg, 0, 0)
        
        DMusic_PlayMidi = True
        Me.Midi_IS_Playing = True
        Exit Function
    End If
    fIsPaused = False

    DMusic_PlayMidi = True
Exit Function
LocalErrors:
    Call LocalError(Err.Number, Err.Description) 'We've already written this sub.
    DMusic_PlayMidi = False


End Function

Public Function DMusic_PauseMidi() As Boolean
On Error GoTo LocalErrors

    If Seg Is Nothing Then 'If it hasn't been loaded yet, get out of here
        Exit Function
    End If

    IsPlayingCheck = perf.IsPlaying(Seg, segstate)
    If IsPlayingCheck = True Then 'music is playing
        fIsPaused = True
        ' pause music and button down
        mtTime = perf.GetMusicTime()
        GetStartTime = segstate.GetStartTime()
        Call perf.Stop(Seg, Nothing, 0, 0)
    Else
        'unpause
        fIsPaused = False
        Offset = mtTime - GetStartTime + Offset + 1
        Call Seg.SetStartPoint(Offset)
        Set segstate = perf.PlaySegment(Seg, 0, 0)
    End If
    DMusic_PauseMidi = True
Exit Function
LocalErrors:
    Call LocalError(Err.Number, Err.Description) 'The Error handler shown earlier
    DMusic_PauseMidi = False
End Function

Public Function DMusic_StopMidi() As Boolean
On Error GoTo LocalErrors
    
    If Seg Is Nothing Then 'nothing has been loaded yet...
        Exit Function
    End If
    fIsPaused = False 'internal flag to tell it that it isn't paused.
    
    Call perf.Stop(Seg, segstate, 0, 0)
    time = 0
    
    DMusic_StopMidi = True
Exit Function
LocalErrors:
    Call LocalError(Err.Number, Err.Description) 'The Error handler shown earlier
    DMusic_StopMidi = False
End Function


Public Property Get Dmusic_volume() As Integer
    Dmusic_volume = (perf.GetMasterVolume / 42 + 71)
End Property

Public Property Let Dmusic_volume(ByVal Percentage As Integer)
If Percentage > 100 Then Percentage = 100
If Percentage < 0 Then Percentage = 0

perf.SetMasterVolume (Percentage * 42 - 3000)
End Property

Public Property Get Dmusic_Percentage_Done() As Integer
    Current_Time = ((((perf.GetMusicTime() - (segstate.GetStartTime() - Offset)) / 768) * 60) / dTempo) 'get the current time
    Percent_Time = Int((Current_Time / Total_Time) * 100) 'work out the percentage - you remember these?
    
    If Percent_Time > 100 Then
        Dmusic_Percentage_Done = 100
    Else
        Dmusic_Percentage_Done = Percent_Time
    End If
End Property


Public Property Get Dmusic_LengthInSeconds() As Double
    Dmusic_LengthInSeconds = format(Total_Time, "00.00")
End Property
